#pragma once

typedef enum _FILTER_CATEGORY {
	FILTER_CATEGORY_DIRECTSHOW,
	FILTER_CATEGORY_VIDEO_CAPTURE,
	FILTER_CATEGORY_AUDIO_CAPTURE,
} FILTER_CATEGORY;

//////////////////////////////////////////////////////////////////////////////////////
// tB^擾pNXQ(Info)

class CPinInfo {
public:
	BOOL					bInput; // 
	std::wstring			wsName; // s
	std::wstring			wsCategory; // sJeS
	std::wstring			wsMediaType; // fBA^Cv
};


class CAnalogVideoStandardInfo {
public:
	long lElement; // vfirbgtOj
	std::wstring wsElement; // vf
};

class CVideoCaptureFormatInfo {
public:
	VIDEO_STREAM_CONFIG_CAPS	ssc;
	AM_MEDIA_TYPE				mt;
	VIDEOINFOHEADER				vih;
	std::wstring				wsFourCC; // Tu^CviktH[}bgjGUID subtype / DWORD biCompression

	long						lStandard; // ݐݒ肳ĂAiOrfIKĩrbgtO
	std::vector<CAnalogVideoStandardInfo> vecStandard; // AiOrfIKirbgtOzɕϊ
};

class CAudioCaptureFormatInfo {
public:
	AUDIO_STREAM_CONFIG_CAPS	ssc;
	AM_MEDIA_TYPE				mt;
	WAVEFORMATEX				wav;
	std::wstring				wsFourCC; // Tu^CviktH[}bgjGUID subtype / DWORD biCompression
};


class CCrossbarInputPinInfo {
public:
	long lIndex; // sԍ
	long lRelated; // ֘Asԍ
	long lRouted; // [gĂsԍ
	std::wstring wsType; // s̎
};

class CCrossbarOutputPinInfo {
public:
	long lIndex;
	long lRelated;
	long lRouted;
	std::wstring wsType;
	std::vector<CCrossbarInputPinInfo> vecCanRoute; // ڑłs̔z
};

class CCrossbarInfo {
public:
	std::vector<CCrossbarOutputPinInfo> vecOutput;
	std::vector<CCrossbarInputPinInfo> vecInput;
};

class CVideoCaptureFilterInfo {
public:
	std::vector<CPinInfo> vecPin; // s
	std::vector<CVideoCaptureFormatInfo> vecFormat; // tH[}bg

	CCrossbarInfo Xbar1; // NXo[
	CCrossbarInfo Xbar2; // NXo[
};

class CAudioCaptureFilterInfo {
public:
	std::vector<CPinInfo> vecPin;
	std::vector<CAudioCaptureFormatInfo> vecFormat;
};

class CDirectShowFilterInfo {
public:
	CDirectShowFilterInfo() : bIsLoaded(FALSE), nInput(-1), nOutput(-1), bCheck(TRUE) {}
	~CDirectShowFilterInfo() {}

	std::wstring wsFriendlyName;
	std::wstring wsDescription;
	std::wstring wsDevicePath;
	BOOL bIsLoaded; // GetDirectShowFilterInfoŃs擾
	// s̓tB^XgIƂɈ񂾂擾̂ł̃tOg
	// ̃tOĂȂƂGetDirectShowFilterInfo͏擾
	// tOĂƂ͉Ȃ
	std::vector<CPinInfo> vecPin;
	int nInput; // ڑsԍ
	int nOutput;
	BOOL bCheck;
};


class CDirectShowFilterID {
public:
	std::wstring wsFriendlyName;
	std::wstring wsDescription;
	std::wstring wsDevicePath;
	long lFilterCategory;
};

class Sort_CDirectShowFilterID {
public:
	Sort_CDirectShowFilterID()
		: m_bGreater(false)
	{}
	Sort_CDirectShowFilterID(bool fGreater)
		: m_bGreater(false)
	{
		m_bGreater = fGreater;
	}
	void Set(bool fGreater)
	{
		m_bGreater = fGreater;
	}

	bool operator()(const CDirectShowFilterID& l, const CDirectShowFilterID& r) const
	{
		if (m_bGreater)
		{
			return lstrcmpi(l.wsFriendlyName.c_str(), r.wsFriendlyName.c_str()) > 0
				? true : false;
		}
		return lstrcmpi(l.wsFriendlyName.c_str(), r.wsFriendlyName.c_str()) < 0
			? true : false;
	}
private:
	bool m_bGreater;
};



class CCaptureFilterInfo {
public:
	CCaptureFilterInfo(void);
	~CCaptureFilterInfo(void);

	BOOL Init(void);
	void UnInit(void);
	BOOL IsInit(void);

private:
	// wp[֐
	struct ToUpper {
		WCHAR operator()(WCHAR wc) { return towupper(wc); }
	};

	BOOL MakeVideoFourCC(const GUID &subtype, const DWORD biCompression, std::wstring *pwsOutput);
	BOOL MakeAudioFourCC(const GUID &subtype, std::wstring *pwsOutput);
	BOOL MakeAnalogVideoStandard(ULONG ulStandard, std::vector<CAnalogVideoStandardInfo> &vec);
	LPCWSTR GetPhysicalPinName(long lType);

	BOOL HasAudioCapturePin(std::vector<CPinInfo> &vecInfo);

	BOOL CreateBuilder(IGraphBuilder** ppGB, ICaptureGraphBuilder2** ppCGB2);

	BOOL GetVideoCaptureFormatInfo(IBaseFilter *pFilter, std::vector<CVideoCaptureFormatInfo> &vec);
	BOOL GetAudioCaptureFormatInfo(IBaseFilter *pFilter, std::vector<CAudioCaptureFormatInfo> &vec);
	BOOL GetCrossbarInfo(IBaseFilter *pFilter, CCrossbarInfo &info1, CCrossbarInfo &info2);
	BOOL GetCrossbarInfo(IAMCrossbar *pXBar, CCrossbarInfo &info);

	BOOL GetPinMediaType(IPin *pPin, GUID *pMediaType);
	BOOL GetPinMediaType(IPin *pPin, std::wstring &wsMediaType);
	BOOL GetPinCategory(IPin *pPin, GUID *pPinCategory);
	BOOL GetPinCategory(IPin *pPin, std::wstring &wsCategory);
	BOOL GetPinInfo(IBaseFilter *pFilter, std::vector<CPinInfo> &vecInfo);

	// IDDirectShowtB^擾
	BOOL GetDirectShowFilter(const CDirectShowFilterID &id, IBaseFilter **ppFilter);

public:

	// DirectShowtB^IDXg擾
	BOOL GetDirectShowFilterID(long lFilterCategory, std::vector<CDirectShowFilterID> &vecID);

	BOOL GetDirectShowFilterInfo(const CDirectShowFilterID &id, CDirectShowFilterInfo &info);
	BOOL GetVideoCaptureFilterInfo(const CDirectShowFilterID &id, CVideoCaptureFilterInfo &info);
	BOOL GetAudioCaptureFilterInfo(const CDirectShowFilterID &id, CAudioCaptureFilterInfo &info);

private:
	BOOL m_bCoInitialize; // COM
};
