#include "StdAfx.h"
#include "CaptureGraphBuilder.h"



// {0B390488-D80F-4A68-8408-48DC199F0E97}
DEFINE_GUID(CLSID_ffdshow, 
0x0b390488, 0xd80f, 0x4a68, 0x84, 0x08, 0x48, 0xdc, 0x19, 0x9f, 0x0e, 0x97);

// {15061C3B-C7B0-467C-AFCC-FFB303BA4163}
DEFINE_GUID(CLSID_HWDeint, 
0x15061c3b, 0xc7b0, 0x467c, 0xaf, 0xcc, 0xff, 0xb3, 0x03, 0xba, 0x41, 0x63);

const VideoProcAmpProperty g_VideoProcAmpProp[] = {
    VideoProcAmp_Brightness,
    VideoProcAmp_Contrast,
    VideoProcAmp_Hue,
    VideoProcAmp_Saturation,
    VideoProcAmp_Sharpness,
    VideoProcAmp_Gamma,
    VideoProcAmp_ColorEnable,
    VideoProcAmp_WhiteBalance,
    VideoProcAmp_BacklightCompensation,
    VideoProcAmp_Gain
};



// tB^vpeBEBhEɕ\tbNƃTuNX
namespace HOOK {

HWND g_hParentWnd;

void SetCenterWindow(HWND hWnd)
{
	RECT rcParent, rcClient, rcDesktop;
	GetWindowRect(g_hParentWnd, &rcParent);
	GetWindowRect(hWnd, &rcClient);

	rcDesktop.left = GetSystemMetrics(SM_XVIRTUALSCREEN);
	rcDesktop.top = GetSystemMetrics(SM_YVIRTUALSCREEN);
	rcDesktop.right = rcDesktop.left + GetSystemMetrics(SM_CXVIRTUALSCREEN);
	rcDesktop.bottom = rcDesktop.top + GetSystemMetrics(SM_CYVIRTUALSCREEN);


	int x = rcParent.left + ((rcParent.right - rcParent.left) / 2) - ((rcClient.right - rcClient.left) / 2);
	int y = rcParent.top + ((rcParent.bottom - rcParent.top) / 2) - ((rcClient.bottom - rcClient.top) / 2);

	if (x < rcDesktop.left)
	{
		x = rcDesktop.left;
	}

	if ((x + (rcClient.right - rcClient.left)) > rcDesktop.right)
	{
		x = rcDesktop.right - (rcClient.right - rcClient.left);
	}

	if (y < rcDesktop.top)
	{
		y = rcDesktop.top;
	}

	if ((y + (rcClient.bottom - rcClient.top)) > rcDesktop.bottom)
	{
		y = rcDesktop.bottom - (rcClient.bottom - rcClient.top);
	}

	SetWindowPos(hWnd, 0, x, y, 0, 0, SWP_NOZORDER|SWP_NOSIZE);
}

// TuNX
WNDPROC g_wndproc;
LRESULT CALLBACK WindowProc(HWND hWnd, UINT uMsg, UINT wp, LONG lp);

#ifdef _WIN64
void Subclass(HWND hWnd)
{
	g_wndproc = (WNDPROC)(LONG_PTR)::GetWindowLongPtr(hWnd, GWLP_WNDPROC);
	::SetWindowLong(hWnd, GWLP_WNDPROC, (LONG)(LONG_PTR)WindowProc);
}

void Unsubclass(HWND hWnd)
{
	::SetWindowLongPtr(hWnd, GWLP_WNDPROC, (LONG)(LONG_PTR)g_wndproc);
	g_wndproc = NULL;
}
#else
void Subclass(HWND hWnd)
{
	g_wndproc = (WNDPROC)(LONG_PTR)::GetWindowLong(hWnd, GWL_WNDPROC);
	::SetWindowLong(hWnd, GWL_WNDPROC, (LONG)(LONG_PTR)WindowProc);
}

void Unsubclass(HWND hWnd)
{
	::SetWindowLong(hWnd, GWL_WNDPROC, (LONG)(LONG_PTR)g_wndproc);
	g_wndproc = NULL;
}
#endif

LRESULT CALLBACK WindowProc( HWND hWnd, UINT uMsg, UINT wp, LONG lp )
{
	LRESULT ret = ::CallWindowProc(g_wndproc, hWnd, uMsg, wp, lp);
	if (WM_INITDIALOG == uMsg)
	{
		SetCenterWindow(hWnd);
		Unsubclass(hWnd);
	}

	return ret;
}

// tbN
HHOOK g_hHook;


void Unhook()
{
	::UnhookWindowsHookEx(g_hHook);
	g_hHook = NULL;
}

#ifdef _WIN64
LRESULT CALLBACK CallWndRetProc(int code, WPARAM wp, LPARAM lp)
{
	const CWPRETSTRUCT* p = (const CWPRETSTRUCT*)(LONG_PTR)lp;

	if (WM_NCCREATE == p->message &&
		GetParent(p->hwnd) == g_hParentWnd)
	{
		Unhook();
		Subclass(p->hwnd);
	}
	return ::CallNextHookEx(g_hHook, code, wp, lp);
}
#else
LRESULT CALLBACK CallWndRetProc(int code, UINT wp, LONG lp)
{
	const CWPRETSTRUCT* p = (const CWPRETSTRUCT*)(LONG_PTR)lp;

	if (WM_NCCREATE == p->message &&
		GetParent(p->hwnd) == g_hParentWnd)
	{
		Unhook();
		Subclass(p->hwnd);
	}
	return ::CallNextHookEx(g_hHook, code, wp, lp);
}
#endif

void Hook(HWND hParentWnd, HINSTANCE hi, DWORD id)
{
	g_hParentWnd = hParentWnd;
	g_hHook = ::SetWindowsHookEx(WH_CALLWNDPROCRET, CallWndRetProc, hi, id);
}


};






// IMFGetServicẽev[g

template <typename T>
static CComPtr<T> GetService(IBaseFilter *filter, REFGUID guid, REFIID riid)
{
    CComPtr<T> pRet;
    
	HRESULT hr;
	CComPtr<IMFGetService> pGS;
	hr = filter->QueryInterface<IMFGetService>(&pGS);
	if (FAILED(hr) || pGS == NULL)
	{
		FAILED_TRACE;
		return pRet;
	}

    pGS->GetService(guid, riid, reinterpret_cast<void**>(&pRet));
    return pRet;
}



CCaptureGraphBuilder::CCaptureGraphBuilder(void)
{
	m_bCoInitialize = FALSE;

	m_bVideoFormatFourCC = 0;

	// EBhEݒ
	m_nWndAspectX = 16; // AXyNg
	m_nWndAspectY = 9;

	m_rcCrop.SetRect(0, 0, 0, 0);

#ifdef _DEBUG
	m_dwRegister = 0;
#endif
}

CCaptureGraphBuilder::~CCaptureGraphBuilder(void)
{
	UnInit();
}

BOOL CCaptureGraphBuilder::Init(void)
{
	// COM
	UnInit();

	m_vecGraph.clear();

	HRESULT hr = S_OK;
	
	hr = CoInitialize(NULL);

	if (FAILED(hr))
	{
		return FALSE;
	}

	m_bCoInitialize = TRUE;
	return TRUE;
}

void CCaptureGraphBuilder::UnInit(void)
{
	Stop();

#ifdef _DEBUG
	RemoveFromRot();
#endif

	m_pProp.Release();

	m_pMux.Release();
	m_pTF.Release();

	m_pAS.Release();
	m_pVS.Release();


	m_pAR.Release();
	m_pVR.Release();


	m_pAC.Release();
	m_pVC.Release();

	m_pME.Release();
	m_pMC.Release();

	/*
	if (m_pGB)
	{
		CComPtr<IEnumFilters> fenum;
		HRESULT hr = m_pGB->EnumFilters(&fenum);
		if (SUCCEEDED(hr))
		{
			CComPtr<IBaseFilter> filter;
			ULONG fetched = 0;
			while (S_OK == fenum->Next(1, &filter, &fetched))
			{
				if (filter == NULL) { continue; }

				m_pGB->RemoveFilter(filter);
				fenum->Reset();
				filter.Release();
			}
		}
	}
	*/

	m_pCGB2.Release();
	m_pGB.Release();


	m_vecGraph.clear();

	// COMI
	if (m_bCoInitialize)
	{
		m_bCoInitialize = FALSE;
		CoUninitialize();
	}
}

BOOL CCaptureGraphBuilder::CreateBuilder(IGraphBuilder** ppGB, ICaptureGraphBuilder2** ppCGB2)
{
	if (ppGB == NULL || ppCGB2 == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;

	// IGraphBuilder擾
	hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC,
		IID_IGraphBuilder, (LPVOID *)ppGB);

	if (FAILED(hr) || *ppGB == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	// ICaptureGraphBuilder2擾
	hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC, 
		IID_ICaptureGraphBuilder2, (LPVOID *)ppCGB2);

	if (FAILED(hr) || *ppCGB2 == NULL)
	{
		(*ppGB)->Release();
		*ppGB = NULL;
		FAILED_TRACE;
		return FALSE;
	}

	// OtZbg
	hr = (*ppCGB2)->SetFiltergraph(*ppGB);

	if (FAILED(hr))
	{
		(*ppGB)->Release();
		*ppGB = NULL;
		(*ppCGB2)->Release();
		*ppCGB2 = NULL;
		FAILED_TRACE;
		return FALSE;
	}

	return TRUE;
}


BOOL CCaptureGraphBuilder::SetVideoCaptureFormat(IBaseFilter *pFilter, CVideoCaptureFormat &format)
{
	if (pFilter == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;
	CComPtr<ICaptureGraphBuilder2> pCGB2;
	CComPtr<IAMStreamConfig> pSC;
	int iCount = 0, iSize = 0;

	// ICaptureGraphBuilder2擾
	hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC, 
		IID_ICaptureGraphBuilder2, (LPVOID *)&pCGB2);

	if (FAILED(hr) || pCGB2 == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}


	hr = pCGB2->FindInterface(
		&PIN_CATEGORY_CAPTURE,	// Lv`[s
		&MEDIATYPE_Video,		// ׂẴfBA^Cv
		pFilter,				// Lv`tB^ւ̃|C^
		IID_IAMStreamConfig, (void**)&pSC);

	if (FAILED(hr) || pSC == NULL)
	{
		hr = pCGB2->FindInterface(
			&PIN_CATEGORY_PREVIEW,	// Lv`[s
			&MEDIATYPE_Video,		// ׂẴfBA^Cv
			pFilter,				// Lv`tB^ւ̃|C^
			IID_IAMStreamConfig, (void**)&pSC);

		if (FAILED(hr) || pSC == NULL)
		{
			FAILED_TRACE;
			return FALSE;
		}
	}

	hr = pSC->GetNumberOfCapabilities(&iCount, &iSize);
	if (FAILED(hr))
	{
		FAILED_TRACE;
		return FALSE;
	}

	LPBYTE pCap = new BYTE[iSize];

	if (pCap == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	int nIndex = 0;
	for (int i = 0; i < iCount; i++)
	{
		AM_MEDIA_TYPE *pMT = NULL;

		hr = pSC->GetStreamCaps(i, &pMT, (BYTE*)pCap);
		if (SUCCEEDED(hr) && pMT != NULL && pCap != NULL)
		{
			if (pMT->majortype == MEDIATYPE_Video &&
				pMT->formattype == FORMAT_VideoInfo &&
				pMT->cbFormat >= sizeof(VIDEOINFOHEADER) &&
				pMT->pbFormat != NULL)
			{
				if (format.nIndex == nIndex)
				{
					VIDEOINFOHEADER *pVih = reinterpret_cast<VIDEOINFOHEADER*>(pMT->pbFormat);
					if (pVih != NULL)
					{
						pVih->bmiHeader.biWidth = format.biWidth;
						pVih->bmiHeader.biHeight = format.biHeight;
						pVih->bmiHeader.biSizeImage = DIBSIZE(pVih->bmiHeader);

						pVih->AvgTimePerFrame = format.AvgTimePerFrame;


						// AiOrfIKiݒ
						CComPtr<IAMAnalogVideoDecoder> pDecorder;
						hr = pFilter->QueryInterface<IAMAnalogVideoDecoder>(&pDecorder);
						if (FAILED(hr) || pDecorder == NULL)
						{
							
						}
						else
						{
							pDecorder->put_TVFormat(format.lStandard);
						}

						hr = pSC->SetFormat(pMT);
						if (FAILED(hr))
						{
							DeleteMediaType(pMT);
							delete [] pCap;
							FAILED_TRACE;
							return FALSE;
						}

						m_bVideoFormatFourCC = pVih->bmiHeader.biCompression;
					}
					DeleteMediaType(pMT);
					break;
				}

				nIndex++;
			}

			DeleteMediaType(pMT);
		}
	}

	delete [] pCap;

	return TRUE;
}

BOOL CCaptureGraphBuilder::SetAudioCaptureFormat(IBaseFilter *pFilter, CAudioCaptureFormat &format)
{
	if (pFilter == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;

	CComPtr<ICaptureGraphBuilder2> pCGB2;
	CComPtr<IAMStreamConfig> pSC;
	CComPtr<IAMBufferNegotiation> pBN;
	int iCount = 0, iSize = 0;

	// ICaptureGraphBuilder2擾
	hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC, 
		IID_ICaptureGraphBuilder2, (LPVOID *)&pCGB2);

	if (FAILED(hr) || pCGB2 == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	pCGB2->FindInterface(
		&PIN_CATEGORY_CAPTURE,	// Lv`s^Cv
		&MEDIATYPE_Audio,		// I[fBIfBA^Cv
		pFilter,				// Lv`tB^ւ̃|C^
		IID_IAMBufferNegotiation, (void**)&pBN);

	hr = pCGB2->FindInterface(
		&PIN_CATEGORY_CAPTURE,	// Lv`s^Cv
		&MEDIATYPE_Audio,		// I[fBIfBA^Cv
		pFilter,				// Lv`tB^ւ̃|C^
		IID_IAMStreamConfig, (void**)&pSC);

	if (FAILED(hr) || pSC == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}


	hr = pSC->GetNumberOfCapabilities(&iCount, &iSize);
	if (FAILED(hr))
	{
		FAILED_TRACE;
		return FALSE;
	}

	LPBYTE pCap = new BYTE[iSize];

	if (pCap == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	int nIndex = 0;
	for (int i = 0; i < iCount; i++)
	{
		AM_MEDIA_TYPE *pMT = NULL;

		hr = pSC->GetStreamCaps(i, &pMT, (BYTE*)pCap);
		if (SUCCEEDED(hr) && pMT != NULL && pCap != NULL)
		{
			if (pMT->majortype == MEDIATYPE_Audio &&
				pMT->formattype == FORMAT_WaveFormatEx &&
				pMT->cbFormat >= sizeof(WAVEFORMATEX) &&
				pMT->pbFormat != NULL)
			{
				if (format.nIndex == nIndex)
				{
					WAVEFORMATEX *pWav = reinterpret_cast<WAVEFORMATEX*>(pMT->pbFormat);
					if (pWav != NULL)
					{
						if (pWav->wFormatTag == WAVE_FORMAT_PCM ||
							pWav->wFormatTag == WAVE_FORMAT_EXTENSIBLE)
						{
							pWav->nChannels = format.nChannels;
							pWav->wBitsPerSample = format.wBitsPerSample;
							pWav->nSamplesPerSec = format.nSamplesPerSec;

							pWav->nBlockAlign = (pWav->nChannels * pWav->wBitsPerSample) / 8;
						}

						hr = pSC->SetFormat(pMT);
						if (FAILED(hr))
						{
							DeleteMediaType(pMT);
							delete [] pCap;
							FAILED_TRACE;
							return FALSE;
						}

						if (pBN != NULL)
						{
							ALLOCATOR_PROPERTIES prop;
							prop.cbAlign = -1; // -1 ͗DvpeBȂƂӖĂB
							prop.cbPrefix = -1;
							prop.cBuffers = -1;

							// ʏAcbBufferύX邾ł
							// nAvgBytesPerSec = nSamplesPerSec * nBlockAlign
							int nBufferSizeMilliSeconds = 20;
							DWORD nAvgBytesPerSec = pWav->nSamplesPerSec * pWav->nBlockAlign;
							prop.cbBuffer = (nAvgBytesPerSec * nBufferSizeMilliSeconds) / 1000;

							hr = pBN->SuggestAllocatorProperties(&prop);
							if (FAILED(hr))
							{
								TRACE(L"[FAILED] IAMBufferNegotiation::SuggestAllocatorPropertiescbBuffer(cbBuffer) = %d\n", prop.cbBuffer);
							}
						}
					}
					DeleteMediaType(pMT);
					break;
				}
				nIndex++;
			}
			DeleteMediaType(pMT);
		}
	}

	delete [] pCap;

	return TRUE;
}


BOOL CCaptureGraphBuilder::GetFilter(long lFilterCategory, LPCWSTR pwszFriendlyName, LPCWSTR pwszDevicePath, IBaseFilter **ppFilter)
{
	if (pwszFriendlyName == NULL || pwszDevicePath == NULL || ppFilter == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;

	CComPtr<ICreateDevEnum> pCreateDevEnum;
	CComPtr<IEnumMoniker> pEnumMoniker;
	CComPtr<IMoniker> pMoniker;
	ULONG nFetched = 0;
	BOOL bResult = FALSE;

	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER, 
		IID_ICreateDevEnum, (LPVOID *)&pCreateDevEnum);
	if (FAILED(hr) || pCreateDevEnum == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	switch (lFilterCategory)
	{
	case FILTER_CATEGORY_VIDEO_CAPTURE:
		hr = pCreateDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory,
			&pEnumMoniker, 0);
		break;

	case FILTER_CATEGORY_AUDIO_CAPTURE:
		hr = pCreateDevEnum->CreateClassEnumerator(CLSID_AudioInputDeviceCategory,
			&pEnumMoniker, 0);
		break;

	default:
		hr = pCreateDevEnum->CreateClassEnumerator(CLSID_LegacyAmFilterCategory,
			&pEnumMoniker, 0);
		break;
	}

	if (FAILED(hr) || pEnumMoniker == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	hr = pEnumMoniker->Reset();
	if (FAILED(hr))
	{
		FAILED_TRACE;
		return FALSE;
	}


	while (pEnumMoniker->Next(1, &pMoniker, &nFetched) == S_OK)
	{
		if (pMoniker == NULL)
		{
			FAILED_TRACE;
			continue;
		}

		CComPtr<IPropertyBag> pPropertyBag;
		VARIANT var;
		std::wstring wsFriendlyName;
		std::wstring wsDevicePath;

		hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag,
			(void **)&pPropertyBag);

		if (FAILED(hr) || pPropertyBag == NULL)
		{
			pMoniker.Release();
			FAILED_TRACE;
			continue;
		}

		// FrienlyName : foCX̖O
		// vpeBׂ͂ẴfoCXŗpłB
		// lǂނƂłfoCXi[B
		var.vt = VT_BSTR;
		hr = pPropertyBag->Read(L"FriendlyName", &var, 0);

		if (FAILED(hr))
		{
			pMoniker.Release();
			FAILED_TRACE;
			continue;
		}
		else
		{
			wsFriendlyName = var.bstrVal;
		}

		VariantClear(&var);


		// DevicePath : ӂ̕
		// vpeB͐lǂނƂł镶ł͂ȂAfoCXƂɈӂł邱Ƃۏ؂ĂB
		// ̃vpeBgAfoCX̓ꃂf̕CX^XʂłB
		var.vt = VT_BSTR;
		hr = pPropertyBag->Read(L"DevicePath", &var, 0);

		if (FAILED(hr))
		{
			wsDevicePath = L"";
		}
		else
		{
			wsDevicePath = var.bstrVal;
		}

		VariantClear(&var);


		if (wsFriendlyName == pwszFriendlyName &&
			wsDevicePath == pwszDevicePath)
		{
			pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)ppFilter);
			pMoniker.Release();
			bResult = TRUE;
			break;
		}
		
		pMoniker.Release();
	}
	
	return bResult;
}

BOOL CCaptureGraphBuilder::ConnectFilter(
	IGraphBuilder *pGB, ICaptureGraphBuilder2 *pCGB2,
	IBaseFilter *pOutput, int nOutput, IBaseFilter *pInput, int nInput)
{
	if (pGB == NULL ||
		pCGB2 == NULL ||
		pOutput == NULL ||
		pInput == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IPin> pOutputPin;
	CComPtr<IPin> pInputPin;
	int nOut = 0, nIn = 0;

	if (nOutput < 0)
	{
		nOut = 0;
	}
	else
	{
		nOut = nOutput;
	}

	if (nInput < 0)
	{
		nIn = 0;
	}
	else
	{
		nIn = nInput;
	}

	for (;;)
	{
		hr = pCGB2->FindPin(pOutput, PINDIR_OUTPUT, NULL, NULL, FALSE, nOut, &pOutputPin);
		if (FAILED(hr) || pOutputPin == NULL)
		{
			FAILED_TRACE;
			return FALSE;
		}

		if (nInput < 0)
		{
			// ̓s͎ڑ
			for (;;)
			{
				hr = pCGB2->FindPin(pInput, PINDIR_INPUT, NULL, NULL, FALSE, nIn, &pInputPin);
				if (FAILED(hr) || pInputPin == NULL)
				{
					if (nOutput < 0)
					{
						// o̓sȂ玟̏o̓s擾
						pOutputPin.Release();
						nOut++;

						// JE^[Zbg
						nIn = 0;
						break;
					}
					else
					{
						// o̓s蓮Ȃ玸s
						FAILED_TRACE;
						return FALSE;
					}
				}

				hr = pGB->Connect(pOutputPin, pInputPin);
				if (FAILED(hr))
				{
					// ڑɎs玟̓̓s擾
					pInputPin.Release();
					nIn++;
					continue;
				}
				else
				{
					// ڑ
					return TRUE;
				}
			}
		}
		else
		{
			// ̓s͎蓮ڑ
			hr = pCGB2->FindPin(pInput, PINDIR_INPUT, NULL, NULL, FALSE, nIn, &pInputPin);
			if (FAILED(hr) || pInputPin == NULL)
			{
				if (nOutput < 0)
				{
					// o̓sȂ玟̏o̓s擾
					pOutputPin.Release();
					nOut++;
					continue;
				}
				else
				{
					// o̓s蓮Ȃ玸s
					FAILED_TRACE;
					return FALSE;
				}
			}

			hr = pGB->Connect(pOutputPin, pInputPin);
			if (FAILED(hr))
			{
				if (nOutput < 0)
				{
					// o̓sȂ玟̏o̓s擾
					pOutputPin.Release();
					pInputPin.Release();
					nOut++;
					continue;
				}
				else
				{
					// o̓s蓮Ȃ玸s
					FAILED_TRACE;
					return FALSE;
				}
			}
			else
			{
				// ڑ
				return TRUE;
			}
		}
	}

	FAILED_TRACE;
	return FALSE;
}

BOOL CCaptureGraphBuilder::ConnectHelperX(BOOL bVideo, BOOL bPreview,
	IGraphBuilder *pGB, ICaptureGraphBuilder2 *pCGB2,
	IBaseFilter *pCapture, IBaseFilter *pSmartTee, IBaseFilter *pTransform, IBaseFilter *pRenderer)
{
	if (pGB == NULL ||
		pCGB2 == NULL ||
		pCapture == NULL ||
		pSmartTee == NULL ||
		pTransform == NULL ||
		pRenderer == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr = E_FAIL;

	CComPtr<IPin> pCaptureOut; // Lv`[iój
	CComPtr<IPin> pSmartTeeIn; // X}[geB[íj
	CComPtr<IPin> pSmartTeeOut; // X}[geB[iój
	CComPtr<IPin> pTransformIn; // gXtH[
	CComPtr<IPin> pTransformOut;
	CComPtr<IPin> pRendererIn; // _íj


	// Lv`[iój
	if (bVideo)
	{
		hr = pCGB2->FindPin(pCapture, PINDIR_OUTPUT, &PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, TRUE, 0, &pCaptureOut);
		if (FAILED(hr) || pCaptureOut == NULL)
		{
			hr = pCGB2->FindPin(pCapture, PINDIR_OUTPUT, &PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, TRUE, 0, &pCaptureOut);
			if (FAILED(hr) || pCaptureOut == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}
		}
	}
	else
	{
		hr = pCGB2->FindPin(pCapture, PINDIR_OUTPUT, &PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, TRUE, 0, &pCaptureOut);
	}

	if (FAILED(hr) || pCaptureOut == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	// X}[geB[íj
	hr = pCGB2->FindPin(pSmartTee, PINDIR_INPUT, NULL, NULL, TRUE, 0, &pSmartTeeIn);
	if (FAILED(hr) || pSmartTeeIn == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	// ڑFLv`[iój  X}[geB[íj
	hr = pGB->Connect(pCaptureOut, pSmartTeeIn);
	if (FAILED(hr))
	{
		AddLog(L"Lv`[  X}[geB[ ڑs");
		FAILED_TRACE;
		return FALSE;
	}

	// X}[geB[iój
	if (bPreview)
	{
		hr = pCGB2->FindPin(pSmartTee, PINDIR_OUTPUT, NULL, NULL, TRUE, 1, &pSmartTeeOut);
	}
	else
	{
		hr = pCGB2->FindPin(pSmartTee, PINDIR_OUTPUT, NULL, NULL, TRUE, 0, &pSmartTeeOut);
	}

	if (FAILED(hr) || pSmartTeeOut == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}



	// gXtH[íj
	hr = pCGB2->FindPin(pTransform, PINDIR_INPUT, NULL, NULL, TRUE, 0, &pTransformIn);
	if (FAILED(hr) || pTransformIn == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}


	// ڑFX}[geB[iój  gXtH[íj
	hr = pGB->Connect(pSmartTeeOut, pTransformIn);
	if (FAILED(hr))
	{
		AddLog(L"X}[geB[  gXtH[ ڑs");
		FAILED_TRACE;
		return FALSE;
	}



	// gXtH[iój
	hr = pCGB2->FindPin(m_pTF, PINDIR_OUTPUT, NULL, NULL, TRUE, 0, &pTransformOut);
	if (FAILED(hr) || pTransformOut == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	// _íj
	hr = pCGB2->FindPin(pRenderer, PINDIR_INPUT, NULL, NULL, TRUE, 0, &pRendererIn);
	if (FAILED(hr) || pRendererIn == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}




	// ڑFgXtH[iój  _íj
	hr = pGB->Connect(pTransformOut, pRendererIn);
	if (FAILED(hr))
	{
		AddLog(L"gXtH[  _ ڑs");
		FAILED_TRACE;
		return FALSE;
	}



	return TRUE;
}



BOOL CCaptureGraphBuilder::ConnectHelper(BOOL bVideo, BOOL bPreview, std::vector<CFilterItem> &vecFilter,
	IGraphBuilder *pGB, ICaptureGraphBuilder2 *pCGB2,
	IBaseFilter *pCapture, IBaseFilter *pSmartTee, IBaseFilter *pRenderer)
{
	if (pGB == NULL ||
		pCGB2 == NULL ||
		pCapture == NULL ||
		pSmartTee == NULL ||
		pRenderer == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr = E_FAIL;


	CComPtr<IPin> pCaptureOut; // Lv`[iój
	CComPtr<IPin> pSmartTeeIn; // X}[geB[íj
	CComPtr<IPin> pSmartTeeOut; // X}[geB[iój
	CComPtr<IPin> pRendererIn; // _íj


	// Lv`[iój
	if (bVideo)
	{
		hr = pCGB2->FindPin(pCapture, PINDIR_OUTPUT, &PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, TRUE, 0, &pCaptureOut);
		if (FAILED(hr) || pCaptureOut == NULL)
		{
			hr = pCGB2->FindPin(pCapture, PINDIR_OUTPUT, &PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, TRUE, 0, &pCaptureOut);
			if (FAILED(hr) || pCaptureOut == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}
		}
	}
	else
	{
		hr = pCGB2->FindPin(pCapture, PINDIR_OUTPUT, &PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, TRUE, 0, &pCaptureOut);
	}

	if (FAILED(hr) || pCaptureOut == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	// X}[geB[íj
	hr = pCGB2->FindPin(pSmartTee, PINDIR_INPUT, NULL, NULL, TRUE, 0, &pSmartTeeIn);
	if (FAILED(hr) || pSmartTeeIn == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	// ڑFLv`[  X}[geB[
	hr = pGB->Connect(pCaptureOut, pSmartTeeIn);
	if (FAILED(hr))
	{
		AddLog(L"Lv`[  X}[geB[ ڑs");
		FAILED_TRACE;
		return FALSE;
	}



	if (vecFilter.size() > 0)
	{
		CComPtr<IBaseFilter> pOutput;
		CComPtr<IBaseFilter> pInput;

		std::wstring wsOutput;
		int nOutput = -1;

		int nCount = 0;
		std::vector<CFilterItem>::iterator it;
		for (it = vecFilter.begin(); it != vecFilter.end(); ++it)
		{
			if (it->bCheck == FALSE)
			{
				continue;
			}

			if (nCount == 0)
			{
				pInput.Release();
				if (!GetFilter(FILTER_CATEGORY_DIRECTSHOW, it->wsFriendlyName.c_str(), it->wsDevicePath.c_str(), &pInput))
				{
					AddLog(L"%s 擾s", it->wsFriendlyName.c_str());
					FAILED_TRACE;
					return FALSE;
				}

				hr = pGB->AddFilter(pInput, it->wsFriendlyName.c_str());
				if (FAILED(hr))
				{
					FAILED_TRACE;
					return FALSE;
				}


				if (!ConnectFilter(pGB, pCGB2, pSmartTee, bPreview ? 1 : 0, pInput, it->nInput))
				{
					AddLog(L"X}[geB[  %s ڑs", it->wsFriendlyName.c_str());
					FAILED_TRACE;
					return FALSE;
				}

				wsOutput = it->wsFriendlyName;
				nOutput = it->nOutput;
				pOutput.Release();
				pOutput = pInput;
			}
			else
			{
				pInput.Release();
				if (!GetFilter(FILTER_CATEGORY_DIRECTSHOW, it->wsFriendlyName.c_str(), it->wsDevicePath.c_str(), &pInput))
				{
					AddLog(L"%d 擾s", it->wsFriendlyName.c_str());
					FAILED_TRACE;
					return FALSE;
				}

				hr = pGB->AddFilter(pInput, it->wsFriendlyName.c_str());
				if (FAILED(hr))
				{
					FAILED_TRACE;
					return FALSE;
				}


				if (!ConnectFilter(pGB, pCGB2, pOutput, nOutput, pInput, it->nInput))
				{
					AddLog(L"%s  %s ڑs", wsOutput.c_str(), it->wsFriendlyName.c_str());
					FAILED_TRACE;
					return FALSE;
				}

				wsOutput = it->wsFriendlyName;
				nOutput = it->nOutput;
				pOutput.Release();
				pOutput = pInput;
			}
			nCount++;
		}

		if (nCount == 0)
		{

			if (!ConnectFilter(pGB, pCGB2, pSmartTee, bPreview ? 1 : 0, pRenderer, 0))
			{
				AddLog(L"X}[geB[  _ ڑs");
				FAILED_TRACE;
				return FALSE;
			}
		}
		else
		{
			if (!ConnectFilter(pGB, pCGB2, pOutput, nOutput, pRenderer, 0))
			{
				AddLog(L"%s  _ ڑs", wsOutput.c_str());
				FAILED_TRACE;
				return FALSE;
			}
		}
	}
	else
	{
		// X}[geB[iój
		if (bPreview)
		{
			hr = pCGB2->FindPin(pSmartTee, PINDIR_OUTPUT, NULL, NULL, TRUE, 1, &pSmartTeeOut);
		}
		else
		{
			hr = pCGB2->FindPin(pSmartTee, PINDIR_OUTPUT, NULL, NULL, TRUE, 0, &pSmartTeeOut);
		}

		if (FAILED(hr) || pSmartTeeOut == NULL)
		{
			FAILED_TRACE;
			return FALSE;
		}

		// _íj
		hr = pCGB2->FindPin(pRenderer, PINDIR_INPUT, NULL, NULL, TRUE, 0, &pRendererIn);
		if (FAILED(hr) || pRendererIn == NULL)
		{
			FAILED_TRACE;
			return FALSE;
		}

		// ڑFX}[geB[iój  _íj
		hr = pGB->Connect(pSmartTeeOut, pRendererIn);
		if (FAILED(hr))
		{
			AddLog(L"X}[geB[  _ ڑs");
			FAILED_TRACE;
			return FALSE;
		}
	}

	return TRUE;
}



BOOL CCaptureGraphBuilder::ConnectMux(BOOL bVideo, BOOL bPreview,
	IGraphBuilder *pGB, ICaptureGraphBuilder2 *pCGB2, IBaseFilter *pTee)
{
	if (pGB == NULL ||
		pCGB2 == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;

	// MuxtB^
	if (m_pMux == NULL)
	{
		m_pMux = new CAVIMuxFilter(NULL, &hr);
		if (FAILED(hr) || m_pMux == NULL)
		{
			AddLog(L"MuxtB^擾s");
			FAILED_TRACE;
			return FALSE;
		}

		hr = pGB->AddFilter(m_pMux, L"PeCaTV AVI Mux");
		if (FAILED(hr))
		{
			FAILED_TRACE;
			return FALSE;
		}
	}

	if (!ConnectFilter(pGB, pCGB2, pTee, bPreview ? 0 : 1, m_pMux, bVideo ? 0 : 1))
	{
		if (bVideo)
		{
			AddLog(L"rfIX}[geB[  AVI Mux (Video In) ڑs");
		}
		else
		{
			AddLog(L"rfIX}[geB[  AVI Mux (Audio In) ڑs");
		}
		FAILED_TRACE;
		return FALSE;
	}

	return TRUE;
}



BOOL CCaptureGraphBuilder::Preview(HWND hWnd, CCaptureGraphProfile &profile)
{
	HRESULT hr;

	ResetLog();

	m_hWnd = hWnd;
	m_lVideoRenderer = profile.Preview.lVideoRenderer;

	if (!::IsWindow(m_hWnd))
	{
		FAILED_TRACE;
		return FALSE;
	}

	if (profile.Video.wsFriendlyName == L"" && profile.Video.wsDevicePath == L"" &&
		profile.Audio.wsFriendlyName == L"" && profile.Audio.wsDevicePath == L"")
	{
		AddLog(L"vt@Cݒ肳Ă܂");
		FAILED_TRACE;
		return FALSE;
	}

	// Otr_[
	if (!CreateBuilder(&m_pGB, &m_pCGB2))
	{
		AddLog(L"IGraphBuilder/ICaptureGraphBuilder2̏s");
		FAILED_TRACE;
		return FALSE;
	}

	// IMediaControl
	hr = m_pGB->QueryInterface<IMediaControl>(&m_pMC);
	if (FAILED(hr) || m_pMC == NULL)
	{
		AddLog(L"IMediaControl̎擾s");
		FAILED_TRACE;
		return FALSE;
	}

	// IMediaEventEx WM_GRAPH_NOTIFYCxgݒ
	hr = m_pGB->QueryInterface<IMediaEventEx>(&m_pME);
	if (FAILED(hr) || m_pME == NULL)
	{
		AddLog(L"IMediaEventEx̎擾s");
		FAILED_TRACE;
		return FALSE;
	}

	hr = m_pME->SetNotifyWindow((OAHWND)m_hWnd, WM_GRAPH_NOTIFY, 0);
	if (FAILED(hr))
	{
		FAILED_TRACE;
		return FALSE;
	}

//-------------------------------------------------------------------------------------

	if (profile.Video.wsFriendlyName != L"" || profile.Video.wsDevicePath != L"")
	{
		int nVideoFilterCount = 0;

		std::vector<CFilterItem>::iterator it;
		for (it = profile.Filter.vecVideo.begin(); it != profile.Filter.vecVideo.end(); ++it)
		{
			if (it->bCheck)
			{
				nVideoFilterCount++;
			}
		}

		
		if (nVideoFilterCount <= 0 &&
			profile.Preview.bTransform &&
			profile.Preview.lTransformCopy == TRANSFORM_COPY_HARDWARE &&
			profile.Preview.lTransformFrame == TRANSFORM_FRAME_DOUBLE)
		{
			// rfICtBjbgseB[
			hr = CoCreateInstance(CLSID_InfTee, 0, CLSCTX_INPROC_SERVER,
				IID_IBaseFilter, (void**)&m_pVS);
			if (FAILED(hr))
			{
				AddLog(L"rfICtBjbgseB[擾s");
				FAILED_TRACE;
				return FALSE;
			}

			hr = m_pGB->AddFilter(m_pVS, L"Video InfTee");
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}
		}
		else
		{
			if (profile.Preview.bVideoPreviewPin)
			{
				// rfIX}[geB[
				hr = CoCreateInstance(CLSID_SmartTee, 0, CLSCTX_INPROC_SERVER,
					IID_IBaseFilter, (void**)&m_pVS);
				if (FAILED(hr))
				{
					AddLog(L"rfIX}[geB[擾s");
					FAILED_TRACE;
					return FALSE;
				}

				hr = m_pGB->AddFilter(m_pVS, L"Video SmartTee");
				if (FAILED(hr))
				{
					FAILED_TRACE;
					return FALSE;
				}
			}
			else
			{
				// rfICtBjbgseB[
				hr = CoCreateInstance(CLSID_InfTee, 0, CLSCTX_INPROC_SERVER,
					IID_IBaseFilter, (void**)&m_pVS);
				if (FAILED(hr))
				{
					AddLog(L"rfICtBjbgseB[擾s");
					FAILED_TRACE;
					return FALSE;
				}

				hr = m_pGB->AddFilter(m_pVS, L"Video InfTee");
				if (FAILED(hr))
				{
					FAILED_TRACE;
					return FALSE;
				}
			}
		}

		// rfI_
		if (m_lVideoRenderer == VIDEO_RENDERER_VMR9)
		{
			hr = CoCreateInstance(CLSID_VideoMixingRenderer9, 0, CLSCTX_INPROC_SERVER,
				IID_IBaseFilter, (void**)&m_pVR);
			if (FAILED(hr) || m_pVR == NULL)
			{
				AddLog(L"VMR9擾s");
				FAILED_TRACE;
				return FALSE;
			}

			hr = m_pGB->AddFilter(m_pVR, L"Video Mixing Renderer9");
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			// EBhX[hɕύX
			// tB^ڑOɐݒ肷Kv
			CComPtr<IVMRFilterConfig9> pFC;
			hr = m_pVR->QueryInterface<IVMRFilterConfig9>(&pFC);
			if (FAILED(hr) || pFC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pFC->SetRenderingMode(VMR9Mode_Windowless);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			// EBhE蓖Ă
			// tB^ڑOɐݒ肷Kv
			CComPtr<IVMRWindowlessControl9> pWC; 
			hr = m_pVR->QueryInterface<IVMRWindowlessControl9>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pWC->SetVideoClippingWindow(m_hWnd);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			// AXyNgKpȂ
			hr = pWC->SetAspectRatioMode(VMR9ARMode_None);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}
		}
		else if (m_lVideoRenderer == VIDEO_RENDERER_EVR)
		{
			hr = CoCreateInstance(CLSID_EnhancedVideoRenderer, 0, CLSCTX_INPROC_SERVER,
				IID_IBaseFilter, (void**)&m_pVR);
			if (FAILED(hr) || m_pVR == NULL)
			{
				AddLog(L"EVR擾s");
				FAILED_TRACE;
				return FALSE;
			}

			hr = m_pGB->AddFilter(m_pVR, L"Enhanced Video Renderer");
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			CComPtr<IMFGetService> pGS;
			hr = m_pVR->QueryInterface<IMFGetService>(&pGS);
			if (FAILED(hr) || pGS == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			CComPtr<IMFVideoDisplayControl> pDC;
			hr = pGS->GetService(MR_VIDEO_RENDER_SERVICE,
				IID_IMFVideoDisplayControl, (void**)&pDC);
			if (FAILED(hr) || pDC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pDC->SetVideoWindow(m_hWnd);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			// AXyNgKpȂ
			hr = pDC->SetAspectRatioMode(MFVideoARMode_None);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			/*
			CComPtr<IEVRFilterConfig> pFC;
			hr = m_pVR->QueryInterface<IEVRFilterConfig>(&pFC);
			if (FAILED(hr) || pFC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			pFC->SetNumberOfStreams(1);
			*/
		}
		else if (m_lVideoRenderer == VIDEO_RENDERER_EVR_CUSTOM)
		{
			hr = CoCreateInstance(CLSID_EnhancedVideoRenderer, 0, CLSCTX_INPROC_SERVER,
				IID_IBaseFilter, (void**)&m_pVR);
			if (FAILED(hr) || m_pVR == NULL)
			{
				AddLog(L"EVR擾s");
				FAILED_TRACE;
				return FALSE;
			}

			CComPtr<IMFVideoPresenter> pVP;
			EVRCustomPresenter::CreateInstance(&pVP);
			if (!pVP) { return FALSE; }

			pVP->QueryInterface(IID_ICustomRenderProp, (void**)&m_pProp);

			CComQIPtr<IMFVideoRenderer, &IID_IMFVideoRenderer> pVR(m_pVR);
			if (!pVR) { return FALSE; }

			HRESULT hr = pVR->InitializeRenderer(NULL, pVP);
			if (FAILED(hr)) { return FALSE; }


			hr = m_pGB->AddFilter(m_pVR, L"Enhanced Video Renderer Custom");
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			CComPtr<IMFGetService> pGS;
			hr = m_pVR->QueryInterface<IMFGetService>(&pGS);
			if (FAILED(hr) || pGS == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			CComPtr<IMFVideoDisplayControl> pDC;
			hr = pGS->GetService(MR_VIDEO_RENDER_SERVICE,
				IID_IMFVideoDisplayControl, (void**)&pDC);
			if (FAILED(hr) || pDC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pDC->SetVideoWindow(m_hWnd);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			// fC^[[Xݒ
			if (profile.Preview.bTransform &&
				profile.Preview.lTransformCopy == TRANSFORM_COPY_HARDWARE)
			{
				CComPtr<IMFVideoMixerControl2> vmc2;
				hr = pGS->GetService(MR_VIDEO_MIXER_SERVICE,
					IID_IMFVideoMixerControl2, (void**)&vmc2);
				if (vmc2)
				{
					hr = vmc2->SetMixingPrefs(MFVideoMixPrefs_ForceBob);
				}
			}

			// AXyNgKpȂ
			hr = pDC->SetAspectRatioMode(MFVideoARMode_None);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			m_pProp->SetResizer(d3dutl::RESIZER_SHADER_2PASS_LANCZOS3);
		}
		else
		{
			hr = CoCreateInstance(CLSID_VideoMixingRenderer, 0, CLSCTX_INPROC_SERVER,
				IID_IBaseFilter, (void**)&m_pVR);
			if (FAILED(hr) || m_pVR == NULL)
			{
				AddLog(L"VMR7擾s");
				FAILED_TRACE;
				return FALSE;
			}

			hr = m_pGB->AddFilter(m_pVR, L"Video Mixing Renderer 7");
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			// EBhX[hɕύX
			// tB^ڑOɐݒ肷Kv
			CComPtr<IVMRFilterConfig> pFC;
			hr = m_pVR->QueryInterface<IVMRFilterConfig>(&pFC);
			if (FAILED(hr) || pFC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pFC->SetRenderingMode(VMRMode_Windowless);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			if (m_lVideoRenderer == VIDEO_RENDERER_VMR7_OFFSCREEN)
			{
				hr = pFC->SetRenderingPrefs(RenderPrefs_ForceOffscreen);
				if (FAILED(hr))
				{
					FAILED_TRACE;
					return FALSE;
				}
			}

			// EBhE蓖Ă
			// tB^ڑOɐݒ肷Kv
			CComPtr<IVMRWindowlessControl> pWC; 
			hr = m_pVR->QueryInterface<IVMRWindowlessControl>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pWC->SetVideoClippingWindow(m_hWnd);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			// AXyNgKpȂ
			hr = pWC->SetAspectRatioMode(VMR_ARMODE_NONE);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}
		}

		// rfILv`[tB^[
		if (!GetFilter(FILTER_CATEGORY_VIDEO_CAPTURE, profile.Video.wsFriendlyName.c_str(), profile.Video.wsDevicePath.c_str(), &m_pVC))
		{
			AddLog(L"rfILv`[tB^擾s");
			FAILED_TRACE;
			return FALSE;
		}

		hr = m_pGB->AddFilter(m_pVC, profile.Video.wsFriendlyName.c_str());
		if (FAILED(hr))
		{
			FAILED_TRACE;
			return FALSE;
		}

		// tH[}bgݒ
		if (profile.Video.Format.nIndex >= 0)
		{ //tH[}bgԍ0菬Ȃݒ肵Ȃ

			m_bVideoFormatFourCC = 0;
			if (!SetVideoCaptureFormat(m_pVC, profile.Video.Format))
			{
				AddLog(L"rfILv`[tB^̃tH[}bgύXs");
				FAILED_TRACE;
				return FALSE;
			}

			// m_bVideoFormatFourCC  SetVideoCaptureFormat Őݒ肳ĂKvB
			if (m_lVideoRenderer == VIDEO_RENDERER_VMR7 ||
				m_lVideoRenderer == VIDEO_RENDERER_VMR7_OFFSCREEN)
			{
				if (profile.Preview.bTransform &&
					profile.Preview.lTransformCopy == TRANSFORM_COPY_HARDWARE)
				{
					// Packed Format YUV422
					if (m_bVideoFormatFourCC == MAKEFOURCC('Y', 'U', 'Y', '2') || // Y0, U0, Y1, V0
						m_bVideoFormatFourCC == MAKEFOURCC('U', 'Y', 'V', 'Y') || // U0, Y0, V0, Y1
						m_bVideoFormatFourCC == MAKEFOURCC('H', 'D', 'Y', 'C'))
					{
						CComPtr<IVMRFilterConfig> pFC;
						hr = m_pVR->QueryInterface<IVMRFilterConfig>(&pFC);
						if (FAILED(hr) || pFC == NULL)
						{
							FAILED_TRACE;
							return FALSE;
						}

						// Mixing[hɕύX
						hr = pFC->SetNumberOfStreams(1);
						if (FAILED(hr))
						{
							FAILED_TRACE;
							return FALSE;
						}

						CComPtr<IVMRMixerControl> pMC;
						hr = m_pVR->QueryInterface<IVMRMixerControl>(&pMC);
						if (FAILED(hr) || pMC == NULL)
						{
							FAILED_TRACE;
							return FALSE;
						}

						DWORD dwPrefs = MixerPref_NoDecimation | MixerPref_RenderTargetYUV | MixerPref_BiLinearFiltering;

						hr = pMC->SetMixingPrefs(dwPrefs);
						if (FAILED(hr))
						{
							FAILED_TRACE;
							return FALSE;
						}
					}
				}
			}
		}

		// tB^ڑ
		if (profile.Preview.bTransform == FALSE)
		{
			if (!ConnectHelper(TRUE, profile.Preview.bVideoPreviewPin, profile.Filter.vecVideo,
				m_pGB, m_pCGB2,
				m_pVC, m_pVS, m_pVR))
			{
				AddLog(L"rfILv`[tB^ڑs");
				FAILED_TRACE;
				return FALSE;
			}
		}
		else
		{
			// OtB^ȂtB^ڑȂ
			if (nVideoFilterCount > 0)
			{
				if (!ConnectHelper(TRUE, profile.Preview.bVideoPreviewPin, profile.Filter.vecVideo,
					m_pGB, m_pCGB2,
					m_pVC, m_pVS, m_pVR))
				{
					AddLog(L"rfILv`[tB^ڑs");
					FAILED_TRACE;
					return FALSE;
				}
			}
			else
			{
				// gXtH[tB^
				if (m_pTF == NULL)
				{
					m_pTF = new CMyTransform(NULL, &hr);
					if (FAILED(hr) || m_pTF == NULL)
					{
						FAILED_TRACE;
						return FALSE;
					}

					hr = m_pGB->AddFilter(m_pTF, L"PeCaTV Transform");
					if (FAILED(hr))
					{
						FAILED_TRACE;
						return FALSE;
					}
				}
				else
				{
					FAILED_TRACE;
					return FALSE;
				}

				SetTransformCopy(profile.Preview.lTransformCopy);
				SetTransformFrame(profile.Preview.lTransformFrame);
				SetTransformFieldOrder(profile.Preview.lTransformFieldOrder);
				SetTransformFlipVertical(profile.Preview.bTransformFlipVertical);
				SetTransformYCExpand(profile.Preview.lTransformYCExpand);


				if (nVideoFilterCount <= 0 &&
					profile.Preview.bTransform &&
					profile.Preview.lTransformCopy == TRANSFORM_COPY_HARDWARE &&
					profile.Preview.lTransformFrame == TRANSFORM_FRAME_DOUBLE)
				{
					if (!ConnectHelperX(TRUE, FALSE,
						m_pGB, m_pCGB2,
						m_pVC, m_pVS, m_pTF, m_pVR))
					{
						AddLog(L"rfILv`[tB^ڑs");
						FAILED_TRACE;
						return FALSE;
					}
				}
				else
				{
					if (!ConnectHelperX(TRUE, profile.Preview.bVideoPreviewPin,
						m_pGB, m_pCGB2,
						m_pVC, m_pVS, m_pTF, m_pVR))
					{
						AddLog(L"rfILv`[tB^ڑs");
						FAILED_TRACE;
						return FALSE;
					}
				}
			}
		}
/*
		if (!ConnectMux(TRUE, profile.Preview.bVideoPreviewPin,
			m_pGB, m_pCGB2, m_pVS))
		{
			AddLog(L"MuxtB^ڑs");
			FAILED_TRACE;
			return FALSE;
		}
*/
	}



//---------------------------------------------------------------------------------
	if (profile.Audio.wsFriendlyName != L"" || profile.Audio.wsDevicePath != L"")
	{
		if (profile.Preview.bAudioPreviewPin)
		{
			// I[fBIX}[geB[
			hr = CoCreateInstance(CLSID_SmartTee, 0, CLSCTX_INPROC_SERVER,
				IID_IBaseFilter, (void**)&m_pAS);
			if (FAILED(hr) || m_pAS == NULL)
			{
				AddLog(L"I[fBIX}[geB[擾s");
				FAILED_TRACE;
				return FALSE;
			}

			hr = m_pGB->AddFilter(m_pAS, L"Audio SmartTee");
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}
		}
		else
		{
			// I[fBICtBjbgseB[
			hr = CoCreateInstance(CLSID_InfTee, 0, CLSCTX_INPROC_SERVER,
				IID_IBaseFilter, (void**)&m_pAS);
			if (FAILED(hr))
			{
				AddLog(L"rfICtBjbgseB[擾s");
				FAILED_TRACE;
				return FALSE;
			}

			hr = m_pGB->AddFilter(m_pAS, L"Audio InfTee");
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}
		}

		// I[fBI_
		if (profile.Preview.lAudioRenderer == AUDIO_RENDERER_WAVEOUT)
		{
			hr = CoCreateInstance(CLSID_AudioRender, 0, CLSCTX_INPROC_SERVER,
				IID_IBaseFilter, (void**)&m_pAR);
			if (FAILED(hr) || m_pAR == NULL)
			{
				AddLog(L"WaveOut Renderer擾s");
				FAILED_TRACE;
				return FALSE;
			}
			
			hr = m_pGB->AddFilter(m_pAR, L"WaveOut Renderer");
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}
		}
		else
		{
			hr = CoCreateInstance(CLSID_DSoundRender, 0, CLSCTX_INPROC_SERVER,
				IID_IBaseFilter, (void**)&m_pAR);
			if (FAILED(hr) || m_pAR == NULL)
			{
				AddLog(L"DirectSound Renderer擾s");
				FAILED_TRACE;
				return FALSE;
			}
			
			hr = m_pGB->AddFilter(m_pAR, L"DirectSound Renderer");
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}
		}


		/*
		// Wb^[e͈
		CComPtr<IAMClockSlave> pCS;
		m_pAR->QueryInterface<IAMClockSlave>(&pCS);
		hr = pCS->SetErrorTolerance(500);
		*/

		if (profile.Video.wsFriendlyName == profile.Audio.wsFriendlyName &&
			profile.Video.wsDevicePath == profile.Audio.wsDevicePath)
		{
			// rfI`v`[tB^ƃI[fBILv`[tB^ꍇ
			if (m_pVC == NULL)
			{
				AddLog(L"I[fBILv`[prfILv`[tB^擾s");
				FAILED_TRACE;
				return FALSE;
			}

			m_pAC = m_pVC;
		}
		else
		{
			// I[fBILv`[tB^[
			if (!GetFilter(FILTER_CATEGORY_AUDIO_CAPTURE, profile.Audio.wsFriendlyName.c_str(), profile.Audio.wsDevicePath.c_str(), &m_pAC))
			{
				if (!GetFilter(FILTER_CATEGORY_VIDEO_CAPTURE, profile.Audio.wsFriendlyName.c_str(), profile.Audio.wsDevicePath.c_str(), &m_pAC))
				{
					AddLog(L"I[fBILv`[tB^擾s");
					FAILED_TRACE;
					return FALSE;
				}
			}

			hr = m_pGB->AddFilter(m_pAC, profile.Audio.wsFriendlyName.c_str());
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}
		}


		// tH[}bgݒ
		if (profile.Audio.Format.nIndex >= 0)
		{ //tH[}bgԍ0菬Ȃݒ肵Ȃ
			if (!SetAudioCaptureFormat(m_pAC, profile.Audio.Format))
			{
				AddLog(L"I[fBILv`[tB^ݒύXs");
				FAILED_TRACE;
				return FALSE;
			}
		}


		if (!ConnectHelper(FALSE, profile.Preview.bAudioPreviewPin, profile.Filter.vecAudio,
			m_pGB, m_pCGB2,
			m_pAC, m_pAS, m_pAR))
		{
			AddLog(L"I[fBILv`[tB^ڑs");
			FAILED_TRACE;
			return FALSE;
		}
/*
		if (!ConnectMux(FALSE, profile.Preview.bAudioPreviewPin,
			m_pGB, m_pCGB2, m_pAS))
		{
			AddLog(L"MuxtB^ڑs");
			FAILED_TRACE;
			return FALSE;
		}
*/
	}
//--------------------------------------------------------------------------------------------

	CComPtr<IAMGraphStreams> pGS;
	m_pGB->QueryInterface<IAMGraphStreams>(&pGS);
	pGS->SyncUsingStreamOffset(TRUE);

	// IBasicVideo
	if (!GetNativeVideoSize(&m_lVideoWidth, &m_lVideoHeight))
	{
		m_lVideoWidth = 640;
		m_lVideoHeight = 480;
	}

	if (m_lVideoWidth <= 0 || m_lVideoHeight <= 0)
	{
		m_lVideoWidth = 640;
		m_lVideoHeight = 480;
	}


	switch(profile.Preview.lAspectRatio)
	{
	case ASPECT_RATIO_INPUT:
		SetAspectRatio(-1, -1);
		break;

	case ASPECT_RATIO_4_3:
		SetAspectRatio(4, 3);
		break;

	case ASPECT_RATIO_16_9:
		SetAspectRatio(16, 9);
		break;

	case ASPECT_RATIO_40_33:
		SetAspectRatio(40, 33);
		break;

	case ASPECT_RATIO_10_11:
		SetAspectRatio(10, 11);
		break;

	case ASPECT_RATIO_CUSTOM:
		SetAspectRatio(profile.Preview.nAspectX, profile.Preview.nAspectY);
		break;

	case ASPECT_RATIO_WINDOW:
		SetAspectRatio(-2, -2);
		break;
	default:
		SetAspectRatio(-1, -1);
		break;
	}


	// }EXzC[悤ɐeEBhEɃtH[JXn
	::SetFocus(m_hWnd);

//------------------------------------------------------------------------------------

	// NXo[ݒ
	if (m_pVC != NULL)
	{
		int nCount = (int)profile.Video.vecCrossbar.size();
		if (nCount > 0)
		{
			CComPtr<IAMCrossbar> pXBar;
			hr = m_pCGB2->FindInterface(&LOOK_UPSTREAM_ONLY, NULL, m_pVC,
				IID_IAMCrossbar, (void**)&pXBar);

			if (SUCCEEDED(hr) && pXBar != NULL) 
			{
				std::vector<CCrossbar>::iterator it;
				for (it = profile.Video.vecCrossbar.begin(); it != profile.Video.vecCrossbar.end(); ++it)
				{
					if (it->lInput >= 0 && it->lOutput >= 0)
					{
						pXBar->Route(it->lOutput, it->lInput);
					}
				}
			}
		}
	}

#ifdef _DEBUG
	AddToRot(m_pGB);
	DumpGraph(m_pGB, 0);
#endif

	if (profile.Preview.bAudioMute)
	{
		SetAudioVolume(0);
	}
	else
	{
		SetAudioVolume(profile.Preview.nAudioVolume);
	}

	GetFilterGraph(m_pGB, m_vecGraph);

	Pause();
	Run();

	SetVideoProcAmpConfig(profile.VideoProcAmp);

	// f
	if (profile.Preview.lVideoRenderer == VIDEO_RENDERER_VMR9)
	{
		SetVMR9ProcAmp(profile.VMR9ProcAmp);
	}
	else if (
		profile.Preview.lVideoRenderer == VIDEO_RENDERER_EVR ||
		profile.Preview.lVideoRenderer == VIDEO_RENDERER_EVR_CUSTOM)
	{
		SetEVRProcAmp(profile.EVRProcAmp);
	}

	// NbsO
	SetCroppingRect(profile.Preview.rcCropping);

	// TCU[
	SetResizer(profile.Preview.lResizer);

	return TRUE;
}

BOOL CCaptureGraphBuilder::GetFilterGraph(IGraphBuilder *pGB, std::vector<CFilterGraph> &vecGraph)
{
	vecGraph.clear();

	if (pGB == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IEnumFilters> pEnum;
	CComPtr<IBaseFilter> pFilter;
	ULONG cFetched;

	hr = pGB->EnumFilters(&pEnum);
	if (FAILED(hr) || pEnum == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	hr = pEnum->Reset();
	if (FAILED(hr))
	{
		FAILED_TRACE;
		return FALSE;
	}

	while (pEnum->Next(1, &pFilter, &cFetched) == S_OK)
	{
		CFilterGraph filter;

		if (pFilter == NULL)
		{
			filter.wsFriendlyName = L"ERROR: pFilter == NULL";
			filter.bHasProperty = FALSE;
			vecGraph.push_back(filter);
            continue;
		}

        FILTER_INFO FilterInfo;
		::memset(&FilterInfo, 0, sizeof(FILTER_INFO));
		FilterInfo.pGraph = NULL; // Ô

        hr = pFilter->QueryFilterInfo(&FilterInfo);
        if (FAILED(hr))
        {
			filter.wsFriendlyName = L"ERROR: QueryFilterInfo";
			filter.bHasProperty = FALSE;
			vecGraph.push_back(filter);

			pFilter.Release();
            continue;
        }

		FilterInfo.achName[128 - 1] = L'\0'; // Ô
		filter.wsFriendlyName = FilterInfo.achName;

        if (FilterInfo.pGraph != NULL)
        {
            FilterInfo.pGraph->Release();
        }


		CComPtr<ISpecifyPropertyPages> pSPP;
		hr = pFilter->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pSPP);
		if (FAILED(hr) || pSPP == NULL)
		{
			filter.bHasProperty = FALSE;
			vecGraph.push_back(filter);

			pFilter.Release();
			continue;
		}

		CAUUID caGUID;
		caGUID.cElems = 0;
		caGUID.pElems = NULL;
		hr = pSPP->GetPages(&caGUID);
		if (FAILED(hr) || caGUID.cElems <= 0 || caGUID.pElems == NULL)
		{
			if (caGUID.pElems != NULL)
			{
				CoTaskMemFree(caGUID.pElems);
			}

			filter.bHasProperty = FALSE;
			vecGraph.push_back(filter);

			pFilter.Release();
			continue;
		}

		filter.bHasProperty = TRUE;

		vecGraph.push_back(filter);

		CoTaskMemFree(caGUID.pElems);
		pFilter.Release();
	}

	std::reverse(vecGraph.begin(), vecGraph.end());

	return TRUE;
}

BOOL CCaptureGraphBuilder::GetFilterGraph(std::vector<CFilterGraph> &vecGraph)
{
	vecGraph.clear();
	if (m_pGB)
	{
		vecGraph = m_vecGraph;
		return TRUE;
	}

	FAILED_TRACE;
	return FALSE;
}

BOOL CCaptureGraphBuilder::ShowFilterProperty(int nIndex)
{
	if (m_pGB == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	std::wstring wsFriendlyName;

	try
	{
		if (m_vecGraph.at(nIndex).bHasProperty != TRUE)
		{
			FAILED_TRACE;
			return FALSE;
		}

		wsFriendlyName = m_vecGraph.at(nIndex).wsFriendlyName;

	}
	catch (std::exception const&)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IBaseFilter> pFilter;
	hr = m_pGB->FindFilterByName(wsFriendlyName.c_str(), &pFilter);
	if (FAILED(hr) || pFilter == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	CComPtr<ISpecifyPropertyPages> pSPP;
	hr = pFilter->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pSPP);
	if (FAILED(hr) || pSPP == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	CAUUID caGUID;
	caGUID.cElems = 0;
	caGUID.pElems = NULL;
	hr = pSPP->GetPages(&caGUID);
	if (FAILED(hr) || caGUID.cElems <= 0 || caGUID.pElems == NULL)
	{
		if (caGUID.pElems != NULL)
		{
			CoTaskMemFree(caGUID.pElems);
		}

		FAILED_TRACE;
		return FALSE;
	}

	IUnknown *pFilterUnk = NULL;
	hr = pFilter->QueryInterface(IID_IUnknown, (void **)&pFilterUnk);
	if (FAILED(hr) || pFilterUnk == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	// vpeB\̒OɃtbNd
	HOOK::Hook(m_hWnd, AfxGetApp()->m_hInstance, GetCurrentThreadId());

	hr = OleCreatePropertyFrame(
		m_hWnd,                 // eEBhE
		0,                      // x (\ς)
		0,                      // y (\ς)
		wsFriendlyName.c_str(), // _CAO {bNX̃LvV
		1,                      // tB^̐
		&pFilterUnk,			// tB^ւ̃|C^
		caGUID.cElems,          // vpeB y[W̐
		caGUID.pElems,          // vpeB y[W CLSID ւ̃|C^
		LOCALE_USER_DEFAULT,                      // P[ʎq
		0,                      // \ς
		NULL                    // \ς
		);

	if (caGUID.pElems != NULL)
	{
		CoTaskMemFree(caGUID.pElems);
	}

	if (pFilterUnk != NULL)
	{
		pFilterUnk->Release();
	}

	return TRUE;
}

BOOL CCaptureGraphBuilder::SetTransformCopy(long _trans_copy)
{
	if (m_pTF == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IPeCaTVFilterCtrl> pFC;
	hr = m_pTF->QueryInterface(IID_IPeCaTVFilterCtrl, (void**)&pFC);

	if (FAILED(hr) || pFC == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	pFC->SetTransformCopy(_trans_copy);

	return TRUE;
}

BOOL CCaptureGraphBuilder::SetTransformFrame(long _trans_frame)
{
	if (m_pTF == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IPeCaTVFilterCtrl> pFC;
	hr = m_pTF->QueryInterface(IID_IPeCaTVFilterCtrl, (void**)&pFC);

	if (FAILED(hr) || pFC == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	pFC->SetTransformFrame(_trans_frame);

	return TRUE;
}

BOOL CCaptureGraphBuilder::SetTransformFieldOrder(long _trans_order)
{
	if (m_pTF == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IPeCaTVFilterCtrl> pFC;
	hr = m_pTF->QueryInterface(IID_IPeCaTVFilterCtrl, (void**)&pFC);

	if (FAILED(hr) || pFC == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	pFC->SetTransformFieldOrder(_trans_order);

	return TRUE;
}

BOOL CCaptureGraphBuilder::SetTransformFlipVertical(BOOL _trans_flip)
{
	if (m_pTF == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IPeCaTVFilterCtrl> pFC;
	hr = m_pTF->QueryInterface(IID_IPeCaTVFilterCtrl, (void**)&pFC);

	if (FAILED(hr) || pFC == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	pFC->SetTransformFlipVertical(_trans_flip);

	return TRUE;
}


BOOL CCaptureGraphBuilder::SetTransformYCExpand(long _trans_ycexpand)
{
	if (m_pTF == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IPeCaTVFilterCtrl> pFC;
	hr = m_pTF->QueryInterface(IID_IPeCaTVFilterCtrl, (void**)&pFC);

	if (FAILED(hr) || pFC == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	pFC->SetTransformYCExpand(_trans_ycexpand);

	return TRUE;
}

BOOL CCaptureGraphBuilder::SetResizer(int iResizer)
{
	if (m_pProp == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	m_pProp->SetResizer(iResizer);

	return TRUE;
}


BOOL CCaptureGraphBuilder::Run(void)
{
	if (m_pMC)
	{
		m_pMC->Run();
		return TRUE;
	}
	return FALSE;
}

BOOL CCaptureGraphBuilder::Pause(void)
{
	HRESULT hr;
	if (m_pMC)
	{
		hr = m_pMC->Pause();
		if (hr == S_FALSE)
		{//Ot̃|[YɐAԂ̈ڍsĂȂtB^B

			// |[YԂɈڍs܂ōőܕbԑ҂
			long lState = 0;
			m_pMC->GetState(5000, &lState);
		}
		return TRUE;
	}
	return FALSE;
}

BOOL CCaptureGraphBuilder::Stop(void)
{
	if (m_pMC)
	{
		//Pause();
		m_pMC->Stop();
		return TRUE;
	}
	return FALSE;
}

BOOL CCaptureGraphBuilder::IsRun(void)
{
	if (m_pGB)
	{
		return TRUE;
	}
	return FALSE;
}

BOOL CCaptureGraphBuilder::IsVideoRenderer(void)
{
	if (m_pVR)
	{
		return TRUE;
	}
	return FALSE;
}

BOOL CCaptureGraphBuilder::IsAudioRenderer(void)
{
	if (m_pAR)
	{
		return TRUE;
	}
	return FALSE;
}

/*
BOOL CCaptureGraphBuilder::GraphClear(void)
{
	if (m_pGB == NULL || m_pMC == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;

	// Ot~
	m_pMC->Stop();

	// Ot̃tB^񋓂
	CComPtr<IEnumFilters> pEnum;
	hr = m_pGB->EnumFilters(&pEnum);
	if (FAILED(hr) || pEnum == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	ULONG cFetched;

	CComPtr<IBaseFilter> pFilter;
	while (S_OK == pEnum->Next(1, &pFilter, &cFetched))
	{
		if (pFilter == NULL)
		{
			continue;
		}

		// tB^폜
		m_pGB->RemoveFilter(pFilter);
		// 񋓎qZbg
		pEnum->Reset();
		pFilter.Release();
	}
	return TRUE;
}
*/

BOOL CCaptureGraphBuilder::GetQualProp(int *piAvgFrameRate, int *piDropFrames)
{
	if (piAvgFrameRate == NULL || piDropFrames == NULL)
	{
		//FAILED_TRACE;
		return FALSE;
	}

	if (m_pVR == NULL)
	{
		//FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IQualProp> pQP;
	hr = m_pVR->QueryInterface(IID_IQualProp, (void**)&pQP);

	if (FAILED(hr) || pQP == NULL)
	{
		//FAILED_TRACE;
		return FALSE;
	}

	hr = pQP->get_AvgFrameRate(piAvgFrameRate);

	if (FAILED(hr))
	{
		//FAILED_TRACE;
		return FALSE;
	}

	hr = pQP->get_FramesDroppedInRenderer(piDropFrames);

	if (FAILED(hr))
	{
		//FAILED_TRACE;
		return FALSE;
	}
	
	return TRUE;
}


BOOL CCaptureGraphBuilder::GetNativeVideoSize(LPLONG lpWidth, LPLONG lpHeight)
{
	if (m_pVR == NULL || lpWidth == NULL || lpHeight == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;

	if (m_lVideoRenderer == VIDEO_RENDERER_VMR9)
	{
		CComPtr<IVMRWindowlessControl9> pWC; 
		hr = m_pVR->QueryInterface<IVMRWindowlessControl9>(&pWC);
		if (FAILED(hr) || pWC == NULL)
		{
			FAILED_TRACE;
			return FALSE;
		}

		hr = pWC->GetNativeVideoSize(lpWidth, lpHeight, NULL, NULL);
		if (FAILED(hr))
		{
			FAILED_TRACE;
			return FALSE;
		}
		return TRUE;
	}
	else if (
		m_lVideoRenderer == VIDEO_RENDERER_EVR ||
		m_lVideoRenderer == VIDEO_RENDERER_EVR_CUSTOM)
	{
		CComPtr<IMFGetService> pGS;
		hr = m_pVR->QueryInterface<IMFGetService>(&pGS);
		if (FAILED(hr) || pGS == NULL)
		{
			FAILED_TRACE;
			return FALSE;
		}

		CComPtr<IMFVideoDisplayControl> pDC;
		hr = pGS->GetService(MR_VIDEO_RENDER_SERVICE,
			IID_IMFVideoDisplayControl, (void**)&pDC);
		if (FAILED(hr) || pDC == NULL)
		{
			FAILED_TRACE;
			return FALSE;
		}

		SIZE size;
		hr = pDC->GetNativeVideoSize(&size, NULL);
		if (FAILED(hr))
		{
			FAILED_TRACE;
			return FALSE;
		}

		*lpWidth = size.cx;
		*lpHeight = size.cy;

		return TRUE;
	}
	else
	{
		CComPtr<IVMRWindowlessControl> pWC; 
		hr = m_pVR->QueryInterface<IVMRWindowlessControl>(&pWC);
		if (FAILED(hr) || pWC == NULL)
		{
			FAILED_TRACE;
			return FALSE;
		}

		hr = pWC->GetNativeVideoSize(lpWidth, lpHeight, NULL, NULL);
		if (FAILED(hr))
		{
			FAILED_TRACE;
			return FALSE;
		}

		return TRUE;
	}

	FAILED_TRACE;
	return FALSE;
}


BOOL CCaptureGraphBuilder::RepaintVideo(void)
{
	HRESULT hr;

	if (m_pVR)
	{
		if (m_lVideoRenderer == VIDEO_RENDERER_VMR9)
		{
			CComPtr<IVMRWindowlessControl9> pWC;
			hr = m_pVR->QueryInterface<IVMRWindowlessControl9>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			RECT rcSrc, rcDst;
			hr = pWC->GetVideoPosition(&rcSrc, &rcDst);

			PAINTSTRUCT ps; 
			HDC         hdc; 
			RECT        rcClient; 
			GetClientRect(m_hWnd, &rcClient); 
			hdc = BeginPaint(m_hWnd, &ps); 


			// VMR ɃrfI̕`vB
			hr = pWC->RepaintVideo(m_hWnd, hdc);


			// NCAg̈悩rfI]`ƂŁA
			// AvP[V`\ȗ̈擾B
			HRGN rgnClient = CreateRectRgnIndirect(&rcClient); 
			HRGN rgnVideo  = CreateRectRgnIndirect(&rcDst);  
			CombineRgn(rgnClient, rgnClient, rgnVideo, RGN_DIFF);  
	        
			// EBhEɕ`悷B
			HBRUSH hbr = CreateSolidBrush(RGB(0, 0, 0)); 
			FillRgn(hdc, rgnClient, hbr); 

			// N[ AbvB
			DeleteObject(hbr); 
			DeleteObject(rgnClient); 
			DeleteObject(rgnVideo); 



			EndPaint(m_hWnd, &ps); 
			return TRUE;
		}
		else if (
			m_lVideoRenderer == VIDEO_RENDERER_EVR ||
			m_lVideoRenderer == VIDEO_RENDERER_EVR_CUSTOM)
		{
			CComPtr<IMFGetService> pGS;
			hr = m_pVR->QueryInterface<IMFGetService>(&pGS);
			if (FAILED(hr) || pGS == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			CComPtr<IMFVideoDisplayControl> pDC;
			hr = pGS->GetService(MR_VIDEO_RENDER_SERVICE,
				IID_IMFVideoDisplayControl, (void**)&pDC);
			if (FAILED(hr) || pDC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			MFVideoNormalizedRect rcSrc;
			RECT rcDst;
			hr = pDC->GetVideoPosition(&rcSrc, &rcDst);


			PAINTSTRUCT ps; 
			HDC         hdc; 
			RECT        rcClient; 
			GetClientRect(m_hWnd, &rcClient);
			//TRACE(L"rcDst l:%d t:%d r:%d b:%d\n", rcDst.left, rcDst.top, rcDst.right, rcDst.bottom);

			hdc = BeginPaint(m_hWnd, &ps);

			// VMR ɃrfI̕`vB
			hr = pDC->RepaintVideo();

			// NCAg̈悩rfI]`ƂŁA
			// AvP[V`\ȗ̈擾B
			HRGN rgnClient = CreateRectRgnIndirect(&rcClient);
			HRGN rgnVideo  = CreateRectRgnIndirect(&rcDst);
			CombineRgn(rgnClient, rgnClient, rgnVideo, RGN_DIFF);  
	        
			// EBhEɕ`悷B
			HBRUSH hbr = CreateSolidBrush(RGB(0, 0, 0)); 
			FillRgn(hdc, rgnClient, hbr); 

			// N[ AbvB
			DeleteObject(hbr); 
			DeleteObject(rgnClient); 
			DeleteObject(rgnVideo); 

			EndPaint(m_hWnd, &ps); 

			return TRUE;
		}
		else
		{
			CComPtr<IVMRWindowlessControl> pWC;
			hr = m_pVR->QueryInterface<IVMRWindowlessControl>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			RECT rcSrc, rcDst;
			hr = pWC->GetVideoPosition(&rcSrc, &rcDst);

			PAINTSTRUCT ps; 
			HDC         hdc; 
			RECT        rcClient; 
			GetClientRect(m_hWnd, &rcClient); 
			hdc = BeginPaint(m_hWnd, &ps);

			// VMR ɃrfI̕`vB
			hr = pWC->RepaintVideo(m_hWnd, hdc);

			// NCAg̈悩rfI]`ƂŁA
			// AvP[V`\ȗ̈擾B
			HRGN rgnClient = CreateRectRgnIndirect(&rcClient); 
			HRGN rgnVideo  = CreateRectRgnIndirect(&rcDst);  
			CombineRgn(rgnClient, rgnClient, rgnVideo, RGN_DIFF);  
	        
			// EBhEɕ`悷B
			HBRUSH hbr = CreateSolidBrush(RGB(0, 0, 0)); 
			FillRgn(hdc, rgnClient, hbr); 

			// N[ AbvB
			DeleteObject(hbr); 
			DeleteObject(rgnClient); 
			DeleteObject(rgnVideo); 

			EndPaint(m_hWnd, &ps); 
			return TRUE;
		}
	}

	return FALSE;
}


BOOL CCaptureGraphBuilder::DisplayModeChanged(void)
{
	HRESULT hr;

	if (m_pVR)
	{
		if (m_lVideoRenderer == VIDEO_RENDERER_VMR9)
		{
			CComPtr<IVMRWindowlessControl9> pWC;
			hr = m_pVR->QueryInterface<IVMRWindowlessControl9>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pWC->DisplayModeChanged();

			return TRUE;
		}
		else if (
			m_lVideoRenderer == VIDEO_RENDERER_EVR ||
			m_lVideoRenderer == VIDEO_RENDERER_EVR_CUSTOM)
		{
			/*
			CComPtr<IMFGetService> pGS;
			hr = m_pVR->QueryInterface<IMFGetService>(&pGS);
			if (FAILED(hr) || pGS == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			CComPtr<IMFVideoDisplayControl> pDC;
			hr = pGS->GetService(MR_VIDEO_RENDER_SERVICE,
				IID_IMFVideoDisplayControl, (void**)&pDC);
			if (FAILED(hr) || pDC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}
			*/

			return TRUE;
		}
		else
		{
			CComPtr<IVMRWindowlessControl> pWC;
			hr = m_pVR->QueryInterface<IVMRWindowlessControl>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pWC->DisplayModeChanged();
 
			return TRUE;
		}
	}

	return FALSE;
}


BOOL CCaptureGraphBuilder::SetVideoPosition(void)
{
	HRESULT hr;

	if (m_pVR)
	{
		CRect rcClient, rcDst;
		if (!::GetClientRect(m_hWnd, &rcClient))
		{
			return FALSE;
		}

		long ax = 640, ay = 480;
		long cx = rcClient.Width();
		long cy = rcClient.Height();

		ConvertAspectRatio(cx, cy, &ax, &ay);

		rcDst.SetRect(
			(int)(((double)cx / 2.0) - ((double)ax / 2.0)), (int)(((double)cy / 2.0) - ((double)ay / 2.0)),
			(int)(((double)cx / 2.0) + ((double)ax / 2.0)), (int)(((double)cy / 2.0) + ((double)ay / 2.0))); 


		if (m_lVideoRenderer == VIDEO_RENDERER_VMR9)
		{
			CComPtr<IVMRWindowlessControl9> pWC; 
			hr = m_pVR->QueryInterface<IVMRWindowlessControl9>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			long lWidth, lHeight;
			hr = pWC->GetNativeVideoSize(&lWidth, &lHeight, NULL, NULL);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			CRect rcSrc; 
			// ]`ݒ肷B

			rcSrc.SetRect(0, 0, lWidth, lHeight);
			rcSrc.DeflateRect(m_rcCrop.left, m_rcCrop.top, m_rcCrop.right, m_rcCrop.bottom);
			
			// rfÏʒuݒ肷B
			hr = pWC->SetVideoPosition(&rcSrc, &rcDst); 
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			HRGN rgnClient = CreateRectRgnIndirect(&rcClient); 
			HRGN rgnVideo  = CreateRectRgnIndirect(&rcDst);  
			CombineRgn(rgnClient, rgnClient, rgnVideo, RGN_DIFF);  

			::InvalidateRgn(m_hWnd, rgnClient, TRUE);

			// N[ AbvB
			DeleteObject(rgnClient); 
			DeleteObject(rgnVideo); 

			return TRUE;
		}
		else if (
			m_lVideoRenderer == VIDEO_RENDERER_EVR ||
			m_lVideoRenderer == VIDEO_RENDERER_EVR_CUSTOM)
		{
			CComPtr<IMFGetService> pGS;
			hr = m_pVR->QueryInterface<IMFGetService>(&pGS);
			if (FAILED(hr) || pGS == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			CComPtr<IMFVideoDisplayControl> pDC;
			hr = pGS->GetService(MR_VIDEO_RENDER_SERVICE,
				IID_IMFVideoDisplayControl, (void**)&pDC);
			if (FAILED(hr) || pDC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}


			//CComPtr<IMFVideoMixerControl> pMC;
			//hr = pGS->GetService(MR_VIDEO_MIXER_SERVICE,
			//	IID_IMFVideoMixerControl, (void**)&pMC);
			//if (FAILED(hr) || pMC == NULL)
			//{
			//	FAILED_TRACE;
			//	return FALSE;
			//}


			long lWidth, lHeight;
			SIZE size;
			hr = pDC->GetNativeVideoSize(&size, NULL);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			lWidth = size.cx;
			lHeight = size.cy;

			MFVideoNormalizedRect nrcSrc;
			CRect rcSrc; 
			// ]`ݒ肷B

			rcSrc.SetRect(0, 0, lWidth, lHeight);
			rcSrc.DeflateRect(m_rcCrop.left, m_rcCrop.top, m_rcCrop.right, m_rcCrop.bottom);

			if (lWidth > 0)
			{
				nrcSrc.left = (float)rcSrc.left / (float)lWidth;
				nrcSrc.right = (float)rcSrc.right / (float)lWidth;
			}
			else
			{
				nrcSrc.left = 0.0;
				nrcSrc.right = 1.0;
			}

			if (lHeight > 0)
			{
				nrcSrc.top = (float)rcSrc.top / (float)lHeight;
				nrcSrc.bottom = (float)rcSrc.bottom / (float)lHeight;
			}
			else
			{
				nrcSrc.top = 0.0;
				nrcSrc.bottom = 1.0;
			}


			// rfÏʒuݒ肷B
			//hr = pMC->SetStreamOutputRect(0, &nrcSrc);
			hr = pDC->SetVideoPosition(&nrcSrc, &rcDst);
			

			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			HRGN rgnClient = CreateRectRgnIndirect(&rcClient); 
			HRGN rgnVideo  = CreateRectRgnIndirect(&rcDst);  
			CombineRgn(rgnClient, rgnClient, rgnVideo, RGN_DIFF);  

			::InvalidateRgn(m_hWnd, rgnClient, TRUE);

			// N[ AbvB
			DeleteObject(rgnClient); 
			DeleteObject(rgnVideo); 

			return TRUE;
		}
		else
		{
			CComPtr<IVMRWindowlessControl> pWC; 
			hr = m_pVR->QueryInterface<IVMRWindowlessControl>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			long lWidth, lHeight;
			hr = pWC->GetNativeVideoSize(&lWidth, &lHeight, NULL, NULL);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			CRect rcSrc; 
			// ]`ݒ肷B

			rcSrc.SetRect(0, 0, lWidth, lHeight);
			rcSrc.DeflateRect(m_rcCrop.left, m_rcCrop.top, m_rcCrop.right, m_rcCrop.bottom);

			// rfÏʒuݒ肷B
			hr = pWC->SetVideoPosition(&rcSrc, &rcDst); 
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}

			HRGN rgnClient = CreateRectRgnIndirect(&rcClient); 
			HRGN rgnVideo  = CreateRectRgnIndirect(&rcDst);  
			CombineRgn(rgnClient, rgnClient, rgnVideo, RGN_DIFF);  

			::InvalidateRgn(m_hWnd, rgnClient, TRUE);

			// N[ AbvB
			DeleteObject(rgnClient); 
			DeleteObject(rgnVideo); 

			return TRUE;
		}
	}

	return FALSE;
}

BOOL CCaptureGraphBuilder::ConvertAspectRatio(long lWidth, long lHeight, long *lpAspectCX, long *lpAspectCY, BOOL bAuto, BOOL bApplyWidth)
{
	if (lpAspectCX == NULL || lpAspectCY == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	if (m_nWndAspectX > 0 && m_nWndAspectY > 0)
	{
		// ƍ
		long cx = lWidth;
		long cy = lHeight;

		// AXyNgKp
		long ax = (long)(((double)cy / (double)m_nWndAspectY) * (double)m_nWndAspectX);
		long ay = (long)(((double)cx / (double)m_nWndAspectX) * (double)m_nWndAspectY);

		if (bAuto)
		{
			if (ax <= cx)
			{
				*lpAspectCX = ax;
				*lpAspectCY = cy;
			}
			else
			{
				*lpAspectCX = cx;
				*lpAspectCY = ay;
			}
		}
		else
		{
			if (bApplyWidth)
			{
				*lpAspectCX = ax;
				*lpAspectCY = cy;
			}
			else
			{
				*lpAspectCX = cx;
				*lpAspectCY = ay;
			}
		}
	}
	else if (m_nWndAspectX == -1) // ͔䗦
	{
		if (m_lVideoWidth <= 0)
		{
			m_lVideoWidth = 1;
		}
		if (m_lVideoHeight <= 0)
		{
			m_lVideoHeight = 1;
		}

		// ƍ
		long cx = lWidth;
		long cy = lHeight;

		// AXyNgKp
		long ax = (long)(((double)cy / (double)m_lVideoHeight) * (double)m_lVideoWidth);
		long ay = (long)(((double)cx / (double)m_lVideoWidth) * (double)m_lVideoHeight);


		if (bAuto)
		{
			if (ax <= cx)
			{
				*lpAspectCX = ax;
				*lpAspectCY = cy;
			}
			else
			{
				*lpAspectCX = cx;
				*lpAspectCY = ay;
			}
		}
		else
		{
			if (bApplyWidth)
			{
				*lpAspectCX = ax;
				*lpAspectCY = cy;
			}
			else
			{
				*lpAspectCX = cx;
				*lpAspectCY = ay;
			}
		}
	}
	else
	{
		*lpAspectCX = lWidth;
		*lpAspectCY = lHeight;
	}

	return TRUE;
}

BOOL CCaptureGraphBuilder::GetCurrentImage(BITMAPINFO *pBmpInfo, BYTE **ppDIB)
{
	if (pBmpInfo == NULL || ppDIB == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;

	if (m_pVR)
	{
		LPBYTE pBuff = NULL;
		DWORD dwBuffSize = 0;

		BITMAPINFOHEADER bih;
		BITMAPINFOHEADER *pBIH = NULL;

		LPBYTE pImage = NULL;

		if (m_lVideoRenderer == VIDEO_RENDERER_VMR9)
		{
			CComPtr<IVMRWindowlessControl9> pWC;
			hr = m_pVR->QueryInterface<IVMRWindowlessControl9>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pWC->GetCurrentImage(&pBuff);
			if (FAILED(hr) || pBuff == NULL)
			{
				if (pBuff != NULL)
				{
					CoTaskMemFree(pBuff);
				}
				FAILED_TRACE;
				return FALSE;
			}

			pBIH = reinterpret_cast<BITMAPINFOHEADER*>(pBuff);

			pImage = pBuff + pBIH->biSize;
		}
		else if (
			m_lVideoRenderer == VIDEO_RENDERER_EVR ||
			m_lVideoRenderer == VIDEO_RENDERER_EVR_CUSTOM)
		{
			CComPtr<IMFGetService> pGS;
			hr = m_pVR->QueryInterface<IMFGetService>(&pGS);
			if (FAILED(hr) || pGS == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			CComPtr<IMFVideoDisplayControl> pDC;
			hr = pGS->GetService(MR_VIDEO_RENDER_SERVICE,
				IID_IMFVideoDisplayControl, (void**)&pDC);
			if (FAILED(hr) || pDC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			if (m_lVideoRenderer == VIDEO_RENDERER_EVR)
			{
				// EVRSetVideoPositiondest̃TCYŕԂĂ̂ňꎞISetVideoPositionKp
				MFVideoNormalizedRect nrcSrc = {0.0, 0.0, 1.0, 1.0};
				CRect rcDst;
				rcDst.SetRect(0, 0, m_lVideoWidth, m_lVideoHeight);

				hr = pDC->SetVideoPosition(&nrcSrc, &rcDst);
				if (FAILED(hr))
				{
					FAILED_TRACE;
					return FALSE;
				}
			}


			bih.biSize = sizeof(BITMAPINFOHEADER);
			LONGLONG llTimeStamp;

			hr = pDC->GetCurrentImage(&bih, &pBuff, &dwBuffSize, &llTimeStamp);
			if (FAILED(hr) || pBuff == NULL)
			{
				if (pBuff != NULL)
				{
					CoTaskMemFree(pBuff);
				}
				FAILED_TRACE;
				return FALSE;
			}

			if (m_lVideoRenderer == VIDEO_RENDERER_EVR)
			{
				// fʒu߂
				SetVideoPosition();
			}

			pBIH = &bih;

			pImage = pBuff;
		}
		else
		{
			CComPtr<IVMRWindowlessControl> pWC;
			hr = m_pVR->QueryInterface<IVMRWindowlessControl>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pWC->GetCurrentImage(&pBuff);
			if (FAILED(hr) || pBuff == NULL)
			{
				if (pBuff != NULL)
				{
					CoTaskMemFree(pBuff);
				}
				FAILED_TRACE;
				return FALSE;
			}

			pBIH = reinterpret_cast<BITMAPINFOHEADER*>(pBuff);

			pImage = pBuff + pBIH->biSize;
		}

		

		if (pBIH == NULL)
		{
			if (pBuff != NULL)
			{
				CoTaskMemFree(pBuff);
			}
			FAILED_TRACE;
			return FALSE;
		}

		if (pBIH->biClrUsed != 0)
		{
			if (pBuff != NULL)
			{
				CoTaskMemFree(pBuff);
			}

			FAILED_TRACE;
			return FALSE;
		}

		DWORD dwImageSize = pBIH->biSizeImage;
		LPBYTE pDIB = new BYTE[dwImageSize];

		if (pDIB == NULL)
		{
			if (pBuff != NULL)
			{
				CoTaskMemFree(pBuff);
			}
			FAILED_TRACE;
			return FALSE;
		}

		memcpy(&(pBmpInfo->bmiHeader), pBIH, sizeof(BITMAPINFOHEADER));
		memcpy(pDIB, pImage, dwImageSize);

		*ppDIB = pDIB;

		if (pBuff != NULL)
		{
			CoTaskMemFree(pBuff);
		}

		return TRUE;
	}

	FAILED_TRACE;
	return FALSE;
}

/*


//FILE *pfSnap = fopen("Image.bmp", "wb");
//fwrite(pDIB, dwDIBSize, 1, pfSnap);
//fclose(pfSnap);
BOOL CCaptureGraphBuilder::GetCurrentImage(BYTE **ppDIB, DWORD *pdwDIBSize)
{
	if (ppDIB == NULL || pdwDIBSize == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;

	if (m_pVR)
	{
		LPBYTE pBuff = NULL;
		DWORD dwBuffSize = 0;
		BITMAPINFOHEADER bih;
		BITMAPINFOHEADER *pBIH = NULL;
		

		if (m_lVideoRenderer == VIDEO_RENDERER_VMR9)
		{
			CComPtr<IVMRWindowlessControl9> pWC;
			hr = m_pVR->QueryInterface<IVMRWindowlessControl9>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pWC->GetCurrentImage(&pBuff);
			if (FAILED(hr) || pBuff == NULL)
			{
				if (pBuff != NULL)
				{
					CoTaskMemFree(pBuff);
				}
				FAILED_TRACE;
				return FALSE;
			}

			pBIH = reinterpret_cast<BITMAPINFOHEADER*>(pBuff);
		}
		else if (m_lVideoRenderer == VIDEO_RENDERER_EVR)
		{
			CComPtr<IMFGetService> pGS;
			hr = m_pVR->QueryInterface<IMFGetService>(&pGS);
			if (FAILED(hr) || pGS == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			CComPtr<IMFVideoDisplayControl> pDC;
			hr = pGS->GetService(MR_VIDEO_RENDER_SERVICE,
				IID_IMFVideoDisplayControl, (void**)&pDC);
			if (FAILED(hr) || pDC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			// EVRSetVideoPositiondest̃TCYŕԂĂ̂ňꎞISetVideoPositionKp
			MFVideoNormalizedRect nrcSrc = {0.0, 0.0, 1.0, 1.0};
			CRect rcDst;
			rcDst.SetRect(0, 0, m_lVideoWidth, m_lVideoHeight);

			hr = pDC->SetVideoPosition(&nrcSrc, &rcDst);
			if (FAILED(hr))
			{
				FAILED_TRACE;
				return FALSE;
			}


			bih.biSize = sizeof(BITMAPINFOHEADER);
			LONGLONG llTimeStamp;

			hr = pDC->GetCurrentImage(&bih, &pBuff, &dwBuffSize, &llTimeStamp);
			if (FAILED(hr) || pBuff == NULL)
			{
				if (pBuff != NULL)
				{
					CoTaskMemFree(pBuff);
				}
				FAILED_TRACE;
				return FALSE;
			}

			// fʒu߂
			SetVideoPosition();

			pBIH = &bih;
		}
		else
		{
			CComPtr<IVMRWindowlessControl> pWC;
			hr = m_pVR->QueryInterface<IVMRWindowlessControl>(&pWC);
			if (FAILED(hr) || pWC == NULL)
			{
				FAILED_TRACE;
				return FALSE;
			}

			hr = pWC->GetCurrentImage(&pBuff);
			if (FAILED(hr) || pBuff == NULL)
			{
				if (pBuff != NULL)
				{
					CoTaskMemFree(pBuff);
				}
				FAILED_TRACE;
				return FALSE;
			}

			pBIH = reinterpret_cast<BITMAPINFOHEADER*>(pBuff);
		}

		

		if (pBIH == NULL)
		{
			if (pBuff != NULL)
			{
				CoTaskMemFree(pBuff);
			}
			FAILED_TRACE;
			return FALSE;
		}

		if (pBIH->biClrUsed != 0)
		{
			if (pBuff != NULL)
			{
				CoTaskMemFree(pBuff);
			}

			FAILED_TRACE;
			return FALSE;
		}

		BITMAPFILEHEADER bfh;
		DWORD dwImageSize = pBIH->biSizeImage;
		LPBYTE pImage = pBuff + pBIH->biSize;

		bfh.bfType = ('M' << 8) | 'B';
		bfh.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + dwImageSize;
		bfh.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

		DWORD dwDIBSize = bfh.bfSize;
		LPBYTE pDIB = new BYTE[bfh.bfSize];

		if (pDIB == NULL)
		{
			if (pBuff != NULL)
			{
				CoTaskMemFree(pBuff);
			}
			FAILED_TRACE;
			return FALSE;
		}

		memcpy(pDIB, &bfh, sizeof(BITMAPFILEHEADER));
		memcpy(pDIB + sizeof(BITMAPFILEHEADER), pBIH, sizeof(BITMAPINFOHEADER));
		memcpy(pDIB + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER), pImage, dwImageSize);

		*ppDIB = pDIB;
		*pdwDIBSize = dwDIBSize;

		if (pBuff != NULL)
		{
			CoTaskMemFree(pBuff);
		}

		return TRUE;
	}

	FAILED_TRACE;
	return FALSE;
}
*/


void CCaptureGraphBuilder::SetCroppingRect(RECT &rc)
{
	m_rcCrop = rc;
}

void CCaptureGraphBuilder::SetAspectRatio(int nAspectX, int nAspectY)
{
	m_nWndAspectX = nAspectX;
	m_nWndAspectY = nAspectY;
}

void CCaptureGraphBuilder::SetVideoSize(long lVideoWidth, long lVideoHeight)
{
	m_lVideoWidth = lVideoWidth;
	m_lVideoHeight = lVideoHeight;
}


BOOL CCaptureGraphBuilder::SetAudioVolume(int nVolume)
{
	if (m_pGB == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IBasicAudio> pBA;
	hr = m_pGB->QueryInterface<IBasicAudio>(&pBA);

	if (FAILED(hr) || pBA == NULL)
	{
		FAILED_TRACE;
		return FALSE;
	}

	long lVolume = (nVolume == 0) ? -10000 : (long)((20.0 * log10((double)nVolume / 100.0)) * 100.0);

	pBA->put_Volume(lVolume);

	return TRUE;
}


BOOL CCaptureGraphBuilder::GetEvent(long *lEventCode, LONG_PTR *lParam1, LONG_PTR *lParam2)
{
	HRESULT hr;

	if (m_pME != NULL)
	{
		hr = m_pME->GetEvent(lEventCode, lParam1, lParam1, 0);

		if (SUCCEEDED(hr))
		{
			m_pME->FreeEventParams(*lEventCode, *lParam1, *lParam1);
		}

		return SUCCEEDED(hr) ? TRUE : FALSE;
	}

	return FALSE;
}


void CCaptureGraphBuilder::ResetLog(void)
{
	m_wsLog = L"";
}

void CCaptureGraphBuilder::AddLog(LPCWSTR pwszFormat, ...)
{
	if (pwszFormat == NULL)
	{
		return;
	}

	WCHAR wsBuff[1025];

	va_list arg;
	va_start(arg, pwszFormat);

	int nResult = ::_vsnwprintf_s(wsBuff, (sizeof(wsBuff) / sizeof(wsBuff[0])) - 1, pwszFormat, arg);
	wsBuff[sizeof(wsBuff) / sizeof(wsBuff[0]) - 1] = L'\0';

	va_end(arg);

	if (nResult < 0)
	{
		m_wsLog += L"O݃G[\n";
	}
	else
	{
		m_wsLog += wsBuff;
		m_wsLog += L"\n";
	}
}

LPCWSTR CCaptureGraphBuilder::GetLog(void)
{
	return m_wsLog.c_str();
}




BOOL CCaptureGraphBuilder::GetVideoProcAmp(CVideoProcAmp *pAmp)
{
	if (m_pVC == NULL || pAmp == NULL)
	{
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IAMVideoProcAmp> pVPA;

	hr = m_pVC->QueryInterface<IAMVideoProcAmp>(&pVPA);

	if (FAILED(hr) || pVPA == NULL)
	{
		return FALSE;
	}

	const int nCount = sizeof(g_VideoProcAmpProp) / sizeof(g_VideoProcAmpProp[0]);

	for (int i = 0; i < nCount; i++)
	{
		CVideoProcAmp vpa;

		vpa.lProperty = g_VideoProcAmpProp[i];

		pVPA->GetRange(
			vpa.lProperty,
			&(vpa.lMin),
			&(vpa.lMax),
			&(vpa.lSteppingDelta),
			&(vpa.lDefault),
			&(vpa.lCapsFlags));

		pVPA->Get(
		  vpa.lProperty,
		  &(vpa.lValue),
		  &(vpa.lFlags));

		pAmp[i] = vpa;
	}

	return TRUE;
}



BOOL CCaptureGraphBuilder::SetVideoProcAmp(long Property, long lValue, long Flags)
{
	if (m_pVC == NULL)
	{
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IAMVideoProcAmp> pVPA;

	hr = m_pVC->QueryInterface<IAMVideoProcAmp>(&pVPA);

	if (FAILED(hr) || pVPA == NULL)
	{
		return FALSE;
	}

	hr = pVPA->Set(Property, lValue, Flags);

	if (FAILED(hr))
	{
		return FALSE;
	}

	return TRUE;
}

BOOL CCaptureGraphBuilder::SetVideoProcAmpConfig(CVideoProcAmpConfig *pAmp)
{
	if (pAmp == NULL)
	{
		return FALSE;
	}

	for (int i = 0; i < 10; i++)
	{
		if (pAmp[i].lValue != LONG_MIN)
		{
			SetVideoProcAmp(g_VideoProcAmpProp[i], pAmp[i].lValue, pAmp[i].lFlags);
		}
	}

	return TRUE;
}

BOOL CCaptureGraphBuilder::GetVideoProcAmpConfig(CVideoProcAmpConfig *pAmp)
{
	if (pAmp == NULL)
	{
		return FALSE;
	}

	if (m_pVC == NULL)
	{
		return FALSE;
	}

	HRESULT hr;
	CComPtr<IAMVideoProcAmp> pVPA;

	hr = m_pVC->QueryInterface<IAMVideoProcAmp>(&pVPA);

	if (FAILED(hr) || pVPA == NULL)
	{
		return FALSE;
	}

	for (int i = 0; i < 10; i++)
	{
		pVPA->Get(g_VideoProcAmpProp[i], &(pAmp[i].lValue), &(pAmp[i].lFlags));
	}

	return TRUE;
}





/*
    ProcAmpControl9_Contrast   = 0x00000001,
    ProcAmpControl9_Brightness = 0x00000002,
    ProcAmpControl9_Hue        = 0x00000004,
    ProcAmpControl9_Saturation = 0x00000008,
    ProcAmpControl9_Mask       = 0x0000000F
*/


static void VMR9ProcAmpControlRangeToVMR9ProcAmpRange(VMR9ProcAmpControlRange &range, CVMR9ProcAmpRange &amp)
{
	amp.nDefaultValue = int(ceil(range.DefaultValue * 100.0f));
	amp.nMaxValue = int(ceil(range.MaxValue * 100.0f));
	amp.nMinValue = int(ceil(range.MinValue * 100.0f));
	amp.nStepSize = int(ceil(range.StepSize * 100.0f));
}


BOOL CCaptureGraphBuilder::GetVMR9ProcAmpRange(CVMR9ProcAmpRanges &amp)
{
	if (m_pVR == NULL) { return FALSE; }

	HRESULT hr;

	CComPtr<IVMRMixerControl9> pMC;
	hr = m_pVR->QueryInterface<IVMRMixerControl9>(&pMC);
	if (FAILED(hr) || pMC == NULL)
	{
		return FALSE;
	}

	VMR9ProcAmpControlRange range;


	range.dwSize = sizeof(VMR9ProcAmpControlRange);
	range.dwProperty = ProcAmpControl9_Brightness;
	hr = pMC->GetProcAmpControlRange(0, &range);
	if (FAILED(hr)) { return FALSE; }
	VMR9ProcAmpControlRangeToVMR9ProcAmpRange(range, amp.Brightness);

	range.dwSize = sizeof(VMR9ProcAmpControlRange);
	range.dwProperty = ProcAmpControl9_Contrast;
	hr = pMC->GetProcAmpControlRange(0, &range);
	if (FAILED(hr)) { return FALSE; }
	VMR9ProcAmpControlRangeToVMR9ProcAmpRange(range, amp.Contrast);

	range.dwSize = sizeof(VMR9ProcAmpControlRange);
	range.dwProperty = ProcAmpControl9_Hue;
	hr = pMC->GetProcAmpControlRange(0, &range);
	if (FAILED(hr)) { return FALSE; }
	VMR9ProcAmpControlRangeToVMR9ProcAmpRange(range, amp.Hue);

	range.dwSize = sizeof(VMR9ProcAmpControlRange);
	range.dwProperty = ProcAmpControl9_Saturation;
	hr = pMC->GetProcAmpControlRange(0, &range);
	if (FAILED(hr)) { return FALSE; }
	VMR9ProcAmpControlRangeToVMR9ProcAmpRange(range, amp.Saturation);

	return TRUE;
}


BOOL CCaptureGraphBuilder::GetVMR9ProcAmp(CVMR9ProcAmpConfig &amp)
{
	if (m_pVR == NULL) { return FALSE; }

	HRESULT hr;

	CComPtr<IVMRMixerControl9> pMC;
	hr = m_pVR->QueryInterface<IVMRMixerControl9>(&pMC);
	if (FAILED(hr) || pMC == NULL)
	{
		return FALSE;
	}

	VMR9ProcAmpControl vals;
	vals.dwSize = sizeof(VMR9ProcAmpControl);
	vals.dwFlags =	ProcAmpControl9_Contrast |
					ProcAmpControl9_Brightness |
					ProcAmpControl9_Hue |
					ProcAmpControl9_Saturation;

	hr = pMC->GetProcAmpControl(0, &vals);

	if (FAILED(hr)) { return FALSE; }


	amp.nBrightness = int(ceil(vals.Brightness * 100.0f));
	amp.nContrast = int(ceil(vals.Contrast * 100.0f));
	amp.nHue = int(ceil(vals.Hue * 100.0f));
	amp.nSaturation = int(ceil(vals.Saturation * 100.0f));

	return TRUE;
}


BOOL CCaptureGraphBuilder::SetVMR9ProcAmp(const CVMR9ProcAmpConfig &amp)
{
	if (amp.nBrightness == INT_MIN ||
		amp.nContrast == INT_MIN ||
		amp.nHue == INT_MIN ||
		amp.nSaturation == INT_MIN)
	{
		return FALSE;
	}


	if (m_pVR == NULL) { return FALSE; }

	HRESULT hr;

	CComPtr<IVMRMixerControl9> pMC;
	hr = m_pVR->QueryInterface<IVMRMixerControl9>(&pMC);
	if (FAILED(hr) || pMC == NULL)
	{
		return FALSE;
	}

	VMR9ProcAmpControl vals;
	vals.dwSize = sizeof(VMR9ProcAmpControl);
	vals.dwFlags =	ProcAmpControl9_Contrast |
					ProcAmpControl9_Brightness |
					ProcAmpControl9_Hue |
					ProcAmpControl9_Saturation;

	vals.Brightness = float(amp.nBrightness) / 100.0f;
	vals.Contrast = float(amp.nContrast) / 100.0f;
	vals.Hue = float(amp.nHue) / 100.0f;
	vals.Saturation = float(amp.nSaturation) / 100.0f;

	hr = pMC->SetProcAmpControl(0, &vals);

	if (FAILED(hr)) { return FALSE; }

	return TRUE;
}




/*
	DXVA2_ProcAmp_None
	DXVA2_ProcAmp_Brightness
	DXVA2_ProcAmp_Contrast
	DXVA2_ProcAmp_Hue
	DXVA2_ProcAmp_Saturation
*/

static void DXVA2ValueRangeToEVRProcAmpRange(DXVA2_ValueRange &range, CEVRProcAmpRange &amp)
{
	float val = 0.0f;

	val = DXVA2FixedToFloat(range.DefaultValue);
	amp.nDefaultValue = int(ceil(val * 100.0f));
	val = DXVA2FixedToFloat(range.MaxValue);
	amp.nMaxValue = int(ceil(val * 100.0f));
	val = DXVA2FixedToFloat(range.MinValue);
	amp.nMinValue = int(ceil(val * 100.0f));
	val = DXVA2FixedToFloat(range.StepSize);
	amp.nStepSize = int(ceil(val * 100.0f));
}

BOOL CCaptureGraphBuilder::GetEVRProcAmpRange(CEVRProcAmpRanges &amp)
{
	if (m_pVR == NULL) { return FALSE; }

	HRESULT hr;

	CComPtr<IMFVideoProcessor> pVP;
	pVP = GetService<IMFVideoProcessor>(m_pVR, MR_VIDEO_MIXER_SERVICE, IID_IMFVideoProcessor);

	if (pVP == NULL) { return FALSE; }

	DXVA2_ValueRange range;
	float val = 0.0f;

	hr = pVP->GetProcAmpRange(DXVA2_ProcAmp_Brightness, &range);
	if (FAILED(hr)) { return FALSE; }
	DXVA2ValueRangeToEVRProcAmpRange(range, amp.Brightness);

	hr = pVP->GetProcAmpRange(DXVA2_ProcAmp_Contrast, &range);
	if (FAILED(hr)) { return FALSE; }
	DXVA2ValueRangeToEVRProcAmpRange(range, amp.Contrast);

	hr = pVP->GetProcAmpRange(DXVA2_ProcAmp_Hue, &range);
	if (FAILED(hr)) { return FALSE; }
	DXVA2ValueRangeToEVRProcAmpRange(range, amp.Hue);

	hr = pVP->GetProcAmpRange(DXVA2_ProcAmp_Saturation, &range);
	if (FAILED(hr)) { return FALSE; }
	DXVA2ValueRangeToEVRProcAmpRange(range, amp.Saturation);

	return TRUE;
}

BOOL CCaptureGraphBuilder::GetEVRProcAmp(CEVRProcAmpConfig &amp)
{
	if (m_pVR == NULL) { return FALSE; }

	HRESULT hr;

	CComPtr<IMFVideoProcessor> pVP;
	pVP = GetService<IMFVideoProcessor>(m_pVR, MR_VIDEO_MIXER_SERVICE, IID_IMFVideoProcessor);

	if (pVP == NULL) { return FALSE; }

	DXVA2_ProcAmpValues vals;

	hr = pVP->GetProcAmpValues(
		DXVA2_ProcAmp_Brightness |
		DXVA2_ProcAmp_Contrast |
		DXVA2_ProcAmp_Hue |
		DXVA2_ProcAmp_Saturation, &vals);

	if (FAILED(hr)) { return FALSE; }

	float val = 0.0f;

	val = DXVA2FixedToFloat(vals.Brightness);
	amp.nBrightness = int(ceil(val * 100.0f));
	val = DXVA2FixedToFloat(vals.Contrast);
	amp.nContrast = int(ceil(val * 100.0f));
	val = DXVA2FixedToFloat(vals.Hue);
	amp.nHue = int(ceil(val * 100.0f));
	val = DXVA2FixedToFloat(vals.Saturation);
	amp.nSaturation = int(ceil(val * 100.0f));

	return TRUE;
}

BOOL CCaptureGraphBuilder::SetEVRProcAmp(const CEVRProcAmpConfig &amp)
{
	if (amp.nBrightness == INT_MIN ||
		amp.nContrast == INT_MIN ||
		amp.nHue == INT_MIN ||
		amp.nSaturation == INT_MIN)
	{
		return FALSE;
	}


	if (m_pVR == NULL) { return FALSE; }

	HRESULT hr;

	CComPtr<IMFVideoProcessor> pVP;
	pVP = GetService<IMFVideoProcessor>(m_pVR, MR_VIDEO_MIXER_SERVICE, IID_IMFVideoProcessor);

	if (pVP == NULL) { return FALSE; }

	DXVA2_ProcAmpValues vals;

	vals.Brightness = DXVA2FloatToFixed(float(amp.nBrightness) / 100.0f);
	vals.Contrast = DXVA2FloatToFixed(float(amp.nContrast) / 100.0f);
	vals.Hue = DXVA2FloatToFixed(float(amp.nHue) / 100.0f);
	vals.Saturation = DXVA2FloatToFixed(float(amp.nSaturation) / 100.0f);

	hr = pVP->SetProcAmpValues(
		DXVA2_ProcAmp_Brightness |
		DXVA2_ProcAmp_Contrast |
		DXVA2_ProcAmp_Hue |
		DXVA2_ProcAmp_Saturation, &vals);

	if (FAILED(hr)) { return FALSE; }

	return TRUE;
}


