// WindowSizeDlg.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "CommonListDlg.h"

#define DEFAULT_COUNT (30) // 


struct sort_pred_check {
	sort_pred_check(bool reverse = false)
		: reverse_(reverse)
	{}

	bool operator()(const CommonValue& l, const CommonValue& r)
	{
		if (!reverse_ && l.enable && !r.enable)
		{
			return true;
		}

		if (reverse_ && !l.enable && r.enable)
		{
			return true;
		}

		return false;
	}

private:
	bool reverse_;
};

struct sort_pred_size {
	sort_pred_size(bool reverse = false)
		: reverse_(reverse)
	{}

	bool operator()(const CommonValue& l, const CommonValue& r)
	{
		return reverse_ ? l.width * l.height > r.width * r.height : l.width * l.height < r.width * r.height;
	}

private:
	bool reverse_;
};

struct sort_pred_zoom {
	sort_pred_zoom(bool reverse = false)
		: reverse_(reverse)
	{}

	bool operator()(const CommonValue& l, const CommonValue& r)
	{
		return reverse_ ? l.zoom > r.zoom : l.zoom < r.zoom;
	}

private:
	bool reverse_;
};


// CCommonListDlg _CAO

IMPLEMENT_DYNAMIC(CCommonListDlg, CDialog)

CCommonListDlg::CCommonListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCommonListDlg::IDD, pParent)
	, mode_(WINDOW_SIZE)
	, sort_order_check(false)
	, sort_order_value(false)
{

}

CCommonListDlg::~CCommonListDlg()
{
}

void CCommonListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_xcList);
	DDX_Control(pDX, IDC_BTN_UP, m_xcBtnUp);
	DDX_Control(pDX, IDC_BTN_DOWN, m_xcBtnDown);
	DDX_Control(pDX, IDC_BTN_DEL, m_xcBtnDel);
	DDX_Control(pDX, IDC_BTN_ADD, m_xcBtnAdd);
	DDX_Control(pDX, IDC_ED_VALUE1, m_xcEdValue1);
	DDX_Control(pDX, IDC_ED_VALUE2, m_xcEdValue2);
	DDX_Control(pDX, IDC_SP_VALUE1, m_xcSpinValue1);
	DDX_Control(pDX, IDC_SP_VALUE2, m_xcSpinValue2);
	DDX_Control(pDX, IDC_ED_NAME1, m_xcEdName1);
	DDX_Control(pDX, IDC_ED_NAME2, m_xcEdName2);
}


BEGIN_MESSAGE_MAP(CCommonListDlg, CDialog)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST, &CCommonListDlg::OnLvnGetdispinfoList)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST, &CCommonListDlg::OnLvnItemchangedList)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST, &CCommonListDlg::OnNMCustomdrawList)
	ON_NOTIFY(NM_CLICK, IDC_LIST, &CCommonListDlg::OnNMClickList)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST, &CCommonListDlg::OnLvnColumnclickList)
	ON_BN_CLICKED(IDC_BTN_UP, &CCommonListDlg::OnBnClickedBtnUp)
	ON_BN_CLICKED(IDC_BTN_DOWN, &CCommonListDlg::OnBnClickedBtnDown)
	ON_BN_CLICKED(IDC_BTN_DEL, &CCommonListDlg::OnBnClickedBtnDel)
	ON_BN_CLICKED(IDC_BTN_ADD, &CCommonListDlg::OnBnClickedBtnAdd)
	ON_BN_CLICKED(IDC_BTN_DEFAULT, &CCommonListDlg::OnBnClickedBtnDefault)
	ON_EN_CHANGE(IDC_ED_VALUE1, &CCommonListDlg::OnEnChangeEdValue1)
	ON_EN_CHANGE(IDC_ED_VALUE2, &CCommonListDlg::OnEnChangeEdValue2)
END_MESSAGE_MAP()


void CCommonListDlg::SetMode(MODE mode)
{
	mode_ = mode;
}

CCommonListDlg::MODE CCommonListDlg::GetMode()
{
	return mode_;
}


void CCommonListDlg::SetStatusText()
{
	int count = 0;
	for (auto it = m_vecValue.begin(); it != m_vecValue.end(); ++it)
	{
		if (it->enable)
		{
			count++;
		}
	}

	int size = static_cast<int>(m_vecValue.size());

	m_statusBar.SetPaneText(0, (boost::wformat(L"\t\t%1%/%2%") % size % DEFAULT_COUNT).str().c_str());
}

// CCommonListDlg bZ[W nh


BOOL CCommonListDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


BOOL CCommonListDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// _CAO
	if (GetMode() == WINDOW_SIZE) {
		SetWindowText(L"EBhETCY");
	}
	else {
		SetWindowText(L"EBhE{");
	}

	// Xe[^Xo[

	if (m_statusBar.Create(this))
	{
		const UINT ind[1] = { 0 };
		m_statusBar.SetIndicators(ind, 1);
		m_statusBar.SetPaneInfo(0, 0, SBPS_STRETCH, 0);

		SetStatusText();

		RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);
	}


	// xiGfBbg{bNXj
	if (GetMode() == WINDOW_SIZE) {
		m_xcEdName1.SetWindowText(L"");
		m_xcEdName2.SetWindowText(L"");
	}
	else {
		m_xcEdName1.ShowWindow(SW_HIDE);
		m_xcEdName2.SetWindowText(L"{");
	}

	// XgRg[
	m_xcList.SetExtendedStyle(m_xcList.GetExtendedStyle()|
		LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_CHECKBOXES);
	m_xcList.SetCallbackMask(LVIS_STATEIMAGEMASK);

	m_xcList.InsertColumn(0, L"", LVCFMT_CENTER, 30);

	if (GetMode() == WINDOW_SIZE) {
		m_xcList.InsertColumn(1, L"TCY", LVCFMT_LEFT, 220);
	}
	else {
		m_xcList.InsertColumn(1, L"{", LVCFMT_LEFT, 220);
	}

	m_xcList.SetItemCountEx(static_cast<int>(m_vecValue.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	// XsRg[
	if (GetMode() == WINDOW_SIZE) {
		m_xcSpinValue1.SetRange32(16, 10000);
		m_xcSpinValue1.SetPos32(800);
		m_xcSpinValue2.SetRange32(16, 10000);
		m_xcSpinValue2.SetPos32(600);
	}
	else
	{
		m_xcSpinValue1.SetRange32(0, 0);
		m_xcSpinValue1.SetPos32(0);
		m_xcSpinValue2.SetRange32(10, 1000);
		m_xcSpinValue2.SetPos32(100);
		m_xcSpinValue1.ShowWindow(SW_HIDE);
	}

	// GfBbg{bNX
	if (GetMode() == WINDOW_ZOOM) {
		m_xcEdValue1.ShowWindow(SW_HIDE);
	}

	if (m_vecValue.size() > 0)
	{
		m_xcList.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcList.EnsureVisible(0, FALSE);
	}
	else
	{
		// {^
		//m_xcBtnAdd.EnableWindow(FALSE);
		//m_xcBtnDel.EnableWindow(FALSE);
		//m_xcBtnUp.EnableWindow(FALSE);
		//m_xcBtnDown.EnableWindow(FALSE);
		m_xcEdValue1.EnableWindow(FALSE);
		m_xcEdValue2.EnableWindow(FALSE);
	}
		

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void CCommonListDlg::OnLvnGetdispinfoList(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);
	if (pDispInfo == NULL)
	{
		return;
	}

	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_STATE)
	{
		try {
			pDispInfo->item.state = LVIS_STATEIMAGEMASK;

			if (m_vecValue.at(i).enable) {
				pDispInfo->item.stateMask = INDEXTOSTATEIMAGEMASK(2);
			}
			else {
				pDispInfo->item.stateMask = INDEXTOSTATEIMAGEMASK(1);
			}
		} catch (std::exception const&) {}
	}

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 1:
			{
				try {
					CommonValue t = m_vecValue.at(i);
					if (GetMode() == WINDOW_SIZE) {
						csLine.Format(L"%dx%d", t.width, t.height);
					}
					else {
						csLine.Format(L"%d%%", t.zoom);
					}
				} catch (std::exception&) {}

				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult)
	{
		*pResult = 0;
	}
}

void CCommonListDlg::OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult)
{
	//LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	//if (pNMLV == NULL) { return; }

	int i = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);

	if (i >= 0) // I
	{

		int width = 800, height = 600, zoom = 100;
		try {
			width = m_vecValue.at(i).width;
			height = m_vecValue.at(i).height;
			zoom = m_vecValue.at(i).zoom;

		}
		catch(...) {}

		if (GetMode() == WINDOW_SIZE)
		{
			m_xcSpinValue1.SetPos32(width);
			m_xcSpinValue2.SetPos32(height);
		}
		else
		{
			m_xcSpinValue2.SetPos32(zoom);
		}

		//m_xcBtnAdd.EnableWindow(TRUE);
		//m_xcBtnDel.EnableWindow(TRUE);
		//m_xcBtnUp.EnableWindow(TRUE);
		//m_xcBtnDown.EnableWindow(TRUE);
		m_xcEdValue1.EnableWindow(TRUE);
		m_xcEdValue2.EnableWindow(TRUE);
	}
	else
	{
		//m_xcBtnAdd.EnableWindow(FALSE);
		//m_xcBtnDel.EnableWindow(FALSE);
		//m_xcBtnUp.EnableWindow(FALSE);
		//m_xcBtnDown.EnableWindow(FALSE);
		m_xcEdValue1.EnableWindow(FALSE);
		m_xcEdValue2.EnableWindow(FALSE);
	}

	if (pResult != NULL) { *pResult = 0; }
}

void CCommonListDlg::OnNMCustomdrawList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	if (pNMCD == NULL)
	{
		return;
	}
	/*
	LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW)pNMCD;

	if (lplvcd == NULL)
	{
		return;
	}


	// `TCNJnbZ[WLb`
	if (lplvcd->nmcd.dwDrawStage == CDDS_PREPAINT)
	{
		// JX^h[sƂʒm
		if (pResult != NULL)
		{
			*pResult =  CDRF_NOTIFYITEMDRAW;
		}
		return;
	}

	// ACe`悷郁bZ[WLb`
	if (lplvcd->nmcd.dwDrawStage == CDDS_ITEMPREPAINT)
	{
		// s̕Fɂ
		lplvcd->clrText = RGB(0, 0, 0);

		// s̏ꍇ
		if(lplvcd->nmcd.dwItemSpec % 2 == 0)
		{
			// s̔wi𔒂ɂ
			lplvcd->clrTextBk = RGB(255, 255, 255);
		}
		else
		{
			// s̔wiDFɂ
			lplvcd->clrTextBk = RGB(240, 240, 240);
		}
	}
	*/

	if (pResult != NULL)
	{
		*pResult = 0;
	}
}

void CCommonListDlg::OnNMClickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	CPoint pt;
	::GetCursorPos(&pt);
	m_xcList.ScreenToClient(&pt);

	LVHITTESTINFO lvHit;
	lvHit.pt = pt;
	int i = m_xcList.SubItemHitTest(&lvHit);

	if (lvHit.iSubItem == 0 && lvHit.flags & LVHT_ONITEMSTATEICON)
	{
		try {
			if (m_vecValue.at(i).enable == FALSE)
			{
				m_vecValue.at(i).enable = TRUE;
			}
			else
			{
				m_vecValue.at(i).enable = FALSE;
			}
		} catch (std::exception const&) {}

		CRect rc;
		m_xcList.GetItemRect(i, &rc, LVIR_BOUNDS);
		m_xcList.InvalidateRect(&rc, FALSE);

		SetStatusText();
	}

	if (pResult != NULL)
	{
		*pResult = 0;
	}
}

void CCommonListDlg::OnLvnColumnclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	if (pNMLV == NULL)
	{
		return;
	}

	/*
	// I
	int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (index >= 0 && index < (int)m_vecValue.size())
	{
		m_xcList.SetItemState(index, 0, LVIS_SELECTED);
	}
	*/
	
	switch(pNMLV->iSubItem)
	{
	case 0:
		std::stable_sort(m_vecValue.begin(), m_vecValue.end(), sort_pred_check(sort_order_check));
		m_xcList.RedrawWindow();
		sort_order_check = sort_order_check ? false : true;
		break;

	case 1:
		if (GetMode() == WINDOW_SIZE) {
			std::stable_sort(m_vecValue.begin(), m_vecValue.end(), sort_pred_size(sort_order_value));
		}
		else {
			std::stable_sort(m_vecValue.begin(), m_vecValue.end(), sort_pred_zoom(sort_order_value));
		}
		m_xcList.RedrawWindow();
		sort_order_value = sort_order_value ? false : true;
		break;

	default:
		break;
	}

	OnLvnItemchangedList(0, 0);


	if (pResult != NULL)
	{
		*pResult = 0;
	}
}
void CCommonListDlg::OnBnClickedBtnUp()
{
	int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (index < 0 || index >= (int)m_vecValue.size())
	{
		return;
	}

	if (index <= 0)
	{
		return;
	}

	try {
		CommonValue t = m_vecValue.at(index - 1);
		m_vecValue.at(index - 1) = m_vecValue.at(index);
		m_vecValue.at(index) = t;

		m_xcList.SetItemState(index - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcList.EnsureVisible(index - 1, FALSE);

		m_xcList.RedrawWindow();

	} catch (std::exception&) {}
}

void CCommonListDlg::OnBnClickedBtnDown()
{
	int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (index < 0 || index >= (int)m_vecValue.size())
	{
		return;
	}

	// Xg̈ԉȂ̂ŉɂ͈ړłȂ
	if (index >= (int)(m_vecValue.size() - 1))
	{
		return;
	}

	try {
		CommonValue t = m_vecValue.at(index + 1);
		m_vecValue.at(index + 1) = m_vecValue.at(index);
		m_vecValue.at(index) = t;

		m_xcList.SetItemState(index + 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcList.EnsureVisible(index + 1, FALSE);

		m_xcList.RedrawWindow();

	} catch (std::exception const&) {}
}

void CCommonListDlg::OnBnClickedBtnDel()
{
	int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (index < 0 || index >= (int)m_vecValue.size())
	{
		return;
	}

	try {
		std::vector<CommonValue>::iterator it = m_vecValue.begin() + index;
		m_vecValue.erase(it);
		m_xcList.SetItemCountEx((int)m_vecValue.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

		if ((int)m_vecValue.size() > index)
		{
			m_xcList.SetItemState(index, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
			m_xcList.EnsureVisible(index, FALSE);
		}
		else
		{
			//m_xcBtnAdd.EnableWindow(FALSE);
			//m_xcBtnDel.EnableWindow(FALSE);
			//m_xcBtnUp.EnableWindow(FALSE);
			//m_xcBtnDown.EnableWindow(FALSE);
			m_xcEdValue1.EnableWindow(FALSE);
			m_xcEdValue2.EnableWindow(FALSE);
		}
		m_xcList.RedrawWindow();

	} catch (std::exception const&) {}

	SetStatusText();
	OnLvnItemchangedList(0, 0);
}
/*
void CCommonListDlg::OnBnClickedBtnChange()
{
	int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (index < 0 || index >= (int)m_vecValue.size())
	{
		return;
	}

	try {
		m_vecValue.at(index).width = m_xcSpinValue1.GetPos32();
		m_vecValue.at(index).height = m_xcSpinValue2.GetPos32();
		m_vecValue.at(index).zoom = m_xcSpinValue2.GetPos32();
		m_xcList.RedrawWindow();
	} catch (std::exception&) {}
}
*/

void CCommonListDlg::OnBnClickedBtnAdd()
{
	int size = (int)m_vecValue.size();
	if (size >= DEFAULT_COUNT) // l葽ȂȂɂȂ
	{
		return;
	}

	m_vecValue.push_back(
		CommonValue(TRUE, 800, 600, 100));

	m_xcList.SetItemCountEx(static_cast<int>(m_vecValue.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	int i = m_vecValue.size();
	m_xcList.SetItemState(i - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
	m_xcList.EnsureVisible(i - 1, FALSE);
	m_xcList.RedrawWindow();

	SetStatusText();
}

void CCommonListDlg::OnBnClickedBtnDefault()
{
	m_xcList.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	m_vecValue.clear();

	if (GetMode() == WINDOW_SIZE)
	{
		m_vecValue.push_back(CommonValue(TRUE, 1920, 1080, 100));
		m_vecValue.push_back(CommonValue(FALSE, 1600, 900, 100));
		m_vecValue.push_back(CommonValue(FALSE, 1440, 810, 100));
		m_vecValue.push_back(CommonValue(TRUE, 1280, 720, 100));
		m_vecValue.push_back(CommonValue(FALSE, 1024, 576, 100));
		m_vecValue.push_back(CommonValue(FALSE, 960, 540, 100));
		m_vecValue.push_back(CommonValue(FALSE, 800, 450, 100));
		m_vecValue.push_back(CommonValue(FALSE, 640, 360, 100));
		m_vecValue.push_back(CommonValue(FALSE, 480, 270, 100));
		m_vecValue.push_back(CommonValue(FALSE, 352, 200, 100));
		m_vecValue.push_back(CommonValue(FALSE, 320, 180, 100));
		
		m_vecValue.push_back(CommonValue(FALSE, 1920, 1440, 100));
		m_vecValue.push_back(CommonValue(FALSE, 1600, 1200, 100));
		m_vecValue.push_back(CommonValue(FALSE, 1440, 1080, 100));
		m_vecValue.push_back(CommonValue(FALSE, 1280, 960, 100));
		m_vecValue.push_back(CommonValue(FALSE, 1024, 768, 100));
		m_vecValue.push_back(CommonValue(FALSE, 960, 720, 100));
		m_vecValue.push_back(CommonValue(TRUE, 800, 600, 100));
		m_vecValue.push_back(CommonValue(TRUE, 640, 480, 100));
		m_vecValue.push_back(CommonValue(FALSE, 512, 384, 100));
		m_vecValue.push_back(CommonValue(FALSE, 480, 360, 100));
		m_vecValue.push_back(CommonValue(FALSE, 320, 240, 100));
	}
	else
	{
		m_vecValue.push_back(CommonValue(FALSE, 800, 600, 150));
		m_vecValue.push_back(CommonValue(FALSE, 800, 600, 125));
		m_vecValue.push_back(CommonValue(TRUE, 800, 600, 100));
		m_vecValue.push_back(CommonValue(TRUE, 800, 600, 75));
		m_vecValue.push_back(CommonValue(TRUE, 800, 600, 50));
	}

	m_xcList.SetItemCountEx(static_cast<int>(m_vecValue.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	SetStatusText();
}







void CCommonListDlg::OnEnChangeEdValue1()
{
	if (!IsWindow(m_xcList.GetSafeHwnd())) { return; }

	int i = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)m_vecValue.size()) { return; }

	if (!IsWindow(m_xcEdValue1.GetSafeHwnd())) { return; }

	CString tmp;
	m_xcEdValue1.GetWindowText(tmp);

	m_vecValue.at(i).width = ::_wtoi(tmp);
	m_xcList.Update(i);
}

void CCommonListDlg::OnEnChangeEdValue2()
{
	if (!IsWindow(m_xcList.GetSafeHwnd())) { return; }

	int i = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)m_vecValue.size()) { return; }


	CString tmp;
	m_xcEdValue2.GetWindowText(tmp);

	if (GetMode() == WINDOW_SIZE)
	{
		m_vecValue.at(i).height = ::_wtoi(tmp);
	}
	else
	{
		m_vecValue.at(i).zoom = ::_wtoi(tmp);
	}

	m_xcList.Update(i);
}
