#pragma once
#include "afxcmn.h"
#include "afxwin.h"
#include "afxext.h"

struct CommonValue {
	CommonValue(BOOL enable, int width, int height, int zoom)
		: enable(enable)
		, width(width)
		, height(height)
		, zoom(zoom)
	{}
	BOOL enable;
	int width;
	int height;
	int zoom;
};



// CCommonListDlg _CAO

class CCommonListDlg : public CDialog
{
	DECLARE_DYNAMIC(CCommonListDlg)

public:
	CCommonListDlg(CWnd* pParent = NULL);   // WRXgN^
	virtual ~CCommonListDlg();

// _CAO f[^
	enum { IDD = IDD_COMMON_LIST };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()

public:
	enum MODE {
		WINDOW_SIZE,
		WINDOW_ZOOM
	};

private:
	CStatusBar m_statusBar;
	MODE mode_;

	bool sort_order_check;
	bool sort_order_value;

public:
	void SetMode(MODE mode);
	MODE GetMode();

	void SetStatusText();

	std::vector<CommonValue> m_vecValue;

	CListCtrl m_xcList;
	CEdit m_xcEdName1;
	CEdit m_xcEdName2;
	CButton m_xcBtnUp;
	CButton m_xcBtnDown;
	CButton m_xcBtnDel;
	CButton m_xcBtnAdd;
	CEdit m_xcEdValue1;
	CEdit m_xcEdValue2;
	CSpinButtonCtrl m_xcSpinValue1;
	CSpinButtonCtrl m_xcSpinValue2;
	
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnInitDialog();
	afx_msg void OnLvnGetdispinfoList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMClickList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnColumnclickList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedBtnUp();
	afx_msg void OnBnClickedBtnDown();
	afx_msg void OnBnClickedBtnDel();
	afx_msg void OnBnClickedBtnAdd();
	afx_msg void OnBnClickedBtnDefault();
	afx_msg void OnEnChangeEdValue1();
	afx_msg void OnEnChangeEdValue2();
};
