#include "stdafx.h"
#include "Config.h"
#include "PeCaTV2.h"

const wchar_t* videoProcAmpKey[10] = {
		L"brightness",
		L"contrast",
		L"hue",
		L"saturation",
		L"sharpness",
		L"gamma",
		L"colorEnable",
		L"whiteBalance",
		L"backlightCompensation",
		L"gain",
	};

CConfig::CConfig(void)
{
	m_bInitialize = FALSE;
	m_bMultiBoot = FALSE;
}

CConfig::~CConfig(void)
{
}

// private:
//================================================================================

//--------------------------------------------------------------------------------
//	GetModuleFolder
//	vÕJgtH_ԂBL'\\'
//--------------------------------------------------------------------------------
BOOL CConfig::GetModuleFolder(std::wstring &wsPath)
{
	WCHAR* pwsSearch = NULL;
	WCHAR pwsFilePath[MAX_PATH + 1];

	::ZeroMemory(pwsFilePath, sizeof(pwsFilePath) / sizeof(pwsFilePath[0]));

	// g̃vOpX擾
	if (0 == ::GetModuleFileName(NULL, pwsFilePath, MAX_PATH))
	{
		return FALSE;
	}

	// Ō'\\'oʒu
	pwsSearch = wcsrchr(pwsFilePath, L'\\');

	if (pwsSearch == NULL)
	{
		return FALSE;
	}

	// fBNgԂ߂ɖ̃vOt@C
	pwsSearch[1] = L'\0';

	wsPath = pwsFilePath;
	return TRUE;
}

// public:
//================================================================================

//--------------------------------------------------------------------------------
//	Init
//	BJgtH_̎擾Ɛݒt@CpX̐ݒ
//--------------------------------------------------------------------------------
BOOL CConfig::Init(void)
{
	if (!GetModuleFolder(m_wsCurrentFolder))
	{
		return FALSE;
	}

	m_wsConfigFilePathINI = m_wsCurrentFolder + L"PeCaTV2.ini";
	m_wsConfigFilePathXML = m_wsCurrentFolder + L"PeCaTV2.xml";
	m_wsProfileFilePathINI = m_wsCurrentFolder + L"Profile.ini";
	m_wsProfileFilePathXML = m_wsCurrentFolder + L"Profile.xml";

	m_bInitialize = TRUE;
	return TRUE;
}

//--------------------------------------------------------------------------------
//	LoadConfig
//	ݒt@Cǂݍ
//--------------------------------------------------------------------------------
void CConfig::LoadConfig(void)
{
	if (PathFileExists(m_wsConfigFilePathXML.c_str()))
	{// xmlxmlǂݍ
		ReadConfigXML();
		return;
	}
	else if (PathFileExists(m_wsConfigFilePathINI.c_str()))
	{// xmlȂƂiniiniǂݍ
		ReadConfigINI();

		// iniɖݒ
		InitShortCut(m_vecShortCut);
		return;
	}
	// Vxmlŏ
	ReadConfigXML();
}

//--------------------------------------------------------------------------------
//	SaveConfig
//	ݒt@C
//--------------------------------------------------------------------------------
void CConfig::SaveConfig(void)
{
	WriteConfigXML();
}

//--------------------------------------------------------------------------------
//	LoadProfile
//	vt@Cǂݍ
//--------------------------------------------------------------------------------
void CConfig::LoadProfile(void)
{
	if (PathFileExists(m_wsProfileFilePathXML.c_str()))
	{// xmlxmlǂݍ
		ReadProfileXML();
		return;
	}
	else if (PathFileExists(m_wsProfileFilePathINI.c_str()))
	{// xmlȂƂiniiniǂݍ
		ReadProfileINI();
		return;
	}
	// Vxmlŏ
	ReadProfileXML();
}

//--------------------------------------------------------------------------------
//	SaveProfile
//	ݒt@C
//--------------------------------------------------------------------------------
void CConfig::SaveProfile(void)
{
	//WriteProfileINI();
	WriteProfileXML();
}

CConfig g_cfg;



/*
void CMainApp::ReadXML()
{
	//========================================
	// JgpX擾t@CpXݒ
	GetModuleDirectory(m_wsCurrentPath);
	::SetCurrentDirectory(m_wsCurrentPath.c_str());

	std::wstring path = m_wsCurrentPath;

	if (PathFileExists((path + L"PeCaRecorder.xml").c_str()))
	{// xmlɒT
		ReadProfileXML();
		ReadFilterXML();
		ReadVisualXML();
	}
	else
	{// xmlȂꍇiniT
		if (PathFileExists((path + L"PeCaRecorder.ini").c_str()))
		{
			ReadINI();
			return;
		}
		else
		{// ȂȂxmlŏ
			ReadProfileXML();
			ReadFilterXML();
			ReadVisualXML();
		}
	}
}
*/