#pragma once

#include "InitFile.h"
#include "CaptureGraphBuilder.h"
#include "SnapShot.h"
#include "ShortCut.h"
#include "IPeCaTVFilterCtrl.h"

// ݒt@C̃o[WvOo[W
// ver.5 2016/06/11
// vt@C̉ω
// Œvt@Cp~
// 
// vt@C莞̃vr[ݒ
// BOOL m_bProfilePreview;


#define CONFIG_FILE_VERSION			(10)


// vt@C̐
#define CONFIG_PROFILE_COUNT		(10)

//
//	CConfig
//	ݒt@C̓ǂݏƐݒlO[oϐŕێ
//

// fTCY
struct WindowSize {
	WindowSize(BOOL enable, int width, int height)
		: enable(enable)
		, width(width)
		, height(height)
	{}
	BOOL enable;
	int width;
	int height;
};

// fg嗦
struct WindowZoom {
	WindowZoom(BOOL enable, int zoom)
		: enable(enable)
		, zoom(zoom)
	{}
	BOOL enable;
	int zoom;
};

class CConfig
{
public:
	CConfig(void);
	~CConfig(void);

private:
	BOOL GetModuleFolder(std::wstring &wsPath);

	void ReadConfigINI();
	void WriteConfigINI();

	void ReadProfileINI();
	void WriteProfileINI();

	void ReadConfigXML();
	void WriteConfigXML();

	void ReadProfileXML();
	void ReadProfileItemXML(const XmlParser& root, CCaptureGraphProfile& profile);
	void ReadProfileCrossbarXML(const XmlParser& root, std::vector<CCrossbar>& crossbar);
	void ReadProfileFilterXML(const XmlParser& root, std::vector<CFilterItem>& filter);
	void ReadProfileVideoProcAmpXML(const XmlParser& root, CVideoProcAmpConfig* vpa);


	void WriteProfileXML();
	void WriteProfileItemXML(XmlParser& root, CCaptureGraphProfile& profile);
	void WriteProfileCrossbarXML(XmlParser& root, std::vector<CCrossbar>& crossbar);
	void WriteProfileFilterXML(XmlParser& root, std::vector<CFilterItem>& filter);
	void WriteProfileVideoProcAmpXML(XmlParser& root, CVideoProcAmpConfig* vpa);
	

public:
	BOOL Init(void);
	void LoadConfig(void);
	void SaveConfig(void);

	void LoadProfile(void);
	void SaveProfile(void);

private:
	BOOL m_bInitialize;	// Ă邩iɃpXݒj

public:
	std::wstring		m_wsCurrentFolder;	// JgtH_

	std::wstring		m_wsConfigFilePathINI;		// iniݒt@CpX
	std::wstring		m_wsConfigFilePathXML;		// xmlݒt@CpX
	std::wstring		m_wsProfileFilePathINI;	// iniݒt@CpX
	std::wstring		m_wsProfileFilePathXML;	// xmlݒt@CpX

	BOOL m_bMultiBoot; // dNĂ

	//--------------------------------------------------------------
	// Common
	BOOL m_bFirstTime;


	//--------------------------------------------------------------
	// Window
	WINDOWPLACEMENT		m_stWndPlacement;	// EBhEݒ

	BOOL m_bWindowAspectRatio;
	BOOL m_bTitleBar;
	BOOL m_bWindowFrame;
	BOOL m_bTopMost;
	BOOL m_bWindowSnap;
	BOOL m_bWindowDrag;
	BOOL m_bScreenSaverStop;
	BOOL m_bMonitorPowerOffStop;
	BOOL m_bSystemStandbyStop;

	std::vector<WindowSize> m_vecWindowSize;
	std::vector<WindowZoom> m_vecWindowZoom;

	//--------------------------------------------------------------
	// Cropping
	std::vector<CRect> m_vecCrop;

	//--------------------------------------------------------------
	// SnapShot
	std::wstring m_wsSnapShotFolder;
	long m_lSnapShotType;
	int m_nSnapShotVideoSize;
	BOOL m_bSnapShotCrop;
	int m_nSnapShotJpegQuality;

	//---------------------------------------------------------------
	// Otvt@C
	int m_nProfileSelected; // I𒆃vt@Cԍ
	std::vector<CCaptureGraphProfile> m_vecProfile; // vt@C

	//---------------------------------------------------------------
	// V[gJbg
	std::vector<ShortCut> m_vecShortCut;

	int m_nProfileLastTab;
	int m_nOptionLastTab;

	BOOL m_bProfilePreview; // vt@C_CAOɍĐ邩ǂ
};


extern CConfig g_cfg;