#include "stdafx.h"
#include "Config.h"
#include "PeCaTV2.h"

//--------------------------------------------------------------------------------
//	ReadConfigINI
//	ini`̐ݒt@C̓ǂݍ
//--------------------------------------------------------------------------------
void CConfig::ReadConfigINI()
{
	CInitFile ini;

	ini.Load(m_wsConfigFilePathINI.c_str());

	// NtO
	ini.Read(L"Common", L"FirstTime", m_bFirstTime, TRUE);

	// AvP[Vo[W
	int nVersion = 0;
	ini.Read(L"Common", L"FileVersion", nVersion, CONFIG_FILE_VERSION);

	// EBhEʒu
	if (!ini.ReadData(L"Window", L"Placement", &m_stWndPlacement, sizeof(WINDOWPLACEMENT)))
	{
		::ZeroMemory(&m_stWndPlacement, sizeof(WINDOWPLACEMENT));
		m_stWndPlacement.length = sizeof(WINDOWPLACEMENT);


		int nCYCaption = GetSystemMetrics(SM_CYCAPTION);
		int nCXFrame = GetSystemMetrics(SM_CXFRAME);
		int nCYFrame = GetSystemMetrics(SM_CYFRAME);

		CRect rcClient, rcDesktop;

		rcClient.SetRect(0, 0, 640, 480);
		rcClient.InflateRect(0, nCYCaption, 0, 0);
		rcClient.InflateRect(nCXFrame, nCYFrame);

		::GetWindowRect(::GetDesktopWindow(), &rcDesktop);

		if ((rcDesktop.Width() / 2) - (rcClient.Width() / 2) < 0 ||
			(rcDesktop.Height() / 2) - (rcClient.Height() / 2) < 0)
		{
			m_stWndPlacement.rcNormalPosition.left = 0;
			m_stWndPlacement.rcNormalPosition.top = 0;
			m_stWndPlacement.rcNormalPosition.right = rcClient.Width();
			m_stWndPlacement.rcNormalPosition.bottom = rcClient.Height();
		}
		else
		{
			m_stWndPlacement.rcNormalPosition.left = (rcDesktop.Width() / 2) - (rcClient.Width() / 2);
			m_stWndPlacement.rcNormalPosition.top = (rcDesktop.Height() / 2) - (rcClient.Height() / 2);
			m_stWndPlacement.rcNormalPosition.right = m_stWndPlacement.rcNormalPosition.left + rcClient.Width();
			m_stWndPlacement.rcNormalPosition.bottom = m_stWndPlacement.rcNormalPosition.top + rcClient.Height();
		}
	}

	// EBhEX^C
	ini.Read(L"Window", L"AspectRatio", m_bWindowAspectRatio, TRUE);
	ini.Read(L"Window", L"TitleBar", m_bTitleBar, TRUE);
	ini.Read(L"Window", L"Frame", m_bWindowFrame, TRUE);
	ini.Read(L"Window", L"TopMost", m_bTopMost, FALSE);
	ini.Read(L"Window", L"Snap", m_bWindowSnap, TRUE);
	ini.Read(L"Window", L"Drag", m_bWindowDrag, TRUE);
	ini.Read(L"Window", L"ScreenSaverStop", m_bScreenSaverStop, TRUE);
	ini.Read(L"Window", L"MonitorPowerOffStop", m_bMonitorPowerOffStop, TRUE);
	ini.Read(L"Window", L"SystemStandbyStop", m_bSystemStandbyStop, TRUE);


	// fTCY
	if (m_bFirstTime)
	{
		m_vecWindowSize.clear();
		m_vecWindowSize.push_back(WindowSize(TRUE, 1920, 1080));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1600, 900));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1440, 810));
		m_vecWindowSize.push_back(WindowSize(TRUE, 1280, 720));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1024, 576));
		m_vecWindowSize.push_back(WindowSize(FALSE, 960, 540));
		m_vecWindowSize.push_back(WindowSize(FALSE, 800, 450));
		m_vecWindowSize.push_back(WindowSize(FALSE, 640, 360));
		m_vecWindowSize.push_back(WindowSize(FALSE, 480, 270));
		m_vecWindowSize.push_back(WindowSize(FALSE, 352, 200));
		m_vecWindowSize.push_back(WindowSize(FALSE, 320, 180));
		
		m_vecWindowSize.push_back(WindowSize(FALSE, 1920, 1440));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1600, 1200));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1440, 1080));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1280, 960));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1024, 768));
		m_vecWindowSize.push_back(WindowSize(FALSE, 960, 720));
		m_vecWindowSize.push_back(WindowSize(TRUE, 800, 600));
		m_vecWindowSize.push_back(WindowSize(TRUE, 640, 480));
		m_vecWindowSize.push_back(WindowSize(FALSE, 512, 384));
		m_vecWindowSize.push_back(WindowSize(FALSE, 480, 360));
		m_vecWindowSize.push_back(WindowSize(FALSE, 320, 240));
	}
	else
	{
		m_vecWindowSize.clear();
		int count = 0;
		ini.Read(L"WindowSize", L"Count", count, 0);
		if (count > 0)
		{
			CString csKey;
			BOOL enable;
			int width, height;
			for (int i = 0; i < count; ++i)
			{
				csKey.Format(L"Enable(%d)", i);
				ini.Read(L"WindowSize", csKey, enable, FALSE);

				csKey.Format(L"Width(%d)", i);
				ini.Read(L"WindowSize", csKey, width, 800);

				csKey.Format(L"Height(%d)", i);
				ini.Read(L"WindowSize", csKey, height, 600);

				m_vecWindowSize.push_back(WindowSize(enable, width, height));
			}
		}
	}

	// fg嗦
	if (m_bFirstTime)
	{
		m_vecWindowZoom.clear();
		m_vecWindowZoom.push_back(WindowZoom(FALSE, 150));
		m_vecWindowZoom.push_back(WindowZoom(FALSE, 125));
		m_vecWindowZoom.push_back(WindowZoom(TRUE, 100));
		m_vecWindowZoom.push_back(WindowZoom(TRUE, 75));
		m_vecWindowZoom.push_back(WindowZoom(TRUE, 50));
	}
	else
	{
		m_vecWindowZoom.clear();
		int count = 0;
		ini.Read(L"WindowZoom", L"Count", count, 0);
		if (count > 0)
		{
			CString csKey;
			BOOL enable;
			int zoom;
			for (int i = 0; i < count; ++i)
			{
				csKey.Format(L"Enable(%d)", i);
				ini.Read(L"WindowZoom", csKey, enable, FALSE);

				csKey.Format(L"Zoom(%d)", i);
				ini.Read(L"WindowZoom", csKey, zoom, 100);

				m_vecWindowZoom.push_back(WindowZoom(enable, zoom));
			}
		}
	}

	// NbsO
	{
		m_vecCrop.clear();
		int count = 0;
		ini.Read(L"Cropping", L"Count", count, 0);
		if (count > 0)
		{
			CString csKey;
			CRect rc;

			for (int i = 0; i < count; ++i)
			{
				csKey.Format(L"Top(%d)", i);
				ini.Read(L"Cropping", csKey, rc.top, 0);

				csKey.Format(L"Left(%d)", i);
				ini.Read(L"Cropping", csKey, rc.left, 0);

				csKey.Format(L"Right(%d)", i);
				ini.Read(L"Cropping", csKey, rc.right, 0);

				csKey.Format(L"Bottom(%d)", i);
				ini.Read(L"Cropping", csKey, rc.bottom, 0);

				m_vecCrop.push_back(rc);
			}
		}
	}

	// XibvVbg
	ini.Read(L"SnapShot", L"Folder", m_wsSnapShotFolder, m_wsCurrentFolder.c_str());
	ini.Read(L"SnapShot", L"Type", m_lSnapShotType, CSnapShot::FORMAT_PNG);
	ini.Read(L"SnapShot", L"WindowSize", m_nSnapShotVideoSize, 1);
	ini.Read(L"SnapShot", L"Crop", m_bSnapShotCrop, TRUE);
	ini.Read(L"SnapShot", L"JpegQuality", m_nSnapShotJpegQuality, 100);

	// IvV
	ini.Read(L"Option", L"LastTab", m_nOptionLastTab, 0);
}




//--------------------------------------------------------------------------------
//	ReadProfileINI
//	o[WƂɐݒt@C̓ǂݍ
//--------------------------------------------------------------------------------
void CConfig::ReadProfileINI()
{
	CInitFile ini;
	ini.Load(m_wsProfileFilePathINI.c_str());

	// AvP[Vo[W
	int nVersion = 0;
	ini.Read(L"Common", L"FileVersion", nVersion, CONFIG_FILE_VERSION);

	// tB^Otvt@C
	ini.Read(L"Profile", L"Selected", m_nProfileSelected, 0);
	ini.Read(L"Profile", L"LastTab", m_nProfileLastTab, 0);
	ini.Read(L"Profile", L"Preview", m_bProfilePreview, TRUE);

	int nCount = CONFIG_PROFILE_COUNT;
	ini.Read(L"Profile", L"Count", nCount, CONFIG_PROFILE_COUNT);

	{
		m_vecProfile.clear();

		// Vistaȏ̃o[W
		// EVRlɐݒ肷
		long lPresetVideoRenderer = VIDEO_RENDERER_EVR_CUSTOM;

		OSVERSIONINFO info;
		info.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		if (GetVersionEx(&info))
		{
			// dwMajorVersion == 6 Vista
			if (info.dwMajorVersion < 6)
			{
				lPresetVideoRenderer = VIDEO_RENDERER_VMR7;
			}
		}

		for (int i = 0; i < nCount; i++)
		{
			CCaptureGraphProfile profile;

			CString csSection;
			csSection.Format(L"Profile:%02d", i);

			CString csName;
			csName.Format(L"vt@C%d", i);
			ini.Read(csSection, L"Name", profile.wsName, csName);

			//-------------------------------------------------------------------
			// rfILv`[tB^
			ini.Read(csSection, L"Video.FriendlyName", profile.Video.wsFriendlyName, L"");
			ini.Read(csSection, L"Video.DevicePath", profile.Video.wsDevicePath, L"");
			ini.Read(csSection, L"Video.Description", profile.Video.wsDescription, L"");

			// NXo[
			profile.Video.vecCrossbar.clear();

			int nXbarCount = 0;
			ini.Read(csSection, L"Video.Crossbar", nXbarCount, 0);

			
			for (int nXbar = 0; nXbar < nXbarCount; nXbar++)
			{
				CCrossbar xbar;
				CString csKey;

				csKey.Format(L"Video.Crossbar(%d).Output", nXbar);
				ini.Read(csSection, csKey, xbar.lOutput, -1);

				csKey.Format(L"Video.Crossbar(%d).Input", nXbar);
				ini.Read(csSection, csKey, xbar.lInput, -1);

				profile.Video.vecCrossbar.push_back(xbar);
			}


			ini.Read(csSection, L"Video.Format.Index", profile.Video.Format.nIndex, 0);
			ini.Read(csSection, L"Video.Format.Width", profile.Video.Format.biWidth, 0);
			ini.Read(csSection, L"Video.Format.Height", profile.Video.Format.biHeight, 0);
			ini.Read(csSection, L"Video.Format.AvgTimePerFrame", profile.Video.Format.AvgTimePerFrame, 0);
			ini.Read(csSection, L"Video.Format.Standard", profile.Video.Format.lStandard, 0);

			//-------------------------------------------------------------------
			// I[fBILv`[tB^
			ini.Read(csSection, L"Audio.FriendlyName", profile.Audio.wsFriendlyName, L"");
			ini.Read(csSection, L"Audio.DevicePath", profile.Audio.wsDevicePath, L"");
			ini.Read(csSection, L"Audio.Description", profile.Audio.wsDescription, L"");

			ini.Read(csSection, L"Audio.UseBufferSize", profile.Audio.bBufferSize, FALSE);
			ini.Read(csSection, L"Audio.BufferSize", profile.Audio.nBufferSize, 50);

			ini.Read(csSection, L"Audio.Format.Index", profile.Audio.Format.nIndex, 0);
			ini.Read(csSection, L"Audio.Format.Channels", profile.Audio.Format.nChannels, 0);
			ini.Read(csSection, L"Audio.Format.BitsPerSample", profile.Audio.Format.wBitsPerSample, 0);
			ini.Read(csSection, L"Audio.Format.SamplesPerSec", profile.Audio.Format.nSamplesPerSec, 0);

			//-------------------------------------------------------------------
			// tB^

			int nFilterCount = 0;
			ini.Read(csSection, L"Filter.Video", nFilterCount, 0);

			profile.Filter.vecVideo.clear();
			for (int nFilter = 0; nFilter < nFilterCount; nFilter++)
			{
				CFilterItem item;
				CString csKey;

				csKey.Format(L"Filter.Video(%d).Check", nFilter);
				ini.Read(csSection, csKey, item.bCheck, TRUE);

				csKey.Format(L"Filter.Video(%d).FriendlyName", nFilter);
				ini.Read(csSection, csKey, item.wsFriendlyName, L"");

				csKey.Format(L"Filter.Video(%d).Description", nFilter);
				ini.Read(csSection, csKey, item.wsDescription, L"");

				csKey.Format(L"Filter.Video(%d).DevicePath", nFilter);
				ini.Read(csSection, csKey, item.wsDevicePath, L"");

				csKey.Format(L"Filter.Video(%d).Input", nFilter);
				ini.Read(csSection, csKey, item.nInput, -1);

				csKey.Format(L"Filter.Video(%d).Output", nFilter);
				ini.Read(csSection, csKey, item.nOutput, -1);

				profile.Filter.vecVideo.push_back(item);
			}

			ini.Read(csSection, L"Filter.Audio", nFilterCount, 0);

			profile.Filter.vecAudio.clear();
			for (int nFilter = 0; nFilter < nFilterCount; nFilter++)
			{
				CFilterItem item;
				CString csKey;

				csKey.Format(L"Filter.Audio(%d).Check", nFilter);
				ini.Read(csSection, csKey, item.bCheck, TRUE);

				csKey.Format(L"Filter.Audio(%d).FriendlyName", nFilter);
				ini.Read(csSection, csKey, item.wsFriendlyName, L"");

				csKey.Format(L"Filter.Audio(%d).Description", nFilter);
				ini.Read(csSection, csKey, item.wsDescription, L"");

				csKey.Format(L"Filter.Audio(%d).DevicePath", nFilter);
				ini.Read(csSection, csKey, item.wsDevicePath, L"");

				csKey.Format(L"Filter.Audio(%d).Input", nFilter);
				ini.Read(csSection, csKey, item.nInput, -1);

				csKey.Format(L"Filter.Audio(%d).Output", nFilter);
				ini.Read(csSection, csKey, item.nOutput, -1);

				profile.Filter.vecAudio.push_back(item);
			}

			//-------------------------------------------------------------------
			// vr[ݒ
			ini.Read(csSection, L"Preview.VideoSync", profile.Preview.bVideoPreviewPin, TRUE);
			ini.Read(csSection, L"Preview.AudioSync", profile.Preview.bAudioPreviewPin, TRUE);

			ini.Read(csSection, L"Preview.VideoRenderer", profile.Preview.lVideoRenderer, lPresetVideoRenderer);
			ini.Read(csSection, L"Preview.AudioRenderer", profile.Preview.lAudioRenderer, AUDIO_RENDERER_DIRECTSOUND);

			ini.Read(csSection, L"Preview.Transform", profile.Preview.bTransform, TRUE);
			ini.Read(csSection, L"Preview.Transform.Copy", profile.Preview.lTransformCopy, TRANSFORM_COPY_NONE);
			ini.Read(csSection, L"Preview.Transform.Frame", profile.Preview.lTransformFrame, TRANSFORM_FRAME_NONE);
			ini.Read(csSection, L"Preview.Transform.FieldOrder", profile.Preview.lTransformFieldOrder, TRANSFORM_FIELD_ORDER_ODD);
			ini.Read(csSection, L"Preview.Transform.Rotation", profile.Preview.lTransformRotation, TRANSFORM_ROTATION_NONE);
			ini.Read(csSection, L"Preview.Transform.FlipHorizontal", profile.Preview.bTransformFlipHorizontal, FALSE);
			ini.Read(csSection, L"Preview.Transform.FlipVertical", profile.Preview.bTransformFlipVertical, FALSE);
			ini.Read(csSection, L"Preview.Transform.DoubleHeight", profile.Preview.bTransformDoubleHeight, FALSE);
			ini.Read(csSection, L"Preview.Transform.YCExpand", profile.Preview.lTransformYCExpand, TRANSFORM_YCEXPAND_NONE);

			ini.Read(csSection, L"Preview.AudioVolume", profile.Preview.nAudioVolume, 100);

			ini.Read(csSection, L"Preview.AspectRatio", profile.Preview.lAspectRatio, ASPECT_RATIO_INPUT);
			ini.Read(csSection, L"Preview.AspectX", profile.Preview.nAspectX, 4);
			ini.Read(csSection, L"Preview.AspectY", profile.Preview.nAspectY, 3);

			ini.Read(csSection, L"Preview.ProcessPriority", profile.Preview.lProcessPriority, PROCESS_PRIORITY_ABOVE_NORMAL);

			ini.Read(csSection, L"Preview.Cropping.Top", profile.Preview.rcCropping.top, 0);
			ini.Read(csSection, L"Preview.Cropping.Left", profile.Preview.rcCropping.left, 0);
			ini.Read(csSection, L"Preview.Cropping.Right", profile.Preview.rcCropping.right, 0);
			ini.Read(csSection, L"Preview.Cropping.Bottom", profile.Preview.rcCropping.bottom, 0);
			
			//-------------------------------------------------------------------
			// VideoProcAmp
			ini.Read(csSection, L"VideoProcAmp.Brightness.Value",			profile.VideoProcAmp[0].lValue, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Brightness.Flags",			profile.VideoProcAmp[0].lFlags, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Contrast.Value",				profile.VideoProcAmp[1].lValue, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Contrast.Flags",				profile.VideoProcAmp[1].lFlags, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Hue.Value",					profile.VideoProcAmp[2].lValue, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Hue.Flags",					profile.VideoProcAmp[2].lFlags, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Saturation.Value",			profile.VideoProcAmp[3].lValue, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Saturation.Flags",			profile.VideoProcAmp[3].lFlags, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Sharpness.Value",			profile.VideoProcAmp[4].lValue, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Sharpness.Flags",			profile.VideoProcAmp[4].lFlags, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Gamma.Value",				profile.VideoProcAmp[5].lValue, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Gamma.Flags",				profile.VideoProcAmp[5].lFlags, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.ColorEnable.Value",			profile.VideoProcAmp[6].lValue, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.ColorEnable.Flags",			profile.VideoProcAmp[6].lFlags, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.WhiteBalance.Value",			profile.VideoProcAmp[7].lValue, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.WhiteBalance.Flags",			profile.VideoProcAmp[7].lFlags, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.BacklightCompensation.Value",profile.VideoProcAmp[8].lValue, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.BacklightCompensation.Flags",profile.VideoProcAmp[8].lFlags, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Gain.Value",					profile.VideoProcAmp[9].lValue, LONG_MIN);
			ini.Read(csSection, L"VideoProcAmp.Gain.Flags",					profile.VideoProcAmp[9].lFlags, LONG_MIN);

			//-------------------------------------------------------------------
			// VMR9ProcAmp
			ini.Read(csSection, L"VMR9ProcAmp.Brightness",	profile.VMR9ProcAmp.nBrightness, INT_MIN);
			ini.Read(csSection, L"VMR9ProcAmp.Contrast",	profile.VMR9ProcAmp.nContrast, INT_MIN);
			ini.Read(csSection, L"VMR9ProcAmp.Hue",			profile.VMR9ProcAmp.nHue, INT_MIN);
			ini.Read(csSection, L"VMR9ProcAmp.Saturation",	profile.VMR9ProcAmp.nSaturation, INT_MIN);

			//-------------------------------------------------------------------
			// EVRProcAmp
			ini.Read(csSection, L"EVRProcAmp.Brightness",	profile.EVRProcAmp.nBrightness, INT_MIN);
			ini.Read(csSection, L"EVRProcAmp.Contrast",		profile.EVRProcAmp.nContrast, INT_MIN);
			ini.Read(csSection, L"EVRProcAmp.Hue",			profile.EVRProcAmp.nHue, INT_MIN);
			ini.Read(csSection, L"EVRProcAmp.Saturation",	profile.EVRProcAmp.nSaturation, INT_MIN);

			m_vecProfile.push_back(profile);
		}
	}

	// ver0.04
	// ȑÕo[W̃fC^[[XݒuRs[i{jvɋύX
	if (nVersion < 4)
	{
		for (auto it = m_vecProfile.begin(); it != m_vecProfile.end(); ++it)
		{
			it->Preview.lTransformCopy = TRANSFORM_COPY_NONE;
		}
	}

	// ver0.10
	// VistaȏȂǉEVRCustomɕύX
	// xmlֈڍs
	OSVERSIONINFO info;
	info.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if (GetVersionEx(&info))
	{
		// dwMajorVersion == 6 Vista
		if (info.dwMajorVersion >= 6)
		{
			for (auto it = m_vecProfile.begin(); it != m_vecProfile.end(); ++it)
			{
				it->Preview.lVideoRenderer = VIDEO_RENDERER_EVR_CUSTOM;
			}
		}
	}
}

