#include "stdafx.h"
#include "Config.h"
#include "PeCaTV2.h"

////////////////////////////////////////
// EBhEftHgTCYw
/*
// EBhETCYŌvZ
static WINDOWPLACEMENT defWindowPlacement(int width, int height)
{
	WINDOWPLACEMENT wp = {};
	wp.length = sizeof(WINDOWPLACEMENT);

	CRect rc;
	::GetWindowRect(GetDesktopWindow(), &rc);

	if ((rc.Width() / 2) - (width / 2) < 0 || (rc.Height() / 2) - (height / 2) < 0)
	{// fXNgbvEBhE菬
		wp.rcNormalPosition.left = 0;
		wp.rcNormalPosition.top = 0;
		wp.rcNormalPosition.right = width;
		wp.rcNormalPosition.bottom = height;
	}
	else
	{// fXNgbvɔzu
		wp.rcNormalPosition.left = (rc.Width() / 2) - (width / 2);
		wp.rcNormalPosition.top = (rc.Height() / 2) - (height / 2);
		wp.rcNormalPosition.right = (rc.Width() / 2) + (width / 2);
		wp.rcNormalPosition.bottom = (rc.Height() / 2) + (height / 2);
	}
	return wp;
}
*/

// NCAgTCYŌvZ
static WINDOWPLACEMENT defWindowPlacement(int width, int height)
{
	WINDOWPLACEMENT wp = {};
	wp.length = sizeof(WINDOWPLACEMENT);

	CRect client, desktop;
	client.SetRect(0, 0, width, height);
	client.InflateRect(0, GetSystemMetrics(SM_CYCAPTION), 0, 0);
	client.InflateRect(GetSystemMetrics(SM_CXFRAME), GetSystemMetrics(SM_CYFRAME));

	::GetWindowRect(::GetDesktopWindow(), &desktop);

	if ((desktop.Width() / 2) - (client.Width() / 2) < 0 ||
		(desktop.Height() / 2) - (client.Height() / 2) < 0)
	{// fXNgbvEBhE菬
		wp.rcNormalPosition.left = 0;
		wp.rcNormalPosition.top = 0;
		wp.rcNormalPosition.right = client.Width();
		wp.rcNormalPosition.bottom = client.Height();
	}
	else
	{// fXNgbvɔzu
		wp.rcNormalPosition.left = (desktop.Width() / 2) - (client.Width() / 2);
		wp.rcNormalPosition.top = (desktop.Height() / 2) - (client.Height() / 2);
		wp.rcNormalPosition.right = wp.rcNormalPosition.left + client.Width();
		wp.rcNormalPosition.bottom = wp.rcNormalPosition.top + client.Height();
	}
	return wp;
}

static long defVideoRenderer()
{
	// Vistaȏ̃o[W
	// EVRlɐݒ肷
	long lPresetVideoRenderer = VIDEO_RENDERER_EVR_CUSTOM;

	OSVERSIONINFO info;
	info.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if (GetVersionEx(&info))
	{
		// dwMajorVersion == 6 Vista
		if (info.dwMajorVersion < 6)
		{
			lPresetVideoRenderer = VIDEO_RENDERER_VMR7;
		}
	}
	return lPresetVideoRenderer;
}

void CConfig::ReadConfigXML()
{
	XmlParser xml(m_wsConfigFilePathXML);
	XmlParser x;

	int nVersion = 0;

	auto root = xml.get(L"root");
	root.get(L"version", nVersion, CONFIG_FILE_VERSION);
	root.get(L"initial", m_bFirstTime, true);

	try {
		x = root.get(L"windowPlacement");
		x.get(L"length", m_stWndPlacement.length);
		x.get(L"flags", m_stWndPlacement.flags);
		x.get(L"showCmd", m_stWndPlacement.showCmd);

		x = root.get(L"windowPlacement.ptMinPosition");
		x.get(L"x", m_stWndPlacement.ptMinPosition.x);
		x.get(L"y", m_stWndPlacement.ptMinPosition.y);

		x = root.get(L"windowPlacement.ptMaxPosition");
		x.get(L"x", m_stWndPlacement.ptMaxPosition.x);
		x.get(L"y", m_stWndPlacement.ptMaxPosition.y);

		x = root.get(L"windowPlacement.rcNormalPosition");
		x.get(L"left", m_stWndPlacement.rcNormalPosition.left);
		x.get(L"top", m_stWndPlacement.rcNormalPosition.top);
		x.get(L"right", m_stWndPlacement.rcNormalPosition.right);
		x.get(L"bottom", m_stWndPlacement.rcNormalPosition.bottom);
	}
	catch (...) {
		m_stWndPlacement = defWindowPlacement(640, 480);
	}

	x = root.get(L"window");
	x.get(L"topMost", m_bTopMost, false);
	x.get(L"title", m_bTitleBar, true);
	x.get(L"frame", m_bWindowFrame, true);
	x.get(L"aspectRatio", m_bWindowAspectRatio, true);
	x.get(L"snap", m_bWindowSnap, true);
	x.get(L"drag", m_bWindowDrag, true);

	x = root.get(L"control");
	x.get(L"screenSaver", m_bScreenSaverStop, true);
	x.get(L"monitorPower", m_bMonitorPowerOffStop, true);
	x.get(L"systemStandby", m_bSystemStandbyStop, true);


	m_vecWindowSize.clear();
	x = root.get(L"size");
	if (x)
	{
		x.foreach(L"item", [&](const XmlParser& item){
			BOOL enable;
			int width, height;

			item.get(L"enable", enable, false);
			item.get(L"width", width, 800);
			item.get(L"height", height, 600);

			m_vecWindowSize.push_back(WindowSize(enable, width, height));
		});
	}
	else
	{
		m_vecWindowSize.push_back(WindowSize(TRUE, 1920, 1080));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1600, 900));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1440, 810));
		m_vecWindowSize.push_back(WindowSize(TRUE, 1280, 720));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1024, 576));
		m_vecWindowSize.push_back(WindowSize(FALSE, 960, 540));
		m_vecWindowSize.push_back(WindowSize(FALSE, 800, 450));
		m_vecWindowSize.push_back(WindowSize(FALSE, 640, 360));
		m_vecWindowSize.push_back(WindowSize(FALSE, 480, 270));
		m_vecWindowSize.push_back(WindowSize(FALSE, 352, 200));
		m_vecWindowSize.push_back(WindowSize(FALSE, 320, 180));
		
		m_vecWindowSize.push_back(WindowSize(FALSE, 1920, 1440));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1600, 1200));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1440, 1080));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1280, 960));
		m_vecWindowSize.push_back(WindowSize(FALSE, 1024, 768));
		m_vecWindowSize.push_back(WindowSize(FALSE, 960, 720));
		m_vecWindowSize.push_back(WindowSize(TRUE, 800, 600));
		m_vecWindowSize.push_back(WindowSize(TRUE, 640, 480));
		m_vecWindowSize.push_back(WindowSize(FALSE, 512, 384));
		m_vecWindowSize.push_back(WindowSize(FALSE, 480, 360));
		m_vecWindowSize.push_back(WindowSize(FALSE, 320, 240));
	}

	m_vecWindowZoom.clear();
	x = root.get(L"zoom");
	if (x)
	{
		x.foreach(L"item", [&](const XmlParser& item){
			BOOL enable;
			int zoom;
			item.get(L"enable", enable, false);
			item.get(L"zoom", zoom, 100);

			m_vecWindowZoom.push_back(WindowZoom(enable, zoom));
		});
	}
	else
	{
		m_vecWindowZoom.push_back(WindowZoom(FALSE, 150));
		m_vecWindowZoom.push_back(WindowZoom(FALSE, 125));
		m_vecWindowZoom.push_back(WindowZoom(TRUE, 100));
		m_vecWindowZoom.push_back(WindowZoom(TRUE, 75));
		m_vecWindowZoom.push_back(WindowZoom(TRUE, 50));
	}

	m_vecCrop.clear();
	x = root.get(L"crop");
	x.foreach(L"item", [&](const XmlParser& item){
		CRect rc;
		item.get(L"left", rc.left);
		item.get(L"top", rc.top);
		item.get(L"right", rc.right);
		item.get(L"bottom", rc.bottom);

		m_vecCrop.push_back(rc);
	});

	x = root.get(L"snapshot");
	x.get(L"folder", m_wsSnapShotFolder, m_wsCurrentFolder);
	x.get(L"type", m_lSnapShotType, (long)CSnapShot::FORMAT_PNG);
	x.get(L"size", m_nSnapShotVideoSize, 1);
	x.get(L"crop", m_bSnapShotCrop, true);
	x.get(L"jpegQuality", m_nSnapShotJpegQuality, 100);

	x = root.get(L"option");
	x.get(L"lastTab", m_nOptionLastTab, 0);

	InitShortCut(m_vecShortCut);
	x = root.get(L"shortcut");
	if (x)
	{
		x.foreach(L"item", [&](const XmlParser& item){
			ShortCut tmp;
			item.get(L"messageID", tmp.dwMessageID, 0UL); // ĂяoEBhEbZ[WID
			item.get(L"keyModify", tmp.dwKeyModify, 0UL); // CL[
			item.get(L"keyCode", tmp.dwKeyCode, 0UL); // L[R[h
			item.get(L"mouseModify", tmp.dwMouseModify, 0UL); // CL[
			item.get(L"mouseCode", tmp.dwMouseCode, 0UL); // }EXR[h

			for (auto it = m_vecShortCut.begin(); it != m_vecShortCut.end(); ++it)
			{
				if (it->dwMessageID == tmp.dwMessageID)
				{
					*it = tmp;
				}
			}
		});
	}
}

void CConfig::ReadProfileXML()
{
	XmlParser xml(m_wsProfileFilePathXML);
	XmlParser x;

	int nVersion = 0;

	auto root = xml.get(L"root");
	root.get(L"version", nVersion, CONFIG_FILE_VERSION);

	x = root.get(L"option");
	x.get(L"lastTab", m_nProfileLastTab, 0);
	x.get(L"preview", m_bProfilePreview, true);



	std::wstring profileName = L"vt@C";
	m_vecProfile.clear();
	x = root.get(L"profile");
	x.get(L"selected", m_nProfileSelected, 0);
	if (x)
	{
		x.foreach(L"item", [&](const XmlParser& item){
			CCaptureGraphProfile profile;
			item.get(L"name", profile.wsName, profileName);

			ReadProfileItemXML(item, profile);

			m_vecProfile.push_back(profile);
		});
	}
	else
	{
		for (int i = 0; i < CONFIG_PROFILE_COUNT; ++i)
		{
			CCaptureGraphProfile profile;
			profile.wsName = profileName;
			m_vecProfile.push_back(profile);
		}
	}
}

void CConfig::ReadProfileItemXML(const XmlParser& root, CCaptureGraphProfile& profile)
{
	auto x = root.get(L"video");
	x.get(L"name", profile.Video.wsFriendlyName, L"");
	x.get(L"path", profile.Video.wsDevicePath, L"");
	x.get(L"desc", profile.Video.wsDescription, L"");

	x = root.get(L"video.format");
	x.get(L"index", profile.Video.Format.nIndex, 0);
	x.get(L"width", profile.Video.Format.biWidth, 0L);
	x.get(L"height", profile.Video.Format.biHeight, 0L);
	x.get(L"avgTimePerFrame", profile.Video.Format.AvgTimePerFrame, 0LL);
	x.get(L"standard", profile.Video.Format.lStandard, 0L);

	ReadProfileCrossbarXML(x, profile.Video.vecCrossbar);

	x = root.get(L"audio");
	x.get(L"name", profile.Audio.wsFriendlyName, L"");
	x.get(L"path", profile.Audio.wsDevicePath, L"");
	x.get(L"desc", profile.Audio.wsDescription, L"");

	x = root.get(L"audio.buffer");
	x.get(L"enable", profile.Audio.bBufferSize, false);
	x.get(L"size", profile.Audio.nBufferSize, 50);

	x = root.get(L"audio.format");
	x.get(L"index", profile.Audio.Format.nIndex, 0);
	x.get(L"channels", profile.Audio.Format.nChannels, (WORD)0);
	x.get(L"bitsPerSample", profile.Audio.Format.wBitsPerSample, (WORD)0);
	x.get(L"samplesPerSec", profile.Audio.Format.nSamplesPerSec, 0UL);

	x = root.get(L"filter.video");
	ReadProfileFilterXML(x, profile.Filter.vecVideo);

	x = root.get(L"filter.audio");
	ReadProfileFilterXML(x, profile.Filter.vecAudio);


	x = root.get(L"preview");
	x.get(L"processPriority", profile.Preview.lProcessPriority, (long)PROCESS_PRIORITY_ABOVE_NORMAL);

	
	x = root.get(L"preview.video");
	x.get(L"renderder", profile.Preview.lVideoRenderer, defVideoRenderer());
	bool videoSync = false;
	x.get(L"sync", videoSync, false); // !۔]
	profile.Preview.bVideoPreviewPin = videoSync ? FALSE : TRUE;
	x.get(L"aspectRatio", profile.Preview.lAspectRatio, (long)ASPECT_RATIO_INPUT);
	x.get(L"aspectX", profile.Preview.nAspectX, 4);
	x.get(L"aspectY", profile.Preview.nAspectY, 3);
	x.get(L"resizer", profile.Preview.lResizer, (long)d3dutl::RESIZER_DEFAULT);

	x = root.get(L"preview.audio");
	x.get(L"renderder", profile.Preview.lAudioRenderer, (long)AUDIO_RENDERER_DIRECTSOUND);
	bool audioSync = false;
	x.get(L"sync", audioSync, false); // !۔]
	profile.Preview.bAudioPreviewPin = audioSync ? FALSE : TRUE;
	x.get(L"volume", profile.Preview.nAudioVolume, 100);
	x.get(L"mute", profile.Preview.bAudioMute, false);

	x = root.get(L"preview.transform");
	x.get(L"enable", profile.Preview.bTransform, true); 
	x.get(L"copy", profile.Preview.lTransformCopy, (long)TRANSFORM_COPY_NONE);
	x.get(L"frame", profile.Preview.lTransformFrame, (long)TRANSFORM_FRAME_NONE);
	x.get(L"fieldOrder", profile.Preview.lTransformFieldOrder, (long)TRANSFORM_FIELD_ORDER_ODD);
	x.get(L"rotation", profile.Preview.lTransformRotation, (long)TRANSFORM_ROTATION_NONE);
	x.get(L"flipHorizontal", profile.Preview.bTransformFlipHorizontal, false);
	x.get(L"flipVertical", profile.Preview.bTransformFlipVertical, false);
	x.get(L"doubleHeight", profile.Preview.bTransformDoubleHeight, false);
	x.get(L"ycExpand", profile.Preview.lTransformYCExpand, (long)TRANSFORM_YCEXPAND_NONE);

	x = root.get(L"preview.crop");
	x.get(L"left", profile.Preview.rcCropping.left, 0L);
	x.get(L"top", profile.Preview.rcCropping.top, 0L);
	x.get(L"right", profile.Preview.rcCropping.right, 0L);
	x.get(L"bottom", profile.Preview.rcCropping.bottom, 0L);

	x = root.get(L"preview.videoProcAmp");
	WriteProfileVideoProcAmpXML(x, profile.VideoProcAmp);

	x = root.get(L"preview.vmr9ProcAmp");
	x.get(L"brightness", profile.VMR9ProcAmp.nBrightness, INT_MIN);
	x.get(L"contrast", profile.VMR9ProcAmp.nContrast, INT_MIN);
	x.get(L"hue", profile.VMR9ProcAmp.nHue, INT_MIN);
	x.get(L"saturation", profile.VMR9ProcAmp.nSaturation, INT_MIN);

	x = root.get(L"preview.evrProcAmp");
	x.get(L"brightness", profile.EVRProcAmp.nBrightness, INT_MIN);
	x.get(L"contrast", profile.EVRProcAmp.nContrast, INT_MIN);
	x.get(L"hue", profile.EVRProcAmp.nHue, INT_MIN);
	x.get(L"saturation", profile.EVRProcAmp.nSaturation, INT_MIN);
}

void CConfig::ReadProfileCrossbarXML(const XmlParser& root, std::vector<CCrossbar>& crossbar)
{
	crossbar.clear();
	auto x = root.get(L"crossbar");
	x.foreach(L"item", [&](const XmlParser& item){
		CCrossbar cross;
		item.get(L"input", cross.lInput, (long)-1);
		item.get(L"output", cross.lOutput, (long)-1);
		crossbar.push_back(cross);
	});
}

void CConfig::ReadProfileFilterXML(const XmlParser& root, std::vector<CFilterItem>& filter)
{
	root.foreach(L"item", [&](const XmlParser& item){
		CFilterItem fi;
		item.get(L"enable", fi.bCheck, true);
		item.get(L"name", fi.wsFriendlyName, L"");
		item.get(L"path", fi.wsDevicePath, L"");
		item.get(L"desc", fi.wsDescription, L"");
		item.get(L"input", fi.nInput, -1);
		item.get(L"output", fi.nOutput, -1);
		filter.push_back(fi);
	});
}

extern const wchar_t* videoProcAmpKey[10];
void CConfig::ReadProfileVideoProcAmpXML(const XmlParser& root, CVideoProcAmpConfig* vpa)
{
	for (int i = 0; i < 10; ++i)
	{
		auto x = root.get(videoProcAmpKey[i]);
		x.get(L"value", vpa[i].lValue, LONG_MIN);
		x.get(L"flags", vpa[i].lFlags, LONG_MIN);
	}
}
