#include "stdafx.h"
#include "Config.h"
#include "PeCaTV2.h"



//--------------------------------------------------------------------------------
//	WriteConfigINI
//	ݒt@C
//--------------------------------------------------------------------------------
void CConfig::WriteConfigINI()
{
	CInitFile ini;

	// NtO
	ini.Write(L"Common", L"FirstTime", FALSE);

	// AvP[Vo[W
	ini.Write(L"Common", L"FileVersion", CONFIG_FILE_VERSION);

	// EBhEʒu
	ini.WriteData(L"Window", L"Placement", &m_stWndPlacement, sizeof(WINDOWPLACEMENT));

	// EBhEX^C
	ini.Write(L"Window", L"AspectRatio", m_bWindowAspectRatio);
	ini.Write(L"Window", L"TitleBar", m_bTitleBar);
	ini.Write(L"Window", L"Frame", m_bWindowFrame);
	ini.Write(L"Window", L"TopMost", m_bTopMost);
	ini.Write(L"Window", L"Snap", m_bWindowSnap);
	ini.Write(L"Window", L"Drag", m_bWindowDrag);
	ini.Write(L"Window", L"ScreenSaverStop", m_bScreenSaverStop);
	ini.Write(L"Window", L"MonitorPowerOffStop", m_bMonitorPowerOffStop);
	ini.Write(L"Window", L"SystemStandbyStop", m_bSystemStandbyStop);


	// fTCY
	{
		ini.Write(L"WindowSize", L"Count", static_cast<int>(m_vecWindowSize.size()));

		CString csKey;
		int count = 0;
		for (std::vector<WindowSize>::iterator it = m_vecWindowSize.begin(), end = m_vecWindowSize.end();
			it != end; ++it)
		{
			csKey.Format(L"Enable(%d)", count);
			ini.Write(L"WindowSize", csKey, it->enable);

			csKey.Format(L"Width(%d)", count);
			ini.Write(L"WindowSize", csKey, it->width);

			csKey.Format(L"Height(%d)", count);
			ini.Write(L"WindowSize", csKey, it->height);

			count++;
		}
	}

	// fg嗦
	{
		ini.Write(L"WindowZoom", L"Count", static_cast<int>(m_vecWindowZoom.size()));

		CString csKey;
		int count = 0;
		for (std::vector<WindowZoom>::iterator it = m_vecWindowZoom.begin(), end = m_vecWindowZoom.end();
			it != end; ++it)
		{
			csKey.Format(L"Enable(%d)", count);
			ini.Write(L"WindowZoom", csKey, it->enable);

			csKey.Format(L"Zoom(%d)", count);
			ini.Write(L"WindowZoom", csKey, it->zoom);

			count++;
		}
	}

	// NbsO
	{
		ini.Write(L"Cropping", L"Count", static_cast<int>(m_vecCrop.size()));

		CString csKey;
		int count = 0;
		for (std::vector<CRect>::iterator it = m_vecCrop.begin(), end = m_vecCrop.end();
			it != end; ++it)
		{
			csKey.Format(L"Top(%d)", count);
			ini.Write(L"Cropping", csKey, it->top);

			csKey.Format(L"Left(%d)", count);
			ini.Write(L"Cropping", csKey, it->left);

			csKey.Format(L"Right(%d)", count);
			ini.Write(L"Cropping", csKey, it->right);

			csKey.Format(L"Bottom(%d)", count);
			ini.Write(L"Cropping", csKey, it->bottom);

			count++;
		}
	}

	// XibvVbg
	ini.Write(L"SnapShot", L"Folder", m_wsSnapShotFolder);
	ini.Write(L"SnapShot", L"Type", m_lSnapShotType);
	ini.Write(L"SnapShot", L"WindowSize", m_nSnapShotVideoSize);
	ini.Write(L"SnapShot", L"Crop", m_bSnapShotCrop);
	ini.Write(L"SnapShot", L"JpegQuality", m_nSnapShotJpegQuality);

	// IvV
	ini.Write(L"Option", L"LastTab", m_nOptionLastTab);

	ini.Save(m_wsConfigFilePathINI.c_str());
}



//--------------------------------------------------------------------------------
//	WriteProfileINI
//	ݒt@C
//--------------------------------------------------------------------------------
void CConfig::WriteProfileINI()
{
	CInitFile ini;

	// t@Co[W
	ini.Write(L"Common", L"FileVersion", CONFIG_FILE_VERSION);

	// tB^Otvt@C
	ini.Write(L"Profile", L"Selected", m_nProfileSelected);
	ini.Write(L"Profile", L"LastTab", m_nProfileLastTab);
	ini.Write(L"Profile", L"Preview", m_bProfilePreview);
	ini.Write(L"Profile", L"Count", (int)m_vecProfile.size());

	{
		int i = 0;
		for (auto it = m_vecProfile.begin(); it != m_vecProfile.end(); ++it)
		{
			CString csSection;
			csSection.Format(L"Profile:%02d", i);

			ini.Write(csSection, L"Name", it->wsName);

			//-------------------------------------------------------------------
			// rfILv`[tB^
			ini.Write(csSection, L"Video.FriendlyName", it->Video.wsFriendlyName);
			ini.Write(csSection, L"Video.DevicePath", it->Video.wsDevicePath);
			ini.Write(csSection, L"Video.Description", it->Video.wsDescription);

			// NXo[
			ini.Write(csSection, L"Video.Crossbar", (int)it->Video.vecCrossbar.size());

			int nXbar = 0;
			std::vector<CCrossbar>::iterator itXbar;
			for (itXbar = it->Video.vecCrossbar.begin(); itXbar != it->Video.vecCrossbar.end(); itXbar++)
			{
				CString csKey;

				csKey.Format(L"Video.Crossbar(%d).Output", nXbar);
				ini.Write(csSection, csKey, itXbar->lOutput);

				csKey.Format(L"Video.Crossbar(%d).Input", nXbar);
				ini.Write(csSection, csKey, itXbar->lInput);

				nXbar++;
			}

			ini.Write(csSection, L"Video.Format.Index", it->Video.Format.nIndex);
			ini.Write(csSection, L"Video.Format.Width", it->Video.Format.biWidth);
			ini.Write(csSection, L"Video.Format.Height", it->Video.Format.biHeight);
			ini.Write(csSection, L"Video.Format.AvgTimePerFrame", it->Video.Format.AvgTimePerFrame);
			ini.Write(csSection, L"Video.Format.Standard", it->Video.Format.lStandard);

			//-------------------------------------------------------------------
			// I[fBILv`[tB^
			ini.Write(csSection, L"Audio.FriendlyName", it->Audio.wsFriendlyName);
			ini.Write(csSection, L"Audio.DevicePath", it->Audio.wsDevicePath);
			ini.Write(csSection, L"Audio.Description", it->Audio.wsDescription);

			ini.Write(csSection, L"Audio.UseBufferSize", it->Audio.bBufferSize);
			ini.Write(csSection, L"Audio.BufferSize", it->Audio.nBufferSize);

			ini.Write(csSection, L"Audio.Format.Index", it->Audio.Format.nIndex);
			ini.Write(csSection, L"Audio.Format.Channels", it->Audio.Format.nChannels);
			ini.Write(csSection, L"Audio.Format.BitsPerSample", it->Audio.Format.wBitsPerSample);
			ini.Write(csSection, L"Audio.Format.SamplesPerSec", it->Audio.Format.nSamplesPerSec);

			//-------------------------------------------------------------------
			// tB^
			int nFilter;
			std::vector<CFilterItem>::iterator itFilter;

			ini.Write(csSection, L"Filter.Video", (int)it->Filter.vecVideo.size());

			nFilter = 0;
			for (itFilter = it->Filter.vecVideo.begin(); itFilter != it->Filter.vecVideo.end(); ++itFilter)
			{
				CString csKey;

				csKey.Format(L"Filter.Video(%d).Check", nFilter);
				ini.Write(csSection, csKey, itFilter->bCheck);

				csKey.Format(L"Filter.Video(%d).FriendlyName", nFilter);
				ini.Write(csSection, csKey, itFilter->wsFriendlyName);

				csKey.Format(L"Filter.Video(%d).Description", nFilter);
				ini.Write(csSection, csKey, itFilter->wsDescription);

				csKey.Format(L"Filter.Video(%d).DevicePath", nFilter);
				ini.Write(csSection, csKey, itFilter->wsDevicePath);

				csKey.Format(L"Filter.Video(%d).Input", nFilter);
				ini.Write(csSection, csKey, itFilter->nInput);

				csKey.Format(L"Filter.Video(%d).Output", nFilter);
				ini.Write(csSection, csKey, itFilter->nOutput);

				nFilter++;
			}

			ini.Write(csSection, L"Filter.Audio", (int)it->Filter.vecAudio.size());

			nFilter = 0;
			for (itFilter = it->Filter.vecAudio.begin(); itFilter != it->Filter.vecAudio.end(); ++itFilter)
			{
				CString csKey;

				csKey.Format(L"Filter.Audio(%d).Check", nFilter);
				ini.Write(csSection, csKey, itFilter->bCheck);

				csKey.Format(L"Filter.Audio(%d).FriendlyName", nFilter);
				ini.Write(csSection, csKey, itFilter->wsFriendlyName);

				csKey.Format(L"Filter.Audio(%d).Description", nFilter);
				ini.Write(csSection, csKey, itFilter->wsDescription);

				csKey.Format(L"Filter.Audio(%d).DevicePath", nFilter);
				ini.Write(csSection, csKey, itFilter->wsDevicePath);

				csKey.Format(L"Filter.Audio(%d).Input", nFilter);
				ini.Write(csSection, csKey, itFilter->nInput);

				csKey.Format(L"Filter.Audio(%d).Output", nFilter);
				ini.Write(csSection, csKey, itFilter->nOutput);

				nFilter++;
			}

			//-------------------------------------------------------------------
			// vr[ݒ
			ini.Write(csSection, L"Preview.VideoSync", it->Preview.bVideoPreviewPin);
			ini.Write(csSection, L"Preview.AudioSync", it->Preview.bAudioPreviewPin);

			ini.Write(csSection, L"Preview.VideoRenderer", it->Preview.lVideoRenderer);
			ini.Write(csSection, L"Preview.AudioRenderer", it->Preview.lAudioRenderer);

			ini.Write(csSection, L"Preview.Transform", it->Preview.bTransform);
			ini.Write(csSection, L"Preview.Transform.Copy", it->Preview.lTransformCopy);
			ini.Write(csSection, L"Preview.Transform.Frame", it->Preview.lTransformFrame);
			ini.Write(csSection, L"Preview.Transform.FieldOrder", it->Preview.lTransformFieldOrder);
			ini.Write(csSection, L"Preview.Transform.Rotation", it->Preview.lTransformRotation);
			ini.Write(csSection, L"Preview.Transform.FlipHorizontal", it->Preview.bTransformFlipHorizontal);
			ini.Write(csSection, L"Preview.Transform.FlipVertical", it->Preview.bTransformFlipVertical);
			ini.Write(csSection, L"Preview.Transform.DoubleHeight", it->Preview.bTransformDoubleHeight);
			ini.Write(csSection, L"Preview.Transform.YCExpand", it->Preview.lTransformYCExpand);

			ini.Write(csSection, L"Preview.AudioVolume", it->Preview.nAudioVolume);

			ini.Write(csSection, L"Preview.AspectRatio", it->Preview.lAspectRatio);
			ini.Write(csSection, L"Preview.AspectX", it->Preview.nAspectX);
			ini.Write(csSection, L"Preview.AspectY", it->Preview.nAspectY);

			ini.Write(csSection, L"Preview.ProcessPriority", it->Preview.lProcessPriority);

			ini.Write(csSection, L"Preview.Cropping.Top", it->Preview.rcCropping.top);
			ini.Write(csSection, L"Preview.Cropping.Left", it->Preview.rcCropping.left);
			ini.Write(csSection, L"Preview.Cropping.Right", it->Preview.rcCropping.right);
			ini.Write(csSection, L"Preview.Cropping.Bottom", it->Preview.rcCropping.bottom);

			//-------------------------------------------------------------------
			// VideoProcAmp
			ini.Write(csSection, L"VideoProcAmp.Brightness.Value",				it->VideoProcAmp[0].lValue);
			ini.Write(csSection, L"VideoProcAmp.Brightness.Flags",				it->VideoProcAmp[0].lFlags);
			ini.Write(csSection, L"VideoProcAmp.Contrast.Value",				it->VideoProcAmp[1].lValue);
			ini.Write(csSection, L"VideoProcAmp.Contrast.Flags",				it->VideoProcAmp[1].lFlags);
			ini.Write(csSection, L"VideoProcAmp.Hue.Value",						it->VideoProcAmp[2].lValue);
			ini.Write(csSection, L"VideoProcAmp.Hue.Flags",						it->VideoProcAmp[2].lFlags);
			ini.Write(csSection, L"VideoProcAmp.Saturation.Value",				it->VideoProcAmp[3].lValue);
			ini.Write(csSection, L"VideoProcAmp.Saturation.Flags",				it->VideoProcAmp[3].lFlags);
			ini.Write(csSection, L"VideoProcAmp.Sharpness.Value",				it->VideoProcAmp[4].lValue);
			ini.Write(csSection, L"VideoProcAmp.Sharpness.Flags",				it->VideoProcAmp[4].lFlags);
			ini.Write(csSection, L"VideoProcAmp.Gamma.Value",					it->VideoProcAmp[5].lValue);
			ini.Write(csSection, L"VideoProcAmp.Gamma.Flags",					it->VideoProcAmp[5].lFlags);
			ini.Write(csSection, L"VideoProcAmp.ColorEnable.Value",				it->VideoProcAmp[6].lValue);
			ini.Write(csSection, L"VideoProcAmp.ColorEnable.Flags",				it->VideoProcAmp[6].lFlags);
			ini.Write(csSection, L"VideoProcAmp.WhiteBalance.Value",			it->VideoProcAmp[7].lValue);
			ini.Write(csSection, L"VideoProcAmp.WhiteBalance.Flags",			it->VideoProcAmp[7].lFlags);
			ini.Write(csSection, L"VideoProcAmp.BacklightCompensation.Value",	it->VideoProcAmp[8].lValue);
			ini.Write(csSection, L"VideoProcAmp.BacklightCompensation.Flags",	it->VideoProcAmp[8].lFlags);
			ini.Write(csSection, L"VideoProcAmp.Gain.Value",					it->VideoProcAmp[9].lValue);
			ini.Write(csSection, L"VideoProcAmp.Gain.Flags",					it->VideoProcAmp[9].lFlags);

			//-------------------------------------------------------------------
			// VMR9ProcAmp
			ini.Write(csSection, L"VMR9ProcAmp.Brightness",	it->VMR9ProcAmp.nBrightness);
			ini.Write(csSection, L"VMR9ProcAmp.Contrast",	it->VMR9ProcAmp.nContrast);
			ini.Write(csSection, L"VMR9ProcAmp.Hue",		it->VMR9ProcAmp.nHue);
			ini.Write(csSection, L"VMR9ProcAmp.Saturation",	it->VMR9ProcAmp.nSaturation);

			//-------------------------------------------------------------------
			// EVRProcAmp
			ini.Write(csSection, L"EVRProcAmp.Brightness",	it->EVRProcAmp.nBrightness);
			ini.Write(csSection, L"EVRProcAmp.Contrast",	it->EVRProcAmp.nContrast);
			ini.Write(csSection, L"EVRProcAmp.Hue",			it->EVRProcAmp.nHue);
			ini.Write(csSection, L"EVRProcAmp.Saturation",	it->EVRProcAmp.nSaturation);

			i++;
		}	
	}

	ini.Save(m_wsProfileFilePathINI.c_str());
}

