// CroppingDlg.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "CroppingDlg.h"


// CCroppingDlg _CAO

IMPLEMENT_DYNAMIC(CCroppingDlg, CDialog)

CCroppingDlg::CCroppingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCroppingDlg::IDD, pParent)
{
	m_nCrop[0] = 0;
	m_nCrop[1] = 0;
	m_nCrop[2] = 0;
	m_nCrop[3] = 0;
}

CCroppingDlg::~CCroppingDlg()
{
}

void CCroppingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SB_TOP, m_xcSBCtrl[0]);
	DDX_Control(pDX, IDC_SB_LEFT, m_xcSBCtrl[1]);
	DDX_Control(pDX, IDC_SB_RIGHT, m_xcSBCtrl[2]);
	DDX_Control(pDX, IDC_SB_BOTTOM, m_xcSBCtrl[3]);
	DDX_Control(pDX, IDC_ED_TOP, m_xcEDCtrl[0]);
	DDX_Control(pDX, IDC_ED_LEFT, m_xcEDCtrl[1]);
	DDX_Control(pDX, IDC_ED_RIGHT, m_xcEDCtrl[2]);
	DDX_Control(pDX, IDC_ED_BOTTOM, m_xcEDCtrl[3]);
	DDX_Control(pDX, IDC_CB_LIST, m_xcCbList);
	DDX_Control(pDX, IDC_BTN_DEL, m_xcBtnDel);
	DDX_Control(pDX, IDC_BTN_ADD, m_xcBtnAdd);
}


BEGIN_MESSAGE_MAP(CCroppingDlg, CDialog)
	ON_WM_DESTROY()
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_CB_LIST, &CCroppingDlg::OnCbnSelchangeCbList)
	ON_BN_CLICKED(IDC_BTN_DEL, &CCroppingDlg::OnBnClickedBtnDel)
	ON_BN_CLICKED(IDC_BTN_ADD, &CCroppingDlg::OnBnClickedBtnAdd)
END_MESSAGE_MAP()


void CCroppingDlg::SetCroppingRect(RECT &rc)
{
	m_rcCrop = rc;
}

void CCroppingDlg::GetCroppingRect(RECT &rc)
{
	rc = m_rcCrop;
}



BOOL CCroppingDlg::SetCaptureGraphBuilder(CCaptureGraphBuilder* pGraph)
{
	if (pGraph == NULL)
	{
		return FALSE;
	}

	m_pGraph = pGraph;

	return TRUE;
}


// CCroppingDlg bZ[W nh

BOOL CCroppingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_nCrop[0] = m_rcCrop.top;
	m_nCrop[1] = m_rcCrop.left;
	m_nCrop[2] = m_rcCrop.right;
	m_nCrop[3] = m_rcCrop.bottom;


	CString csTmp;

	for (int i = 0; i < 4; i++)
	{
		m_xcSBCtrl[i].SetScrollRange(0, CROPPING_MAX);
		m_xcSBCtrl[i].SetScrollPos(m_nCrop[i]);

		
		csTmp.Format(L"%d", m_nCrop[i]);
		m_xcEDCtrl[i].SetWindowText(csTmp);
	}



	m_xcCbList.ResetContent();
	m_xcCbList.AddString(L"ftHg");

	for (std::vector<CRect>::iterator it = m_vecCrop.begin(), end = m_vecCrop.end();
		it != end; ++it)
	{
		csTmp.Format(L"(%d) (%d) E(%d) (%d)", it->top, it->left, it->right, it->bottom);
		m_xcCbList.AddString(csTmp);
	}

	m_xcCbList.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CCroppingDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ɃbZ[W nh R[hǉ܂B
}

void CCroppingDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int nNewPos = pScrollBar->GetScrollPos();

	for (int i = 0; i < 4; i++)
	{
		if (*pScrollBar != m_xcSBCtrl[i])
		{
			continue;
		}

		switch (nSBCode)
		{
		// ܂݂hbO
		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:
			nNewPos = nPos;
			break;

		// {^NbN
		case SB_LINELEFT:
		case SB_PAGELEFT:
			{
				nNewPos--;
				if (nNewPos < 0)
				{
					nNewPos = 0;
				}
				break;
			}
		// E{^NbN
		case SB_LINERIGHT:
		case SB_PAGERIGHT:
			{
				nNewPos++;
				if (nNewPos > CROPPING_MAX)
				{
					nNewPos = CROPPING_MAX;
				}
				break;
			}

		default:
			break;
		}

		m_xcSBCtrl[i].SetScrollPos(nNewPos);

		m_nCrop[i] = nNewPos;

		m_rcCrop.top = m_nCrop[0];
		m_rcCrop.left = m_nCrop[1];
		m_rcCrop.right = m_nCrop[2];
		m_rcCrop.bottom = m_nCrop[3];

		CString csTmp;
		csTmp.Format(L"%d", m_nCrop[i]);
		m_xcEDCtrl[i].SetWindowText(csTmp);

		if (m_pGraph != NULL)
		{
			m_pGraph->SetCroppingRect(m_rcCrop);
			m_pGraph->SetVideoPosition();
		}

		return;
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


void CCroppingDlg::OnCbnSelchangeCbList()
{
	int index = m_xcCbList.GetCurSel();

	CRect rc(0, 0, 0, 0);

	if (index > 0)
	{
		try {
			rc = m_vecCrop.at(index - 1);
		} catch (std::exception&) {}
	}


	m_xcSBCtrl[0].SetScrollPos(rc.top);
	m_xcSBCtrl[1].SetScrollPos(rc.left);
	m_xcSBCtrl[2].SetScrollPos(rc.right);
	m_xcSBCtrl[3].SetScrollPos(rc.bottom);

	m_nCrop[0] = rc.top;
	m_nCrop[1] = rc.left;
	m_nCrop[2] = rc.right;
	m_nCrop[3] = rc.bottom;

	m_rcCrop.top = m_nCrop[0];
	m_rcCrop.left = m_nCrop[1];
	m_rcCrop.right = m_nCrop[2];
	m_rcCrop.bottom = m_nCrop[3];

	CString csTmp;
	csTmp.Format(L"%d", m_nCrop[0]);
	m_xcEDCtrl[0].SetWindowText(csTmp);
	csTmp.Format(L"%d", m_nCrop[1]);
	m_xcEDCtrl[1].SetWindowText(csTmp);
	csTmp.Format(L"%d", m_nCrop[2]);
	m_xcEDCtrl[2].SetWindowText(csTmp);
	csTmp.Format(L"%d", m_nCrop[3]);
	m_xcEDCtrl[3].SetWindowText(csTmp);

	if (m_pGraph != NULL)
	{
		m_pGraph->SetCroppingRect(m_rcCrop);
		m_pGraph->SetVideoPosition();
	}
}


void CCroppingDlg::OnBnClickedBtnDel()
{
	int index = m_xcCbList.GetCurSel();

	if (index <= 0)
	{
		return;
	}

	int count = 1;
	std::vector<CRect>::iterator it = m_vecCrop.begin();
	std::vector<CRect>::iterator end = m_vecCrop.end();

	for (; it != end; ++it)
	{
		if (index == count)
		{
			m_vecCrop.erase(it);
			m_xcCbList.DeleteString(index);
			m_xcCbList.SetCurSel(index - 1);
			break;
		}
		count++;
	}
}


void CCroppingDlg::OnBnClickedBtnAdd()
{
	if (m_vecCrop.size() > 20)
	{
		return;
	}

	CRect rc(
		m_xcSBCtrl[1].GetScrollPos(),
		m_xcSBCtrl[0].GetScrollPos(),
		m_xcSBCtrl[2].GetScrollPos(),
		m_xcSBCtrl[3].GetScrollPos());

	// łɓlǉĂȂ
	// ǉɃJ[\킹
	int result = 1;
	std::vector<CRect>::iterator it = m_vecCrop.begin();
	std::vector<CRect>::iterator end = m_vecCrop.end();
	for (; it != end; ++it)
	{
		if (*it == rc)
		{
			m_xcCbList.SetCurSel(result);
			return;
		}
		result++;
	}

	m_vecCrop.push_back(rc);

	CString csTmp;
	csTmp.Format(L"(%d) (%d) E(%d) (%d)", rc.top, rc.left, rc.right, rc.bottom);
	m_xcCbList.AddString(csTmp);

	int count = m_xcCbList.GetCount();
	if (count > 0)
	{
		m_xcCbList.SetCurSel(count - 1);
	}
}
