// CroppingPage.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "CroppingPage.h"
#include "afxdialogex.h"


// CCroppingPage _CAO

IMPLEMENT_DYNAMIC(CCroppingPage, CPropertyPage)

CCroppingPage::CCroppingPage(CMainDlg *dlg, CCaptureGraphProfile *profile, std::vector<CRect>* crop)
	: CPropertyPage(CCroppingPage::IDD)
	, dlg_(dlg)
	, profile_(profile)
	, graph_(&(dlg->m_Preview))
	, cfg_(&(profile->Preview.rcCropping))
	, crop_(crop)
{
	m_psp.dwFlags &= ~PSP_HASHELP;
}

CCroppingPage::~CCroppingPage()
{

}

void CCroppingPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SB_TOP, m_xcSBCtrl[0]);
	DDX_Control(pDX, IDC_SB_LEFT, m_xcSBCtrl[1]);
	DDX_Control(pDX, IDC_SB_RIGHT, m_xcSBCtrl[2]);
	DDX_Control(pDX, IDC_SB_BOTTOM, m_xcSBCtrl[3]);
	DDX_Control(pDX, IDC_ED_TOP, m_xcEDCtrl[0]);
	DDX_Control(pDX, IDC_ED_LEFT, m_xcEDCtrl[1]);
	DDX_Control(pDX, IDC_ED_RIGHT, m_xcEDCtrl[2]);
	DDX_Control(pDX, IDC_ED_BOTTOM, m_xcEDCtrl[3]);
	DDX_Control(pDX, IDC_CB_LIST, m_xcCbList);
	DDX_Control(pDX, IDC_BTN_DEL, m_xcBtnDel);
	DDX_Control(pDX, IDC_BTN_ADD, m_xcBtnAdd);
}


BEGIN_MESSAGE_MAP(CCroppingPage, CPropertyPage)
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_CB_LIST, &CCroppingPage::OnCbnSelchangeCbList)
	ON_BN_CLICKED(IDC_BTN_DEL, &CCroppingPage::OnBnClickedBtnDel)
	ON_BN_CLICKED(IDC_BTN_ADD, &CCroppingPage::OnBnClickedBtnAdd)
END_MESSAGE_MAP()


// CCroppingPage bZ[W nh[


BOOL CCroppingPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// ݂̐ݒ
	int crop[4] = { cfg_->top, cfg_->left, cfg_->right, cfg_->bottom };

	// Jgݒ
	CString csTmp;
	for (int i = 0; i < 4; i++)
	{
		m_xcSBCtrl[i].SetScrollRange(0, CROPPING_MAX);
		m_xcSBCtrl[i].SetScrollPos(crop[i]);

		csTmp.Format(L"%d", crop[i]);
		m_xcEDCtrl[i].SetWindowText(csTmp);
	}


	// Xgݒ
	m_xcCbList.ResetContent();
	m_xcCbList.AddString(L"ftHg");

	for (auto it = crop_->begin(); it != crop_->end(); ++it)
	{
		csTmp.Format(L"(%d) (%d) E(%d) (%d)", it->top, it->left, it->right, it->bottom);
		m_xcCbList.AddString(csTmp);
	}

	m_xcCbList.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void CCroppingPage::OnOK()
{
	CPropertyPage::OnOK();
}


void CCroppingPage::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int nNewPos = pScrollBar->GetScrollPos();
	int crop[4] = { cfg_->top, cfg_->left, cfg_->right, cfg_->bottom };

	for (int i = 0; i < 4; i++)
	{
		if (*pScrollBar != m_xcSBCtrl[i])
		{
			continue;
		}

		switch (nSBCode)
		{
		// ܂݂hbO
		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:
			nNewPos = nPos;
			break;

		// {^NbN
		case SB_LINELEFT:
		case SB_PAGELEFT:
			{
				nNewPos--;
				if (nNewPos < 0) { nNewPos = 0; }
				break;
			}
		// E{^NbN
		case SB_LINERIGHT:
		case SB_PAGERIGHT:
			{
				nNewPos++;
				if (nNewPos > CROPPING_MAX) { nNewPos = CROPPING_MAX; }
				break;
			}

		default:
			break;
		}

		m_xcSBCtrl[i].SetScrollPos(nNewPos);

		crop[i] = nNewPos;

		cfg_->top = crop[0];
		cfg_->left = crop[1];
		cfg_->right = crop[2];
		cfg_->bottom = crop[3];

		CString csTmp;
		csTmp.Format(L"%d", crop[i]);
		m_xcEDCtrl[i].SetWindowText(csTmp);

		if (graph_)
		{
			graph_->SetCroppingRect(*cfg_);
			graph_->SetVideoPosition();
		}

		return;
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


void CCroppingPage::OnCbnSelchangeCbList()
{
	int index = m_xcCbList.GetCurSel();

	CRect rc(0, 0, 0, 0);

	if (index > 0)
	{
		try {
			rc = crop_->at(index - 1);
		} catch (std::exception&) {}
	}


	m_xcSBCtrl[0].SetScrollPos(rc.top);
	m_xcSBCtrl[1].SetScrollPos(rc.left);
	m_xcSBCtrl[2].SetScrollPos(rc.right);
	m_xcSBCtrl[3].SetScrollPos(rc.bottom);

	CString csTmp;
	csTmp.Format(L"%d", rc.top);
	m_xcEDCtrl[0].SetWindowText(csTmp);
	csTmp.Format(L"%d", rc.left);
	m_xcEDCtrl[1].SetWindowText(csTmp);
	csTmp.Format(L"%d", rc.right);
	m_xcEDCtrl[2].SetWindowText(csTmp);
	csTmp.Format(L"%d", rc.bottom);
	m_xcEDCtrl[3].SetWindowText(csTmp);

	*cfg_ = rc;

	if (graph_)
	{
		graph_->SetCroppingRect(*cfg_);
		graph_->SetVideoPosition();
	}
}


void CCroppingPage::OnBnClickedBtnDel()
{
	int index = m_xcCbList.GetCurSel();

	if (index <= 0)
	{
		return;
	}

	int count = 1;
	for (auto it = crop_->begin(); it != crop_->end(); ++it)
	{
		if (index == count)
		{
			crop_->erase(it);
			m_xcCbList.DeleteString(index);
			m_xcCbList.SetCurSel(index - 1);
			break;
		}
		count++;
	}
}


void CCroppingPage::OnBnClickedBtnAdd()
{
	if (crop_->size() > 20)
	{
		return;
	}

	CRect rc(
		m_xcSBCtrl[1].GetScrollPos(),
		m_xcSBCtrl[0].GetScrollPos(),
		m_xcSBCtrl[2].GetScrollPos(),
		m_xcSBCtrl[3].GetScrollPos());

	// łɓlǉĂȂ
	// ǉɃJ[\킹
	int result = 1;
	for (auto it = crop_->begin(); it != crop_->end(); ++it)
	{
		if (*it == rc)
		{
			m_xcCbList.SetCurSel(result);
			return;
		}
		result++;
	}

	crop_->push_back(rc);

	CString csTmp;
	csTmp.Format(L"(%d) (%d) E(%d) (%d)", rc.top, rc.left, rc.right, rc.bottom);
	m_xcCbList.AddString(csTmp);

	int count = m_xcCbList.GetCount();
	if (count > 0)
	{
		m_xcCbList.SetCurSel(count - 1);
	}
}

