#pragma once

class __declspec(uuid("{57ABA012-7EBF-478b-A472-BFCA4CD5E725}")) CCustomTeeFilter;

class CCustomTeeVideoInputPin : public CBaseInputPin
{
public:
	CCustomTeeVideoInputPin(CBaseFilter *pFilter, CCritSec *pLock, HRESULT *phr);
	virtual ~CCustomTeeVideoInputPin();

	// IPin
	STDMETHODIMP BeginFlush(void);
	STDMETHODIMP EndFlush(void);
	STDMETHODIMP NewSegment(REFERENCE_TIME tStart, REFERENCE_TIME tStop, double dRate);
	STDMETHODIMP EndOfStream(void);
	STDMETHODIMP Receive(IMediaSample *pSample);

	// CBaseInputPin
	HRESULT GetMediaType(int iPosition, CMediaType *pMediaType);
	HRESULT CheckMediaType(const CMediaType *pmt);
};

class CCustomTeeVideoOutputPin : public CBaseOutputPin
{
	int m_Channel; // och 0=L 1=R
	COutputQueue* m_OutQ;
	CPosPassThru* m_PosPass;
public:
	AudioOutPin(LPCTSTR name, CBaseFilter *pFilter
				, CCritSec *pLock
				, HRESULT *phr, int ch);
	virtual ~AudioOutPin();
    STDMETHODIMP NonDelegatingQueryInterface(REFIID riid, void **ppv);
	// CBaseOutputPin
    HRESULT Active(void);
    HRESULT Inactive(void);
    HRESULT DeliverBeginFlush(void);
    HRESULT DeliverEndFlush(void);
    HRESULT DeliverEndOfStream(void);
	HRESULT DeliverNewSegment(
		REFERENCE_TIME tStart, REFERENCE_TIME tStop, double dRate);
	HRESULT Deliver(IMediaSample *pSample);
	HRESULT DecideBufferSize(
		IMemAllocator *pAlloc
		, ALLOCATOR_PROPERTIES *ppropInputRequest);
	HRESULT GetMediaType(int iPosition, CMediaType *pMediaType);
	HRESULT CheckMediaType(const CMediaType *pmt);
};

class CCustomTeeFilter : public CBaseFilter
{
	CCritSec m_FilterLock; // tB^bN
	CCustomTeeVideoInputPin *m_pVideoInputPin;

	CCustomTeeVideoOutputPin *m_pVideoOutputPin;

public:
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN pUnk, HRESULT *phr);
	CCustomTeeFilter(LPUNKNOWN pUnk, HRESULT *phr);
	virtual ~CCustomTeeFilter();

	CCustomTeeVideoInputPin *GetVideoInputPin() { return m_pVideoInputPin; }
	CCustomTeeVideoOutputPin *GetVideoOutputPin() { return m_pVideoOutputPin; }

	// CBaseFilter
	int GetPinCount(void);
	CBasePin *GetPin(int n);
};
