// EVRProcAmpPage.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "EVRProcAmpPage.h"
#include "afxdialogex.h"


// CEVRProcAmpPage _CAO

IMPLEMENT_DYNAMIC(CEVRProcAmpPage, CPropertyPage)

CEVRProcAmpPage::CEVRProcAmpPage(CMainDlg *dlg, CCaptureGraphProfile *profile)
	: CPropertyPage(CEVRProcAmpPage::IDD)
	, dlg_(dlg)
	, profile_(profile)
	, graph_(&(dlg->m_Preview))
	, cfg_(&(profile->EVRProcAmp))
	, isinit_(false)
{
	m_psp.dwFlags &= ~PSP_HASHELP;
}

CEVRProcAmpPage::~CEVRProcAmpPage()
{
}

void CEVRProcAmpPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SCROLLBAR1, m_xcScrollBar[0]);
	DDX_Control(pDX, IDC_SCROLLBAR2, m_xcScrollBar[1]);
	DDX_Control(pDX, IDC_SCROLLBAR3, m_xcScrollBar[2]);
	DDX_Control(pDX, IDC_SCROLLBAR4, m_xcScrollBar[3]);
	DDX_Control(pDX, IDC_EDIT1, m_xcEdit[0]);
	DDX_Control(pDX, IDC_EDIT2, m_xcEdit[1]);
	DDX_Control(pDX, IDC_EDIT3, m_xcEdit[2]);
	DDX_Control(pDX, IDC_EDIT4, m_xcEdit[3]);
	DDX_Control(pDX, IDC_BUTTON1, m_xcButton[0]);
	DDX_Control(pDX, IDC_BUTTON2, m_xcButton[1]);
	DDX_Control(pDX, IDC_BUTTON3, m_xcButton[2]);
	DDX_Control(pDX, IDC_BUTTON4, m_xcButton[3]);
	DDX_Control(pDX, IDC_BTN_DEFAULT, m_xcBtnDefault);
}


BEGIN_MESSAGE_MAP(CEVRProcAmpPage, CPropertyPage)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BUTTON1, &CEVRProcAmpPage::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CEVRProcAmpPage::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CEVRProcAmpPage::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CEVRProcAmpPage::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BTN_DEFAULT, &CEVRProcAmpPage::OnBnClickedBtnDefault)
END_MESSAGE_MAP()




void CEVRProcAmpPage::SetControlParam(int index, int val)
{
	CString csTmp;
	m_xcScrollBar[index].SetScrollPos(val);
	csTmp.Format(L"%.2f", float(val) / 100.0f);
	m_xcEdit[index].SetWindowText(csTmp);
}


// CEVRProcAmpPage bZ[W nh[


BOOL CEVRProcAmpPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	isinit_ = true;
	InitCtrl();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CEVRProcAmpPage::InitCtrl()
{
	if (!isinit_)
	{
		return;
	}

	CEVRProcAmpConfig last; // tB^ɐݒ肳Ăl

	if (graph_ &&
		graph_->GetEVRProcAmpRange(range_) &&
		graph_->GetEVRProcAmp(last))
	{
		CString csTmp;

		*cfg_ = last;

		// Brightness
		m_xcScrollBar[0].SetScrollRange(range_.Brightness.nMinValue, range_.Brightness.nMaxValue);
		SetControlParam(0, last.nBrightness);

		// Contrast
		m_xcScrollBar[1].SetScrollRange(range_.Contrast.nMinValue, range_.Contrast.nMaxValue);
		SetControlParam(1, last.nContrast);

		// Hue
		m_xcScrollBar[2].SetScrollRange(range_.Hue.nMinValue, range_.Hue.nMaxValue);
		SetControlParam(2, last.nHue);

		// Saturation
		m_xcScrollBar[3].SetScrollRange(range_.Saturation.nMinValue, range_.Saturation.nMaxValue);
		SetControlParam(3, last.nSaturation);

		for (int i = 0; i < 4; ++i)
		{
			m_xcScrollBar[i].EnableWindow(TRUE);
			m_xcEdit[i].EnableWindow(TRUE);
			m_xcButton[i].EnableWindow(TRUE);
		}
		m_xcBtnDefault.EnableWindow(TRUE);
	}
	else
	{
		for (int i = 0; i < 4; ++i)
		{
			m_xcScrollBar[i].EnableWindow(FALSE);
			m_xcEdit[i].EnableWindow(FALSE);
			m_xcEdit[i].SetWindowText(L"");
			m_xcButton[i].EnableWindow(FALSE);
		}
		m_xcBtnDefault.EnableWindow(FALSE);
	}
}

void CEVRProcAmpPage::OnOK()
{
	CPropertyPage::OnOK();
}



void CEVRProcAmpPage::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int next = pScrollBar->GetScrollPos();

	CEVRProcAmpRange* range = NULL;
	CEVRProcAmpRange* ranges[4];
	ranges[0] = &(range_.Brightness);
	ranges[1] = &(range_.Contrast);
	ranges[2] = &(range_.Hue);
	ranges[3] = &(range_.Saturation);

	int* cfgs[4];
	cfgs[0] = &(cfg_->nBrightness);
	cfgs[1] = &(cfg_->nContrast);
	cfgs[2] = &(cfg_->nHue);
	cfgs[3] = &(cfg_->nSaturation);

	for (int i = 0; i < 4; ++i)
	{
		if (*pScrollBar != m_xcScrollBar[i])
		{
			continue;
		}

		range = ranges[i];

		switch (nSBCode)
		{
		// ܂݂hbO
		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:
			if (range->nStepSize > 0)
			{
				next = (signed int(nPos) / range->nStepSize) * range->nStepSize;
			}
			else
			{
				next = signed int(nPos);
			}
			break;

		// {^NbN
		case SB_LINELEFT:
		case SB_PAGELEFT:
			if ((next - range->nStepSize) >= range->nMinValue)
			{
				next -= range->nStepSize;
			}
			break;

		// E{^NbN
		case SB_LINERIGHT:
		case SB_PAGERIGHT:
			if ((next + range->nStepSize) <= range->nMaxValue)
			{
				next += range->nStepSize;
			}
			break;

		default:
			break;
		}

		SetControlParam(i, next);


		*cfgs[i] = next;

		if (graph_)
		{
			graph_->SetEVRProcAmp(*cfg_);
		}

		return;
	}

	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CEVRProcAmpPage::OnBnClickedButton1()
{
	cfg_->nBrightness = range_.Brightness.nDefaultValue;
	SetControlParam(0, cfg_->nBrightness);

	if (graph_)
	{
		graph_->SetEVRProcAmp(*cfg_);
	}
}


void CEVRProcAmpPage::OnBnClickedButton2()
{
	cfg_->nContrast = range_.Contrast.nDefaultValue;
	SetControlParam(1, cfg_->nContrast);

	if (graph_)
	{
		graph_->SetEVRProcAmp(*cfg_);
	}
}


void CEVRProcAmpPage::OnBnClickedButton3()
{
	cfg_->nHue = range_.Hue.nDefaultValue;
	SetControlParam(2, cfg_->nHue);

	if (graph_)
	{
		graph_->SetEVRProcAmp(*cfg_);
	}
}


void CEVRProcAmpPage::OnBnClickedButton4()
{
	cfg_->nSaturation = range_.Saturation.nDefaultValue;
	SetControlParam(3, cfg_->nSaturation);

	if (graph_)
	{
		graph_->SetEVRProcAmp(*cfg_);
	}
}


void CEVRProcAmpPage::OnBnClickedBtnDefault()
{
	cfg_->nBrightness = range_.Brightness.nDefaultValue;
	SetControlParam(0, cfg_->nBrightness);
	cfg_->nContrast = range_.Contrast.nDefaultValue;
	SetControlParam(1, cfg_->nContrast);
	cfg_->nHue = range_.Hue.nDefaultValue;
	SetControlParam(2, cfg_->nHue);
	cfg_->nSaturation = range_.Saturation.nDefaultValue;
	SetControlParam(3, cfg_->nSaturation);

	if (graph_)
	{
		graph_->SetEVRProcAmp(*cfg_);
	}
}
