#include "StdAfx.h"
#include "GraphicUtl.h"

#pragma warning(disable: 4311)


CCPUInfo::CCPUInfo()
	: m_MMX(FALSE)
	, m_SSE(FALSE)
	, m_SSE2(FALSE)
	, m_SSE3(FALSE)
	, m_SSE4_1(FALSE)
	, m_SSE4_2(FALSE)
{
}

CCPUInfo::~CCPUInfo()
{
}

void CCPUInfo::Init(void)
{
	DWORD _ecx, _edx;
	__asm{
		mov		eax,	1;
		cpuid;
		mov		_ecx,	ecx;
		mov		_edx,	edx;
	}

	m_MMX =		_edx & 0x00800000 ? TRUE : FALSE;
	m_SSE =		_edx & 0x02000000 ? TRUE : FALSE;
	m_SSE2 =	_edx & 0x04000000 ? TRUE : FALSE;
	m_SSE3 =	_ecx & 0x00000001 ? TRUE : FALSE;
	m_SSE4_1 =	_ecx & 0x00080000 ? TRUE : FALSE;
	m_SSE4_2 =	_ecx & 0x00100000 ? TRUE : FALSE;
}

BOOL CCPUInfo::IsMMX(void)
{
	return m_MMX;
}

BOOL CCPUInfo::IsSSE(void)
{
	return m_SSE;
}

BOOL CCPUInfo::IsSSE2(void)
{
	return m_SSE2;
}

BOOL CCPUInfo::IsSSE3(void)
{
	return m_SSE3;
}

BOOL CCPUInfo::IsSSE4_1(void)
{
	return m_SSE4_1;
}

BOOL CCPUInfo::IsSSE4_2(void)
{
	return m_SSE4_2;
}





VOID ASMAlphaBlending(LPBYTE lpDest, // Rs[
                   LPBYTE lpSrc1,    // Rs[1
		   LPBYTE lpSrc2,    // Rs[2
		   DWORD dwLength,   // Rs[钷
		   WORD wAlpha)     // l
{
     DWORD dwAlpha = (DWORD)wAlpha;
     DWORD dwAlpha2 = (256 - dwAlpha);

_asm{

     mov eax,dwLength  // eax = JE^
     mov ebx,lpDest  // ebx = Rs[AhX
     mov edi,lpSrc1  // ecx = Rs[1@AhX
     mov esi,lpSrc2  // edx = Rs[2@AhX
     xor ecx,ecx  // ecx 
     xor edx,edx  // edx 

LOOP1:
        // f[^ǂݍ
	mov cl,byte ptr [edi]
	mov dl,byte ptr [esi]

	// |Z
	imul ecx,dwAlpha
	imul edx,dwAlpha2

	//  256 Ŋē]
	add ecx,edx
	shr ecx,8
	shr edx,8
	mov byte ptr [ebx],cl

	inc ebx
	inc edi
	inc esi
	dec eax
	jne LOOP1
    }
}



// MMX SSE2 AlphaBlending 64bit ŏ̂ŉ摜̃TCY 8 byte Eɍ킹Ȃ΂ȂȂ 
VOID AlphaBlending(LPBYTE lpDest, // Rs[
                   LPBYTE lpSrc1,    // Rs[1
		   LPBYTE lpSrc2,    // Rs[2
		   DWORD dwLength,   // Rs[钷
		   WORD wAlpha)     // l
{
	if (dwLength <= 0)
	{
		return;
	}

	if (dwLength < 8)
	{
		ASMAlphaBlending(lpDest, lpSrc1, lpSrc2, dwLength, wAlpha);
		return;
	}

	DWORD dwFraction = dwLength % 8;

	if (dwFraction > 0)
	{
		dwLength -= dwFraction;

		if (dwLength <= 0)
		{
			return;
		}
	}


	DWORD dwAlpha = (DWORD)wAlpha;
	DWORD dwAlpha2 = (256 - dwAlpha);

	_asm{

	mov eax,dwLength  // eax = JE^
	mov ebx,lpDest  // ebx = Rs[AhX
	mov ecx,lpSrc1  // ecx = Rs[1@AhX
	mov edx,lpSrc2  // edx = Rs[2@AhX
	shr eax,3        // eax/=8

	movd mm4,dwAlpha // mm4 =  0000
	punpcklwd mm4,mm4
	punpckldq mm4,mm4
	movd mm5,dwAlpha2 // mm5 = 0(1-)0(1-)0(1-)0(1-)
	punpcklwd mm5,mm5
	punpckldq mm5,mm5

	pxor mm6,mm6 // mm6 = pbNp_~[ = 0

LOOP1:
	// f[^ǂݍ(64 bit )
	movq mm0,[ecx]  
	movq mm1,[edx]  

	// Rs[
	movq mm2,mm0  
	movq mm3,mm1

	// byte -> word ɃApbN
	punpckhbw mm0,mm6 // High
	punpckhbw mm1,mm6
	punpcklbw mm2,mm6 // Low
	punpcklbw mm3,mm6

	// pbN|Z
	pmullw mm0,mm4
	pmullw mm1,mm5
	pmullw mm2,mm4
	pmullw mm3,mm5

	// pbNZ256Ŋ
	paddw mm0,mm1
	paddw mm2,mm3
	psrlw mm0,8
	psrlw mm2,8

	// word->byte ɃpbNē]
	packuswb mm2,mm0
	movq [ebx],mm2

	// |C^Abv
	add ecx,8
	add edx,8
	add ebx,8

	// JE^_Eă[v
	dec eax
	jne LOOP1

	emms
	}

	if (dwFraction > 0)
	{
		ASMAlphaBlending(lpDest + dwLength, lpSrc1 + dwLength, lpSrc2 + dwLength, dwFraction, wAlpha);
	}
}

VOID HalfBlending(LPBYTE lpDest, // Rs[
                   LPBYTE lpSrc1,    // Rs[1
		   LPBYTE lpSrc2,    // Rs[2
		   DWORD dwLength)   // Rs[钷
{
	if (dwLength <= 0)
	{
		return;
	}

	if (dwLength < 16)
	{
		ASMAlphaBlending(lpDest, lpSrc1, lpSrc2, dwLength, 127);
		return;
	}

	DWORD dwFraction = dwLength % 16;

	if (dwFraction > 0)
	{
		dwLength -= dwFraction;

		if (dwLength <= 0)
		{
			return;
		}
	}

	_asm {
		mov eax, dwLength	// eax = JE^
		mov ebx, lpDest	// ebx = Rs[AhX
		mov ecx, lpSrc1	// ecx = Rs[AhX1
		mov edx, lpSrc2	// edx = Rs[AhX2
		shr eax, 4		// dwSize /= 8

		pxor xmm4, xmm4
		//pxor mm4, mm4 // mm4 = pbNp_~[ = 0

	LOOP1:
		// f[^ǂݍ(64 bits = 8 bytes )
		//movq mm0, [ecx]	// *lpSrc1
		//movq mm1, [edx]	// *lpSrc2
		movdqu xmm0, [ecx]
		movdqu xmm1, [edx]

		// Rs[
		//movq mm2, mm0  
		//movq mm3, mm1
		movdqa xmm2, xmm0  
		movdqa xmm3, xmm1

		// byte -> word ɃApbN
		//punpckhbw mm0, mm4 // High
		//punpckhbw mm1, mm4
		//punpcklbw mm2, mm4 // Low
		//punpcklbw mm3, mm4
		punpckhbw xmm0, xmm4 // High
		punpckhbw xmm1, xmm4
		punpcklbw xmm2, xmm4 // Low
		punpcklbw xmm3, xmm4

		// pbNZ2Ŋ
		//paddw mm0, mm1
		//paddw mm2, mm3
		//psrlw mm0, 1
		//psrlw mm2, 1
		paddw xmm0, xmm1
		paddw xmm2, xmm3
		psrlw xmm0, 1
		psrlw xmm2, 1

		// word->byte ɃpbNē]
		//packuswb mm2, mm0
		//movq [ebx], mm2
		packuswb xmm2, xmm0
		movdqu [ebx], xmm2

		// |C^Abv
		add ecx, 16
		add edx, 16
		add ebx, 16

		// JE^_Eă[v
		dec eax
		jne LOOP1

		emms
	}

/*
	_asm {
		mov eax, dwLength	// eax = JE^
		mov ebx, lpDest	// ebx = Rs[AhX
		mov ecx, lpSrc1	// ecx = Rs[AhX1
		mov edx, lpSrc2	// edx = Rs[AhX2
		shr eax, 3		// dwSize /= 8

		pxor mm4, mm4 // mm6 = pbNp_~[ = 0

	LOOP1:
		// f[^ǂݍ(64 bits = 8 bytes )
		movq mm0, [ecx]	// *lpSrc1
		movq mm1, [edx]	// *lpSrc2

		// Rs[
		movq mm2, mm0  
		movq mm3, mm1

		// byte -> word ɃApbN
		punpckhbw mm0, mm4 // High
		punpckhbw mm1, mm4
		punpcklbw mm2, mm4 // Low
		punpcklbw mm3, mm4

		// pbNZ2Ŋ
		paddw mm0, mm1
		paddw mm2, mm3
		psrlw mm0, 1
		psrlw mm2, 1

		// word->byte ɃpbNē]
		packuswb mm2, mm0
		movq [ebx], mm2

		// |C^Abv
		add ecx, 8
		add edx, 8
		add ebx, 8

		// JE^_Eă[v
		dec eax
		jne LOOP1

		emms
	}
*/
	if (dwFraction > 0)
	{
		ASMAlphaBlending(lpDest + dwLength, lpSrc1 + dwLength, lpSrc2 + dwLength, dwFraction, 127);
	}
}

VOID SubtractCopy(LPBYTE lpDest, // Rs[
                   LPBYTE lpSrc1,    // Rs[1 (*2)
		   LPBYTE lpSrc2,    // Rs[2 (-)
		   DWORD dwLength)   // Rs[钷
{
	if (dwLength <= 0)
	{
		return;
	}

	if (dwLength < 8)
	{
		int sub = 0;
		for (DWORD i = 0; i < dwLength; i++)
		{
			sub = (lpSrc1[i] << 1) - lpSrc2[i];
			if (sub < 0)
			{
				sub = 0;
			}
			else if (sub > 255)
			{
				sub = 255;
			}
			lpDest[i] = sub;
		}
		return;
	}

	DWORD dwFraction = dwLength % 8;

	if (dwFraction > 0)
	{
		dwLength -= dwFraction;

		if (dwLength <= 0)
		{
			return;
		}
	}

	_asm {
		mov eax, dwLength	// eax = JE^
		mov ebx, lpDest	// ebx = Rs[AhX
		mov ecx, lpSrc1	// ecx = Rs[AhX1
		mov edx, lpSrc2	// edx = Rs[AhX2
		shr eax, 3		// dwSize /= 8

		pxor mm4, mm4 // mm6 = pbNp_~[ = 0

	LOOP1:
		// f[^ǂݍ(64 bits = 8 bytes )
		movq mm0, [ecx]	// *lpSrc1
		movq mm1, [edx]	// *lpSrc2

		// Rs[
		movq mm2, mm0  
		movq mm3, mm1

		// byte -> word ɃApbN
		punpckhbw mm0, mm4 // High
		punpckhbw mm1, mm4
		punpcklbw mm2, mm4 // Low
		punpcklbw mm3, mm4


		// lpSrc1 * 2
		psllw mm0, 1
		psllw mm2, 1

		// *lpSrc1 - *lpSrc2
		psubw mm0, mm1
		psubw mm2, mm3

		// word->byte ɃpbNē]
		packuswb mm2, mm0
		movq [ebx], mm2

		// |C^Abv
		add ecx, 8
		add edx, 8
		add ebx, 8

		// JE^_Eă[v
		dec eax
		jne LOOP1

		emms
	}

	if (dwFraction > 0)
	{
		int sub = 0;
		for (DWORD i = 0; i < dwFraction; i++)
		{
			sub = (lpSrc1[i + dwLength] << 1) - lpSrc2[i + dwLength];
			if (sub < 0)
			{
				sub = 0;
			}
			else if (sub > 255)
			{
				sub = 255;
			}
			lpDest[i + dwLength] = sub;
		}
	}
}


void *MemoryCopy2(void *b, const void *a, size_t n)
{
  char * s1 = (char *)b;
  const char * s2 = (char *)a;
  for(; 0<n; --n)*s1++ = *s2++;
  return b;
}

// SSE2
void SSE2AlignedMemoryCopy(void *pDst, void *pSrc, DWORD dwSize)
{
    if (dwSize < 64)
	{
		::memcpy(pDst, pSrc, dwSize);
        return;
    }

__asm
{
    mov     esi, pSrc;
    mov     eax, pDst;
    sub     eax, esi;
    mov     ecx, dwSize;
    shr     ecx, 6;      // ecx = ecx / 64;

LOOP_MAIN:
    movdqa  xmm0, [esi+ 0];
    movdqa  xmm1, [esi+16];
    movdqa  xmm2, [esi+32];
    movdqa  xmm3, [esi+48];
    MOVNTDQ [esi+eax+ 0], xmm0;
    MOVNTDQ [esi+eax+16], xmm1;
    MOVNTDQ [esi+eax+32], xmm2;
    MOVNTDQ [esi+eax+48], xmm3;
    add     esi, 64;
    loop    LOOP_MAIN;
 
    add     eax, esi;
    mov     pSrc, esi;
    mov     pDst, eax;
}

	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
}

#define _SSECOPY(_SHIFT) movdqa  xmm0, [esi+ 0];\
    movdqu  [esi+eax+ 0], xmm0;\
    add     eax, _SHIFT;\
    psrldq  xmm0, _SHIFT;\
 \
LB_SHIFT( MAIN ):\
    movdqa  xmm1, [esi+16];\
    movdqa  xmm3, [esi+32];\
    movdqa  xmm2, xmm1;\
    movdqa  xmm4, xmm3;\
    pslldq  xmm1, 16-_SHIFT;\
    psrldq  xmm2, _SHIFT;\
    pslldq  xmm3, 16-_SHIFT;\
    psrldq  xmm4, _SHIFT;\
    por     xmm1, xmm0;\
    por     xmm3, xmm2;\
    MOVNTDQ [esi+eax+ 0], xmm1;\
    MOVNTDQ [esi+eax+16], xmm3;\
 \
    movdqa  xmm1, [esi+48];\
    movdqa  xmm3, [esi+64];\
    movdqa  xmm2, xmm1;\
    movdqa  xmm0, xmm3;\
    pslldq  xmm1, 16-_SHIFT;\
    psrldq  xmm2, _SHIFT;\
    pslldq  xmm3, 16-_SHIFT;\
    psrldq  xmm0, _SHIFT;\
    por     xmm1, xmm4;\
    por     xmm3, xmm2;\
    MOVNTDQ [esi+eax+32], xmm1;\
    MOVNTDQ [esi+eax+48], xmm3;\
 \
    add     esi, 64;\
    loop    LB_SHIFT( MAIN );\

void SSE2MemoryCopy(void *pDst, void *pSrc, DWORD dwSize)
{
    if (dwSize < 64)
	{
		::memcpy(pDst, pSrc, dwSize);
        return;
    }

	int nDstGap = reinterpret_cast<unsigned long>(pDst) & 0x0000000F;
	int nSrcGap = reinterpret_cast<unsigned long>(pSrc) & 0x0000000F;

	if (nDstGap == nSrcGap) // Mbv
	{
		if (nSrcGap == 0) // MbvȂ
		{
			SSE2AlignedMemoryCopy(pDst, pSrc, dwSize);
			return;
		}
		else // ʂ̃Mbv
		{
			::memcpy(pDst, pSrc, 16-nSrcGap);
			SSE2AlignedMemoryCopy((LPBYTE)pDst + (16-nSrcGap), (LPBYTE)pSrc + (16-nSrcGap), dwSize - (16-nSrcGap));
			return;
		}
	}

	if (nSrcGap != 0)
	{
		::memcpy(pDst, pSrc, (16-nSrcGap));
		pDst = ((LPBYTE)pDst) + (16-nSrcGap);
		pSrc = ((LPBYTE)pSrc) + (16-nSrcGap);
		dwSize -= (16-nSrcGap);
	}

	nDstGap = reinterpret_cast<unsigned long>(pDst) & 0x0000000F;
	nSrcGap = reinterpret_cast<unsigned long>(pSrc) & 0x0000000F;

	if (nSrcGap != 0)
	{
		::memcpy(pDst, pSrc, dwSize);
		return;
	}

	int nGap = nDstGap;

	if (nGap == 1)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(1)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}

	if (nGap == 2)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(2)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}

	if (nGap == 3)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(3)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}

	if (nGap == 4)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(4)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}
	else if (nGap == 5)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(5)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}
	else if (nGap == 6)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(6)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}
	else if (nGap == 7)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(7)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}
	else if (nGap == 8)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(8)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}
	else if (nGap == 9)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(9)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}
	else if (nGap == 10)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(10)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}
	else if (nGap == 11)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(11)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}
	else if (nGap == 12)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(12)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}
	else if (nGap == 13)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(13)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}
	else if (nGap == 14)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(14)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}
	else if (nGap == 15)
	{
__asm
{
	mov     esi, pSrc;
	mov     eax, pDst;
	sub     eax, esi;
	mov     ecx, dwSize;
	shr     ecx, 1;

	_SSECOPY(15)
}
	::memcpy(pDst, pSrc, dwSize & 0x0000003F);
	}

	TRACE(L"SUCCEDED(nGap:%d, nDstGap:%d nSrcGap:%d)\n", nGap, nDstGap, nSrcGap);
}


// mȐL
static const BYTE YCCOLOR[] = {
   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
   1,   2,   3,   4,   5,   6,   7,   9,  10,  11,  12,  13,  14,  15,  17,  18,
  19,  20,  21,  22,  23,  25,  26,  27,  28,  29,  30,  31,  33,  34,  35,  36,
  37,  38,  39,  41,  42,  43,  44,  45,  46,  47,  48,  50,  51,  52,  53,  54,
  55,  56,  58,  59,  60,  61,  62,  63,  64,  66,  67,  68,  69,  70,  71,  72,
  74,  75,  76,  77,  78,  79,  80,  82,  83,  84,  85,  86,  87,  88,  89,  91,
  92,  93,  94,  95,  96,  97,  99, 100, 101, 102, 103, 104, 105, 107, 108, 109,
 110, 111, 112, 113, 115, 116, 117, 118, 119, 120, 121, 123, 124, 125, 126, 127,
 128, 129, 130, 132, 133, 134, 135, 136, 137, 138, 140, 141, 142, 143, 144, 145,
 146, 148, 149, 150, 151, 152, 153, 154, 156, 157, 158, 159, 160, 161, 162, 164,
 165, 166, 167, 168, 169, 170, 171, 173, 174, 175, 176, 177, 178, 179, 181, 182,
 183, 184, 185, 186, 187, 189, 190, 191, 192, 193, 194, 195, 197, 198, 199, 200,
 201, 202, 203, 205, 206, 207, 208, 209, 210, 211, 212, 214, 215, 216, 217, 218,
 219, 220, 222, 223, 224, 225, 226, 227, 228, 230, 231, 232, 233, 234, 235, 236,
 238, 239, 240, 241, 242, 243, 244, 246, 247, 248, 249, 250, 251, 252, 253, 254,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
};

static const BYTE YCBRIGHT[] = {
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   1,   2,   3,   4,   5,   7,   8,   9,  10,  11,  12,  14,  15,  16,  17,
  18,  19,  21,  22,  23,  24,  25,  26,  28,  29,  30,  31,  32,  33,  35,  36,
  37,  38,  39,  40,  42,  43,  44,  45,  46,  47,  49,  50,  51,  52,  53,  54,
  56,  57,  58,  59,  60,  61,  63,  64,  65,  66,  67,  69,  70,  71,  72,  73,
  74,  76,  77,  78,  79,  80,  81,  83,  84,  85,  86,  87,  88,  90,  91,  92,
  93,  94,  95,  97,  98,  99, 100, 101, 102, 104, 105, 106, 107, 108, 109, 111,
 112, 113, 114, 115, 116, 118, 119, 120, 121, 122, 123, 125, 126, 127, 128, 129,
 131, 132, 133, 134, 135, 136, 138, 139, 140, 141, 142, 143, 145, 146, 147, 148,
 149, 150, 152, 153, 154, 155, 156, 157, 159, 160, 161, 162, 163, 164, 166, 167,
 168, 169, 170, 171, 173, 174, 175, 176, 177, 178, 180, 181, 182, 183, 184, 185,
 187, 188, 189, 190, 191, 193, 194, 195, 196, 197, 198, 200, 201, 202, 203, 204,
 205, 207, 208, 209, 210, 211, 212, 214, 215, 216, 217, 218, 219, 221, 222, 223,
 224, 225, 226, 228, 229, 230, 231, 232, 233, 235, 236, 237, 238, 239, 240, 242,
 243, 244, 245, 246, 247, 249, 250, 251, 252, 253, 254, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
};



void YCExpandUYVYCopy(void *pDst_, void *pSrc_, DWORD dwSize_)
{
	LPBYTE pColor = (LPBYTE)YCCOLOR;
	LPBYTE pBright = (LPBYTE)YCBRIGHT;
	LPBYTE pDst = (LPBYTE)pDst_;
	LPBYTE pSrc = (LPBYTE)pSrc_;

	int nAlign = dwSize_ % 4;
	if (nAlign > 0)
	{
		dwSize_ -= nAlign;
	}

	if (dwSize_ < 4)
	{
		return;
	}

	for (register int i = dwSize_; i; i -= 4)
	{
		pDst[i-1] = pBright[pSrc[i-1]];
		pDst[i-2]  = pColor[pSrc[i-2]];
		pDst[i-3] = pBright[pSrc[i-3]];
		pDst[i-4] = pColor[pSrc[i-4]];
	}
}

void YCExpandYUY2Copy(void *pDst_, void *pSrc_, DWORD dwSize_)
{
	LPBYTE pColor = (LPBYTE)YCCOLOR;
	LPBYTE pBright = (LPBYTE)YCBRIGHT;
	LPBYTE pDst = (LPBYTE)pDst_;
	LPBYTE pSrc = (LPBYTE)pSrc_;

	int nAlign = dwSize_ % 4;
	if (nAlign > 0)
	{
		dwSize_ -= nAlign;
	}

	if (dwSize_ < 4)
	{
		return;
	}

	for (register int i = dwSize_; i; i -= 4)
	{
		pDst[i-1]  = pColor[pSrc[i-1]];
		pDst[i-2] = pBright[pSrc[i-2]];
		pDst[i-3] = pColor[pSrc[i-3]];
		pDst[i-4] = pBright[pSrc[i-4]];
	}
}

void YCExpandUYVY(void *pDst_, DWORD dwSize_)
{
	LPBYTE pColor = (LPBYTE)YCCOLOR;
	LPBYTE pBright = (LPBYTE)YCBRIGHT;
	LPBYTE pDst = (LPBYTE)pDst_;

	int nAlign = dwSize_ % 4;
	if (nAlign > 0)
	{
		dwSize_ -= nAlign;
	}

	if (dwSize_ < 4)
	{
		return;
	}

	// UYVY HDYC
	for (register int i = dwSize_; i; i -= 4)
	{
		pDst[i-1] = pBright[pDst[i-1]];
		pDst[i-2] = pColor[pDst[i-2]];
		pDst[i-3] = pBright[pDst[i-3]];
		pDst[i-4] = pColor[pDst[i-4]];
	}
}

void YCExpandYUY2(void *pDst_, DWORD dwSize_)
{
	LPBYTE pColor = (LPBYTE)YCCOLOR;
	LPBYTE pBright = (LPBYTE)YCBRIGHT;
	LPBYTE pDst = (LPBYTE)pDst_;

	int nAlign = dwSize_ % 4;
	if (nAlign > 0)
	{
		dwSize_ -= nAlign;
	}

	if (dwSize_ < 4)
	{
		return;
	}

	// UYVY HDYC
	for (register int i = dwSize_; i; i -= 4)
	{
		pDst[i-1]  = pColor[pDst[i-1]];
		pDst[i-2] = pBright[pDst[i-2]];
		pDst[i-3] = pColor[pDst[i-3]];
		pDst[i-4] = pBright[pDst[i-4]];
	}
}


void SSE2StrideMemoryCopy(void *pDst_, void *pSrc_, DWORD dwSize_, int nHeight_, DWORD dwWidthSize_, DWORD dwStrideSize_, BOOL bBottomUp_)
{
	if (!bBottomUp_)
	{
		if (dwStrideSize_ > 0)
		{
			LPBYTE pDst = (LPBYTE)pDst_;
			LPBYTE pSrc = (LPBYTE)pSrc_;
			for (int y = 0; y < nHeight_; y++)
			{
				SSE2MemoryCopy(pDst + (y * dwWidthSize_) + (y * dwStrideSize_), pSrc + (y * dwWidthSize_), dwWidthSize_);
			}
		}
		else
		{
			SSE2MemoryCopy(pDst_, pSrc_, dwSize_);
		}
	}
	else
	{
		LPBYTE pDst = (LPBYTE)pDst_;
		LPBYTE pSrc = (LPBYTE)pSrc_;
		for (int y = 0; y < nHeight_; y++)
		{
			SSE2MemoryCopy(pDst + (y * dwWidthSize_) + (y * dwStrideSize_), pSrc + ((((nHeight_ - 1) - y)) * dwWidthSize_), dwWidthSize_);
		}
	}
}

/*
	UYVY  YiPxj2sNZ
	UViFj2sNZŋLĂ
*/

void SSE2StrideRotationMemoryCopy(void *pDst_, void *pSrc_, LPBITMAPINFOHEADER pIn_, LPBITMAPINFOHEADER pOut_)
{


	/*
	const int bitCount = pIn_->biBitCount;
	const int width = pIn_->biWidth;
	const int height = abs(pIn_->biHeight);
	const int stride = pOut_->biWidth - pIn_->biWidth;

	const int widthSize = (width * bitCount) / 8;
	const int strideSize = ((stride > 0 ? stride : 0) * bitCount) / 8;
	*/

	const int bitCount = pIn_->biBitCount;
	const int width = pIn_->biWidth;
	const int height = abs(pIn_->biHeight);
	const int wstride = abs(pOut_->biHeight) - pIn_->biWidth;
	const int hstride = pOut_->biWidth - abs(pIn_->biHeight);

	const int widthSize = (width * bitCount) / 8;
	const int heightSize = (height * bitCount) / 8;
	const int wstrideSize = ((wstride > 0 ? wstride : 0) * bitCount) / 8;
	const int hstrideSize = ((hstride > 0 ? hstride : 0) * bitCount) / 8;

	{
		LPDWORD dst = (LPDWORD)pDst_;
		LPDWORD src = (LPDWORD)pSrc_;

		DWORD data = 0;

		
		for (int x = 0; x < width; x++)
		{
			for (int y = 0; y < height; y++)
			{
				data = *(src + x + (y * width));

				*(dst + (x * (height + hstride)) + y) = data;
			}
		}
		
	}

	/*
	for (int x = 0; x < width; x++)
	{
		for (int y = 0; y < height; y++)
		{
			data = *(src + (x / 2) + (y * (width / 2)));

			*(dst + (x * ((height + hstride) / 2)) + ((height / 2) - (y / 2)))
				= (data & 0x00FF00FF) | 0x7F007F00;
		}
	}
	*/

	/*
	// 16bit WORD Copy
	{
		LPWORD dst = (LPWORD)pDst_;
		LPWORD src = (LPWORD)pSrc_;

		WORD data = 0;

		for (int x = 0; x < width; x++)
		{
			for (int y = 0; y < height; y++)
			{
				data = *(src + x + (y * width));

				*(dst + (height - y) + (x * (height + hstride)))
					= (data & 0xFF00);
			}
		}
	}
	*/

	/*
	// 16bit DWORD Copy
	{
		LPDWORD dst = (LPDWORD)pDst_;
		LPDWORD src = (LPDWORD)pSrc_;

		DWORD data = 0;

		for (int x = 0; x < width; x++)
		{
			for (int y = 0; y < height; y++)
			{
				data = *(src + (x / 2) + (y * (width / 2)));

				*(dst + (x * ((height + hstride) / 2)) + ((height / 2) - (y / 2)))
					|= (data & 0x00FF00FF);
			}
		}
	}
	*/


	/*
	// 1280
	for (int y = 0; y < width; y++)
	{
		// 720
		for (int x = 0; x < heightSize; x++)
		{
			*(dst + x) = *(src + i);
			i++;
		}
		dst += heightSize + hstrideSize;
	}
	*/

	/*
	// 1280
	for (int y = 0; y < width; y++)
	{
		// 720
		for (int x = 0; x < heightSize; x++)
		{
			*(dst + x) = *(src + x);
			srcx = src + (widthSize * x);
		}
		dst += heightSize + hstrideSize;
	}
	*/


	/*
	for (int x = 0; x < width; x++)
	{
		for (int y = 0; y < height; y++)
		{
			for (int i = 0; i < count; i++)
			{
				*(dst + ((widthSize + hstrideSize) * y)) = *(src + (x + i));
			}
		}
	}
	*/
}

void StrideMemoryCopy(void *pDst_, void *pSrc_, DWORD dwSize_, int nHeight_, DWORD dwWidthSize_, DWORD dwStrideSize_, BOOL bBottomUp_)
{
	if (!bBottomUp_)
	{
		if (dwStrideSize_ > 0)
		{
			LPBYTE pDst = (LPBYTE)pDst_;
			LPBYTE pSrc = (LPBYTE)pSrc_;
			for (int y = 0; y < nHeight_; y++)
			{
				MemoryCopy2(pDst + (y * dwWidthSize_) + (y * dwStrideSize_), pSrc + (y * dwWidthSize_), dwWidthSize_);
			}
		}
		else
		{
			MemoryCopy2(pDst_, pSrc_, dwSize_);
		}
	}
	else
	{
		LPBYTE pDst = (LPBYTE)pDst_;
		LPBYTE pSrc = (LPBYTE)pSrc_;
		for (int y = 0; y < nHeight_; y++)
		{
			MemoryCopy2(pDst + (y * dwWidthSize_) + (y * dwStrideSize_), pSrc + ((((nHeight_ - 1) - y)) * dwWidthSize_), dwWidthSize_);
		}
	}
}

void StrideYCExpandUYVYCopy(void *pDst_, void *pSrc_, DWORD dwSize_, int nHeight_, DWORD dwWidthSize_, DWORD dwStrideSize_, BOOL bBottomUp_)
{
	if (!bBottomUp_)
	{
		if (dwStrideSize_ > 0)
		{
			LPBYTE pDst = (LPBYTE)pDst_;
			LPBYTE pSrc = (LPBYTE)pSrc_;
			for (int y = 0; y < nHeight_; y++)
			{
				YCExpandUYVYCopy(pDst + (y * dwWidthSize_) + (y * dwStrideSize_), pSrc + (y * dwWidthSize_), dwWidthSize_);
			}
		}
		else
		{
			YCExpandUYVYCopy(pDst_, pSrc_, dwSize_);
		}
	}
	else
	{
		LPBYTE pDst = (LPBYTE)pDst_;
		LPBYTE pSrc = (LPBYTE)pSrc_;
		for (int y = 0; y < nHeight_; y++)
		{
			YCExpandUYVYCopy(pDst + (y * dwWidthSize_) + (y * dwStrideSize_), pSrc + ((((nHeight_ - 1) - y)) * dwWidthSize_), dwWidthSize_);
		}
	}
}

void StrideYCExpandYUY2Copy(void *pDst_, void *pSrc_, DWORD dwSize_, int nHeight_, DWORD dwWidthSize_, DWORD dwStrideSize_, BOOL bBottomUp_)
{
	if (!bBottomUp_)
	{
		if (dwStrideSize_ > 0)
		{
			LPBYTE pDst = (LPBYTE)pDst_;
			LPBYTE pSrc = (LPBYTE)pSrc_;
			for (int y = 0; y < nHeight_; y++)
			{
				YCExpandYUY2Copy(pDst + (y * dwWidthSize_) + (y * dwStrideSize_), pSrc + (y * dwWidthSize_), dwWidthSize_);
			}
		}
		else
		{
			YCExpandYUY2Copy(pDst_, pSrc_, dwSize_);
		}
	}
	else
	{
		LPBYTE pDst = (LPBYTE)pDst_;
		LPBYTE pSrc = (LPBYTE)pSrc_;
		for (int y = 0; y < nHeight_; y++)
		{
			YCExpandYUY2Copy(pDst + (y * dwWidthSize_) + (y * dwStrideSize_), pSrc + ((((nHeight_ - 1) - y)) * dwWidthSize_), dwWidthSize_);
		}
	}
}

void VerticalSharpnessCopy(void *pDst_, void *pSrc_, DWORD dwSize_, int nHeight_, DWORD dwWidthSize_, DWORD dwStrideSize_, BOOL bBottomUp_)
{
	if (!bBottomUp_)
	{
		int pt = 0;
		LPBYTE pDst = (LPBYTE)pDst_;
		LPBYTE pSrc = (LPBYTE)pSrc_;
		LPBYTE pBff = (LPBYTE)_aligned_malloc(dwWidthSize_, 16);

		if (pBff != NULL)
		{
			SubtractCopy(pDst, pSrc, pSrc + dwWidthSize_, dwWidthSize_);
			for (int y = 1; y < (nHeight_ - 1); y++)
			{
				pt = dwWidthSize_ * y;
				HalfBlending(pBff, pSrc + pt - dwWidthSize_, pSrc + pt + dwWidthSize_, dwWidthSize_);
				SubtractCopy(pDst + pt + (dwStrideSize_ * y), pSrc + pt, pBff, dwWidthSize_);
			}
			SubtractCopy(pDst + ((nHeight_ - 1) * dwWidthSize_) + ((nHeight_ - 1) * dwStrideSize_),
				pSrc + ((nHeight_ - 1) * dwWidthSize_), pSrc + ((nHeight_ - 1) * dwWidthSize_) - dwWidthSize_, dwWidthSize_);

			_aligned_free(pBff);
		}
	}
	else
	{
		int ry = 0;
		int pt = 0;
		LPBYTE pDst = (LPBYTE)pDst_;
		LPBYTE pSrc = (LPBYTE)pSrc_;
		LPBYTE pBff = (LPBYTE)_aligned_malloc(dwWidthSize_, 16);

		if (pBff != NULL)
		{
			SubtractCopy(pDst + ((nHeight_ - 1) * dwWidthSize_) + ((nHeight_ - 1) * dwStrideSize_),
				pSrc, pSrc + dwWidthSize_, dwWidthSize_);
			for (int y = 1; y < (nHeight_ - 1); y++)
			{
				ry = (nHeight_ - 1) - y;
				pt = dwWidthSize_ * y;
				HalfBlending(pBff, pSrc + pt - dwWidthSize_, pSrc + pt + dwWidthSize_, dwWidthSize_);
				SubtractCopy(pDst + (dwWidthSize_ * ry) + (dwStrideSize_ * ry), pSrc + pt, pBff, dwWidthSize_);
			}
			SubtractCopy(pDst,
				pSrc + ((nHeight_ - 1) * dwWidthSize_), pSrc + ((nHeight_ - 1) * dwWidthSize_) - dwWidthSize_, dwWidthSize_);

			_aligned_free(pBff);
		}
	}
}


BOOL IsBottomUpBitmap(LPBITMAPINFOHEADER pbmOutput)
{
	if (pbmOutput != NULL &&
		pbmOutput->biCompression == BI_RGB &&
		pbmOutput->biHeight < 0)
	{
		return TRUE;
	}

	return FALSE;
}
