#pragma once

class CCPUInfo {
public:
	CCPUInfo();
	~CCPUInfo();

	void Init(void);

	BOOL IsMMX(void);
	BOOL IsSSE(void);
	BOOL IsSSE2(void);
	BOOL IsSSE3(void);
	BOOL IsSSE4_1(void);
	BOOL IsSSE4_2(void);

private:
	BOOL m_MMX;
	BOOL m_SSE;
	BOOL m_SSE2;
	BOOL m_SSE3;
	BOOL m_SSE4_1;
	BOOL m_SSE4_2;
};

VOID ASMAlphaBlending(LPBYTE lpDest, // Rs[
                   LPBYTE lpSrc1,    // Rs[1
		   LPBYTE lpSrc2,    // Rs[2
		   DWORD dwLength,   // Rs[钷
		   WORD wAlpha);

VOID AlphaBlending(LPBYTE lpDest, // Rs[
                   LPBYTE lpSrc1,    // Rs[1
		   LPBYTE lpSrc2,    // Rs[2
		   DWORD dwLength,   // Rs[钷
		   WORD wAlpha);

VOID HalfBlending(LPBYTE lpDest, // Rs[
                   LPBYTE lpSrc1,    // Rs[1
		   LPBYTE lpSrc2,    // Rs[2
		   DWORD dwLength);   // Rs[钷

VOID SubtractCopy(LPBYTE lpDest, // Rs[
                   LPBYTE lpSrc1,    // Rs[1 (*2)
		   LPBYTE lpSrc2,    // Rs[2 (-)
		   DWORD dwLength);   // Rs[钷

void *MemoryCopy2(void *b, const void *a, size_t n);

void SSE2AlignedMemoryCopy(void *pDst, void *pSrc, DWORD dwSize);
void SSE2MemoryCopy(void *pDst, void *pSrc, DWORD dwSize);

void YCExpandUYVYCopy(void *pDst_, void *pSrc_, DWORD dwSize_);
void YCExpandYUY2Copy(void *pDst_, void *pSrc_, DWORD dwSize_);
void YCExpandUYVY(void *pDst_, DWORD dwSize_);
void YCExpandYUY2(void *pDst_, DWORD dwSize_);

void SSE2StrideMemoryCopy(void *pDst_, void *pSrc_, DWORD dwSize_, int nHeight_, DWORD dwWidthSize_, DWORD dwStrideSize_, BOOL bBottomUp_);
void SSE2StrideRotationMemoryCopy(void *pDst_, void *pSrc_, LPBITMAPINFOHEADER pIn_, LPBITMAPINFOHEADER pOut_);
void StrideMemoryCopy(void *pDst_, void *pSrc_, DWORD dwSize_, int nHeight_, DWORD dwWidthSize_, DWORD dwStrideSize_, BOOL bBottomUp_);
void StrideYCExpandUYVYCopy(void *pDst_, void *pSrc_, DWORD dwSize_, int nHeight_, DWORD dwWidthSize_, DWORD dwStrideSize_, BOOL bBottomUp_);
void StrideYCExpandYUY2Copy(void *pDst_, void *pSrc_, DWORD dwSize_, int nHeight_, DWORD dwWidthSize_, DWORD dwStrideSize_, BOOL bBottomUp_);

void VerticalSharpnessCopy(void *pDst_, void *pSrc_, DWORD dwSize_, int nHeight_, DWORD dwWidthSize_, DWORD dwStrideSize_, BOOL bBottomUp_);


BOOL IsBottomUpBitmap(LPBITMAPINFOHEADER pbmOutput);