#include "stdafx.h"
#include "InitFile.h"


////////////////////////////////////////////////////////////////////////////////////////
//	CInitFile
BOOL CInitFile::CInitFileSection::Insert(LPCWSTR pwszKey, LPCWSTR pwszValue)
{
	if (pwszKey == NULL || pwszValue == NULL)
	{
		return FALSE;
	}

	std::vector<CInitFileKey>::iterator it;
	for (it = vcKey.begin(); it != vcKey.end(); it++)
	{
		if (it->wsKey == pwszKey)
		{
			it->wsValue = pwszValue;
			return TRUE;
		}
	}

	vcKey.push_back(CInitFileKey(pwszKey, pwszValue));
	return TRUE;
}

BOOL CInitFile::CInitFileSection::Erase(LPCWSTR pwszKey)
{
	if (pwszKey == NULL)
	{
		return FALSE;
	}

	std::vector<CInitFileKey>::iterator it;
	for (it = vcKey.begin(); it != vcKey.end(); it++)
	{
		if (it->wsKey == pwszKey)
		{
			vcKey.erase(it);
			return TRUE;
		}
	}

	return FALSE;
}

BOOL CInitFile::CInitFileSection::GetValue(LPCWSTR pwszKey, std::wstring &wsValue)
{
	if (pwszKey == NULL)
	{
		return FALSE;
	}

	std::vector<CInitFileKey>::iterator it;
	for (it = vcKey.begin(); it != vcKey.end(); it++)
	{
		if (it->wsKey == pwszKey)
		{
			wsValue = it->wsValue;
			return TRUE;
		}
	}

	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////////////
//	CInitFileData

BOOL CInitFile::CInitFileData::Insert(LPCWSTR pwszSection, LPCWSTR pwszKey, LPCWSTR pwszValue)
{
	if (pwszSection == NULL || pwszKey == NULL || pwszValue == NULL)
	{
		return FALSE;
	}

	std::vector<CInitFileSection>::iterator it;
	for (it = m_vcSection.begin(); it != m_vcSection.end(); it++)
	{
		if (it->wsSection == pwszSection)
		{
			return it->Insert(pwszKey, pwszValue);
		}
	}

	m_vcSection.push_back(CInitFileSection(pwszSection, pwszKey, pwszValue));
	return TRUE;
}

BOOL CInitFile::CInitFileData::Erase(LPCWSTR pwszSection, LPCWSTR pwszKey)
{
	if (pwszSection == NULL || pwszKey == NULL)
	{
		return FALSE;
	}

	std::vector<CInitFileSection>::iterator it;
	for (it = m_vcSection.begin(); it != m_vcSection.end(); it++)
	{
		if (it->wsSection == pwszSection)
		{
			return it->Erase(pwszKey);
		}
	}

	return FALSE;
}

BOOL CInitFile::CInitFileData::Erase(LPCWSTR pwszSection)
{
	if (pwszSection == NULL)
	{
		return FALSE;
	}

	std::vector<CInitFileSection>::iterator it;
	for (it = m_vcSection.begin(); it != m_vcSection.end(); it++)
	{
		if (it->wsSection == pwszSection)
		{
			m_vcSection.erase(it);
			return TRUE;
		}
	}

	return FALSE;
}

BOOL CInitFile::CInitFileData::GetValue(LPCWSTR pwszSection, LPCWSTR pwszKey, std::wstring &wsValue)
{
	if (pwszSection == NULL || pwszKey == NULL)
	{
		return FALSE;
	}

	std::vector<CInitFileSection>::iterator it;
	for (it = m_vcSection.begin(); it != m_vcSection.end(); it++)
	{
		if (it->wsSection == pwszSection)
		{
			return it->GetValue(pwszKey, wsValue);
		}
	}
	return FALSE;
}

void CInitFile::CInitFileData::GetText(std::wstring &wsText)
{
	wsText = L"";

	std::vector<CInitFileSection>::iterator itSection;
	std::vector<CInitFileKey>::iterator itKey;

	for (itSection = m_vcSection.begin(); itSection != m_vcSection.end(); itSection++)
	{
		wsText += L"[";
		wsText += itSection->wsSection;
		wsText += L"]";
		wsText += L"\n";

		for (itKey = itSection->vcKey.begin(); itKey != itSection->vcKey.end(); itKey++)
		{
			wsText += itKey->wsKey;
			wsText += L"=";
			wsText += itKey->wsValue;
			wsText += L"\n";
		}

		wsText += L"\n";
	}
}

//////////////////////////////////////////////////////////////////////
//	CInitFile

CInitFile::CInitFile(void)
{
	m_pFile = NULL;
	m_wsFileName = L"";
}

CInitFile::~CInitFile(void)
{
	Close();
}

BOOL CInitFile::Open(LPCWSTR pwszFileName, LPCWSTR pwszMode)
{
	if (pwszFileName == NULL || pwszMode == NULL)
	{
		return FALSE;
	}

	// t@CłɊJĂꍇ͕
	Close();

	if (::_wfopen_s(&m_pFile, pwszFileName, pwszMode))
	{
		return FALSE;
	}
	return TRUE;
}

BOOL CInitFile::Close(void)
{
	if (m_pFile != NULL)
	{
		if (::fclose(m_pFile))
		{
			return FALSE;
		}
		m_pFile = NULL;

		return TRUE;
	}
	return FALSE;
}

BOOL CInitFile::Read(LPCWSTR pwszFileName)
{
	m_wsFile = L"";

	if (!Open(pwszFileName, L"r"))
	{
		return FALSE;
	}

	WCHAR *pResult = NULL;
	WCHAR wszBuff[1025];

	::rewind(m_pFile);

	for (;;)
	{
		::memset(wszBuff, 0, sizeof(wszBuff) / sizeof(wszBuff[0]));

		pResult = ::fgetws(wszBuff, 1024, m_pFile);
		m_wsFile += wszBuff;

		if (pResult == NULL)
		{
			break;
		}
	}

	Close();
	return TRUE;
}

BOOL CInitFile::Write(LPCWSTR pwszFileName)
{
	if (!Open(pwszFileName, L"w"))
	{
		return FALSE;
	}

	::rewind(m_pFile);

	if (fputws(m_wsFile.c_str(), m_pFile) < 0)
	{
		Close();
		return FALSE;
	}

	Close();
	return TRUE;
}

BOOL CInitFile::Parse(void)
{
	m_dat.Clear();
	std::wstring wsTmp;

	std::wstring::iterator it;
	for (it = m_wsFile.begin(); it != m_wsFile.end(); it++)
	{
		/* sƂɎo */
		if (*it == L'\n')
		{
			if (wsTmp != L"")
			{
				LineParse(&wsTmp);
				wsTmp = L"";
			}
			continue;
		}
		wsTmp += *it;
	}

	/* I[ɂ͉sȂ̂łōŌ̍sƂ */
	if (wsTmp != L"")
	{
		LineParse(&wsTmp);
	}

	return TRUE;
}

void CInitFile::LineParse(std::wstring *pwsLine)
{
	if (pwsLine == NULL)
	{
		return;
	}

	// 擪̕ŃZNVAL[ARgA͕s\ʂ
	// ZNV	'['
	// L[			p
	// Rg		̑

	WCHAR wc = L'\0';

	if (pwsLine->size() <= 0)
	{
		return;
	}

	try
	{
		wc = pwsLine->at(0);
	}
	catch (std::exception const&)
	{
		return;
	}


	if (wc == L'[')
	{
		std::wstring wsTmp;
		std::wstring::iterator it;
		for (it = pwsLine->begin() + 1; it != pwsLine->end(); it++)
		{
			if (*it == L']')
			{
				break;
			}
			wsTmp += *it;
		}
		if (wsTmp != L"")
		{
			m_wsSection = wsTmp;
		}
		return;
	}
	else if (IsAlpha(wc))
	{
		std::wstring wsTmp, wsKey, wsValue;
		std::wstring::iterator it;
		bool foundEqual = false;
		for (it = pwsLine->begin(); it != pwsLine->end(); it++)
		{
			if (!foundEqual && *it == L'=')
			{
				foundEqual = true;
				if (wsTmp != L"")
				{
					wsKey = wsTmp;
					wsTmp = L"";
					continue;
				}
				else
				{
					return;
				}
			}
			wsTmp += *it;
		}

		wsValue = wsTmp;

		if (m_wsSection != L"" || wsKey != L"")
		{
			m_dat.Insert(m_wsSection.c_str(), wsKey.c_str(), wsValue.c_str());
		}
	}

	return;
}

BOOL CInitFile::IsAlpha(WCHAR wc)
{
	WCHAR wszAlpha[] = L"aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPqQrRsStTuUvVwWxXyYzZ";
	int nSize = sizeof(wszAlpha) / sizeof(wszAlpha[0]);

	for (int i = 0; i < nSize; i++)
	{
		if (wc == wszAlpha[i])
		{
			return TRUE;
		}
	}
	return FALSE;
}

BOOL CInitFile::ToHex(LPVOID lpStruct, UINT uSizeStruct, std::wstring &wsHex)
{
	LPBYTE pData = (LPBYTE)lpStruct;

	if (pData == NULL)
	{
		return FALSE;
	}

	BYTE btCheckSum = 0;
	WCHAR pwszHex[] = L"0123456789ABCDEF";

	for (UINT i = 0; i < uSizeStruct; i++)
	{
		/* oCgf[^\ZiɕϊĒǉ */
		wsHex += pwszHex[((pData[i] & 0xF0) >> 4) & 0x0F];
		wsHex += pwszHex[pData[i] & 0x0F];

		/* `FbNT͒PȉZ */
		btCheckSum += pData[i];
	}

	/* ŌɃ`FbNTǉ */
	wsHex += pwszHex[((btCheckSum & 0xF0) >> 4) & 0x0F];
	wsHex += pwszHex[btCheckSum & 0x0F];
	return TRUE;
}

BOOL CInitFile::FromHex(LPVOID lpStruct, UINT uSizeStruct, std::wstring &wsHex)
{
	LPBYTE pData = (LPBYTE)lpStruct;

	if (pData == NULL)
	{
		return FALSE;
	}

	if (wsHex.length() < 4)
	{
		return FALSE;
	}

	if (uSizeStruct != (wsHex.length() - 1) / 2)
	{
		return FALSE;
	}

	LPBYTE pBuff = new BYTE[uSizeStruct];

	if (pBuff == NULL)
	{
		return FALSE;
	}

	BYTE btCheckSum = 0;

	try
	{
		for (UINT i = 0; i < uSizeStruct; i++)
		{
			pBuff[i] = WCharToByte(wsHex.at((i * 2)), wsHex.at((i * 2) + 1));
			btCheckSum += pBuff[i];
		}

		if (btCheckSum != WCharToByte(*(wsHex.rbegin() + 1), *(wsHex.rbegin())))
		{
			delete [] pBuff;
			return FALSE;
		}
	}
	catch(std::exception const&)
	{
		delete [] pBuff;
		return FALSE;
	}

	::CopyMemory(pData, pBuff, uSizeStruct);

	delete [] pBuff;
	return TRUE;
}

BYTE CInitFile::WCharToByte(WCHAR wcHigh, WCHAR wcLow)
{
	BYTE btHigh = 0, btLow = 0;
	WCHAR pwszUpperHex[] = L"0123456789ABCDEF";
	WCHAR pwszLowerHex[] = L"0123456789ABCDEF";

	for(BYTE i = 0; i < 16; i++)
	{
		if (pwszUpperHex[i] == wcHigh ||
			pwszLowerHex[i] == wcHigh)
		{
			btHigh = i;
		}

		if (pwszUpperHex[i] == wcLow ||
			pwszLowerHex[i] == wcLow)
		{
			btLow = i;
		}
	}
	return (btHigh * 16) + btLow;
}

void CInitFile::GUIDToString(const GUID &guid, std::wstring &wsStr)
{
	WCHAR pwszHex[] = L"0123456789ABCDEF";

	wsStr = L"{";

	wsStr += pwszHex[((guid.Data1 & 0xF0000000) >> 28) & 0x0000000F];
	wsStr += pwszHex[((guid.Data1 & 0x0F000000) >> 24) & 0x0000000F];
	wsStr += pwszHex[((guid.Data1 & 0x00F00000) >> 20) & 0x0000000F];
	wsStr += pwszHex[((guid.Data1 & 0x000F0000) >> 16) & 0x0000000F];
	wsStr += pwszHex[((guid.Data1 & 0x0000F000) >> 12) & 0x0000000F];
	wsStr += pwszHex[((guid.Data1 & 0x00000F00) >>  8) & 0x0000000F];
	wsStr += pwszHex[((guid.Data1 & 0x000000F0) >>  4) & 0x0000000F];
	wsStr += pwszHex[guid.Data1 & 0x0000000F];


	wsStr += L"-";

	wsStr += pwszHex[((guid.Data2 & 0xF000) >> 12) & 0x000F];
	wsStr += pwszHex[((guid.Data2 & 0x0F00) >>  8) & 0x000F];
	wsStr += pwszHex[((guid.Data2 & 0x00F0) >>  4) & 0x000F];
	wsStr += pwszHex[guid.Data2 & 0x000F];

	wsStr += L"-";

	wsStr += pwszHex[((guid.Data3 & 0xF000) >> 12) & 0x000F];
	wsStr += pwszHex[((guid.Data3 & 0x0F00) >>  8) & 0x000F];
	wsStr += pwszHex[((guid.Data3 & 0x00F0) >>  4) & 0x000F];
	wsStr += pwszHex[guid.Data3 & 0x000F];

	wsStr += L"-";

	LPBYTE pData = (LPBYTE)&(guid.Data4);
	int nSize = sizeof(guid.Data4);
	for (int i = 0; i < nSize; i++)
	{
		/* oCgf[^\ZiɕϊĒǉ */
		wsStr += pwszHex[((pData[i] & 0xF0) >> 4) & 0x0F];
		wsStr += pwszHex[pData[i] & 0x0F];

		if (i == 1)
		{
			wsStr += L"-";
		}
	}

	wsStr += L"}";
}


BOOL CInitFile::StringToGUID(LPCWSTR pwszStr, GUID &guid)
{
	if (pwszStr == NULL)
	{
		return FALSE;
	}

	WCHAR pwszUpperHex[] = L"0123456789ABCDEF";
	WCHAR pwszLowerHex[] = L"0123456789abcdef";

	std::wstring wsTmp;
	wsTmp = pwszStr;

	if (wsTmp.size() != 38)
	{
		return FALSE;
	}

	// {B87BEB7B-8D29-423f-AE4D-6582C10175AC}

	try
	{
		// ʂ邩
		if (wsTmp.at( 0) != L'{' ||
			wsTmp.at(37) != L'}')
		{
			return FALSE;
		}

		// nCt邩
		if (wsTmp.at( 9) != L'-' ||
			wsTmp.at(14) != L'-' ||
			wsTmp.at(19) != L'-' ||
			wsTmp.at(24) != L'-')
		{
			return FALSE;
		}

		DWORD dwValue = 0;
		int nPos = 1;
		for (int i = nPos; i < (nPos + 8); i++)
		{
			WCHAR wc = wsTmp.at(i);
			for(int n = 0; n < 16; n++)
			{
				if (pwszUpperHex[n] == wc ||
					pwszLowerHex[n] == wc)
				{
					dwValue += n << (7 - (i - nPos)) * 4;
					break;
				}
			}
		}

		guid.Data1 = dwValue;


		WORD wValue = 0;
		nPos = 10;
		for (int i = nPos; i < (nPos + 4); i++)
		{
			WCHAR wc = wsTmp.at(i);
			for(int n = 0; n < 16; n++)
			{
				if (pwszUpperHex[n] == wc ||
					pwszLowerHex[n] == wc)
				{
					wValue += n << (3 - (i - nPos)) * 4;
					break;
				}
			}
		}

		guid.Data2 = wValue;


		wValue = 0;
		nPos = 15;
		for (int i = nPos; i < (nPos + 4); i++)
		{
			WCHAR wc = wsTmp.at(i);
			for(int n = 0; n < 16; n++)
			{
				if (pwszUpperHex[n] == wc ||
					pwszLowerHex[n] == wc)
				{
					wValue += n << (3 - (i - nPos)) * 4;
					break;
				}
			}
		}

		guid.Data3 = wValue;

		guid.Data4[0] = WCharToByte(wsTmp.at(20), wsTmp.at(21));
		guid.Data4[1] = WCharToByte(wsTmp.at(22), wsTmp.at(23));

		guid.Data4[2] = WCharToByte(wsTmp.at(25), wsTmp.at(26));
		guid.Data4[3] = WCharToByte(wsTmp.at(27), wsTmp.at(28));
		guid.Data4[4] = WCharToByte(wsTmp.at(29), wsTmp.at(30));
		guid.Data4[5] = WCharToByte(wsTmp.at(31), wsTmp.at(32));
		guid.Data4[6] = WCharToByte(wsTmp.at(33), wsTmp.at(34));
		guid.Data4[7] = WCharToByte(wsTmp.at(35), wsTmp.at(36));

	}
	catch (std::exception const&)
	{
		return FALSE;
	}

	return TRUE;
}



BOOL CInitFile::Load(LPCWSTR pwszFileName)
{
	if (pwszFileName == NULL)
	{
		return FALSE;
	}

	m_wsFileName = pwszFileName;
	if (Read(pwszFileName))
	{
		return Parse();
	}
	return FALSE;
}

BOOL CInitFile::Save(LPCWSTR pwszFileName)
{
	if (pwszFileName == NULL)
	{
		return FALSE;
	}

	m_wsFileName = pwszFileName;
	m_dat.GetText(m_wsFile);

	if (Write(pwszFileName))
	{
		return TRUE;
	}
	return FALSE;
}

BOOL CInitFile::Save(void)
{
	if (m_wsFileName == L"")
	{
		return FALSE;
	}

	m_dat.GetText(m_wsFile);

	if (Write(m_wsFileName.c_str()))
	{
		return TRUE;
	}
	return FALSE;
}

void CInitFile::Clear(void)
{
	m_dat.Clear();
}

BOOL CInitFile::Write(LPCWSTR pwszSection, LPCWSTR pwszKey, LPCWSTR pwszValue)
{
	return m_dat.Insert(pwszSection, pwszKey, pwszValue);
}

BOOL CInitFile::Write(LPCWSTR pwszSection, LPCWSTR pwszKey, std::wstring &wsValue)
{
	return m_dat.Insert(pwszSection, pwszKey, wsValue.c_str());
}

BOOL CInitFile::Read(LPCWSTR pwszSection, LPCWSTR pwszKey, std::wstring &wsValue, LPCWSTR pwszDefault)
{
	if (!m_dat.GetValue(pwszSection, pwszKey, wsValue))
	{
		wsValue = pwszDefault;
		return FALSE;
	}
	return TRUE;
}

BOOL CInitFile::Write(LPCWSTR pwszSection, LPCWSTR pwszKey, int nValue)
{
	WCHAR pwszValue[256];
	memset(pwszValue, 0, sizeof(pwszValue));
	wsprintf(pwszValue, L"%d", nValue);
	pwszValue[256-1] = L'\0';
	return Write(pwszSection, pwszKey, pwszValue);
}

BOOL CInitFile::Read(LPCWSTR pwszSection, LPCWSTR pwszKey, int &nValue, int nDefault)
{
	std::wstring wsValue;
	if (!m_dat.GetValue(pwszSection, pwszKey, wsValue))
	{
		nValue = nDefault;
		return FALSE;
	}

	nValue = _wtoi(wsValue.c_str());
	return TRUE;
}

BOOL CInitFile::Write(LPCWSTR pwszSection, LPCWSTR pwszKey, long lValue)
{
	WCHAR pwszValue[256];
	memset(pwszValue, 0, sizeof(pwszValue));
	wsprintf(pwszValue, L"%d", lValue);
	pwszValue[256-1] = L'\0';
	return Write(pwszSection, pwszKey, pwszValue);
}

BOOL CInitFile::Read(LPCWSTR pwszSection, LPCWSTR pwszKey, long &lValue, long lDefault)
{
	std::wstring wsValue;
	if (!m_dat.GetValue(pwszSection, pwszKey, wsValue))
	{
		lValue = lDefault;
		return FALSE;
	}

	lValue = _wtol(wsValue.c_str());
	return TRUE;
}


BOOL CInitFile::Write(LPCWSTR pwszSection, LPCWSTR pwszKey, LONGLONG llValue)
{
	WCHAR pwszValue[256];
	memset(pwszValue, 0, sizeof(pwszValue));
	wsprintf(pwszValue, L"%I64u", llValue);
	pwszValue[256-1] = L'\0';
	return Write(pwszSection, pwszKey, pwszValue);
}

BOOL CInitFile::Read(LPCWSTR pwszSection, LPCWSTR pwszKey, LONGLONG &llValue, LONGLONG llDefault)
{
	std::wstring wsValue;
	if (!m_dat.GetValue(pwszSection, pwszKey, wsValue))
	{
		llValue = llDefault;
		return FALSE;
	}

	llValue = _wtoi64(wsValue.c_str());
	return TRUE;
}

BOOL CInitFile::Write(LPCWSTR pwszSection, LPCWSTR pwszKey, WORD wValue)
{
	WCHAR pwszValue[256];
	memset(pwszValue, 0, sizeof(pwszValue));
	wsprintf(pwszValue, L"%d", wValue);
	pwszValue[256-1] = L'\0';
	return Write(pwszSection, pwszKey, pwszValue);
}

BOOL CInitFile::Read(LPCWSTR pwszSection, LPCWSTR pwszKey, WORD &wValue, WORD wDefault)
{
	std::wstring wsValue;
	if (!m_dat.GetValue(pwszSection, pwszKey, wsValue))
	{
		wValue = wDefault;
		return FALSE;
	}

	wValue = _wtoi(wsValue.c_str());
	return TRUE;
}


BOOL CInitFile::Write(LPCWSTR pwszSection, LPCWSTR pwszKey, DWORD dwValue)
{
	WCHAR pwszValue[256];
	memset(pwszValue, 0, sizeof(pwszValue));
	wsprintf(pwszValue, L"%d", dwValue);
	pwszValue[256-1] = L'\0';
	return Write(pwszSection, pwszKey, pwszValue);
}

BOOL CInitFile::Read(LPCWSTR pwszSection, LPCWSTR pwszKey, DWORD &dwValue, DWORD dwDefault)
{
	std::wstring wsValue;
	if (!m_dat.GetValue(pwszSection, pwszKey, wsValue))
	{
		dwValue = dwDefault;
		return FALSE;
	}

	dwValue = _wtoi(wsValue.c_str());
	return TRUE;
}

BOOL CInitFile::Write(LPCWSTR pwszSection, LPCWSTR pwszKey, std::vector<int> &vcValue)
{
	std::wstring wsValue;
	std::vector<int>::iterator it;
	for (it = vcValue.begin(); it != vcValue.end(); it++)
	{
		WCHAR pwszValue[256];
		memset(pwszValue, 0, sizeof(pwszValue));
		wsprintf(pwszValue, L"%d", *it);
		pwszValue[256-1] = L'\0';

		if (wsValue != L"")
		{
			wsValue += L",";
		}

		wsValue += pwszValue;
	}
	return Write(pwszSection, pwszKey, wsValue);
}

BOOL CInitFile::Read(LPCWSTR pwszSection, LPCWSTR pwszKey, std::vector<int> &vcValue, LPCWSTR pwszDefault)
{
	vcValue.clear();

	BOOL bResult = FALSE;
	std::wstring wsValue;

	bResult = m_dat.GetValue(pwszSection, pwszKey, wsValue);

	if (bResult == FALSE)
	{
		wsValue = pwszDefault;
	}

	typedef boost::char_separator<wchar_t> wseparator;
	typedef boost::tokenizer<wseparator, std::wstring::const_iterator, std::wstring> wtokenizer;
	wseparator sep(L",", L"", boost::keep_empty_tokens);

	wtokenizer tokens(wsValue, sep);

	std::wstring wsTmp;
	for (wtokenizer::iterator it = tokens.begin(); it != tokens.end(); it++)
	{
		vcValue.push_back(_wtoi(it->c_str()));
	}

	return bResult;
}

BOOL CInitFile::Write(LPCWSTR pwszSection, LPCWSTR pwszKey, const GUID &guidValue)
{
	std::wstring wsValue;
	GUIDToString(guidValue, wsValue);
	return Write(pwszSection, pwszKey, wsValue);
}

BOOL CInitFile::Read(LPCWSTR pwszSection, LPCWSTR pwszKey, GUID &guidValue, LPCWSTR pwszDefault)
{
	BOOL bResult = FALSE;
	std::wstring wsValue;

	::memset(&guidValue, 0, sizeof(GUID));

	if (m_dat.GetValue(pwszSection, pwszKey, wsValue) == FALSE)
	{
		wsValue = pwszDefault;
	}

	return StringToGUID(wsValue.c_str(), guidValue);
}

BOOL CInitFile::WriteData(LPCWSTR pwszSection, LPCWSTR pwszKey, LPVOID lpStruct, UINT uSizeStruct)
{
	std::wstring wsValue;
	if (ToHex(lpStruct, uSizeStruct, wsValue))
	{
		return Write(pwszSection, pwszKey, wsValue);
	}
	return FALSE;
}

BOOL CInitFile::ReadData(LPCWSTR pwszSection, LPCWSTR pwszKey, LPVOID lpStruct, UINT uSizeStruct)
{
	std::wstring wsValue;
	if (!m_dat.GetValue(pwszSection, pwszKey, wsValue))
	{
		return FALSE;
	}
	return FromHex(lpStruct, uSizeStruct, wsValue);
}

