#pragma once

// ̃NXgOɉLsȂƂȂ
// ::setlocale(LC_ALL, "");
// P[ႤƓ{ꂪt@CɕۑȂ

class CInitFile
{
	class CInitFileKey
	{
	public:
		CInitFileKey()
			: wsKey(L"")
			, wsValue(L"")
		{
		}

		~CInitFileKey()
		{
		}

		CInitFileKey(const CInitFileKey& x)
			: wsKey(x.wsKey)
			, wsValue(x.wsValue)
		{
		}

		CInitFileKey(LPCWSTR pwszKey, LPCWSTR pwszValue)
			: wsKey(pwszKey)
			, wsValue(pwszValue)
		{
		}

		CInitFileKey& operator=(const CInitFileKey& x)
		{
			wsKey = x.wsKey;
			wsValue = x.wsValue;
			return *this;
		}

		std::wstring wsKey;
		std::wstring wsValue;
	};

	class CInitFileSection
	{
	public:
		CInitFileSection()
			: wsSection(L"")
			, vcKey(std::vector<CInitFileKey>())
		{
		}

		~CInitFileSection()
		{
		}

		CInitFileSection(const CInitFileSection& x)
			: wsSection(x.wsSection)
			, vcKey(x.vcKey)
		{
		}

		CInitFileSection(LPCWSTR pwszSection, LPCWSTR pwszKey, LPCWSTR pwszValue)
			: wsSection(pwszSection)
			, vcKey(std::vector<CInitFileKey>())
		{
			vcKey.push_back(CInitFileKey(pwszKey, pwszValue));
		}

		CInitFileSection& operator=(const CInitFileSection& x)
		{
			wsSection = x.wsSection;
			vcKey = x.vcKey;
			return *this;
		}

		BOOL Insert(LPCWSTR pwszKey, LPCWSTR pwszValue);
		BOOL Erase(LPCWSTR pwszKey);
		BOOL GetValue(LPCWSTR pwszKey, std::wstring &wsValue);

		std::wstring wsSection;
		std::vector<CInitFileKey> vcKey;
	};

	class CInitFileData
	{
	public:
		CInitFileData()
			: m_vcSection(std::vector<CInitFileSection>())
		{
		
		}
		~CInitFileData()
		{
		
		}
		CInitFileData(const CInitFileData& x)
			: m_vcSection(x.m_vcSection)
		{
		
		}
		CInitFileData& operator=(const CInitFileData& x)
		{
			m_vcSection = x.m_vcSection;
			return *this;
		}

		void Clear(void)
		{
			m_vcSection.clear();
		}

		BOOL Insert(LPCWSTR pwszSection, LPCWSTR pwszKey, LPCWSTR pwszValue);
		BOOL Erase(LPCWSTR pwszSection, LPCWSTR pwszKey);
		BOOL Erase(LPCWSTR pwszSection);
		BOOL GetValue(LPCWSTR pwszSection, LPCWSTR pwszKey, std::wstring &wsValue);
		void GetText(std::wstring &wsText);

	private:
		std::vector<CInitFileSection> m_vcSection;
	};

public:
	CInitFile(void);
	~CInitFile(void);

private:
	BOOL Open(LPCWSTR pwszFileName, LPCWSTR pwszMode);
	BOOL Close(void);
	BOOL Read(LPCWSTR pwszFileName);
	BOOL Write(LPCWSTR pwszFileName);

	BOOL Parse(void);
	void LineParse(std::wstring *pwsLine);
	BOOL IsAlpha(WCHAR wc);

	BOOL ToHex(LPVOID lpStruct, UINT uSizeStruct, std::wstring &wsHex);
	BOOL FromHex(LPVOID lpStruct, UINT uSizeStruct, std::wstring &wsHex);

	BYTE WCharToByte(WCHAR wcHigh, WCHAR wcLow);

	void GUIDToString(const GUID &guid, std::wstring &wsStr);
	BOOL StringToGUID(LPCWSTR pwszStr, GUID &guid);

public:
	BOOL Load(LPCWSTR pwszFileName);
	BOOL Save(LPCWSTR pwszFileName);
	BOOL Save(void);

	void Clear(void);

	// 
	BOOL Write(LPCWSTR pwszSection, LPCWSTR pwszKey, LPCWSTR pwszValue);
	BOOL Write(LPCWSTR pwszSection, LPCWSTR pwszKey, std::wstring &wsValue);
	BOOL Read(LPCWSTR pwszSection, LPCWSTR pwszKey, std::wstring &wsValue, LPCWSTR pwszDefault);

	// int
	BOOL Write(LPCWSTR pwszSection, LPCWSTR pwszKey, int nValue);
	BOOL Read(LPCWSTR pwszSection, LPCWSTR pwszKey, int &nValue, int nDefault);

	// long
	BOOL Write(LPCWSTR pwszSection, LPCWSTR pwszKey, long lValue);
	BOOL Read(LPCWSTR pwszSection, LPCWSTR pwszKey, long &lValue, long lDefault);

	// LONGLONG
	BOOL Write(LPCWSTR pwszSection, LPCWSTR pwszKey, LONGLONG llValue);
	BOOL Read(LPCWSTR pwszSection, LPCWSTR pwszKey, LONGLONG &llValue, LONGLONG llDefault);

	// WORD
	BOOL Write(LPCWSTR pwszSection, LPCWSTR pwszKey, WORD wValue);
	BOOL Read(LPCWSTR pwszSection, LPCWSTR pwszKey, WORD &wValue, WORD wDefault);

	// DWORD
	BOOL Write(LPCWSTR pwszSection, LPCWSTR pwszKey, DWORD dwValue);
	BOOL Read(LPCWSTR pwszSection, LPCWSTR pwszKey, DWORD &dwValue, DWORD dwDefault);

	// intz
	BOOL Write(LPCWSTR pwszSection, LPCWSTR pwszKey, std::vector<int> &vcValue);
	BOOL Read(LPCWSTR pwszSection, LPCWSTR pwszKey, std::vector<int> &vcValue, LPCWSTR pwszDefault);

	// GUID
	BOOL Write(LPCWSTR pwszSection, LPCWSTR pwszKey, const GUID &guidValue);
	BOOL Read(LPCWSTR pwszSection, LPCWSTR pwszKey, GUID &guidValue, LPCWSTR pwszDefault);

	// oCif[^
	BOOL WriteData(LPCWSTR pwszSection, LPCWSTR pwszKey, LPVOID lpStruct, UINT uSizeStruct);
	BOOL ReadData(LPCWSTR pwszSection, LPCWSTR pwszKey, LPVOID lpStruct, UINT uSizeStruct);


private:
	FILE *m_pFile;
	std::wstring m_wsFileName;
	std::wstring m_wsFile;

	// ݂̃ZNVi͂Ɏgpj
	std::wstring m_wsSection;

	CInitFileData m_dat;
};
