// InnerFilterPage.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "InnerFilterPage.h"
#include "afxdialogex.h"


// CInnerFilterPage _CAO

IMPLEMENT_DYNAMIC(CInnerFilterPage, CPropertyPage)

CInnerFilterPage::CInnerFilterPage(CMainDlg *dlg, CCaptureGraphProfile *profile)
	: CPropertyPage(CInnerFilterPage::IDD)
	, dlg_(dlg)
	, profile_(profile)
	, enableCtrl_(FALSE)
{
	m_psp.dwFlags &= ~PSP_HASHELP;
}

CInnerFilterPage::~CInnerFilterPage()
{
}

void CInnerFilterPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CB_ENABLE, m_xcCbEnable);
}


BEGIN_MESSAGE_MAP(CInnerFilterPage, CPropertyPage)
	ON_BN_CLICKED(IDC_CB_ENABLE, &CInnerFilterPage::OnBnClickedCbEnable)
END_MESSAGE_MAP()


// CInnerFilterPage bZ[W nh[


BOOL CInnerFilterPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	if (!profile_)
	{
		m_xcCbEnable.EnableWindow(FALSE);
		return TRUE;
	}

	m_xcCbEnable.SetCheck(profile_->Preview.bTransform ? BST_CHECKED : BST_UNCHECKED);

	EnableCtrl(enableCtrl_);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void CInnerFilterPage::OnOK()
{
	CPropertyPage::OnOK();
}


void CInnerFilterPage::OnBnClickedCbEnable()
{
	BOOL enable = m_xcCbEnable.GetCheck() == BST_CHECKED ? TRUE : FALSE;
	profile_->Preview.bTransform = enable;

	if (pageDeint_) { pageDeint_->EnableCtrl(enable); }
	if (pageYCE_) { pageYCE_->EnableCtrl(enable); }
	if (pageRot_) { pageRot_->EnableCtrl(enable); }

	dlg_->OnPreviewIsRunBuild();
}

void CInnerFilterPage::EnableCtrl(BOOL enable)
{
	if (IsWindow(m_hWnd))
	{
		m_xcCbEnable.EnableWindow(enable);
	}
	enableCtrl_ = enable;
}