// InnerFilterSheet.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "InnerFilterSheet.h"



// CInnerFilterSheet

IMPLEMENT_DYNAMIC(CInnerFilterSheet, CPropertySheet)

CInnerFilterSheet::CInnerFilterSheet(CMainDlg *dlg, CCaptureGraphProfile *profile, UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
	, m_nLastTab(0)
	, m_pageRenderer(dlg, profile)
	, m_pageCropping(dlg, profile, &g_cfg.m_vecCrop)
	, m_pageVideoProcAmp(dlg, profile)
	, m_pageVMR9ProcAmp(dlg, profile)
	, m_pageEVRProcAmp(dlg, profile)
	, m_pageInnerFilter(dlg, profile)
	, m_pageDeinterlace(dlg, profile)
	, m_pageYCExpand(dlg, profile)
	, m_pageRotation(dlg, profile)
	, dlg_(dlg)
	, profile_(profile)
	, crop_(&g_cfg.m_vecCrop)
{
	InitPages();
}

CInnerFilterSheet::CInnerFilterSheet(CMainDlg *dlg, CCaptureGraphProfile *profile, LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
	, m_nLastTab(0)
	, m_pageRenderer(dlg, profile)
	, m_pageCropping(dlg, profile, &g_cfg.m_vecCrop)
	, m_pageVideoProcAmp(dlg, profile)
	, m_pageVMR9ProcAmp(dlg, profile)
	, m_pageEVRProcAmp(dlg, profile)
	, m_pageInnerFilter(dlg, profile)
	, m_pageDeinterlace(dlg, profile)
	, m_pageYCExpand(dlg, profile)
	, m_pageRotation(dlg, profile)
	, dlg_(dlg)
	, profile_(profile)
	, crop_(&g_cfg.m_vecCrop)
{
	InitPages();
}

CInnerFilterSheet::~CInnerFilterSheet()
{
}


BEGIN_MESSAGE_MAP(CInnerFilterSheet, CPropertySheet)
	ON_WM_SYSCOMMAND()
END_MESSAGE_MAP()


// y[W


void CInnerFilterSheet::InitPages(void)
{
	stored_ = *profile_;
	cropStored_ = *crop_;

	m_psh.dwFlags &= ~PSH_HASHELP;
	m_psh.dwFlags |= PSH_NOAPPLYNOW;

	AddPage(&m_pageRenderer);
	AddPage(&m_pageCropping);
	AddPage(&m_pageVideoProcAmp);
	AddPage(&m_pageVMR9ProcAmp);
	AddPage(&m_pageEVRProcAmp);
	AddPage(&m_pageInnerFilter);
	AddPage(&m_pageDeinterlace);
	AddPage(&m_pageYCExpand);
	AddPage(&m_pageRotation);

	m_pageRenderer.SetPage(&m_pageVMR9ProcAmp, &m_pageEVRProcAmp);
	m_pageInnerFilter.SetPage(&m_pageDeinterlace, &m_pageYCExpand, &m_pageRotation);


	m_pageInnerFilter.EnableCtrl(TRUE);
	m_pageDeinterlace.EnableCtrl(profile_->Preview.bTransform);
	m_pageYCExpand.EnableCtrl(profile_->Preview.bTransform);
	m_pageRotation.EnableCtrl(profile_->Preview.bTransform);

	// tB^ɐڑł邩mF
	// rfItB^ڑĂȂƂ͗L
	for (auto it = profile_->Filter.vecVideo.begin(); it != profile_->Filter.vecVideo.end(); ++it)
	{
		if (it->bCheck)
		{
			m_pageInnerFilter.EnableCtrl(FALSE);
			m_pageDeinterlace.EnableCtrl(FALSE);
			m_pageYCExpand.EnableCtrl(FALSE);
			m_pageRotation.EnableCtrl(FALSE);
			break;
		}
	}
}


BOOL CInnerFilterSheet::OnInitDialog()
{
	BOOL bResult = CPropertySheet::OnInitDialog();

	SetActivePage(m_nLastTab);

	return bResult;
}


// y[WOkCancel{^͓̏ƗĂ
// y[WƂɂIłȂ
//
// V[gœIɏIɂ̓V[gOnCommandŃy[W̃{^肷
// ̂܂܂ł͏IȂ̂PressButtonŏI
BOOL CInnerFilterSheet::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch(wParam)
	{
	case IDOK:
		{
			OnOK();
			PressButton(PSBTN_OK);
		}
		return TRUE;

	case IDCANCEL:
		{
			OnCancel();
			PressButton(PSBTN_CANCEL);
		}
		return TRUE;

	default:
		break;
	};

	return CPropertySheet::OnCommand(wParam, lParam);
}

// vpeBV[g̕{^OnCloseł͏EȂ̂
void CInnerFilterSheet::OnSysCommand(UINT nID, LPARAM lParam)
{
	// {^ꂽ
	if (nID == SC_CLOSE)
	{
		OnCancel();
	}

	CPropertySheet::OnSysCommand(nID, lParam);
}


void CInnerFilterSheet::OnOK(void)
{
	m_nLastTab = GetActiveIndex();
}


void CInnerFilterSheet::OnCancel(void)
{
	// Otč\z邩肷
	// vt@CݒOɖ߂

	bool rebuild = false;
	CPreviewConfig* const next = &(profile_->Preview);
	CPreviewConfig* const last = &(stored_.Preview);


	//-------------------------------------------------------------
	// NbsO
	if (next->rcCropping.top != last->rcCropping.top ||
		next->rcCropping.left != last->rcCropping.left ||
		next->rcCropping.right != last->rcCropping.right ||
		next->rcCropping.bottom != last->rcCropping.bottom)
	{
		rebuild = true;
	}

	//-------------------------------------------------------------
	// _
	if (next->lVideoRenderer != last->lVideoRenderer ||
		next->lAudioRenderer != last->lAudioRenderer ||
		next->bVideoPreviewPin != last->bVideoPreviewPin ||
		next->bAudioPreviewPin != last->bAudioPreviewPin)
	{
		rebuild = true;
	}

	//-------------------------------------------------------------
	// S
	if (next->bTransform != last->bTransform)
	{
		rebuild = true;
	}

	//-------------------------------------------------------------
	// fC^[[X
	if (next->bTransform &&
		next->lTransformCopy != last->lTransformCopy &&
		(next->lTransformCopy == TRANSFORM_COPY_HARDWARE ||
		last->lTransformCopy == TRANSFORM_COPY_HARDWARE))
	{
		rebuild = true;
	}

	if (next->bTransform &&
		next->lTransformFrame != last->lTransformFrame &&	// t[ݒ肪ύXĂ
		last->lTransformCopy == TRANSFORM_COPY_HARDWARE &&	// fC^[[Xݒ肪n[hEFAɂȂ
		(next->lTransformFrame == TRANSFORM_FRAME_DOUBLE ||	// 2{A܂2{ɕύXĂ
		last->lTransformFrame == TRANSFORM_FRAME_DOUBLE))
	{
		rebuild = true;
	}

	// ݒ蕜
	*profile_ = stored_;
	*crop_ = cropStored_;

	if (rebuild)
	{
		// č\zĐݒ𕜌
		dlg_->OnPreviewIsRunBuild();
	}
	else
	{
		// č\zȂŐݒ𕜌

		// fC^[[X
		dlg_->m_Preview.SetTransformCopy(next->lTransformCopy);
		dlg_->m_Preview.SetTransformFrame(next->lTransformFrame);
		dlg_->m_Preview.SetTransformFieldOrder(next->lTransformFieldOrder);

		// f
		dlg_->m_Preview.SetVideoProcAmpConfig(profile_->VideoProcAmp);
		dlg_->m_Preview.SetVMR9ProcAmp(profile_->VMR9ProcAmp);
		dlg_->m_Preview.SetEVRProcAmp(profile_->EVRProcAmp);
	}

	m_nLastTab = GetActiveIndex();
}
