#pragma once

#include "RendererPage.h"
#include "CroppingPage.h"
#include "VideoProcAmpPage.h"
#include "EVRProcAmpPage.h"
#include "VMR9ProcAmpPage.h"

#include "InnerFilterPage.h"
#include "DeinterlacePage.h"
#include "YCExpandPage.h"
#include "RotationPage.h"


// CInnerFilterSheet

class CInnerFilterSheet : public CPropertySheet
{
	DECLARE_DYNAMIC(CInnerFilterSheet)

public:
	CInnerFilterSheet(CMainDlg *dlg, CCaptureGraphProfile *profile, UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CInnerFilterSheet(CMainDlg *dlg, CCaptureGraphProfile *profile, LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	virtual ~CInnerFilterSheet();

protected:
	DECLARE_MESSAGE_MAP()

private:
	CCaptureGraphProfile stored_;
	CMainDlg* const dlg_;
	CCaptureGraphProfile* const profile_;

	std::vector<CRect> cropStored_;
	std::vector<CRect>* const crop_;

public:
	virtual BOOL OnInitDialog();

private:
	int m_nLastTab;

public:
	int GetLastTab() { return m_nLastTab; }
	void SetLastTab(int last) { m_nLastTab = last; }

private:
	CRendererPage		m_pageRenderer;
	CCroppingPage		m_pageCropping;
	CVideoProcAmpPage	m_pageVideoProcAmp;
	CEVRProcAmpPage		m_pageEVRProcAmp;
	CVMR9ProcAmpPage	m_pageVMR9ProcAmp;
	CInnerFilterPage	m_pageInnerFilter;
	CDeinterlacePage	m_pageDeinterlace;
	CYCExpandPage		m_pageYCExpand;
	CRotationPage		m_pageRotation;

	void InitPages(void);

	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);

	void OnCancel(void);
	void OnOK(void);
};


