#include"stdafx.h"
#include "MyTransform.h"

#define TEMPLATE_NAME	(L"My Transform Filter")
#define FILTER_NAME		(TEMPLATE_NAME)
#define INPUT_PIN_NAME  (L"Input")
#define OUTPUT_PIN_NAME (L"Output")


// s^Cv̒`
const AMOVIESETUP_MEDIATYPE sudPinTypes =
{
    &MEDIATYPE_Video,        // Major type
    &MEDIASUBTYPE_NULL      // Minor type
};

// ͗pAo͗ps̏
const AMOVIESETUP_PIN sudPins[] =
{
	{
		INPUT_PIN_NAME,
		FALSE,
		FALSE,
		FALSE,
		FALSE,
		&CLSID_NULL,
		NULL,
		1,
		&sudPinTypes
	},
	{
		OUTPUT_PIN_NAME,
		FALSE,
		TRUE,
		FALSE,
		FALSE,
		&CLSID_NULL,
		NULL,
		1,
		&sudPinTypes
	},
};

// tB^
const AMOVIESETUP_FILTER afFilterInfo=
{
    &__uuidof(CMyTransform),
    FILTER_NAME,
    MERIT_DO_NOT_USE,
    2,
    sudPins
};


STDAPI ConvertVideoInfoToVideoInfo2(__inout AM_MEDIA_TYPE *pmt)
{
    if (pmt->formattype != FORMAT_VideoInfo)
	{
        return E_INVALIDARG;
    }

    if (NULL == pmt->pbFormat || pmt->cbFormat < sizeof(VIDEOINFOHEADER))
	{
        return E_INVALIDARG;
    }

    VIDEOINFO *pVideoInfo = (VIDEOINFO *)pmt->pbFormat;
    DWORD dwNewSize;
    HRESULT hr = DWordAdd(pmt->cbFormat, sizeof(VIDEOINFOHEADER2) - sizeof(VIDEOINFOHEADER), &dwNewSize);
    if (FAILED(hr))
	{
        return hr;
    }

    PVOID pvNew = CoTaskMemAlloc(dwNewSize);
    if (pvNew == NULL)
	{
        return E_OUTOFMEMORY;
    }
    CopyMemory(pvNew, pmt->pbFormat, FIELD_OFFSET(VIDEOINFOHEADER, bmiHeader));
    ZeroMemory((PBYTE)pvNew + FIELD_OFFSET(VIDEOINFOHEADER, bmiHeader),
               sizeof(VIDEOINFOHEADER2) - sizeof(VIDEOINFOHEADER));
    CopyMemory((PBYTE)pvNew + FIELD_OFFSET(VIDEOINFOHEADER2, bmiHeader),
               pmt->pbFormat + FIELD_OFFSET(VIDEOINFOHEADER, bmiHeader),
               pmt->cbFormat - FIELD_OFFSET(VIDEOINFOHEADER, bmiHeader));

    VIDEOINFOHEADER2 *pVideoInfo2 = (VIDEOINFOHEADER2 *)pvNew;
    pVideoInfo2->dwPictAspectRatioX = (DWORD)pVideoInfo2->bmiHeader.biWidth;
    pVideoInfo2->dwPictAspectRatioY = (DWORD)abs(pVideoInfo2->bmiHeader.biHeight);
    pmt->formattype = FORMAT_VideoInfo2;
    CoTaskMemFree(pmt->pbFormat);
    pmt->pbFormat = (PBYTE)pvNew;
    pmt->cbFormat += sizeof(VIDEOINFOHEADER2) - sizeof(VIDEOINFOHEADER);
    return S_OK;
}


CMyTransform::CMyTransform(IUnknown *pUnk, HRESULT *phr) :
	CCustomFilter(FILTER_NAME, pUnk, __uuidof(CMyTransform))
{
	::ZeroMemory(&m_bmiInput, sizeof(BITMAPINFOHEADER));
	::ZeroMemory(&m_bmiOutput, sizeof(BITMAPINFOHEADER));

	int nCount = _countof(m_pBuffer);
	for (int i = 0; i < nCount; i++)
	{
		m_pBuffer[i] = NULL;
		m_lBufferSize[i] = 0;
	}

	if (phr != NULL)
	{
		*phr = S_OK;
	}
}

CMyTransform::~CMyTransform()
{
	DeleteBuffer();
}


CUnknown * WINAPI CMyTransform::CreateInstance(LPUNKNOWN pUnk, HRESULT *phr)
{
	CMyTransform *pNewFilter = new CMyTransform(pUnk, phr);
	if (pNewFilter == NULL)
	{
		*phr = E_OUTOFMEMORY;
	}
	else
	{
		*phr = S_OK;
	}

	return pNewFilter;
}

HRESULT CMyTransform::CheckInputType(const CMediaType *mtIn)
{
	if (*mtIn->Type() != MEDIATYPE_Video ||
		*mtIn->FormatType() != FORMAT_VideoInfo)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	/*
	//// 2011/10/08 Begin ////
	// Tu^CvRGB32Ŏ󂯎

	if(!IsEqualGUID(*mtIn->Subtype(), MEDIASUBTYPE_RGB32))	// RGB32rbg^CvH
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	VIDEOINFOHEADER *pvi = (VIDEOINFOHEADER *)mtIn->Format();
	if(pvi && pvi->bmiHeader.biBitCount != 32 )						// rbgJEg32rbgł邩H
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	//// 2011/10/08 End ////
	*/

	return S_OK;
}

// o̓s̗D惁fBA^Cv̒
HRESULT CMyTransform::GetMediaType(int iPosition, CMediaType *pMediaType)
{
	if (pMediaType == NULL)
	{
		return E_POINTER;
	}

	if (iPosition < 0)
	{
		return E_INVALIDARG;
	}
	else if (iPosition > 0)
	{
		return VFW_S_NO_MORE_ITEMS;
	}

	// Do̓^Cv ̓fBA^CvƓƂ
	//  f[^tH[}bgϊtB^(encoder,decoderȂ) ͈قȂ郁fBA^CvɂȂ.
	*pMediaType = m_pInput->CurrentMediaType();

	VIDEOINFOHEADER *pVih = NULL;
	if (NULL != pMediaType->pbFormat && pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER))
	{
		pVih = (VIDEOINFOHEADER *)pMediaType->pbFormat;
	}

	if (pVih != NULL)
	{
		// Tu^CvHDYC̏ꍇUYVYɕϊ
		FOURCCMap fccmap(MAKEFOURCC('H', 'D', 'Y', 'C'));
		GUID guidHDYC = (GUID)fccmap;

		if (::IsEqualGUID(pMediaType->subtype, guidHDYC))
		{
			fccmap.SetFOURCC(MAKEFOURCC('U', 'Y', 'V', 'Y'));
			GUID guidUYVY = (GUID)fccmap;

			pMediaType->subtype = guidUYVY;

			pVih->bmiHeader.biCompression = MAKEFOURCC('U', 'Y', 'V', 'Y');
		}

		if (m_eTransCopy == TRANSFORM_COPY_HARDWARE)
		{
			if (pVih->bmiHeader.biCompression == MAKEFOURCC('Y', 'U', 'Y', '2') || // Y0, U0, Y1, V0
				pVih->bmiHeader.biCompression == MAKEFOURCC('U', 'Y', 'V', 'Y') || // U0, Y0, V0, Y1
				pVih->bmiHeader.biCompression == MAKEFOURCC('H', 'D', 'Y', 'C'))
			{
				ConvertVideoInfoToVideoInfo2(pMediaType);

				if (NULL == pMediaType->pbFormat || pMediaType->cbFormat < sizeof(VIDEOINFOHEADER2))
				{
					return VFW_S_NO_MORE_ITEMS;
				}

				VIDEOINFOHEADER2 *pOut = (VIDEOINFOHEADER2 *)pMediaType->pbFormat;

				pOut->dwInterlaceFlags = 
					AMINTERLACE_IsInterlaced |
					AMINTERLACE_FieldPatBothRegular |
					AMINTERLACE_DisplayModeBobOrWeave;
			}
			else
			{
				m_eTransCopy = TRANSFORM_COPY_NONE;
			}
		}

		/*
		//// 2011/09/26 Begin
		// cւ
		LONG x = pVih->bmiHeader.biHeight;
		pVih->bmiHeader.biHeight = pVih->bmiHeader.biWidth;
		pVih->bmiHeader.biWidth = x;

		//// 2011/09/26 End
		*/

	}



	return S_OK;
}

HRESULT CMyTransform::CheckTransform(const CMediaType *mtIn, const CMediaType *mtOut)
{
	/*
	rfI_̓rfIJ[hT[tFXmۂB
	T[tFX̓rfIJ[h̎dlɍ悤ɉf̕ƍACg邽߁A
	vfTCY傫T[tFXmۂ邱ƂB
	͂Əo͂̉fTCYƃTvTCYvȂ̂ŁA
	Pɓo͂̃fBA^CvrƃtH[}bgvȂȂĂ܂B

	YUṼfBA^CvvʂȂꍇArfI_RGB̃fBA^CvB
	RGBtH[}bǵiقځjACgȂ̂ŁARGB͂Ɍ܂Ă܂B
	YUVRGBɕϊtB^rfI_Ƃ̊Ԃɑ}Ă܂B
	ϊ͒PȃRs[RXĝŃOtɕׂĂ܂B
	HDTCYƂꂪŃ_ɕׂĂ킯łȂ̂ɃJNĂ܂B

	ƂāAfBA^Cv̔r͉fTCYƃTvTCY͂傫ΐɂB
	Rs[ɂ̂܂܃Rs[ƃT[tFX̕ƍȂfĂ܂̂ŁA
	T[tFX̕lăRs[Ȃ΂ȂȂB

	T[tFX傫ȂĂĂۂɕ\TCY͕ςȂB
	*/

#ifdef _DEBUG
	{
		BITMAPINFOHEADER *pbmDbg = NULL;
		if (*mtOut->FormatType() == FORMAT_VideoInfo)
		{
			if (NULL == mtOut->pbFormat || mtOut->cbFormat < sizeof(VIDEOINFOHEADER))
			{
				return VFW_E_TYPE_NOT_ACCEPTED;
			}

			VIDEOINFOHEADER *pOut = (VIDEOINFOHEADER *)mtOut->pbFormat;

			pbmDbg = &(pOut->bmiHeader);
		}
		else if (*mtOut->FormatType() == FORMAT_VideoInfo2)
		{
			if (NULL == mtOut->pbFormat || mtOut->cbFormat < sizeof(VIDEOINFOHEADER2))
			{
				return VFW_E_TYPE_NOT_ACCEPTED;
			}

			VIDEOINFOHEADER2 *pOut = (VIDEOINFOHEADER2 *)mtOut->pbFormat;

			pbmDbg = &(pOut->bmiHeader);
		}

		CString csDbg;
		csDbg.Format(L"(majortype=%S) (subtype=%S) (formattype=%S) (%dx%d)\n",
			GuidNames[mtOut->majortype],
			GuidNames[mtOut->subtype],
			GuidNames[mtOut->formattype],
			pbmDbg != NULL ? pbmDbg->biWidth : 0,
			pbmDbg != NULL ? pbmDbg->biHeight : 0);
		TRACE(csDbg);
	}
#endif




	if (m_eTransCopy == TRANSFORM_COPY_HARDWARE)
	{
		if (*mtOut->Type() != MEDIATYPE_Video ||
			*mtOut->FormatType() != FORMAT_VideoInfo2)
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}
	}
	else
	{
		if (*mtOut->Type() != MEDIATYPE_Video ||
			*mtOut->FormatType() != FORMAT_VideoInfo)
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}
	}


	if (!::IsEqualGUID(mtIn->majortype, mtOut->majortype))
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	// Tu^CvHDYCȂUYVYƔr
	FOURCCMap fccmap;
	fccmap.SetFOURCC(MAKEFOURCC('H', 'D', 'Y', 'C'));
	GUID guidHDYC = (GUID)fccmap;

	if (::IsEqualGUID(mtIn->subtype, guidHDYC))
	{
		fccmap.SetFOURCC(MAKEFOURCC('U', 'Y', 'V', 'Y'));
		GUID guidUYVY = (GUID)fccmap;

		if (!::IsEqualGUID(guidUYVY, mtOut->subtype))
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}
	}
	else if (!::IsEqualGUID(mtIn->subtype, mtOut->subtype))
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	if (mtIn->bFixedSizeSamples != mtOut->bFixedSizeSamples)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	if (mtIn->bTemporalCompression != mtOut->bTemporalCompression)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	// TvTCY͂菬ꍇ͎s
	if (mtIn->lSampleSize > mtOut->lSampleSize)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}


/*
	// łɃRgAEgĂ
	// tH[}bg^Cv͑Oq̕@Ń`FbNĂ
	if (!::IsEqualGUID(mtIn->formattype, mtOut->formattype))
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}
*/




	BITMAPINFOHEADER *pbmIn = NULL;
	BITMAPINFOHEADER *pbmOut = NULL;
	if (*mtOut->FormatType() == FORMAT_VideoInfo)
	{
		// VIDEOINFOHEADER̔r
		if (NULL == mtIn->pbFormat || mtIn->cbFormat < sizeof(VIDEOINFOHEADER))
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}

		if (NULL == mtOut->pbFormat || mtOut->cbFormat < sizeof(VIDEOINFOHEADER))
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}

		VIDEOINFOHEADER *pIn = (VIDEOINFOHEADER *)mtIn->pbFormat;
		VIDEOINFOHEADER *pOut = (VIDEOINFOHEADER *)mtOut->pbFormat;

		if (pIn->AvgTimePerFrame != pOut->AvgTimePerFrame)
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}

		if (pIn->dwBitErrorRate != pOut->dwBitErrorRate)
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}

		if (pIn->dwBitRate != pOut->dwBitRate)
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}

		pbmIn = &(pIn->bmiHeader);
		pbmOut = &(pOut->bmiHeader);
	}
	else if (*mtOut->FormatType() == FORMAT_VideoInfo2)
	{
		// VIDEOINFOHEADER2̔r
		if (NULL == mtIn->pbFormat || mtIn->cbFormat < sizeof(VIDEOINFOHEADER))
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}

		if (NULL == mtOut->pbFormat || mtOut->cbFormat < sizeof(VIDEOINFOHEADER2))
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}

		VIDEOINFOHEADER *pIn = (VIDEOINFOHEADER *)mtIn->pbFormat;
		VIDEOINFOHEADER2 *pOut = (VIDEOINFOHEADER2 *)mtOut->pbFormat;

		if (pIn->AvgTimePerFrame != pOut->AvgTimePerFrame)
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}

		if (pIn->dwBitErrorRate != pOut->dwBitErrorRate)
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}

		if (pIn->dwBitRate != pOut->dwBitRate)
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}

		pbmIn = &(pIn->bmiHeader);
		pbmOut = &(pOut->bmiHeader);
	}
	else
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	if (pbmIn == NULL || pbmOut == NULL)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	/*
	//// 2011/09/26 Begin

	// ͂菬ꍇ͎s
	// ÔߐΒlŔr
	if (::abs(pbmIn->biWidth) > ::abs(pbmOut->biHeight))
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	// ͂菬ꍇ͎s
	// ̓{gAbvƃ}CiXɂȂĂ̂ŐΒlŔr
	if (::abs(pbmIn->biHeight) > ::abs(pbmOut->biWidth))
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	///// 2011/09/26 End
	*/



	// ͂菬ꍇ͎s
	// ÔߐΒlŔr
	if (::abs(pbmIn->biWidth) > ::abs(pbmOut->biWidth))
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	// ͂菬ꍇ͎s
	// ̓{gAbvƃ}CiXɂȂĂ̂ŐΒlŔr
	if (::abs(pbmIn->biHeight) > ::abs(pbmOut->biHeight))
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}


	if (pbmIn->biPlanes != pbmOut->biPlanes)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	if (pbmIn->biBitCount != pbmOut->biBitCount)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	if (::IsEqualGUID(mtIn->subtype, guidHDYC))
	{
		DWORD dwUYVY = MAKEFOURCC('U', 'Y', 'V', 'Y');

		if (dwUYVY != pbmOut->biCompression)
		{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}
	}
	else if (pbmIn->biCompression != pbmOut->biCompression)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	// C[WTCY͂菬ꍇ͎s
	if (pbmIn->biSizeImage > pbmOut->biSizeImage)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	if (pbmIn->biXPelsPerMeter != pbmOut->biXPelsPerMeter)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	if (pbmIn->biYPelsPerMeter != pbmOut->biYPelsPerMeter)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	if (pbmIn->biClrUsed != pbmOut->biClrUsed)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	if (pbmIn->biClrImportant != pbmOut->biClrImportant)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}




/*
	// PȃfBA^Cv̔riɋLRŎgpȂj
	if (*mtIn != *mtOut)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}
*/

	// VIDEOINFOHEADER ۑ
	::CopyMemory(&m_bmiOutput, pbmOut, sizeof(BITMAPINFOHEADER));

	return S_OK;
}

HRESULT CMyTransform::CompleteConnect(PIN_DIRECTION direction, IPin *pReceivePin)
{
	// CPU̎擾
	m_CPU.Init();

	// VIDEOINFOHEADER ۑ
    if (NULL == m_pInput ||
		NULL == m_pInput->CurrentMediaType().pbFormat ||
		m_pInput->CurrentMediaType().cbFormat < sizeof(VIDEOINFOHEADER))
	{
		return E_UNEXPECTED;
    }

	VIDEOINFOHEADER *pVIH = (VIDEOINFOHEADER *)m_pInput->CurrentMediaType().pbFormat;
	::CopyMemory(&m_bmiInput, &(pVIH->bmiHeader), sizeof(BITMAPINFOHEADER));

	return S_OK;
}

HRESULT CMyTransform::StartStreaming()
{
	/*
	IPin *pPin = m_pOutput->GetConnected();
	if (pPin == NULL)
	{
		return NOERROR;
	}

	CMediaType mt;
	pPin->ConnectionMediaType(&mt);

	if (IsEqualGUID(mt.formattype, FORMAT_VideoInfo))
	{
		if (NULL == mt.pbFormat || mt.cbFormat < sizeof(VIDEOINFOHEADER))
		{
			return NOERROR;
		}

		VIDEOINFOHEADER *pVIH = (VIDEOINFOHEADER *)mt.pbFormat;
		::CopyMemory(&m_bmiOutput, &(pVIH->bmiHeader), sizeof(BITMAPINFOHEADER));
	}
	else if (IsEqualGUID(mt.formattype, FORMAT_VideoInfo2))
	{
		if (NULL == mt.pbFormat || mt.cbFormat < sizeof(VIDEOINFOHEADER2))
		{
			return NOERROR;
		}

		VIDEOINFOHEADER2 *pVIH = (VIDEOINFOHEADER2 *)mt.pbFormat;
		::CopyMemory(&m_bmiOutput, &(pVIH->bmiHeader), sizeof(BITMAPINFOHEADER));
	}
	*/

	return NOERROR;
}

HRESULT CMyTransform::StopStreaming()
{
	return NOERROR;
}


//AP[^vpeB̐ݒ
HRESULT CMyTransform::DecideBufferSize(IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *ppropInputRequest)
{
	if (m_pInput == NULL ||
		m_pInput->IsConnected() == FALSE)
	{
		return E_FAIL;
	}

	ppropInputRequest->cBuffers = 1;
	ppropInputRequest->cbBuffer = this->m_pInput->CurrentMediaType().GetSampleSize();


	ALLOCATOR_PROPERTIES prop;
	HRESULT hr = pAlloc->SetProperties(ppropInputRequest, &prop);
	if (FAILED(hr))
	{
		return hr;
	}

	if (ppropInputRequest->cBuffers > prop.cBuffers ||
		ppropInputRequest->cbBuffer > prop.cbBuffer)
	{
		return E_FAIL;
	}

	return S_OK;
}


HRESULT CMyTransform::Transform(IMediaSample *pIn, IMediaSample *pOut)
{
	// f[^
	const long lDataLength = pIn->GetActualDataLength();

	// ͂Əo͂̃|C^
	LPBYTE pOrgSrc, pOrgDst;
	pIn->GetPointer((BYTE**)&pOrgSrc);
	pOut->GetPointer((BYTE**)&pOrgDst);

	if (pOrgSrc == NULL || pOrgDst == NULL)
	{
		return S_OK;
	}


	const BOOL bValidCPU = m_CPU.IsMMX() && m_CPU.IsSSE() && m_CPU.IsSSE2() ? TRUE : FALSE;

	// ݂̃t[͓̓s炵킩Ȃ
	const BOOL bOddFrame = m_pInput->IsOddFrame(); // t[łȂ^
	const BOOL bOddField = (m_eTransFieldOrder == TRANSFORM_FIELD_ORDER_ODD) ? TRUE : FALSE; // ɏtB[h

	const int nBitCount = m_bmiInput.biBitCount;
	const int nWidth = m_bmiInput.biWidth;
	const int nHeight = abs(m_bmiInput.biHeight);
	const int nStride = m_bmiOutput.biWidth - m_bmiInput.biWidth;

	const int nWidthSize = (nWidth * nBitCount) / 8;
	const int nStrideSize = ((nStride > 0 ? nStride : 0) * nBitCount) / 8;


	// ㉺
	BOOL bBottomUp = IsBottomUpBitmap(&m_bmiOutput);

	if (__super::m_bTransFlipVertical)
	{
		bBottomUp = bBottomUp ? FALSE : TRUE;
	}

	pOut->SetActualDataLength(lDataLength);

	if (nWidthSize <= 0)
	{
		return S_OK;
	}


	if (!bValidCPU)
	{	// ΉCPU͒PȃRs[Ȃ
		StrideMemoryCopy(pOrgDst, pOrgSrc, lDataLength, nHeight, nWidthSize, nStrideSize, bBottomUp);
	}
	else if ((lDataLength % nWidthSize) != 0)
	{
		// oCgI[_[sŕϊsȂ͕̂ʂ̃Rs[
		SSE2StrideMemoryCopy(pOrgDst, pOrgSrc, lDataLength, nHeight, nWidthSize, nStrideSize, bBottomUp);
	}
	else if (
		m_eTransYCExpand != TRANSFORM_YCEXPAND_NONE &&
		(m_eTransCopy == TRANSFORM_COPY_NONE || m_eTransCopy == TRANSFORM_COPY_HARDWARE))
	{
		// YCLONŒPȃRs[ȂYCExpandCopyg
		// YCL̃Rs[ɂĉZRXg
		switch (__super::m_eTransYCExpand)
		{
		case TRANSFORM_YCEXPAND_UYVY:
			StrideYCExpandUYVYCopy(pOrgDst, pOrgSrc, lDataLength, nHeight, nWidthSize, nStrideSize, bBottomUp);
			break;

		case TRANSFORM_YCEXPAND_YUY2:
			StrideYCExpandYUY2Copy(pOrgDst, pOrgSrc, lDataLength, nHeight, nWidthSize, nStrideSize, bBottomUp);
			break;
		}
	}
	else if (m_eTransYCExpand == TRANSFORM_YCEXPAND_NONE &&
		(m_eTransCopy == TRANSFORM_COPY_NONE || m_eTransCopy == TRANSFORM_COPY_HARDWARE))
	{
		// ftHgݒ
		SSE2StrideMemoryCopy(pOrgDst, pOrgSrc, lDataLength, nHeight, nWidthSize, nStrideSize, bBottomUp);
		//SSE2StrideRotationMemoryCopy(pOrgDst, pOrgSrc, &m_bmiInput, &m_bmiOutput);
	}
	else
	{
		if (nBitCount % 8 == 0)
		{
			switch (m_eTransYCExpand)
			{
			case TRANSFORM_YCEXPAND_UYVY:
				{
					LPBYTE pOrgBff = GetBuffer(0, lDataLength);

					if (pOrgBff != NULL)
					{
						if (m_eTransCopy == TRANSFORM_COPY_LINER_SHARP ||
							m_eTransCopy == TRANSFORM_COPY_BLEND_SHARP)
						{
							TransformCopy(m_eTransCopy, m_eTransFrame, bOddFrame, bOddField, FALSE, pOrgBff, pOrgSrc, nHeight, lDataLength, nWidthSize, 0);
							YCExpandUYVY(pOrgBff, lDataLength);
							VerticalSharpnessCopy(pOrgDst, pOrgBff, lDataLength, nHeight, nWidthSize, nStrideSize, bBottomUp);
						}
						else
						{
							YCExpandUYVYCopy(pOrgBff, pOrgSrc, lDataLength);
							TransformCopy(m_eTransCopy, m_eTransFrame, bOddFrame, bOddField, bBottomUp, pOrgDst, pOrgBff, nHeight, lDataLength, nWidthSize, nStrideSize);
						}
					}
					break;
				}

			case TRANSFORM_YCEXPAND_YUY2:
				{
					LPBYTE pOrgBff = GetBuffer(0, lDataLength);

					if (pOrgBff != NULL)
					{
						if (m_eTransCopy == TRANSFORM_COPY_LINER_SHARP ||
							m_eTransCopy == TRANSFORM_COPY_BLEND_SHARP)
						{
							TransformCopy(m_eTransCopy, m_eTransFrame, bOddFrame, bOddField, FALSE, pOrgBff, pOrgSrc, nHeight, lDataLength, nWidthSize, 0);
							YCExpandYUY2(pOrgBff, lDataLength);
							VerticalSharpnessCopy(pOrgDst, pOrgBff, lDataLength, nHeight, nWidthSize, nStrideSize, bBottomUp);
						}
						else
						{
							YCExpandYUY2Copy(pOrgBff, pOrgSrc, lDataLength);
							TransformCopy(m_eTransCopy, m_eTransFrame, bOddFrame, bOddField, bBottomUp, pOrgDst, pOrgBff, nHeight, lDataLength, nWidthSize, nStrideSize);
						}
					}
					break;
				}

			case TRANSFORM_YCEXPAND_NONE:
			default:
				{
					if (m_eTransCopy == TRANSFORM_COPY_LINER_SHARP ||
						m_eTransCopy == TRANSFORM_COPY_BLEND_SHARP)
					{
						LPBYTE pOrgBff = GetBuffer(0, lDataLength);

						if (pOrgBff != NULL)
						{
							TransformCopy(m_eTransCopy, m_eTransFrame, bOddFrame, bOddField, FALSE, pOrgBff, pOrgSrc, nHeight, lDataLength, nWidthSize, 0);
							VerticalSharpnessCopy(pOrgDst, pOrgBff, lDataLength, nHeight, nWidthSize, nStrideSize, bBottomUp);
						}
					}
					else
					{
						TransformCopy(m_eTransCopy, m_eTransFrame, bOddFrame, bOddField, bBottomUp, pOrgDst, pOrgSrc, nHeight, lDataLength, nWidthSize, nStrideSize);
					}
					
				}
				break;
			}
		}
		else
		{
			// rbgPʂ[ȃoCg͕ʂ̃Rs[
			switch (m_eTransYCExpand)
			{
			case TRANSFORM_YCEXPAND_UYVY:
				StrideYCExpandUYVYCopy(pOrgDst, pOrgSrc, lDataLength, nHeight, nWidthSize, nStrideSize, bBottomUp);
				break;

			case TRANSFORM_YCEXPAND_YUY2:
				StrideYCExpandYUY2Copy(pOrgDst, pOrgSrc, lDataLength, nHeight, nWidthSize, nStrideSize, bBottomUp);
				break;

			case TRANSFORM_YCEXPAND_NONE:
			default:
				SSE2StrideMemoryCopy(pOrgDst, pOrgSrc, lDataLength, nHeight, nWidthSize, nStrideSize, bBottomUp);
				break;
			}
		}
	}

	return S_OK;
}

#pragma warning(disable: 4311)

LPBYTE CMyTransform::GetBuffer(int nIndex, long lBufferSize)
{
	if (nIndex < 0 || nIndex >= _countof(m_pBuffer))
	{
		return NULL;
	}

	// 摜p̃obt@
	if (m_pBuffer[nIndex] == NULL && lBufferSize > 0)
	{
		// obt@ȂΊmۂ
		m_pBuffer[nIndex] = (LPBYTE)_aligned_malloc(lBufferSize, 16); // ACg킹

		// mێs
		if (errno == ENOMEM)
		{
			m_pBuffer[nIndex] = NULL;
			m_lBufferSize[nIndex] = 0;
			return NULL;
		}

		if (m_pBuffer[nIndex] != NULL)
		{
			// ŏ̃obt@̓ǂݍ݂̂߂128Ă
			// 128͐F0
			LPBYTE pBff = m_pBuffer[nIndex];
			for (int i = lBufferSize; i; i--)
			{
				pBff[i] = 128;
			}

			m_lBufferSize[nIndex] = lBufferSize;
		}
		else
		{
			m_lBufferSize[nIndex] = 0;
		}
	}
	else if (m_pBuffer[nIndex] != NULL && m_lBufferSize[nIndex] != lBufferSize && lBufferSize > 0)
	{
		// obt@͂łɂ邪A߂ꂽTCYƈႤȂmۂȂ
		_aligned_free(m_pBuffer[nIndex]);
		m_pBuffer[nIndex] = NULL;

		m_pBuffer[nIndex] = (LPBYTE)_aligned_malloc(lBufferSize, 16);

		// mێs
		if (errno == ENOMEM)
		{
			m_pBuffer[nIndex] = NULL;
			m_lBufferSize[nIndex] = 0;
			return NULL;
		}

		if (m_pBuffer[nIndex] != NULL)
		{
			// ŏ̃obt@̓ǂݍ݂̂߂128Ă
			// 128͐F0
			LPBYTE pBff = m_pBuffer[nIndex];
			for (int i = lBufferSize; i; i--)
			{
				pBff[i] = 128;
			}
		}

		m_lBufferSize[nIndex] = lBufferSize;
	}

	return m_pBuffer[nIndex];
}

void CMyTransform::DeleteBuffer(void)
{
	int nCount = _countof(m_pBuffer);
	for (int i = 0; i < nCount; i++)
	{
		if (m_pBuffer[i] != NULL && m_lBufferSize[i] > 0)
		{
			_aligned_free(m_pBuffer[i]);
			m_pBuffer[i] = NULL;
			m_lBufferSize[i] = 0;
		}
	}
}


BOOL CMyTransform::IsBottomUpBitmap(BITMAPINFOHEADER* pbmOutput)
{
	if (pbmOutput != NULL &&
		pbmOutput->biCompression == BI_RGB &&
		pbmOutput->biHeight < 0)
	{
		return TRUE;
	}

	return FALSE;
}

BOOL CMyTransform::TransformCopy(long _trans_copy, long _trans_frame, BOOL _odd_frame, BOOL _odd_field, BOOL _bottomup, LPBYTE _dst, LPBYTE _src, int _height, int _size, int _width_size, int _stride_size)
{
	BOOL bOddFrame = _odd_frame;
	int nFieldOrder = _odd_field ? 0 : 1;
	BOOL bOddField = _odd_field;
	BOOL bBottomUp = _bottomup;


	LPBYTE pDst = _dst;
	LPBYTE pSrc = _src;

	int cx = _width_size;
	int xend = _size - _width_size;
	int stride = _stride_size;
	int height = _height;


	BOOL bFirst = FALSE;
	if (bOddField)
	{
		bFirst = bOddFrame ? TRUE : FALSE;
	}
	else
	{
		bFirst = bOddFrame ? FALSE : TRUE;
	}


	switch (_trans_copy)
	{
	case TRANSFORM_COPY_SIMPLE: // Vv
		{
			int ry = 0;
			int dp = 0;
			int sp = 0;
			int st = 0;

			if (!bBottomUp)
			{
				if (bFirst)
				{
					// gbvtB[h̃Rs[
					for (int y = 0; y < height; y += 2)
					{
						sp = y * cx;
						st = y * stride;

						SSE2MemoryCopy(pDst + sp + st, pSrc + sp, cx);
						SSE2MemoryCopy(pDst + sp + st + (cx + stride), pSrc + sp, cx);
					}
				}
				else
				{
					// {gtB[h̃Rs[
					for (int y = 1; y < (height - 1); y += 2)
					{
						sp = y * cx;
						st = y * stride;
						SSE2MemoryCopy(pDst + sp + st, pSrc + sp, cx);
						SSE2MemoryCopy(pDst + sp + st + (cx + stride), pSrc + sp, cx);
					}

					// ŏドC̃Rs[
					SSE2MemoryCopy(pDst, pSrc, cx);

					// ŉC̃Rs[
					SSE2MemoryCopy(pDst + xend + ((height - 1) * stride), pSrc + xend, cx);
				}
			}
			else
			{
				if (bFirst)
				{
					// gbvtB[h̃Rs[
					for (int y = 0; y < height; y += 2)
					{
						ry = (height - 2) - y;
						sp = y * cx;
						dp = ry * cx;
						st = ry * stride;
						SSE2MemoryCopy(pDst + dp + st, pSrc + sp, cx);
						SSE2MemoryCopy(pDst + dp + st + (cx + stride), pSrc + sp, cx);
					}
				}
				else
				{
					// {gtB[h̃Rs[
					for (int y = 1; y < (height - 1); y += 2)
					{
						ry = (height - 2) - y;
						sp = y * cx;
						dp = ry * cx;
						st = ry * stride;
						SSE2MemoryCopy(pDst + dp + st, pSrc + sp, cx);
						SSE2MemoryCopy(pDst + dp + st + (cx + stride), pSrc + sp, cx);
					}

					// ŏドC̃Rs[
					SSE2MemoryCopy(pDst + xend + ((height - 1) * stride), pSrc, cx);

					// ŉC̃Rs[
					SSE2MemoryCopy(pDst, pSrc + xend, cx);
				}
			}
		}
		break;

	case TRANSFORM_COPY_LINER: // jA
	case TRANSFORM_COPY_LINER_SHARP: // jA
		{
			int ry = 0;
			int pt = 0;
			int cx2 = cx * 2;

			if (!bBottomUp)
			{
				if (bFirst)
				{
					// gbvtB[h̃Rs[
					for (int y = 0; y < height; y += 2)
					{
						pt = (y * cx);
						SSE2MemoryCopy(pDst + pt + (y * stride), pSrc + pt, cx);
					}

					// (gbvtB[h0 + gbvtB[h1) / 2
					for (int y = 0; y < (height - 2); y += 2)
					{
						pt = (y * cx);
						HalfBlending(pDst + pt + (y * stride) + (cx + stride), pSrc + pt, pSrc + pt + cx2, cx);
					}

					// ŉC̃Rs[
					SSE2MemoryCopy(pDst + xend + ((height - 1) * stride), pSrc + xend, cx);
				}
				else
				{
					// {gtB[h̃Rs[
					for (int y = 1; y < height; y += 2)
					{
						pt = (y * cx);
						SSE2MemoryCopy(pDst + pt + (y * stride), pSrc + pt, cx);
					}

					// ({gtB[h0 + {gtB[h1) / 2
					for (int y = 1; y < (height - 2); y += 2)
					{
						pt = (y * cx);
						HalfBlending(pDst + pt + (y * stride) + (cx + stride), pSrc + pt, pSrc + pt + cx2, cx);
					}

					// ŏドC̃Rs[
					SSE2MemoryCopy(pDst, pSrc, cx);
				}
			}
			else
			{
				if (bFirst)
				{
					// gbvtB[h̃Rs[
					for (int y = 0; y < height; y += 2)
					{
						ry = (height - 1) - y;
						pt = (y * cx);
						SSE2MemoryCopy(pDst + (ry * cx) + (ry * stride), pSrc + pt, cx);
					}

					// (gbvtB[h0 + gbvtB[h1) / 2
					for (int y = 0; y < (height - 2); y += 2)
					{
						ry = (height - 1) - y;
						pt = (y * cx);
						HalfBlending(pDst + (ry * cx) + (ry * stride) - (cx + stride), pSrc + pt, pSrc + pt + cx2, cx);
					}

					// ŉC̃Rs[
					SSE2MemoryCopy(pDst, pSrc + xend, cx);
				}
				else
				{
					// {gtB[h̃Rs[
					for (int y = 1; y < height; y += 2)
					{
						ry = (height - 1) - y;
						pt = (y * cx);
						SSE2MemoryCopy(pDst + (ry * cx) + (ry * stride), pSrc + pt, cx);
					}

					// ({gtB[h0 + {gtB[h1) / 2
					for (int y = 1; y < (height - 2); y += 2)
					{
						ry = (height - 1) - y;
						pt = (y * cx);
						HalfBlending(pDst + (ry * cx) + (ry * stride) - (cx + stride), pSrc + pt, pSrc + pt + cx2, cx);
					}

					// ŏドC̃Rs[
					SSE2MemoryCopy(pDst + xend + ((height - 1) * stride), pSrc, cx);
				}
			}
		}
		break;

	case TRANSFORM_COPY_BLEND:// uh
	case TRANSFORM_COPY_BLEND_SHARP:// uh

		if (_trans_frame != TRANSFORM_FRAME_DOUBLE)
		{
			LPBYTE pPri = GetBuffer(1, _size);

			if (pPri == NULL)
			{	// obt@̊mۂɎs
				return FALSE;
			}

			LPBYTE pSec = GetBuffer(2, _size);

			if (pSec == NULL)
			{	// obt@̊mۂɎs
				return FALSE;
			}

			int ry = 0;
			int pt = 0;
			int cx2 = cx * 2;


			if (bFirst)
			{
				// gbvtB[h̃Rs[
				for (int y = 0; y < height; y += 2)
				{
					pt = (y * cx);
					SSE2MemoryCopy(pPri + pt, pSrc + pt, cx);
				}

				// (gbvtB[h0 + gbvtB[h1) / 2
				for (int y = 0; y < (height - 2); y += 2)
				{
					pt = (y * cx);
					HalfBlending(pPri + pt + cx, pSrc + pt, pSrc + pt + cx2, cx);
				}

				// ŉC̃Rs[
				SSE2MemoryCopy(pPri + xend, pSrc + xend, cx);


				if (!bBottomUp)
				{
					for (int y = 0; y < height; y++)
					{
						pt = (y * cx);
						HalfBlending(pDst + pt + (y * stride), pPri + pt, pSec + pt, cx);
					}
				}
				else
				{
					for (int y = 0; y < height; y++)
					{
						ry = (height - 1) - y;
						pt = (y * cx);
						HalfBlending(pDst + (ry * cx) + (ry * stride), pPri + pt, pSec + pt, cx);
					}
				}


				// {gtB[h̃Rs[
				for (int y = 1; y < height; y += 2)
				{
					pt = (y * cx);
					SSE2MemoryCopy(pSec + pt, pSrc + pt, cx);
				}

				// ({gtB[h0 + {gtB[h1) / 2
				for (int y = 1; y < (height - 2); y += 2)
				{
					pt = (y * cx);
					HalfBlending(pSec + pt + cx, pSrc + pt, pSrc + pt + cx2, cx);
				}

				// ŏドC̃Rs[
				SSE2MemoryCopy(pSec, pSrc, cx);
			}
			else
			{
				// {gtB[h̃Rs[
				for (int y = 1; y < height; y += 2)
				{
					pt = (y * cx);
					SSE2MemoryCopy(pSec + pt, pSrc + pt, cx);
				}

				// ({gtB[h0 + {gtB[h1) / 2
				for (int y = 1; y < (height - 2); y += 2)
				{
					pt = (y * cx);
					HalfBlending(pSec + pt + cx, pSrc + pt, pSrc + pt + cx2, cx);
				}

				// ŏドC̃Rs[
				SSE2MemoryCopy(pSec, pSrc, cx);


				if (!bBottomUp)
				{
					for (int y = 0; y < height; y++)
					{
						pt = (y * cx);
						HalfBlending(pDst + pt + (y * stride), pPri + pt, pSec + pt, cx);
					}
				}
				else
				{
					for (int y = 0; y < height; y++)
					{
						ry = (height - 1) - y;
						pt = (y * cx);
						HalfBlending(pDst + (ry * cx) + (ry * stride), pPri + pt, pSec + pt, cx);
					}
				}

				// gbvtB[h̃Rs[
				for (int y = 0; y < height; y += 2)
				{
					pt = (y * cx);
					SSE2MemoryCopy(pPri + pt, pSrc + pt, cx);
				}

				// (gbvtB[h0 + gbvtB[h1) / 2
				for (int y = 0; y < (height - 2); y += 2)
				{
					pt = (y * cx);
					HalfBlending(pPri + pt + cx, pSrc + pt, pSrc + pt + cx2, cx);
				}

				// ŉC̃Rs[
				SSE2MemoryCopy(pPri + xend, pSrc + xend, cx);
			}
		}
		else // _trans_frame == TRANSFORM_FRAME_DOUBLE
		{
			LPBYTE pPri = GetBuffer(1, _size);

			if (pPri == NULL)
			{	// obt@̊mۂɎs
				return FALSE;
			}

			LPBYTE pSec = GetBuffer(2, _size);

			if (pSec == NULL)
			{	// obt@̊mۂɎs
				return FALSE;
			}

			int ry = 0;
			int pt = 0;
			int cx2 = cx * 2;


			if (bFirst)
			{
				// gbvtB[h̃Rs[
				for (int y = 0; y < height; y += 2)
				{
					pt = (y * cx);
					SSE2MemoryCopy(pPri + pt, pSrc + pt, cx);
				}

				// (gbvtB[h0 + gbvtB[h1) / 2
				for (int y = 0; y < (height - 2); y += 2)
				{
					pt = (y * cx);
					HalfBlending(pPri + pt + cx, pSrc + pt, pSrc + pt + cx2, cx);
				}

				// ŉC̃Rs[
				SSE2MemoryCopy(pPri + xend, pSrc + xend, cx);
			}
			else
			{
				// {gtB[h̃Rs[
				for (int y = 1; y < height; y += 2)
				{
					pt = (y * cx);
					SSE2MemoryCopy(pSec + pt, pSrc + pt, cx);
				}

				// ({gtB[h0 + {gtB[h1) / 2
				for (int y = 1; y < (height - 2); y += 2)
				{
					pt = (y * cx);
					HalfBlending(pSec + pt + cx, pSrc + pt, pSrc + pt + cx2, cx);
				}

				// ŏドC̃Rs[
				SSE2MemoryCopy(pSec, pSrc, cx);
			}

			if (!bBottomUp)
			{
				for (int y = 0; y < height; y++)
				{
					pt = (y * cx);
					HalfBlending(pDst + pt + (y * stride), pPri + pt, pSec + pt, cx);
				}
			}
			else
			{
				for (int y = 0; y < height; y++)
				{
					ry = (height - 1) - y;
					pt = (y * cx);
					HalfBlending(pDst + (ry * cx) + (ry * stride), pPri + pt, pSec + pt, cx);
				}
			}
		}
		break;

	case TRANSFORM_COPY_NONE:
	default:
		{
			SSE2StrideMemoryCopy(pDst, pSrc, _size, height, cx, stride, bBottomUp);
		}
		break;
	}



	return TRUE;
}
