#pragma once

#include "CustomFilter.h"
#include "GraphicUtl.h"

class __declspec(uuid("{7574EC5F-2B11-4e38-AC85-38F8C0D29D09}")) CMyTransform;

// gXtH[tB^
class CMyTransform : public CCustomFilter {
public:
	CMyTransform(LPUNKNOWN pUnk,HRESULT *phr);
	~CMyTransform();
    static CUnknown * WINAPI	CreateInstance(LPUNKNOWN pUnk, HRESULT *phr);
	HRESULT CheckInputType(const CMediaType *mtIn);
	HRESULT GetMediaType(int iPosition, CMediaType *pMediaType);
	HRESULT CheckTransform(const CMediaType *mtIn, const CMediaType *mtOut);
	HRESULT DecideBufferSize(IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *ppropInputRequest);
	HRESULT Transform(IMediaSample *pIn, IMediaSample *pOut);
	HRESULT CompleteConnect(PIN_DIRECTION direction, IPin *pReceivePin);
    HRESULT StartStreaming();
    HRESULT StopStreaming();

protected:
	BOOL IsBottomUpBitmap(BITMAPINFOHEADER* pbmOutput);
	BOOL TransformCopy(long _trans_copy, long _trans_frame, BOOL _odd_frame, BOOL _odd_field, BOOL _bottomup, LPBYTE _dst, LPBYTE _src, int _height, int _size, int _width_size, int _stride_size);

private:
	BITMAPINFOHEADER	m_bmiInput;
	BITMAPINFOHEADER	m_bmiOutput;

	// 摜pobt@
	LPBYTE GetBuffer(int nIndex, long lBufferSize);	// obt@̊m
	void DeleteBuffer(void);			// obt@J
	LPBYTE m_pBuffer[3];					// obt@
	long m_lBufferSize[3];					// obt@TCY

	// CPU
	CCPUInfo m_CPU;
};
