// ProfileAudioDlg.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "ProfileAudioDlg.h"


// CProfileAudioDlg _CAO

IMPLEMENT_DYNAMIC(CProfileAudioDlg, CDialog)

CProfileAudioDlg::CProfileAudioDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProfileAudioDlg::IDD, pParent)
{
	m_pEditBkBrush = new CBrush(RGB(255, 200, 200));
	m_nLastFilter = INT_MAX;
	m_nLastFormat = INT_MAX;
}

CProfileAudioDlg::~CProfileAudioDlg()
{
}

void CProfileAudioDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_FILTER, m_xcCmbFilter);
	DDX_Control(pDX, IDC_LIST_PIN, m_xcListPin);
	DDX_Control(pDX, IDC_CMB_FORMAT, m_xcCmbFormat);
	DDX_Control(pDX, IDC_LIST_FORMAT, m_xcListFormat);
	DDX_Control(pDX, IDC_SCROLL_CH, m_xcScrollCh);
	DDX_Control(pDX, IDC_SCROLL_BPS, m_xcScrollBps);
	DDX_Control(pDX, IDC_SCROLL_HZ, m_xcScrollHz);
	DDX_Control(pDX, IDC_CMB_CH, m_xcCmbCh);
	DDX_Control(pDX, IDC_CMB_BPS, m_xcCmbBps);
	DDX_Control(pDX, IDC_CMB_HZ, m_xcCmbHz);
	DDX_Control(pDX, IDC_CHECK_BUFFER, m_xcCheckBuffer);
	DDX_Control(pDX, IDC_EDIT_BUFFER, m_xcEditBuffer);
	DDX_Control(pDX, IDC_SPIN_BUFFER, m_xcSpinBuffer);
}


BEGIN_MESSAGE_MAP(CProfileAudioDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_CMB_FILTER, &CProfileAudioDlg::OnCbnSelchangeCmbFilter)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_PIN, &CProfileAudioDlg::OnLvnGetdispinfoListPin)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST_PIN, &CProfileAudioDlg::OnNMCustomdrawListPin)
	ON_CBN_SELCHANGE(IDC_CMB_FORMAT, &CProfileAudioDlg::OnCbnSelchangeCmbFormat)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_FORMAT, &CProfileAudioDlg::OnLvnGetdispinfoListFormat)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST_FORMAT, &CProfileAudioDlg::OnNMCustomdrawListFormat)
	ON_WM_HSCROLL()
	ON_CBN_EDITCHANGE(IDC_CMB_CH, &CProfileAudioDlg::OnCbnEditchangeCmbCh)
	ON_CBN_EDITCHANGE(IDC_CMB_BPS, &CProfileAudioDlg::OnCbnEditchangeCmbBps)
	ON_CBN_EDITCHANGE(IDC_CMB_HZ, &CProfileAudioDlg::OnCbnEditchangeCmbHz)
	ON_CBN_SELCHANGE(IDC_CMB_CH, &CProfileAudioDlg::OnCbnSelchangeCmbCh)
	ON_CBN_SELCHANGE(IDC_CMB_BPS, &CProfileAudioDlg::OnCbnSelchangeCmbBps)
	ON_CBN_SELCHANGE(IDC_CMB_HZ, &CProfileAudioDlg::OnCbnSelchangeCmbHz)
	ON_WM_CTLCOLOR()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECK_BUFFER, &CProfileAudioDlg::OnBnClickedCheckBuffer)
END_MESSAGE_MAP()


// CProfileAudioDlg bZ[W nh

BOOL CProfileAudioDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// s
	m_xcListPin.SetExtendedStyle(m_xcListPin.GetExtendedStyle()|
		LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

	m_xcListPin.InsertColumn(0, L"", LVCFMT_LEFT, 50);
	m_xcListPin.InsertColumn(1, L"s", LVCFMT_LEFT, 100);
	m_xcListPin.InsertColumn(2, L"sJeS", LVCFMT_LEFT, 100);
	m_xcListPin.InsertColumn(3, L"fBA^Cv", LVCFMT_LEFT, 95);

	m_xcListPin.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListPin.EnableWindow(FALSE);


	// tH[}bg
	m_xcListFormat.SetExtendedStyle(m_xcListFormat.GetExtendedStyle()|
		LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

	m_xcListFormat.InsertColumn(0, L"tH[}bg", LVCFMT_LEFT, 170);
	m_xcListFormat.InsertColumn(1, L"l", LVCFMT_LEFT, 140);

	m_xcListFormat.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListFormat.EnableWindow(FALSE);

	// obt@TCY
	m_xcCheckBuffer.SetCheck(BST_UNCHECKED);
	m_xcSpinBuffer.SetRange32(0, 1000);
	m_xcSpinBuffer.SetPos32(50);

	m_xcCheckBuffer.EnableWindow(FALSE);
	m_xcEditBuffer.EnableWindow(FALSE);
	m_xcSpinBuffer.EnableWindow(FALSE);

	// XN[o[
	m_xcScrollCh.EnableWindow(FALSE);
	m_xcScrollBps.EnableWindow(FALSE);
	m_xcScrollHz.EnableWindow(FALSE);

	// R{{bNX̃GfBbg{bNXEɂ
	CEdit *pEdit = NULL;
	pEdit = (CEdit*)m_xcCmbCh.GetWindow(GW_CHILD);
	if (pEdit != NULL)
	{
		pEdit->ModifyStyle(ES_LEFT, ES_RIGHT, SWP_FRAMECHANGED);
	}

	pEdit = (CEdit*)m_xcCmbBps.GetWindow(GW_CHILD);
	if (pEdit != NULL)
	{
		pEdit->ModifyStyle(ES_LEFT, ES_RIGHT, SWP_FRAMECHANGED);
	}

	pEdit = (CEdit*)m_xcCmbHz.GetWindow(GW_CHILD);
	if (pEdit != NULL)
	{
		pEdit->ModifyStyle(ES_LEFT, ES_RIGHT, SWP_FRAMECHANGED);
	}

	m_xcCmbCh.EnableWindow(FALSE);
	m_xcCmbBps.EnableWindow(FALSE);
	m_xcCmbHz.EnableWindow(FALSE);


	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CProfileAudioDlg::InitControl(void)
{
	if (::IsWindow(m_xcCmbFilter.GetSafeHwnd()))
	{
		m_xcCmbFilter.AddString(L"I[fBIo͂Ȃ");
		std::vector<CDirectShowFilterID>::iterator it;
		for (it = m_vecID.begin(); it != m_vecID.end(); ++it)
		{
			m_xcCmbFilter.AddString(it->wsFriendlyName.c_str());
		}

		m_xcCmbFilter.SetCurSel(0);
	}
}

BOOL CProfileAudioDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CProfileAudioDlg::SetProfile(const CAudioCaptureFilter &profile)
{
	int nSel = 0; // R{{bNXԍ
	int nFilter = 0; // tB^ԍ
	std::vector<CDirectShowFilterID>::iterator it;
	for (it = m_vecID.begin(); it != m_vecID.end(); ++it)
	{
		if (profile.wsFriendlyName == it->wsFriendlyName &&
			profile.wsDevicePath == it->wsDevicePath)
		{
			nSel = nFilter + 1;
			break;
		}
		nFilter++;
	}

	m_xcCmbFilter.SetCurSel(nSel);
	OnCbnSelchangeCmbFilter();

	if (nSel > 0)
	{
		// obt@TCY
		if (profile.nBufferSize > 1000)
		{
			m_xcSpinBuffer.SetPos32(1000);
		}
		else if (profile.nBufferSize < 0)
		{
			m_xcSpinBuffer.SetPos32(0);
		}
		else
		{
			m_xcSpinBuffer.SetPos32(profile.nBufferSize);
		}

		if (profile.bBufferSize)
		{
			m_xcCheckBuffer.SetCheck(BST_CHECKED);
			m_xcEditBuffer.EnableWindow(TRUE);
			m_xcSpinBuffer.EnableWindow(TRUE);
		}
		else
		{
			m_xcCheckBuffer.SetCheck(BST_UNCHECKED);
		}

		// tH[}bgԍ͈͂ɂ邩
		int nFormatCount = (int)m_Info.vecFormat.size();
		if (profile.Format.nIndex < nFormatCount && profile.Format.nIndex >= 0)
		{
			m_xcCmbFormat.SetCurSel(profile.Format.nIndex);
			OnCbnSelchangeCmbFormat();

			CString csTmp;
			csTmp.Format(L"%d", profile.Format.nChannels);
			m_xcCmbCh.SetWindowText(csTmp);
			OnCbnEditchangeCmbCh();

			csTmp.Format(L"%d", profile.Format.wBitsPerSample);
			m_xcCmbBps.SetWindowText(csTmp);
			OnCbnEditchangeCmbBps();

			csTmp.Format(L"%d", profile.Format.nSamplesPerSec);
			m_xcCmbHz.SetWindowText(csTmp);
			OnCbnEditchangeCmbHz();
		}
	}
}

void CProfileAudioDlg::GetProfile(CAudioCaptureFilter &profile)
{
	int nFilter = m_xcCmbFilter.GetCurSel(); // tB^ԍ
	int nFormat = m_xcCmbFormat.GetCurSel();	// tH[}bgԍ

	nFilter--;

	if (nFilter < 0)
	{
		profile.wsFriendlyName = L"";
		profile.wsDevicePath = L"";
		profile.wsDescription = L"";
	}
	else
	{
		profile.wsFriendlyName = m_vecID.at(nFilter).wsFriendlyName;
		profile.wsDevicePath = m_vecID.at(nFilter).wsDevicePath;
		profile.wsDescription = m_vecID.at(nFilter).wsDescription;

		profile.bBufferSize = m_xcCheckBuffer.GetCheck() == BST_CHECKED ? TRUE : FALSE;
		profile.nBufferSize = m_xcSpinBuffer.GetPos32();

		if (profile.nBufferSize > 1000)
		{
			profile.nBufferSize = 1000;
		}
		else if (profile.nBufferSize < 0)
		{
			profile.nBufferSize = 0;
		}

		if (m_Info.vecFormat.size() <= 0)
		{
			profile.Format.nIndex = -1;
		}
		else
		{
			profile.Format.nIndex = nFormat;

			CString csTmp;
			m_xcCmbCh.GetWindowText(csTmp);
			profile.Format.nChannels = _wtoi(csTmp);

			m_xcCmbBps.GetWindowText(csTmp);
			profile.Format.wBitsPerSample = _wtoi(csTmp);

			m_xcCmbHz.GetWindowText(csTmp);
			profile.Format.nSamplesPerSec = _wtoi(csTmp);
		}
	}
}

void CProfileAudioDlg::OnCbnSelchangeCmbFilter()
{
	int nFilter = m_xcCmbFilter.GetCurSel();

	// OIꂽڂƓȂ牽Ȃ
	if (m_nLastFilter == nFilter)
	{
		return;
	}
	m_nLastFilter = nFilter;
	m_nLastFormat = INT_MAX;

	m_bValidCh = TRUE;
	m_bValidBps = TRUE;
	m_bValidHz = TRUE;

	if (nFilter == CB_ERR || (nFilter - 1) < 0)
	{
		// tH[}bgR{{bNXNA
		m_xcCmbFormat.ResetContent();
		m_xcCmbFormat.EnableWindow(FALSE);

		// sNA
		m_xcListPin.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
		m_Info.vecPin.clear();
		m_xcListPin.EnableWindow(FALSE);
		m_xcListPin.RedrawWindow();

		// obt@TCYݒNA
		m_xcCheckBuffer.SetCheck(BST_UNCHECKED);
		m_xcSpinBuffer.SetPos32(50);

		m_xcCheckBuffer.EnableWindow(FALSE);
		m_xcEditBuffer.EnableWindow(FALSE);
		m_xcSpinBuffer.EnableWindow(FALSE);

		OnCbnSelchangeCmbFormat();
		return;
	}

	nFilter--;

	// tB^[̎擾
	CCaptureFilterInfo dev;
	dev.Init();

	m_Info.vecPin.clear();
	m_Info.vecFormat.clear();
	dev.GetAudioCaptureFilterInfo(m_vecID.at(nFilter), m_Info);

	dev.UnInit();


	// sXg̍XV
	m_xcListPin.SetItemCountEx((int)m_Info.vecPin.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListPin.EnableWindow(TRUE);
	m_xcListPin.RedrawWindow();

	// obt@TCYݒ̏
	m_xcCheckBuffer.SetCheck(BST_UNCHECKED);
	m_xcSpinBuffer.SetPos32(50);

	m_xcCheckBuffer.EnableWindow(TRUE);
	m_xcEditBuffer.EnableWindow(FALSE);
	m_xcSpinBuffer.EnableWindow(FALSE);

	// tH[}bgIR{{bNX
	if (::IsWindow(m_xcCmbFormat.GetSafeHwnd()))
	{
		m_xcCmbFormat.ResetContent();

		if (m_Info.vecFormat.size() <= 0)
		{
			m_xcCmbFormat.AddString(L"tB^tH[}bg擾ł܂ł");
			m_xcCmbFormat.SetCurSel(0);
			m_xcCmbFormat.EnableWindow(FALSE);
		}
		else
		{
			int nNumber = 0;
			std::vector<CAudioCaptureFormatInfo>::iterator it;
			for (it = m_Info.vecFormat.begin(); it != m_Info.vecFormat.end(); ++it)
			{
				CString csTmp;
				csTmp.Format(L"%02d: %s %dch %dbit %dHz",
					nNumber,
					it->wsFourCC.c_str(),
					it->wav.nChannels,
					it->wav.wBitsPerSample,
					it->wav.nSamplesPerSec);
				m_xcCmbFormat.AddString(csTmp);

				nNumber++;
			}

			m_xcCmbFormat.SetCurSel(0);
			m_xcCmbFormat.EnableWindow(TRUE);
		}

		OnCbnSelchangeCmbFormat();
	}
}

void CProfileAudioDlg::OnLvnGetdispinfoListPin(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (pDispInfo == NULL)
	{
		return;
	}

	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 0:
			{
				csLine = m_Info.vecPin.at(i).bInput ? L"IN" : L"OUT";
				break;
			}
		case 1:
			{
				csLine = m_Info.vecPin.at(i).wsName.c_str();
				break;
			}
		case 2:
			{
				csLine = m_Info.vecPin.at(i).wsCategory.c_str();
				break;
			}
		case 3:
			{
				csLine = m_Info.vecPin.at(i).wsMediaType.c_str();
				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult)
	{
		*pResult = 0;
	}
}

void CProfileAudioDlg::OnNMCustomdrawListPin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	if (pNMCD == NULL)
	{
		return;
	}

	LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW)pNMCD;

	if (lplvcd == NULL)
	{
		return;
	}


	// `TCNJnbZ[WLb`
	if (lplvcd->nmcd.dwDrawStage == CDDS_PREPAINT)
	{
		// JX^h[sƂʒm
		if (pResult != NULL)
		{
			*pResult =  CDRF_NOTIFYITEMDRAW;
		}
		return;
	}

	// ACe`悷郁bZ[WLb`
	if (lplvcd->nmcd.dwDrawStage == CDDS_ITEMPREPAINT)
	{
		// s̕Fɂ
		lplvcd->clrText = RGB(0, 0, 0);

		int i = (int)lplvcd->nmcd.dwItemSpec;
		if (m_Info.vecPin.at(i).wsCategory == L"CAPTURE" && m_Info.vecPin.at(i).wsMediaType == L"Video")
		{
			lplvcd->clrTextBk = RGB(200, 200, 255);
		}
		else if (m_Info.vecPin.at(i).wsCategory == L"PREVIEW" && m_Info.vecPin.at(i).wsMediaType == L"Video")
		{
			lplvcd->clrTextBk = RGB(255, 255, 200);
		}
		else if (m_Info.vecPin.at(i).wsCategory == L"CAPTURE" && m_Info.vecPin.at(i).wsMediaType == L"Audio")
		{
			lplvcd->clrTextBk = RGB(255, 200, 200);
		}
		else
		{
			lplvcd->clrTextBk = RGB(255, 255, 255);
		}
	}

	if (pResult != NULL)
	{
		*pResult = 0;
	}
}

BOOL CProfileAudioDlg::SetCmbChValue(CComboBox *pComboBox, int nNow, int nMin, int nMax, int nGra)
{
	if (pComboBox == NULL)
	{
		return FALSE;
	}

	if (nGra <= 0 || (nMin == nMax))
	{
		CString csTmp;
		csTmp.Format(L"%d", nNow);

		pComboBox->ResetContent();
		pComboBox->AddString(csTmp);
		pComboBox->SetWindowText(csTmp);
	}
	else
	{
		std::vector<int> vec;
		std::vector<int>::iterator it;
		int var[3];

		vec.push_back(1);
		vec.push_back(2);
		vec.push_back(4);
		vec.push_back(6);
		vec.push_back(8);
		vec.push_back(10);
		vec.push_back(12);
		vec.push_back(16);

		// ݂ƍŏőlǉ
		var[0] = nNow;
		var[1] = nMin;
		var[2] = nMax;

		for (int i = 0; i < 3; i++)
		{
			it = std::find(vec.begin(), vec.end(), var[i]);
			if (it == vec.end())
			{
				vec.push_back(var[i]);
			}
		}

		std::sort(vec.begin(), vec.end());

		// R{{bNXɒǉ
		pComboBox->ResetContent();
		for (it = vec.begin(); it != vec.end(); ++it)
		{
			if (*it >= nMin && *it <= nMax && (*it % nGra) == 0)
			{
				CString csTmp;
				csTmp.Format(L"%d", *it);

				pComboBox->AddString(csTmp);
			}
		}
	}

	return TRUE;
}

BOOL CProfileAudioDlg::SetCmbBpsValue(CComboBox *pComboBox, int nNow, int nMin, int nMax, int nGra)
{
	if (pComboBox == NULL)
	{
		return FALSE;
	}

	if (nGra <= 0 || (nMin == nMax))
	{
		CString csTmp;
		csTmp.Format(L"%d", nNow);

		pComboBox->ResetContent();
		pComboBox->AddString(csTmp);
		pComboBox->SetWindowText(csTmp);
	}
	else
	{
		std::vector<int> vec;
		std::vector<int>::iterator it;
		int var[3];

		vec.push_back(8);
		vec.push_back(16);
		vec.push_back(24);
		vec.push_back(32);

		// ݂ƍŏőlǉ
		var[0] = nNow;
		var[1] = nMin;
		var[2] = nMax;

		for (int i = 0; i < 3; i++)
		{
			it = std::find(vec.begin(), vec.end(), var[i]);
			if (it == vec.end())
			{
				vec.push_back(var[i]);
			}
		}

		std::sort(vec.begin(), vec.end());

		// R{{bNXɒǉ
		pComboBox->ResetContent();
		for (it = vec.begin(); it != vec.end(); ++it)
		{
			if (*it >= nMin && *it <= nMax && (*it % nGra) == 0)
			{
				CString csTmp;
				csTmp.Format(L"%d", *it);

				pComboBox->AddString(csTmp);
			}
		}
	}

	return TRUE;
}

BOOL CProfileAudioDlg::SetCmbHzValue(CComboBox *pComboBox, int nNow, int nMin, int nMax, int nGra)
{
	if (pComboBox == NULL)
	{
		return FALSE;
	}

	if (nGra <= 0 || (nMin == nMax))
	{
		CString csTmp;
		csTmp.Format(L"%d", nNow);

		pComboBox->ResetContent();
		pComboBox->AddString(csTmp);
		pComboBox->SetWindowText(csTmp);
	}
	else
	{
		std::vector<int> vec;
		std::vector<int>::iterator it;
		int var[3];

		vec.push_back(8000);
		vec.push_back(11025);
		vec.push_back(22050);
		vec.push_back(32000);
		vec.push_back(44100);
		vec.push_back(48000);
		vec.push_back(96000);

		// ݂ƍŏőlǉ
		var[0] = nNow;
		var[1] = nMin;
		var[2] = nMax;

		for (int i = 0; i < 3; i++)
		{
			it = std::find(vec.begin(), vec.end(), var[i]);
			if (it == vec.end())
			{
				vec.push_back(var[i]);
			}
		}

		std::sort(vec.begin(), vec.end());

		// R{{bNXɒǉ
		pComboBox->ResetContent();
		for (it = vec.begin(); it != vec.end(); ++it)
		{
			if (*it >= nMin && *it <= nMax && (*it % nGra) == 0)
			{
				CString csTmp;
				csTmp.Format(L"%d", *it);

				pComboBox->AddString(csTmp);
			}
		}
	}

	return TRUE;
}

BOOL CProfileAudioDlg::SetScrollValue(CScrollBar *pScrollBar, CComboBox *pComboBox, int nPos, int nMin, int nMax, int nGra)
{
	if (pScrollBar == NULL)
	{
		return FALSE;
	}

	BOOL bResult = TRUE;

	// őŏltɂȂĂꍇ̓Xbv
	if (nMin > nMax)
	{
		int nTmp = nMin;
		nMin = nMax;
		nMax = nMin;
	}

	CString csTmp;
	csTmp.Format(L"%d", nPos);
	pComboBox->SetWindowText(csTmp);

	if (nMin == nMax || nPos > nMax || nPos < nMin || nGra <= 0 || nGra > (nMax - nMin))
	{	
		// ݒlsiXN[o[KvȂjȂύXsɂ
		pScrollBar->EnableWindow(FALSE);
		pComboBox->EnableWindow(TRUE);
	}
	else
	{
		SCROLLINFO info;
		info.cbSize		= sizeof(SCROLLINFO); 
		info.fMask		= SIF_PAGE|SIF_POS|SIF_RANGE;
		info.nMin		= 0;
		info.nMax		= (nMax - nMin) / nGra;
		info.nPage		= 1;
		info.nPos		= (nPos - nMin) / nGra;
		bResult = pScrollBar->SetScrollInfo(&info);

		pScrollBar->EnableWindow(TRUE);
		pScrollBar->RedrawWindow();
		pComboBox->EnableWindow(TRUE);
		pComboBox->RedrawWindow();
	}

	return bResult;
}

void CProfileAudioDlg::OnCbnSelchangeCmbFormat()
{
	int nFilter = m_xcCmbFilter.GetCurSel();	// tB^ԍ
	int nFormat = m_xcCmbFormat.GetCurSel();	// tH[}bgԍ
	int nSel = nFilter;
	nFilter--; // 0Ԃ͑IfoCXȂȂ̂-1

	// OIꂽڂƓȂ牽Ȃ
	if (m_nLastFormat == nFormat)
	{
		return;
	}
	m_nLastFormat = nFormat;

	m_bValidCh = TRUE;
	m_bValidBps = TRUE;
	m_bValidHz = TRUE;

	if (nSel == CB_ERR || nFormat == CB_ERR || nFilter < 0 || m_Info.vecFormat.size() <= 0)
	{
		// ItB^Ȃ̂Ŋ֘AڂύXsɂ
		m_xcListFormat.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
		m_xcListFormat.EnableWindow(FALSE);
		m_xcListFormat.RedrawWindow();

		m_xcScrollCh.EnableWindow(FALSE);
		m_xcScrollBps.EnableWindow(FALSE);
		m_xcScrollHz.EnableWindow(FALSE);

		m_xcCmbCh.ResetContent();
		m_xcCmbCh.EnableWindow(FALSE);
		m_xcCmbCh.RedrawWindow();
		m_xcCmbBps.ResetContent();
		m_xcCmbBps.EnableWindow(FALSE);
		m_xcCmbBps.RedrawWindow();
		m_xcCmbHz.ResetContent();
		m_xcCmbHz.EnableWindow(FALSE);
		m_xcCmbHz.RedrawWindow();
		return;
	}

	// IꂽtH[}bgo[ϐɕۑ
	m_Format = m_Info.vecFormat.at(nFormat);

	m_xcListFormat.SetItemCountEx(10, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListFormat.EnableWindow(TRUE);
	m_xcListFormat.RedrawWindow();

	// `l
	SetCmbChValue(
		&m_xcCmbCh,
		m_Format.wav.nChannels,
		m_Format.ssc.MinimumChannels,
		m_Format.ssc.MaximumChannels,
		m_Format.ssc.ChannelsGranularity);

	SetScrollValue(
		&m_xcScrollCh,
		&m_xcCmbCh,
		m_Format.wav.nChannels,
		m_Format.ssc.MinimumChannels,
		m_Format.ssc.MaximumChannels,
		m_Format.ssc.ChannelsGranularity);

	// BPS
	SetCmbBpsValue(
		&m_xcCmbBps,
		m_Format.wav.wBitsPerSample,
		m_Format.ssc.MinimumBitsPerSample,
		m_Format.ssc.MaximumBitsPerSample,
		m_Format.ssc.BitsPerSampleGranularity);

	SetScrollValue(
		&m_xcScrollBps,
		&m_xcCmbBps,
		m_Format.wav.wBitsPerSample,
		m_Format.ssc.MinimumBitsPerSample,
		m_Format.ssc.MaximumBitsPerSample,
		m_Format.ssc.BitsPerSampleGranularity);

	// g
	SetCmbHzValue(
		&m_xcCmbHz,
		m_Format.wav.nSamplesPerSec,
		m_Format.ssc.MinimumSampleFrequency,
		m_Format.ssc.MaximumSampleFrequency,
		m_Format.ssc.SampleFrequencyGranularity);

	SetScrollValue(
		&m_xcScrollHz,
		&m_xcCmbHz,
		m_Format.wav.nSamplesPerSec,
		m_Format.ssc.MinimumSampleFrequency,
		m_Format.ssc.MaximumSampleFrequency,
		m_Format.ssc.SampleFrequencyGranularity);

	// tH[}bg^O̊mF
	// tH[}bg WAVE_FORMAT_PCM łȂꍇ nBlockAlign vZŋ߂邱ƂłȂ
	if (m_Format.wav.wFormatTag != WAVE_FORMAT_PCM)
	{
		// ݒsɂ
		m_xcScrollCh.EnableWindow(FALSE);
		m_xcScrollBps.EnableWindow(FALSE);
		m_xcScrollHz.EnableWindow(FALSE);

		m_xcCmbCh.EnableWindow(FALSE);
		m_xcCmbCh.RedrawWindow();
		m_xcCmbBps.EnableWindow(FALSE);
		m_xcCmbBps.RedrawWindow();
		m_xcCmbHz.EnableWindow(FALSE);
		m_xcCmbHz.RedrawWindow();
	}
}

void CProfileAudioDlg::OnLvnGetdispinfoListFormat(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (pDispInfo == NULL)
	{
		return;
	}

	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 0:
			{
				switch(i)
				{
				case 0:
					{
						csLine = L"Tu^Cv";
						break;
					}
				case 1:
					{
						csLine = L"ŏ`l";
						break;
					}
				case 2:
					{
						csLine = L"ő`l";
						break;
					}
				case 3:
					{
						csLine = L"`lוx";
						break;
					}
				case 4:
					{
						csLine = L"Tv̍ŏrbg";
						break;
					}
				case 5:
					{
						csLine = L"Tv̍őrbg";
						break;
					}
				case 6:
					{
						csLine = L"rbgוx";
						break;
					}
				case 7:
					{
						csLine = L"ŏTvg";
						break;
					}
				case 8:
					{
						csLine = L"őTvg";
						break;
					}
				case 9:
					{
						csLine = L"gוx";
						break;
					}
				}
				break;
			}
		case 1:
			{
				switch(i)
				{
				case 0: //Tu^Cv
					{
						csLine.Format(L"%s", m_Format.wsFourCC.c_str());
						break;
					}
				case 1: // ŏ`l
					{
						csLine.Format(L"%dch", m_Format.ssc.MinimumChannels);
						break;
					}
				case 2: // ő`l
					{
						csLine.Format(L"%dch", m_Format.ssc.MaximumChannels);
						break;
					}
				case 3: // `lוx
					{
						csLine.Format(L"%d", m_Format.ssc.ChannelsGranularity);
						break;
					}
				case 4: // Tv̍ŏrbg
					{
						csLine.Format(L"%dbit", m_Format.ssc.MinimumBitsPerSample);
						break;
					}
				case 5: // Tv̍őrbg
					{
						csLine.Format(L"%dbit", m_Format.ssc.MaximumBitsPerSample);
						break;
					}
				case 6: // rbgוx
					{
						csLine.Format(L"%d", m_Format.ssc.BitsPerSampleGranularity);
						break;
					}
				case 7: // ŏTvg
					{
						csLine.Format(L"%dHz", m_Format.ssc.MinimumSampleFrequency);
						break;
					}
				case 8: // őTvg
					{
						csLine.Format(L"%dHz", m_Format.ssc.MaximumSampleFrequency);
						break;
					}
				case 9: // gוx
					{
						csLine.Format(L"%d", m_Format.ssc.SampleFrequencyGranularity);
						break;
					}
				}
				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult)
	{
		*pResult = 0;
	}
}

void CProfileAudioDlg::OnNMCustomdrawListFormat(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	if (pNMCD == NULL)
	{
		return;
	}

	LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW)pNMCD;

	if (lplvcd == NULL)
	{
		return;
	}


	// `TCNJnbZ[WLb`
	if (lplvcd->nmcd.dwDrawStage == CDDS_PREPAINT)
	{
		// JX^h[sƂʒm
		if (pResult != NULL)
		{
			*pResult =  CDRF_NOTIFYITEMDRAW;
		}
		return;
	}

	// ACe`悷郁bZ[WLb`
	if (lplvcd->nmcd.dwDrawStage == CDDS_ITEMPREPAINT)
	{
		// s̕Fɂ
		lplvcd->clrText = RGB(0, 0, 0);

		// s̏ꍇ
		if(lplvcd->nmcd.dwItemSpec % 2 == 0)
		{
			// s̔wi𔒂ɂ
			lplvcd->clrTextBk = RGB(255, 255, 255);
		}
		else
		{
			// s̔wiDFɂ
			lplvcd->clrTextBk = RGB(240, 240, 240);
		}
	}

	if (pResult != NULL)
	{
		*pResult = 0;
	}
}

BOOL CProfileAudioDlg::OnScrollCtrl(
	UINT nSBCode, UINT nPos, CScrollBar* pScrollBar,
	CScrollBar *pMyScrollBar, CComboBox *pMyComboBox,
	int nMin, int nMax, int nGra)
{
	if (*pScrollBar == *pMyScrollBar)
	{
		int nNewPos = pScrollBar->GetScrollPos();

		if (nMin > nMax)
		{
			int nTmp = nMin;
			nMin = nMax;
			nMax = nMin;
		}

		switch (nSBCode)
		{
		// ܂݂hbO
		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:
			nNewPos = nPos;
			break;

		// {^NbN
		case SB_LINELEFT:
		case SB_PAGELEFT:
			nNewPos--;
			if (nMin + (nNewPos * nGra) < nMin)
			{
				nNewPos = 0;
			}
			break;
		case SB_LINERIGHT:
		case SB_PAGERIGHT:
			nNewPos++;
			if (nMin + (nNewPos * nGra) > nMax)
			{
				nNewPos = (nMax - nMin) / nGra;
			}
			break;

		default:
			break;
		}

		CString csTmp;
		csTmp.Format(L"%d", nMin + (nNewPos * nGra));
		pMyComboBox->SetWindowText(csTmp);
		pMyScrollBar->SetScrollPos(nNewPos);

		return TRUE;
	}
	return FALSE;
}

void CProfileAudioDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if (OnScrollCtrl(nSBCode, nPos, pScrollBar,
		&m_xcScrollCh, &m_xcCmbCh,
		m_Format.ssc.MinimumChannels,
		m_Format.ssc.MaximumChannels,
		m_Format.ssc.ChannelsGranularity))
	{
		m_bValidCh = TRUE;
		m_xcCmbCh.RedrawWindow();
		return;
	}

	if (OnScrollCtrl(nSBCode, nPos, pScrollBar,
		&m_xcScrollBps, &m_xcCmbBps,
		m_Format.ssc.MinimumBitsPerSample,
		m_Format.ssc.MaximumBitsPerSample,
		m_Format.ssc.BitsPerSampleGranularity))
	{
		m_bValidBps = TRUE;
		m_xcCmbBps.RedrawWindow();
		return;
	}

	if (OnScrollCtrl(nSBCode, nPos, pScrollBar,
		&m_xcScrollHz, &m_xcCmbHz,
		m_Format.ssc.MinimumSampleFrequency,
		m_Format.ssc.MaximumSampleFrequency,
		m_Format.ssc.SampleFrequencyGranularity))
	{
		m_bValidHz = TRUE;
		m_xcCmbHz.RedrawWindow();
		return;
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

BOOL CProfileAudioDlg::OnCmbEditChange(CComboBox *pComboBox, CScrollBar *pScrollBar, int nMin, int nMax, int nGra)
{
	CString csTmp;
	pComboBox->GetWindowText(csTmp);
	int nValue = _wtoi(csTmp);

	if (nMin > nMax)
	{
		int nTmp = nMin;
		nMin = nMax;
		nMax = nMin;
	}

	if (nGra > 0)
	{
		if ((nValue - nMin) % nGra != 0)
		{
			// וxŊ؂Ȃ
			return FALSE;
		}
	}

	if (nValue < nMin || nValue > nMax)
	{
		// l
		return FALSE;
	}


	// XN[o[ɒl𔽉f
	if (nGra > 0)
	{
		if (pScrollBar->IsWindowEnabled())
		{
			int nPos = (nValue - nMin) / nGra;
			pScrollBar->SetScrollPos(nPos);
		}
	}

	return TRUE;
}

void CProfileAudioDlg::OnCbnEditchangeCmbCh()
{
	m_bValidCh = OnCmbEditChange(&m_xcCmbCh, &m_xcScrollCh,
		m_Format.ssc.MinimumChannels,
		m_Format.ssc.MaximumChannels,
		m_Format.ssc.ChannelsGranularity);

	m_xcCmbCh.RedrawWindow();
}

void CProfileAudioDlg::OnCbnEditchangeCmbBps()
{
	m_bValidBps = OnCmbEditChange(&m_xcCmbBps, &m_xcScrollBps,
		m_Format.ssc.MinimumBitsPerSample,
		m_Format.ssc.MaximumBitsPerSample,
		m_Format.ssc.BitsPerSampleGranularity);

	m_xcCmbBps.RedrawWindow();
}

void CProfileAudioDlg::OnCbnEditchangeCmbHz()
{
	m_bValidHz = OnCmbEditChange(&m_xcCmbHz, &m_xcScrollHz,
		m_Format.ssc.MinimumSampleFrequency,
		m_Format.ssc.MaximumSampleFrequency,
		m_Format.ssc.SampleFrequencyGranularity);

	m_xcCmbHz.RedrawWindow();
}

void CProfileAudioDlg::OnCbnSelchangeCmbCh()
{
	int nSel = m_xcCmbCh.GetCurSel();

	if (nSel == CB_ERR)
	{
		return;
	}

	if (m_xcScrollCh.IsWindowEnabled())
	{
		CString csTmp;
		m_xcCmbCh.GetLBText(nSel, csTmp);

		int nValue= _wtoi(csTmp);

		// XN[o[ɒl𔽉f
		if (m_Format.ssc.ChannelsGranularity > 0)
		{
			int nPos = (nValue - m_Format.ssc.MinimumChannels) / m_Format.ssc.ChannelsGranularity;
			m_xcScrollCh.SetScrollPos(nPos);
		}
	}

	m_bValidCh = TRUE;
	m_xcCmbCh.RedrawWindow();
}

void CProfileAudioDlg::OnCbnSelchangeCmbBps()
{
	int nSel = m_xcCmbBps.GetCurSel();

	if (nSel == CB_ERR)
	{
		return;
	}

	if (m_xcScrollBps.IsWindowEnabled())
	{
		CString csTmp;
		m_xcCmbBps.GetLBText(nSel, csTmp);

		int nValue= _wtoi(csTmp);

		// XN[o[ɒl𔽉f
		if (m_Format.ssc.BitsPerSampleGranularity > 0)
		{
			int nPos = (nValue - m_Format.ssc.MinimumBitsPerSample) / m_Format.ssc.BitsPerSampleGranularity;
			m_xcScrollBps.SetScrollPos(nPos);
		}
	}
		
	m_bValidBps = TRUE;
	m_xcCmbBps.RedrawWindow();
}


void CProfileAudioDlg::OnCbnSelchangeCmbHz()
{
	int nSel = m_xcCmbHz.GetCurSel();

	if (nSel == CB_ERR)
	{
		return;
	}

	if (m_xcScrollHz.IsWindowEnabled())
	{
		CString csTmp;
		m_xcCmbHz.GetLBText(nSel, csTmp);

		int nValue= _wtoi(csTmp);

		// XN[o[ɒl𔽉f
		if (m_Format.ssc.SampleFrequencyGranularity > 0)
		{
			int nPos = (nValue - m_Format.ssc.MinimumSampleFrequency) / m_Format.ssc.SampleFrequencyGranularity;
			m_xcScrollHz.SetScrollPos(nPos);
		}
	}

	m_bValidHz = TRUE;
	m_xcCmbHz.RedrawWindow();
}

HBRUSH CProfileAudioDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	HWND hWnd = pWnd->GetSafeHwnd();

    if (nCtlColor == CTLCOLOR_EDIT)
    {
		COMBOBOXINFO info;
		info.cbSize = sizeof(COMBOBOXINFO);
		if (m_xcCmbCh.GetComboBoxInfo(&info))
		{
			if (hWnd == info.hwndCombo ||
				hWnd == info.hwndItem)
			{
				if (!m_bValidCh)
				{
					// F
					pDC->SetTextColor(RGB(0, 0, 0));
					// wiF
					pDC->SetBkColor(RGB(255, 200, 200));
					// Rg[wiF
					hbr = (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				}
			}
		}

		info.cbSize = sizeof(COMBOBOXINFO);
		if (m_xcCmbBps.GetComboBoxInfo(&info))
		{
			if (hWnd == info.hwndCombo ||
				hWnd == info.hwndItem)
			{
				if (!m_bValidBps)
				{
					// F
					pDC->SetTextColor(RGB(0, 0, 0));
					// wiF
					pDC->SetBkColor(RGB(255, 200, 200));
					// Rg[wiF
					hbr = (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				}
			}
		}

		info.cbSize = sizeof(COMBOBOXINFO);
		if (m_xcCmbHz.GetComboBoxInfo(&info))
		{
			if (hWnd == info.hwndCombo ||
				hWnd == info.hwndItem)
			{
				if (!m_bValidHz)
				{
					// F
					pDC->SetTextColor(RGB(0, 0, 0));
					// wiF
					pDC->SetBkColor(RGB(255, 200, 200));
					// Rg[wiF
					hbr = (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				}
			}
		}
    }

	return hbr;
}

void CProfileAudioDlg::OnDestroy()
{
	CDialog::OnDestroy();

	delete m_pEditBkBrush;
}

void CProfileAudioDlg::OnBnClickedCheckBuffer()
{
	if (m_xcCheckBuffer.GetCheck() == BST_CHECKED)
	{
		m_xcEditBuffer.EnableWindow(TRUE);
		m_xcSpinBuffer.EnableWindow(TRUE);
	}
	else
	{
		m_xcEditBuffer.EnableWindow(FALSE);
		m_xcSpinBuffer.EnableWindow(FALSE);
	}
}


