#pragma once

#include "afxwin.h"
#include "afxcmn.h"

#include "CaptureGraphBuilder.h"
#include "CaptureFilterInfo.h"

// CProfileAudioDlg _CAO

class CProfileAudioDlg : public CDialog
{
	DECLARE_DYNAMIC(CProfileAudioDlg)

public:
	CProfileAudioDlg(CWnd* pParent = NULL);   // WRXgN^
	virtual ~CProfileAudioDlg();

// _CAO f[^
	enum { IDD = IDD_PROFILE_AUDIO };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);

	void InitControl(void);
	void SetProfile(const CAudioCaptureFilter &profile);
	void GetProfile(CAudioCaptureFilter &profile);

	BOOL SetCmbChValue(CComboBox *pComboBox, int nNow, int nMin, int nMax, int nGra);
	BOOL SetCmbBpsValue(CComboBox *pComboBox, int nNow, int nMin, int nMax, int nGra);
	BOOL SetCmbHzValue(CComboBox *pComboBox, int nNow, int nMin, int nMax, int nGra);
	BOOL SetScrollValue(CScrollBar *pScrollBar, CComboBox *pComboBox, int nPos, int nMin, int nMax, int nGra);

	BOOL OnScrollCtrl(
		UINT nSBCode, UINT nPos, CScrollBar* pScrollBar,
		CScrollBar *pMyScrollBar, CComboBox *pMyComboBox,
		int nMin, int nMax, int nGra);

	BOOL OnCmbEditChange(CComboBox *pComboBox, CScrollBar *pScrollBar, int nMin, int nMax, int nGra);

	int m_nLastFilter;
	int m_nLastFormat;

	std::vector<CDirectShowFilterID> m_vecID;
	CAudioCaptureFilterInfo m_Info;
	CAudioCaptureFormatInfo m_Format;

	CBrush *m_pEditBkBrush;
	BOOL m_bValidCh;
	BOOL m_bValidBps;
	BOOL m_bValidHz;

	CComboBox m_xcCmbFilter;
	CListCtrl m_xcListPin;

	afx_msg void OnCbnSelchangeCmbFilter();
	afx_msg void OnLvnGetdispinfoListPin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawListPin(NMHDR *pNMHDR, LRESULT *pResult);
	CComboBox m_xcCmbFormat;
	afx_msg void OnCbnSelchangeCmbFormat();
	CListCtrl m_xcListFormat;
	afx_msg void OnLvnGetdispinfoListFormat(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawListFormat(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	CScrollBar m_xcScrollCh;
	CScrollBar m_xcScrollBps;
	CScrollBar m_xcScrollHz;
	CComboBox m_xcCmbCh;
	CComboBox m_xcCmbBps;
	CComboBox m_xcCmbHz;
	afx_msg void OnCbnEditchangeCmbCh();
	afx_msg void OnCbnEditchangeCmbBps();
	afx_msg void OnCbnEditchangeCmbHz();
	afx_msg void OnCbnSelchangeCmbCh();
	afx_msg void OnCbnSelchangeCmbBps();
	afx_msg void OnCbnSelchangeCmbHz();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnDestroy();
	CButton m_xcCheckBuffer;
	CEdit m_xcEditBuffer;
	CSpinButtonCtrl m_xcSpinBuffer;
	afx_msg void OnBnClickedCheckBuffer();
};
