// ProfileEditDlg.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "ProfileEditDlg.h"
#include "afxdialogex.h"

#define DEFAULT_COUNT (30) // 

inline double toFps(REFERENCE_TIME time)
{
	if (time != 0)
	{
		return 10000000.0 / time;
	}
	return 1.0;
}


// CProfileEditDlg _CAO

IMPLEMENT_DYNAMIC(CProfileEditDlg, CDialog)

CProfileEditDlg::CProfileEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProfileEditDlg::IDD, pParent)
	, sortName_(true)
	, sortVideoName_(true)
	, sortVideoFormat_(true)
	, sortAudioName_(true)
	, sortAudioFormat_(true)
{

}

CProfileEditDlg::~CProfileEditDlg()
{
}

void CProfileEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_xcList);
	DDX_Control(pDX, IDC_BTN_ADD, m_xcBtnAdd);
	DDX_Control(pDX, IDC_BTN_COPY, m_xcBtnCopy);
	DDX_Control(pDX, IDC_BTN_DEL, m_xcBtnDel);
	DDX_Control(pDX, IDC_BTN_UP, m_xcBtnUp);
	DDX_Control(pDX, IDC_BTN_DOWN, m_xcBtnDown);
	DDX_Control(pDX, IDC_EDIT, m_xcEdit);
}


BEGIN_MESSAGE_MAP(CProfileEditDlg, CDialog)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST, &CProfileEditDlg::OnLvnGetdispinfoList)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST, &CProfileEditDlg::OnNMCustomdrawList)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST, &CProfileEditDlg::OnLvnColumnclickList)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST, &CProfileEditDlg::OnLvnItemchangedList)
	ON_EN_CHANGE(IDC_EDIT, &CProfileEditDlg::OnEnChangeEdit)
	ON_BN_CLICKED(IDC_BTN_ADD, &CProfileEditDlg::OnBnClickedBtnAdd)
	ON_BN_CLICKED(IDC_BTN_COPY, &CProfileEditDlg::OnBnClickedBtnCopy)
	ON_BN_CLICKED(IDC_BTN_DEL, &CProfileEditDlg::OnBnClickedBtnDel)
	ON_BN_CLICKED(IDC_BTN_UP, &CProfileEditDlg::OnBnClickedBtnUp)
	ON_BN_CLICKED(IDC_BTN_DOWN, &CProfileEditDlg::OnBnClickedBtnDown)
END_MESSAGE_MAP()

void CProfileEditDlg::SetProfile(const std::vector<CCaptureGraphProfile>& profile)
{
	profile_ = profile;
}

void CProfileEditDlg::GetProfile(std::vector<CCaptureGraphProfile>& profile)
{
	profile = profile_;
}

void CProfileEditDlg::UpdateStatus()
{
	if (::IsWindow(status_.GetSafeHwnd()))
	{
		CString tmp;
		tmp.Format(L"\t\t%d/%d", profile_.size(), DEFAULT_COUNT);
		status_.SetPaneText(0, tmp);
	}
}

void CProfileEditDlg::EnableCtrl(BOOL enable)
{
	//m_xcBtnAdd.EnableWindow(enable);
	//m_xcBtnCopy.EnableWindow(enable);
	//m_xcBtnDel.EnableWindow(enable);
	//m_xcBtnUp.EnableWindow(enable);
	//m_xcBtnDown.EnableWindow(enable);
	m_xcEdit.EnableWindow(enable);
}

// CProfileEditDlg bZ[W nh[


BOOL CProfileEditDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


BOOL CProfileEditDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Xe[^Xo[
	if (status_.Create(this))
	{
		const UINT ind[1] = { 0 };
		status_.SetIndicators(ind, 1);
		status_.SetPaneInfo(0, 0, SBPS_STRETCH, 0);
		RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);

		UpdateStatus();
	}

	// XgRg[
	m_xcList.SetExtendedStyle(m_xcList.GetExtendedStyle()|
		LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

	m_xcList.InsertColumn(0, L"̧ٖ", LVCFMT_LEFT, 140);
	m_xcList.InsertColumn(1, L"޵", LVCFMT_LEFT, 100);
	m_xcList.InsertColumn(2, L"޵̫ϯ", LVCFMT_LEFT, 120);
	m_xcList.InsertColumn(3, L"ި", LVCFMT_LEFT, 100);
	m_xcList.InsertColumn(4, L"ި̫ϯ", LVCFMT_LEFT, 120);

	m_xcList.SetItemCountEx(static_cast<int>(profile_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);


	if (profile_.size() > 0)
	{
		// ŏ̍ڂI
		m_xcList.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcList.EnsureVisible(0, FALSE);
	}
	else
	{
		// IȂ̂ŃRg[𖳌
		EnableCtrl(FALSE);
	}


	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void CProfileEditDlg::OnLvnGetdispinfoList(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);
	if (pDispInfo == NULL) { return; }

	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString line;
		switch (pDispInfo->item.iSubItem)
		{
		case 0:
			{
				try {
					line = profile_.at(i).wsName.c_str();
				}
				catch(...) {}
				break;
			}
		case 1:
			{
				try {
					if (!profile_.at(i).Video.wsFriendlyName.empty())
					{
						line.Format(L"%s",
							profile_.at(i).Video.wsFriendlyName.c_str());
					}
				}
				catch(...) {}
				break;
			}

		case 2:
			{
				try {
					if (!profile_.at(i).Video.wsFriendlyName.empty())
					{
						line.Format(L"%dx%d %.2ffps",
							profile_.at(i).Video.Format.biWidth,
							profile_.at(i).Video.Format.biHeight,
							toFps(profile_.at(i).Video.Format.AvgTimePerFrame));
					}
				}
				catch(...) {}
				break;
			}
		case 3:
			{
				try {
					if (!profile_.at(i).Audio.wsFriendlyName.empty())
					{
						line.Format(L"%s",
							profile_.at(i).Audio.wsFriendlyName.c_str());
					}
				}
				catch(...) {}
				break;
			}

		case 4:
			{
				try {
					if (!profile_.at(i).Audio.wsFriendlyName.empty())
					{
						line.Format(L"%dch %dbit %dHz",
							profile_.at(i).Audio.Format.nChannels,
							profile_.at(i).Audio.Format.wBitsPerSample,
							profile_.at(i).Audio.Format.nSamplesPerSec);
					}
				}
				catch(...) {}
				break;
			}
		}

		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			line, _TRUNCATE);
	}

	if (pResult) { *pResult = 0; }
}


void CProfileEditDlg::OnNMCustomdrawList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if (pResult) { *pResult = 0; }
}


void CProfileEditDlg::OnLvnColumnclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	if (pNMLV == NULL) { return; }

	switch(pNMLV->iSubItem)
	{
	case 0:
		std::stable_sort(profile_.begin(), profile_.end(),
			[this](const CCaptureGraphProfile& l, const CCaptureGraphProfile& r)->bool{
				if (sortName_)
				{
					return _wcsicmp(l.wsName.c_str(), r.wsName.c_str()) > 0;
				}
				return _wcsicmp(l.wsName.c_str(), r.wsName.c_str()) < 0;
		});
		m_xcList.RedrawWindow();
		sortName_ = sortName_ ? false : true;
		break;

	case 1:
		std::stable_sort(profile_.begin(), profile_.end(),
			[this](const CCaptureGraphProfile& l, const CCaptureGraphProfile& r)->bool{
				if (sortVideoName_)
				{
					return _wcsicmp(l.Video.wsFriendlyName.c_str(), r.Video.wsFriendlyName.c_str()) > 0;
				}
				return _wcsicmp(l.Video.wsFriendlyName.c_str(), r.Video.wsFriendlyName.c_str()) < 0;
		});
		m_xcList.RedrawWindow();
		sortVideoName_ = sortVideoName_ ? false : true;
		break;

	case 2:
		std::stable_sort(profile_.begin(), profile_.end(),
			[this](const CCaptureGraphProfile& l, const CCaptureGraphProfile& r)->bool{
				double dl = toFps(l.Video.Format.AvgTimePerFrame) * l.Video.Format.biHeight * l.Video.Format.biWidth;
				double dr = toFps(r.Video.Format.AvgTimePerFrame) * r.Video.Format.biHeight * r.Video.Format.biWidth;

				if (l.Video.wsFriendlyName.empty()) { dl = 0.0; }
				if (r.Video.wsFriendlyName.empty()) { dr = 0.0; }

				if (sortVideoFormat_)
				{
					return dl > dr;
				}
				return dl < dr;
		});
		m_xcList.RedrawWindow();
		sortVideoFormat_ = sortVideoFormat_ ? false : true;
		break;

	case 3:
		std::stable_sort(profile_.begin(), profile_.end(),
			[this](const CCaptureGraphProfile& l, const CCaptureGraphProfile& r)->bool{
				if (sortAudioName_)
				{
					return _wcsicmp(l.Audio.wsFriendlyName.c_str(), r.Audio.wsFriendlyName.c_str()) > 0;
				}
				return _wcsicmp(l.Audio.wsFriendlyName.c_str(), r.Audio.wsFriendlyName.c_str()) < 0;
		});
		m_xcList.RedrawWindow();
		sortAudioName_ = sortAudioName_ ? false : true;
		break;

	case 4:
		std::stable_sort(profile_.begin(), profile_.end(),
			[this](const CCaptureGraphProfile& l, const CCaptureGraphProfile& r)->bool{
				double dl = l.Audio.Format.nChannels * l.Audio.Format.wBitsPerSample * l.Audio.Format.nSamplesPerSec;
				double dr = r.Audio.Format.nChannels * r.Audio.Format.wBitsPerSample * r.Audio.Format.nSamplesPerSec;

				if (l.Audio.wsFriendlyName.empty()) { dl = 0.0; }
				if (r.Audio.wsFriendlyName.empty()) { dr = 0.0; }

				if (sortVideoFormat_)
				{
					return dl > dr;
				}
				return dl < dr;
		});
		m_xcList.RedrawWindow();
		sortVideoFormat_ = sortVideoFormat_ ? false : true;
		break;

	default:
		break;
	}

	OnLvnItemchangedList(0, 0);

	if (pResult) { *pResult = 0; }
}


void CProfileEditDlg::OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult)
{
	//LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	
	int i = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);

	if (i >= 0) // I
	{
		std::wstring name;
		try {
			name = profile_.at(i).wsName;
		}
		catch(...) {}

		m_xcEdit.SetWindowText(name.c_str());

		EnableCtrl(TRUE);
	}
	else
	{
		EnableCtrl(FALSE);
	}

	if (pResult) { *pResult = 0; }
}




void CProfileEditDlg::OnEnChangeEdit()
{
	if (!IsWindow(m_xcList.GetSafeHwnd())) { return; }

	int i = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)profile_.size()) { return; }

	if (!IsWindow(m_xcEdit.GetSafeHwnd())) { return; }

	CString tmp;
	m_xcEdit.GetWindowText(tmp);

	profile_.at(i).wsName = tmp;
	m_xcList.Update(i);
}


void CProfileEditDlg::OnBnClickedBtnAdd()
{
	int size = (int)profile_.size();
	if (size >= DEFAULT_COUNT) // l葽ȂȂɂȂ
	{
		return;
	}

	CCaptureGraphProfile profile;
	profile.wsName = L"vt@C";
	profile_.push_back(profile);

	m_xcList.SetItemCountEx(static_cast<int>(profile_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	int i = (int)profile_.size();
	m_xcList.SetItemState(i - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
	m_xcList.EnsureVisible(i - 1, FALSE);
	m_xcList.RedrawWindow();

	UpdateStatus();
}


void CProfileEditDlg::OnBnClickedBtnCopy()
{
	int size = (int)profile_.size();
	if (size >= DEFAULT_COUNT) // l葽ȂȂɂȂ
	{
		return;
	}

	int i = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)profile_.size()) { return; }

	profile_.push_back(profile_.at(i));

	m_xcList.SetItemCountEx(static_cast<int>(profile_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	int n = (int)profile_.size();
	m_xcList.SetItemState(n - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
	m_xcList.EnsureVisible(n - 1, FALSE);
	m_xcList.RedrawWindow();

	UpdateStatus();
}


void CProfileEditDlg::OnBnClickedBtnDel()
{
	int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (index < 0 || index >= (int)profile_.size())
	{
		return;
	}

	if ((int)profile_.size() <= 1)
	{
		return;
	}

	try {
		auto it = profile_.begin() + index;
		profile_.erase(it);
		m_xcList.SetItemCountEx((int)profile_.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

		if ((int)profile_.size() > index)
		{
			m_xcList.SetItemState(index, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
			m_xcList.EnsureVisible(index, FALSE);
		}
		else
		{
			EnableCtrl(FALSE);
		}
		m_xcList.RedrawWindow();

	} catch (std::exception const&) {}

	UpdateStatus();
	OnLvnItemchangedList(0, 0);
}


void CProfileEditDlg::OnBnClickedBtnUp()
{
	int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (index < 0 || index >= (int)profile_.size())
	{
		return;
	}

	if (index <= 0)
	{
		return;
	}

	try {
		CCaptureGraphProfile t = profile_.at(index - 1);
		profile_.at(index - 1) = profile_.at(index);
		profile_.at(index) = t;

		m_xcList.SetItemState(index - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcList.EnsureVisible(index - 1, FALSE);

		m_xcList.RedrawWindow();

	} catch (std::exception&) {}
}


void CProfileEditDlg::OnBnClickedBtnDown()
{
	int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (index < 0 || index >= (int)profile_.size())
	{
		return;
	}

	// Xg̈ԉȂ̂ŉɂ͈ړłȂ
	if (index >= (int)(profile_.size() - 1))
	{
		return;
	}

	try {
		CCaptureGraphProfile t = profile_.at(index + 1);
		profile_.at(index + 1) = profile_.at(index);
		profile_.at(index) = t;

		m_xcList.SetItemState(index + 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcList.EnsureVisible(index + 1, FALSE);

		m_xcList.RedrawWindow();

	} catch (std::exception const&) {}
}
