// ProfileVideoFilterDlg.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "ProfileFilterDlg.h"


// CProfileFilterDlg _CAO

IMPLEMENT_DYNAMIC(CProfileFilterDlg, CDialog)

CProfileFilterDlg::CProfileFilterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProfileFilterDlg::IDD, pParent)
{

}

CProfileFilterDlg::~CProfileFilterDlg()
{
}

void CProfileFilterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_VIDEO_FILTER, m_xcCmbVideoFilter);
	DDX_Control(pDX, IDC_LIST_VIDEO_FILTER, m_xcListVideoFilter);
	DDX_Control(pDX, IDC_CMB_VIDEO_INPUT, m_xcCmbVideoInput);
	DDX_Control(pDX, IDC_CMB_VIDEO_OUTPUT, m_xcCmbVideoOutput);
	DDX_Control(pDX, IDC_LIST_VIDEO_PIN, m_xcListVideoPin);
	DDX_Control(pDX, IDC_CMB_AUDIO_FILTER, m_xcCmbAudioFilter);
	DDX_Control(pDX, IDC_LIST_AUDIO_FILTER, m_xcListAudioFilter);
	DDX_Control(pDX, IDC_CMB_AUDIO_INPUT, m_xcCmbAudioInput);
	DDX_Control(pDX, IDC_CMB_AUDIO_OUTPUT, m_xcCmbAudioOutput);
	DDX_Control(pDX, IDC_LIST_AUDIO_PIN, m_xcListAudioPin);
}


BEGIN_MESSAGE_MAP(CProfileFilterDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_VIDEO_UP, &CProfileFilterDlg::OnBnClickedBtnVideoUp)
	ON_BN_CLICKED(IDC_BTN_VIDEO_DOWN, &CProfileFilterDlg::OnBnClickedBtnVideoDown)
	ON_BN_CLICKED(IDC_BTN_VIDEO_ADD, &CProfileFilterDlg::OnBnClickedBtnVideoAdd)
	ON_BN_CLICKED(IDC_BTN_VIDEO_DEL, &CProfileFilterDlg::OnBnClickedBtnVideoDel)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_VIDEO_FILTER, &CProfileFilterDlg::OnLvnGetdispinfoListVideoFilter)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST_VIDEO_FILTER, &CProfileFilterDlg::OnNMCustomdrawListVideoFilter)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_VIDEO_FILTER, &CProfileFilterDlg::OnLvnItemchangedListVideoFilter)
	ON_NOTIFY(NM_CLICK, IDC_LIST_VIDEO_FILTER, &CProfileFilterDlg::OnNMClickListVideoFilter)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_VIDEO_PIN, &CProfileFilterDlg::OnLvnGetdispinfoListVideoPin)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST_VIDEO_PIN, &CProfileFilterDlg::OnNMCustomdrawListVideoPin)
	ON_CBN_SELCHANGE(IDC_CMB_VIDEO_INPUT, &CProfileFilterDlg::OnCbnSelchangeCmbVideoInput)
	ON_CBN_SELCHANGE(IDC_CMB_VIDEO_OUTPUT, &CProfileFilterDlg::OnCbnSelchangeCmbVideoOutput)
	ON_BN_CLICKED(IDC_BTN_AUDIO_UP, &CProfileFilterDlg::OnBnClickedBtnAudioUp)
	ON_BN_CLICKED(IDC_BTN_AUDIO_DOWN, &CProfileFilterDlg::OnBnClickedBtnAudioDown)
	ON_BN_CLICKED(IDC_BTN_AUDIO_ADD, &CProfileFilterDlg::OnBnClickedBtnAudioAdd)
	ON_BN_CLICKED(IDC_BTN_AUDIO_DEL, &CProfileFilterDlg::OnBnClickedBtnAudioDel)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_AUDIO_FILTER, &CProfileFilterDlg::OnLvnGetdispinfoListAudioFilter)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST_AUDIO_FILTER, &CProfileFilterDlg::OnNMCustomdrawListAudioFilter)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_AUDIO_FILTER, &CProfileFilterDlg::OnLvnItemchangedListAudioFilter)
	ON_NOTIFY(NM_CLICK, IDC_LIST_AUDIO_FILTER, &CProfileFilterDlg::OnNMClickListAudioFilter)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_AUDIO_PIN, &CProfileFilterDlg::OnLvnGetdispinfoListAudioPin)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST_AUDIO_PIN, &CProfileFilterDlg::OnNMCustomdrawListAudioPin)
	ON_CBN_SELCHANGE(IDC_CMB_AUDIO_INPUT, &CProfileFilterDlg::OnCbnSelchangeCmbAudioInput)
	ON_CBN_SELCHANGE(IDC_CMB_AUDIO_OUTPUT, &CProfileFilterDlg::OnCbnSelchangeCmbAudioOutput)
END_MESSAGE_MAP()


void CProfileFilterDlg::InitControl(void)
{
	if (::IsWindow(m_xcCmbVideoFilter.GetSafeHwnd()))
	{
		m_xcCmbVideoFilter.ResetContent();

		std::vector<CDirectShowFilterID>::iterator it;
		for (it = m_vecID.begin(); it != m_vecID.end(); ++it)
		{
			m_xcCmbVideoFilter.AddString(it->wsFriendlyName.c_str());
		}

		m_xcCmbVideoFilter.SetCurSel(0);
		m_xcCmbVideoFilter.EnableWindow(TRUE);
	}

	if (::IsWindow(m_xcListVideoFilter.GetSafeHwnd()))
	{
		m_xcListVideoFilter.SetExtendedStyle(m_xcListVideoFilter.GetExtendedStyle()|
			LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_CHECKBOXES);
		m_xcListVideoFilter.SetCallbackMask(LVIS_STATEIMAGEMASK);

		m_xcListVideoFilter.InsertColumn(0, L"", LVCFMT_LEFT, 30);
		m_xcListVideoFilter.InsertColumn(1, L"ǉtB^", LVCFMT_LEFT, 275);

		m_xcListVideoFilter.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
		m_xcListVideoFilter.EnableWindow(TRUE);
	}

	if (::IsWindow(m_xcCmbVideoInput.GetSafeHwnd()))
	{
		m_xcCmbVideoInput.EnableWindow(FALSE);
	}

	if (::IsWindow(m_xcCmbVideoOutput.GetSafeHwnd()))
	{
		m_xcCmbVideoOutput.EnableWindow(FALSE);
	}

	if (::IsWindow(m_xcListVideoPin.GetSafeHwnd()))
	{
		m_xcListVideoPin.SetExtendedStyle(m_xcListVideoPin.GetExtendedStyle()|
			LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

		m_xcListVideoPin.InsertColumn(0, L"", LVCFMT_LEFT, 50);
		m_xcListVideoPin.InsertColumn(1, L"s", LVCFMT_LEFT, 100);
		m_xcListVideoPin.InsertColumn(2, L"sJeS", LVCFMT_LEFT, 75);
		m_xcListVideoPin.InsertColumn(3, L"fBA^Cv", LVCFMT_LEFT, 80);

		m_xcListVideoPin.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
		m_xcListVideoPin.EnableWindow(FALSE);
	}


	//------------------------------------------------------------------------------


	if (::IsWindow(m_xcCmbAudioFilter.GetSafeHwnd()))
	{
		m_xcCmbAudioFilter.ResetContent();

		std::vector<CDirectShowFilterID>::iterator it;
		for (it = m_vecID.begin(); it != m_vecID.end(); ++it)
		{
			m_xcCmbAudioFilter.AddString(it->wsFriendlyName.c_str());
		}

		m_xcCmbAudioFilter.SetCurSel(0);
		m_xcCmbAudioFilter.EnableWindow(TRUE);
	}

	if (::IsWindow(m_xcListAudioFilter.GetSafeHwnd()))
	{
		m_xcListAudioFilter.SetExtendedStyle(m_xcListAudioFilter.GetExtendedStyle()|
			LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_CHECKBOXES);
		m_xcListAudioFilter.SetCallbackMask(LVIS_STATEIMAGEMASK);

		m_xcListAudioFilter.InsertColumn(0, L"", LVCFMT_LEFT, 30);
		m_xcListAudioFilter.InsertColumn(1, L"ǉtB^", LVCFMT_LEFT, 275);

		m_xcListAudioFilter.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
		m_xcListAudioFilter.EnableWindow(TRUE);
	}

	if (::IsWindow(m_xcCmbAudioInput.GetSafeHwnd()))
	{
		m_xcCmbAudioInput.EnableWindow(FALSE);
	}

	if (::IsWindow(m_xcCmbAudioOutput.GetSafeHwnd()))
	{
		m_xcCmbAudioOutput.EnableWindow(FALSE);
	}

	if (::IsWindow(m_xcListAudioPin.GetSafeHwnd()))
	{
		m_xcListAudioPin.SetExtendedStyle(m_xcListAudioPin.GetExtendedStyle()|
			LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

		m_xcListAudioPin.InsertColumn(0, L"", LVCFMT_LEFT, 50);
		m_xcListAudioPin.InsertColumn(1, L"s", LVCFMT_LEFT, 100);
		m_xcListAudioPin.InsertColumn(2, L"sJeS", LVCFMT_LEFT, 75);
		m_xcListAudioPin.InsertColumn(3, L"fBA^Cv", LVCFMT_LEFT, 80);

		m_xcListAudioPin.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
		m_xcListAudioPin.EnableWindow(FALSE);
	}

}

void CProfileFilterDlg::SetProfile(const CFilterConfig &profile)
{
	int i = -1;
	m_vecVideoInfo.clear();
	for (auto it = profile.vecVideo.begin(); it != profile.vecVideo.end(); ++it)
	{
		CDirectShowFilterInfo info;

		info.wsFriendlyName = it->wsFriendlyName;
		info.wsDevicePath = it->wsDevicePath;
		info.wsDescription = it->wsDescription;
		info.nInput = it->nInput;
		info.nOutput = it->nOutput;
		info.bCheck = it->bCheck;
		info.bIsLoaded = FALSE;

		m_vecVideoInfo.push_back(info);
	}

	i = -1;
	while ((i = m_xcListVideoFilter.GetNextItem(i, LVNI_ALL|LVNI_SELECTED)) != -1)
	{
		m_xcListVideoFilter.SetItemState(i, 0, LVIS_SELECTED|LVIS_FOCUSED);
	}

	m_xcListVideoFilter.SetItemCountEx((int)m_vecVideoInfo.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListVideoFilter.EnableWindow(TRUE);
	m_xcListVideoFilter.RedrawWindow();

	DisableVideoCtrl();



	m_vecAudioInfo.clear();
	for (auto it = profile.vecAudio.begin(); it != profile.vecAudio.end(); ++it)
	{
		CDirectShowFilterInfo info;

		info.wsFriendlyName = it->wsFriendlyName;
		info.wsDevicePath = it->wsDevicePath;
		info.wsDescription = it->wsDescription;
		info.nInput = it->nInput;
		info.nOutput = it->nOutput;
		info.bCheck = it->bCheck;
		info.bIsLoaded = FALSE;

		m_vecAudioInfo.push_back(info);
	}

	i = -1;
	while ((i = m_xcListAudioFilter.GetNextItem(i, LVNI_ALL|LVNI_SELECTED)) != -1)
	{
		m_xcListAudioFilter.SetItemState(i, 0, LVIS_SELECTED|LVIS_FOCUSED);
	}

	m_xcListAudioFilter.SetItemCountEx((int)m_vecAudioInfo.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListAudioFilter.EnableWindow(TRUE);
	m_xcListAudioFilter.RedrawWindow();

	DisableAudioCtrl();
}

void CProfileFilterDlg::GetProfile(CFilterConfig &profile)
{
	std::vector<CDirectShowFilterInfo>::iterator it;

	profile.vecVideo.clear();
	for (it = m_vecVideoInfo.begin(); it != m_vecVideoInfo.end(); ++it)
	{
		CFilterItem item;

		item.wsFriendlyName = it->wsFriendlyName;
		item.wsDevicePath = it->wsDevicePath;
		item.wsDescription = it->wsDescription;
		item.nInput = it->nInput;
		item.nOutput = it->nOutput;
		item.bCheck = it->bCheck;

		profile.vecVideo.push_back(item);
	}

	profile.vecAudio.clear();
	for (it = m_vecAudioInfo.begin(); it != m_vecAudioInfo.end(); ++it)
	{
		CFilterItem item;

		item.wsFriendlyName = it->wsFriendlyName;
		item.wsDevicePath = it->wsDevicePath;
		item.wsDescription = it->wsDescription;
		item.nInput = it->nInput;
		item.nOutput = it->nOutput;
		item.bCheck = it->bCheck;

		profile.vecAudio.push_back(item);
	}
}


// CProfileFilterDlg bZ[W nh

BOOL CProfileFilterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ɏǉĂ

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

BOOL CProfileFilterDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CProfileFilterDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ɃbZ[W nh R[hǉ܂B
}

void CProfileFilterDlg::DisableVideoCtrl(void)
{
	m_xcCmbVideoInput.ResetContent();
	m_xcCmbVideoInput.EnableWindow(FALSE);
	m_xcCmbVideoOutput.ResetContent();
	m_xcCmbVideoOutput.EnableWindow(FALSE);

	m_xcListVideoPin.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListVideoPin.EnableWindow(FALSE);
	m_xcListVideoPin.RedrawWindow();
}

void CProfileFilterDlg::ItemChangedListVideoFilter(int nIndex)
{
	int i = nIndex;
	if (i >= 0)
	{
		// tB^擾
		int nInput = -1;
		int nOutput = -1;
		CDirectShowFilterID id;
		CDirectShowFilterInfo info;

		CCaptureFilterInfo dev;
		dev.Init();

		try {
			// sԍ̐ݒ
			nInput = m_vecVideoInfo.at(i).nInput;
			nOutput = m_vecVideoInfo.at(i).nOutput;

			// 擾pɃtB^ID
			id.wsFriendlyName = m_vecVideoInfo.at(i).wsFriendlyName;
			id.wsDevicePath = m_vecVideoInfo.at(i).wsDevicePath;
			id.wsDescription = m_vecVideoInfo.at(i).wsDescription;
			id.lFilterCategory = FILTER_CATEGORY_DIRECTSHOW;

			dev.GetDirectShowFilterInfo(id, m_vecVideoInfo.at(i));

			m_vecVideoPin = m_vecVideoInfo.at(i).vecPin;
			m_vecVideoInfo.at(i).bIsLoaded = TRUE;


		} catch (std::exception const&) {}

		dev.UnInit();


		try {
			// s񂪂ΏRg[ɐݒ肷
			if (m_vecVideoPin.size() > 0)
			{
				int nIndex; // sԍ
				std::vector<CPinInfo>::iterator it;


				m_xcCmbVideoInput.ResetContent();
				nIndex = 0;
				for (it = m_vecVideoPin.begin(); it != m_vecVideoPin.end(); ++it)
				{
					if (it->bInput)
					{
						if (nIndex == 0)
						{
							m_xcCmbVideoInput.AddString(L"ڑ");
						}
						CString csTmp;
						csTmp.Format(L"%d: %s", nIndex, it->wsName.c_str());
						m_xcCmbVideoInput.AddString(csTmp);
						nIndex++;
					}
				}
				m_xcCmbVideoInput.EnableWindow(nIndex <= 0 ? FALSE : TRUE);
				m_xcCmbVideoInput.SetCurSel(nInput + 1);


				m_xcCmbVideoOutput.ResetContent();
				nIndex = 0;
				for (it = m_vecVideoPin.begin(); it != m_vecVideoPin.end(); ++it)
				{
					if (!(it->bInput))
					{
						if (nIndex == 0)
						{
							m_xcCmbVideoOutput.AddString(L"ڑ");
						}
						CString csTmp;
						csTmp.Format(L"%d: %s", nIndex, it->wsName.c_str());
						m_xcCmbVideoOutput.AddString(csTmp);
						nIndex++;
					}
				}
				m_xcCmbVideoOutput.EnableWindow(nIndex <= 0 ? FALSE : TRUE);
				m_xcCmbVideoOutput.SetCurSel(nOutput + 1);

				m_xcListVideoPin.SetItemCountEx((int)m_vecVideoPin.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
				m_xcListVideoPin.EnableWindow(TRUE);
				m_xcListVideoPin.RedrawWindow();
			}
			else
			{
				DisableVideoCtrl();
			}

		}
		catch (std::exception const&)
		{
			DisableVideoCtrl();
		}
	}
	else
	{
		DisableVideoCtrl();
	}

}




void CProfileFilterDlg::OnBnClickedBtnVideoUp()
{
	int nIndex = m_xcListVideoFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (nIndex < 0 || nIndex >= (int)m_vecVideoInfo.size())
	{
		return;
	}

	// Xg̈ԏȂ̂ŏɂ͈ړłȂ
	if (nIndex <= 0)
	{
		return;
	}

	try {

		CDirectShowFilterInfo info;
		info = m_vecVideoInfo.at(nIndex - 1);
		m_vecVideoInfo.at(nIndex - 1) = m_vecVideoInfo.at(nIndex);
		m_vecVideoInfo.at(nIndex) = info;

		m_xcListVideoFilter.SetItemState(nIndex - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListVideoFilter.EnsureVisible(nIndex - 1, FALSE);

		m_xcListVideoFilter.RedrawWindow();

	} catch (std::exception const&) {}
}

void CProfileFilterDlg::OnBnClickedBtnVideoDown()
{
	int nIndex = m_xcListVideoFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (nIndex < 0 || nIndex >= (int)m_vecVideoInfo.size())
	{
		return;
	}

	// Xg̈ԉȂ̂ŉɂ͈ړłȂ
	if (nIndex >= (int)(m_vecVideoInfo.size() - 1))
	{
		return;
	}

	try {

		CDirectShowFilterInfo info;
		info = m_vecVideoInfo.at(nIndex + 1);
		m_vecVideoInfo.at(nIndex + 1) = m_vecVideoInfo.at(nIndex);
		m_vecVideoInfo.at(nIndex) = info;

		m_xcListVideoFilter.SetItemState(nIndex + 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListVideoFilter.EnsureVisible(nIndex + 1, FALSE);

		m_xcListVideoFilter.RedrawWindow();

	} catch (std::exception const&) {}
}


void CProfileFilterDlg::OnBnClickedBtnVideoAdd()
{
	int nSel = m_xcCmbVideoFilter.GetCurSel();
	if (nSel == CB_ERR)
	{
		return;
	}

	// tB^̐ݒ
	try {
		CDirectShowFilterInfo info;
		info.wsFriendlyName = m_vecID.at(nSel).wsFriendlyName;
		info.wsDevicePath = m_vecID.at(nSel).wsDevicePath;
		info.wsDescription = m_vecID.at(nSel).wsDescription;

		m_vecVideoInfo.push_back(info);

	} catch (std::exception const&) {}

	m_xcListVideoFilter.SetItemCountEx((int)m_vecVideoInfo.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	int i = (int)m_vecVideoInfo.size() - 1;
	if (i >= 0)
	{
		m_xcListVideoFilter.SetItemState(i, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListVideoFilter.EnsureVisible(i, FALSE);
	}

	m_xcListVideoFilter.RedrawWindow();
}

void CProfileFilterDlg::OnBnClickedBtnVideoDel()
{
	int nIndex = m_xcListVideoFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (nIndex < 0 || nIndex >= (int)m_vecVideoInfo.size())
	{
		return;
	}

	try {
		std::vector<CDirectShowFilterInfo>::iterator it = m_vecVideoInfo.begin() + nIndex;
		m_vecVideoInfo.erase(it);
		m_xcListVideoFilter.SetItemCountEx((int)m_vecVideoInfo.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

		if ((int)m_vecVideoInfo.size() > 0)
		{
			m_xcListVideoFilter.SetItemState(nIndex, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
			m_xcListVideoFilter.EnsureVisible(nIndex, FALSE);
			ItemChangedListVideoFilter(nIndex);
		}

		m_xcListVideoFilter.RedrawWindow();

		nIndex = m_xcListVideoFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
		if (nIndex < 0)
		{
			DisableVideoCtrl();
		}
	} catch (std::exception const&) {}
}


void CProfileFilterDlg::OnLvnGetdispinfoListVideoFilter(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (pDispInfo == NULL)
	{
		return;
	}

	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_STATE)
	{
		try {
			pDispInfo->item.state = LVIS_STATEIMAGEMASK;

			if (m_vecVideoInfo.at(i).bCheck)
			{
				pDispInfo->item.stateMask = INDEXTOSTATEIMAGEMASK(2);
			}
			else
			{
				pDispInfo->item.stateMask = INDEXTOSTATEIMAGEMASK(1);
			}
		} catch (std::exception const&) {}
	}

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 1:
			{
				try {
					csLine = m_vecVideoInfo.at(i).wsFriendlyName.c_str();
				} catch (std::exception const&) {}
				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult)
	{
		*pResult = 0;
	}
}

void CProfileFilterDlg::OnNMCustomdrawListVideoFilter(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	*pResult = 0;
}

void CProfileFilterDlg::OnLvnItemchangedListVideoFilter(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	if (pNMLV == NULL)
	{
		return;
	}

	if (pNMLV->uNewState & LVIS_SELECTED) // I
	{
		ItemChangedListVideoFilter(pNMLV->iItem);
	}
	else
	{
		m_xcCmbVideoInput.ResetContent();
		m_xcCmbVideoInput.EnableWindow(FALSE);
		m_xcCmbVideoOutput.ResetContent();
		m_xcCmbVideoOutput.EnableWindow(FALSE);

		m_xcListVideoPin.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
		m_xcListVideoPin.EnableWindow(FALSE);
		m_xcListVideoPin.RedrawWindow();
	}

	if (pResult != NULL)
	{
		*pResult = 0;
	}
}

void CProfileFilterDlg::OnNMClickListVideoFilter(NMHDR *pNMHDR, LRESULT *pResult)
{
	CPoint pt;
	GetCursorPos(&pt);
	m_xcListVideoFilter.ScreenToClient(&pt);

	LVHITTESTINFO lvHit;
	lvHit.pt = pt;
	int i = m_xcListVideoFilter.SubItemHitTest(&lvHit);

	if (lvHit.iSubItem == 0 && lvHit.flags & LVHT_ONITEMSTATEICON)
	{
		try {
			m_vecVideoInfo.at(i).bCheck = m_vecVideoInfo.at(i).bCheck ? FALSE : TRUE;
		} catch (std::exception const&) {}

		CRect rc;
		m_xcListVideoFilter.GetItemRect(i, &rc, LVIR_BOUNDS);
		m_xcListVideoFilter.InvalidateRect(&rc, FALSE);
	}

	if (pResult != NULL)
	{
		*pResult = 0;
	}
}

void CProfileFilterDlg::OnLvnGetdispinfoListVideoPin(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (pDispInfo == NULL)
	{
		return;
	}

	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 0:
			{
				try {
					csLine = m_vecVideoPin.at(i).bInput ? L"IN" : L"OUT";
				} catch(std::exception const&) {}
				break;
			}
		case 1:
			{
				try {
					csLine = m_vecVideoPin.at(i).wsName.c_str();
				} catch(std::exception const&) {}
				break;
			}
		case 2:
			{
				try {
					csLine = m_vecVideoPin.at(i).wsCategory.c_str();
				} catch(std::exception const&) {}
				break;
			}
		case 3:
			{
				try {
					csLine = m_vecVideoPin.at(i).wsMediaType.c_str();
				} catch(std::exception const&) {}
				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult)
	{
		*pResult = 0;
	}
}

void CProfileFilterDlg::OnNMCustomdrawListVideoPin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	*pResult = 0;
}


void CProfileFilterDlg::OnCbnSelchangeCmbVideoInput()
{
	int nIndex = m_xcListVideoFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	int nSel = m_xcCmbVideoInput.GetCurSel();
	if (nIndex < 0 || nSel == CB_ERR)
	{
		return;
	}

	try {
		m_vecVideoInfo.at(nIndex).nInput = nSel - 1;
	} catch (std::exception const&) {}
}

void CProfileFilterDlg::OnCbnSelchangeCmbVideoOutput()
{
	int nIndex = m_xcListVideoFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	int nSel = m_xcCmbVideoOutput.GetCurSel();
	if (nIndex < 0 || nSel == CB_ERR)
	{
		return;
	}

	try {
		m_vecVideoInfo.at(nIndex).nOutput = nSel - 1;
	} catch (std::exception const&) {}
}








//--------------------------------------------------------------------------------------------




void CProfileFilterDlg::DisableAudioCtrl(void)
{
	m_xcCmbAudioInput.ResetContent();
	m_xcCmbAudioInput.EnableWindow(FALSE);
	m_xcCmbAudioOutput.ResetContent();
	m_xcCmbAudioOutput.EnableWindow(FALSE);

	m_xcListAudioPin.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListAudioPin.EnableWindow(FALSE);
	m_xcListAudioPin.RedrawWindow();
}

void CProfileFilterDlg::ItemChangedListAudioFilter(int nIndex)
{
	int i = nIndex;
	if (i >= 0)
	{
		// tB^擾
		int nInput = -1;
		int nOutput = -1;
		CDirectShowFilterID id;
		CDirectShowFilterInfo info;

		CCaptureFilterInfo dev;
		dev.Init();

		try {
			// sԍ̐ݒ
			nInput = m_vecAudioInfo.at(i).nInput;
			nOutput = m_vecAudioInfo.at(i).nOutput;

			// 擾pɃtB^ID
			id.wsFriendlyName = m_vecAudioInfo.at(i).wsFriendlyName;
			id.wsDevicePath = m_vecAudioInfo.at(i).wsDevicePath;
			id.wsDescription = m_vecAudioInfo.at(i).wsDescription;
			id.lFilterCategory = FILTER_CATEGORY_DIRECTSHOW;

			dev.GetDirectShowFilterInfo(id, m_vecAudioInfo.at(i));

			m_vecAudioPin = m_vecAudioInfo.at(i).vecPin;
			m_vecAudioInfo.at(i).bIsLoaded = TRUE;


		} catch (std::exception const&) {}

		dev.UnInit();


		try {
			// s񂪂ΏRg[ɐݒ肷
			if (m_vecAudioPin.size() > 0)
			{
				int nIndex; // sԍ
				std::vector<CPinInfo>::iterator it;


				m_xcCmbAudioInput.ResetContent();
				nIndex = 0;
				for (it = m_vecAudioPin.begin(); it != m_vecAudioPin.end(); ++it)
				{
					if (it->bInput)
					{
						if (nIndex == 0)
						{
							m_xcCmbAudioInput.AddString(L"ڑ");
						}
						CString csTmp;
						csTmp.Format(L"%d: %s", nIndex, it->wsName.c_str());
						m_xcCmbAudioInput.AddString(csTmp);
						nIndex++;
					}
				}
				m_xcCmbAudioInput.EnableWindow(nIndex <= 0 ? FALSE : TRUE);
				m_xcCmbAudioInput.SetCurSel(nInput + 1);


				m_xcCmbAudioOutput.ResetContent();
				nIndex = 0;
				for (it = m_vecAudioPin.begin(); it != m_vecAudioPin.end(); ++it)
				{
					if (!(it->bInput))
					{
						if (nIndex == 0)
						{
							m_xcCmbAudioOutput.AddString(L"ڑ");
						}
						CString csTmp;
						csTmp.Format(L"%d: %s", nIndex, it->wsName.c_str());
						m_xcCmbAudioOutput.AddString(csTmp);
						nIndex++;
					}
				}
				m_xcCmbAudioOutput.EnableWindow(nIndex <= 0 ? FALSE : TRUE);
				m_xcCmbAudioOutput.SetCurSel(nOutput + 1);

				m_xcListAudioPin.SetItemCountEx((int)m_vecAudioPin.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
				m_xcListAudioPin.EnableWindow(TRUE);
				m_xcListAudioPin.RedrawWindow();
			}
			else
			{
				DisableAudioCtrl();
			}

		}
		catch (std::exception const&)
		{
			DisableAudioCtrl();
		}
	}
	else
	{
		DisableAudioCtrl();
	}

}




void CProfileFilterDlg::OnBnClickedBtnAudioUp()
{
	int nIndex = m_xcListAudioFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (nIndex < 0 || nIndex >= (int)m_vecAudioInfo.size())
	{
		return;
	}

	// Xg̈ԏȂ̂ŏɂ͈ړłȂ
	if (nIndex <= 0)
	{
		return;
	}

	try {

		CDirectShowFilterInfo info;
		info = m_vecAudioInfo.at(nIndex - 1);
		m_vecAudioInfo.at(nIndex - 1) = m_vecAudioInfo.at(nIndex);
		m_vecAudioInfo.at(nIndex) = info;

		m_xcListAudioFilter.SetItemState(nIndex - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListAudioFilter.EnsureVisible(nIndex - 1, FALSE);

		m_xcListAudioFilter.RedrawWindow();

	} catch (std::exception const&) {}
}

void CProfileFilterDlg::OnBnClickedBtnAudioDown()
{
	int nIndex = m_xcListAudioFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (nIndex < 0 || nIndex >= (int)m_vecAudioInfo.size())
	{
		return;
	}

	// Xg̈ԉȂ̂ŉɂ͈ړłȂ
	if (nIndex >= (int)(m_vecAudioInfo.size() - 1))
	{
		return;
	}

	try {

		CDirectShowFilterInfo info;
		info = m_vecAudioInfo.at(nIndex + 1);
		m_vecAudioInfo.at(nIndex + 1) = m_vecAudioInfo.at(nIndex);
		m_vecAudioInfo.at(nIndex) = info;

		m_xcListAudioFilter.SetItemState(nIndex + 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListAudioFilter.EnsureVisible(nIndex + 1, FALSE);

		m_xcListAudioFilter.RedrawWindow();

	} catch (std::exception const&) {}
}


void CProfileFilterDlg::OnBnClickedBtnAudioAdd()
{
	int nSel = m_xcCmbAudioFilter.GetCurSel();
	if (nSel == CB_ERR)
	{
		return;
	}

	// tB^̐ݒ
	try {
		CDirectShowFilterInfo info;
		info.wsFriendlyName = m_vecID.at(nSel).wsFriendlyName;
		info.wsDevicePath = m_vecID.at(nSel).wsDevicePath;
		info.wsDescription = m_vecID.at(nSel).wsDescription;

		m_vecAudioInfo.push_back(info);

	} catch (std::exception const&) {}

	m_xcListAudioFilter.SetItemCountEx((int)m_vecAudioInfo.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	int i = (int)m_vecAudioInfo.size() - 1;
	if (i >= 0)
	{
		m_xcListAudioFilter.SetItemState(i, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListAudioFilter.EnsureVisible(i, FALSE);
	}

	m_xcListAudioFilter.RedrawWindow();
}

void CProfileFilterDlg::OnBnClickedBtnAudioDel()
{
	int nIndex = m_xcListAudioFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (nIndex < 0 || nIndex >= (int)m_vecAudioInfo.size())
	{
		return;
	}

	try {
		std::vector<CDirectShowFilterInfo>::iterator it = m_vecAudioInfo.begin() + nIndex;
		m_vecAudioInfo.erase(it);
		m_xcListAudioFilter.SetItemCountEx((int)m_vecAudioInfo.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

		if ((int)m_vecAudioInfo.size() > 0)
		{
			m_xcListAudioFilter.SetItemState(nIndex, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
			m_xcListAudioFilter.EnsureVisible(nIndex, FALSE);
			ItemChangedListAudioFilter(nIndex);
		}

		m_xcListAudioFilter.RedrawWindow();

		nIndex = m_xcListAudioFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
		if (nIndex < 0)
		{
			DisableAudioCtrl();
		}
	} catch (std::exception const&) {}
}


void CProfileFilterDlg::OnLvnGetdispinfoListAudioFilter(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (pDispInfo == NULL)
	{
		return;
	}

	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_STATE)
	{
		try {
			pDispInfo->item.state = LVIS_STATEIMAGEMASK;

			if (m_vecAudioInfo.at(i).bCheck)
			{
				pDispInfo->item.stateMask = INDEXTOSTATEIMAGEMASK(2);
			}
			else
			{
				pDispInfo->item.stateMask = INDEXTOSTATEIMAGEMASK(1);
			}
		} catch (std::exception const&) {}
	}

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 1:
			{
				try {
					csLine = m_vecAudioInfo.at(i).wsFriendlyName.c_str();
				} catch (std::exception const&) {}
				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult)
	{
		*pResult = 0;
	}
}

void CProfileFilterDlg::OnNMCustomdrawListAudioFilter(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	*pResult = 0;
}

void CProfileFilterDlg::OnLvnItemchangedListAudioFilter(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	if (pNMLV == NULL)
	{
		return;
	}

	if (pNMLV->uNewState & LVIS_SELECTED) // I
	{
		ItemChangedListAudioFilter(pNMLV->iItem);
	}
	else
	{
		m_xcCmbAudioInput.ResetContent();
		m_xcCmbAudioInput.EnableWindow(FALSE);
		m_xcCmbAudioOutput.ResetContent();
		m_xcCmbAudioOutput.EnableWindow(FALSE);

		m_xcListAudioPin.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
		m_xcListAudioPin.EnableWindow(FALSE);
		m_xcListAudioPin.RedrawWindow();
	}

	if (pResult != NULL)
	{
		*pResult = 0;
	}
}

void CProfileFilterDlg::OnNMClickListAudioFilter(NMHDR *pNMHDR, LRESULT *pResult)
{
	CPoint pt;
	GetCursorPos(&pt);
	m_xcListAudioFilter.ScreenToClient(&pt);

	LVHITTESTINFO lvHit;
	lvHit.pt = pt;
	int i = m_xcListAudioFilter.SubItemHitTest(&lvHit);

	if (lvHit.iSubItem == 0 && lvHit.flags & LVHT_ONITEMSTATEICON)
	{
		try {
			m_vecAudioInfo.at(i).bCheck = m_vecAudioInfo.at(i).bCheck ? FALSE : TRUE;
		} catch (std::exception const&) {}

		CRect rc;
		m_xcListAudioFilter.GetItemRect(i, &rc, LVIR_BOUNDS);
		m_xcListAudioFilter.InvalidateRect(&rc, FALSE);
	}

	if (pResult != NULL)
	{
		*pResult = 0;
	}
}

void CProfileFilterDlg::OnLvnGetdispinfoListAudioPin(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (pDispInfo == NULL)
	{
		return;
	}

	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 0:
			{
				try {
					csLine = m_vecAudioPin.at(i).bInput ? L"IN" : L"OUT";
				} catch(std::exception const&) {}
				break;
			}
		case 1:
			{
				try {
					csLine = m_vecAudioPin.at(i).wsName.c_str();
				} catch(std::exception const&) {}
				break;
			}
		case 2:
			{
				try {
					csLine = m_vecAudioPin.at(i).wsCategory.c_str();
				} catch(std::exception const&) {}
				break;
			}
		case 3:
			{
				try {
					csLine = m_vecAudioPin.at(i).wsMediaType.c_str();
				} catch(std::exception const&) {}
				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult)
	{
		*pResult = 0;
	}
}

void CProfileFilterDlg::OnNMCustomdrawListAudioPin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	*pResult = 0;
}


void CProfileFilterDlg::OnCbnSelchangeCmbAudioInput()
{
	int nIndex = m_xcListAudioFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	int nSel = m_xcCmbAudioInput.GetCurSel();
	if (nIndex < 0 || nSel == CB_ERR)
	{
		return;
	}

	try {
		m_vecAudioInfo.at(nIndex).nInput = nSel - 1;
	} catch (std::exception const&) {}
}

void CProfileFilterDlg::OnCbnSelchangeCmbAudioOutput()
{
	int nIndex = m_xcListAudioFilter.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	int nSel = m_xcCmbAudioOutput.GetCurSel();
	if (nIndex < 0 || nSel == CB_ERR)
	{
		return;
	}

	try {
		m_vecAudioInfo.at(nIndex).nOutput = nSel - 1;
	} catch (std::exception const&) {}
}

