#pragma once

#include "CaptureGraphBuilder.h"
#include "CaptureFilterInfo.h"
#include "afxcmn.h"
#include "afxwin.h"

// CProfileFilterDlg _CAO

class CProfileFilterDlg : public CDialog
{
	DECLARE_DYNAMIC(CProfileFilterDlg)

public:
	CProfileFilterDlg(CWnd* pParent = NULL);   // WRXgN^
	virtual ~CProfileFilterDlg();

// _CAO f[^
	enum { IDD = IDD_PROFILE_FILTER };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	std::vector<CDirectShowFilterID> m_vecID;

	std::vector<CDirectShowFilterInfo> m_vecVideoInfo;
	std::vector<CPinInfo> m_vecVideoPin;

	std::vector<CDirectShowFilterInfo> m_vecAudioInfo;
	std::vector<CPinInfo> m_vecAudioPin;

	void InitControl(void);

	void SetProfile(const CFilterConfig &profile);
	void GetProfile(CFilterConfig &profile);

public:
	CComboBox m_xcCmbVideoFilter;
	CListCtrl m_xcListVideoFilter;
	CComboBox m_xcCmbVideoInput;
	CComboBox m_xcCmbVideoOutput;
	CListCtrl m_xcListVideoPin;

	CComboBox m_xcCmbAudioFilter;
	CListCtrl m_xcListAudioFilter;
	CComboBox m_xcCmbAudioInput;
	CComboBox m_xcCmbAudioOutput;
	CListCtrl m_xcListAudioPin;

	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnDestroy();

	void DisableVideoCtrl(void);
	void ItemChangedListVideoFilter(int nIndex);

	afx_msg void OnBnClickedBtnVideoUp();
	afx_msg void OnBnClickedBtnVideoDown();
	afx_msg void OnBnClickedBtnVideoAdd();
	afx_msg void OnBnClickedBtnVideoDel();

	afx_msg void OnLvnGetdispinfoListVideoFilter(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawListVideoFilter(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedListVideoFilter(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMClickListVideoFilter(NMHDR *pNMHDR, LRESULT *pResult);

	afx_msg void OnLvnGetdispinfoListVideoPin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawListVideoPin(NMHDR *pNMHDR, LRESULT *pResult);

	afx_msg void OnCbnSelchangeCmbVideoInput();
	afx_msg void OnCbnSelchangeCmbVideoOutput();

	void DisableAudioCtrl(void);
	void ItemChangedListAudioFilter(int nIndex);

	afx_msg void OnBnClickedBtnAudioUp();
	afx_msg void OnBnClickedBtnAudioDown();
	afx_msg void OnBnClickedBtnAudioAdd();
	afx_msg void OnBnClickedBtnAudioDel();

	afx_msg void OnLvnGetdispinfoListAudioFilter(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawListAudioFilter(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedListAudioFilter(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMClickListAudioFilter(NMHDR *pNMHDR, LRESULT *pResult);

	afx_msg void OnLvnGetdispinfoListAudioPin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawListAudioPin(NMHDR *pNMHDR, LRESULT *pResult);

	afx_msg void OnCbnSelchangeCmbAudioInput();
	afx_msg void OnCbnSelchangeCmbAudioOutput();
	
};
