// ProfileMainDlg.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "CaptureGraphBuilder.h"
#include "ProfileEditDlg.h"
#include "ProfileMainDlg.h"


// CProfileMainDlg _CAO

IMPLEMENT_DYNAMIC(CProfileMainDlg, CDialog)

CProfileMainDlg::CProfileMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProfileMainDlg::IDD, pParent)
{
	m_nSelected = 0; // vt@Cԍ
	m_nLastTab = 0; // ^uԍ
	m_bPreview = TRUE;
}

CProfileMainDlg::~CProfileMainDlg()
{
}

void CProfileMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TAB, m_xcTab);
	DDX_Control(pDX, IDC_CMB_PROFILE, m_xcCmbProfile);
	DDX_Control(pDX, IDC_EDIT_PROFILE, m_xcEditProfile);
	DDX_Control(pDX, IDC_CHECK, m_xcCheck);
}


BEGIN_MESSAGE_MAP(CProfileMainDlg, CDialog)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, &CProfileMainDlg::OnTcnSelchangeTab)
	ON_CBN_SELCHANGE(IDC_CMB_PROFILE, &CProfileMainDlg::OnCbnSelchangeCmbProfile)
	ON_EN_CHANGE(IDC_EDIT_PROFILE, &CProfileMainDlg::OnEnChangeEditProfile)
	ON_BN_CLICKED(IDC_BTN_PROFILE, &CProfileMainDlg::OnBnClickedBtnProfile)
	ON_BN_CLICKED(IDC_CHECK, &CProfileMainDlg::OnBnClickedCheck)
END_MESSAGE_MAP()


// CProfileMainDlg bZ[W nh

BOOL CProfileMainDlg::Init(int nSelected, std::vector<CCaptureGraphProfile> &vecProfile)
{
	if (m_nSelected >= (int)vecProfile.size() ||
		m_nSelected < 0)
	{
		return FALSE;
	}

	m_nSelected = nSelected;
	m_vecProfile = vecProfile;

	return TRUE;
}

BOOL CProfileMainDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// q_CAO
	InitChildDlg();

	// ^u
	InitTab();

	// TCYKp
	InitSize();

	// Rg[
	InitControl();

	// vt@CKp
	InitProfile();


	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CProfileMainDlg::InitChildDlg()
{
	if (!m_dlgVideo.Create(CProfileVideoDlg::IDD, this))
	{
		return FALSE;
	}
	m_dlgVideo.SetParent(&m_xcTab);

	if (!m_dlgAudio.Create(CProfileAudioDlg::IDD, this))
	{
		return FALSE;
	}
	m_dlgAudio.SetParent(&m_xcTab);

	if (!m_dlgFilter.Create(CProfileFilterDlg::IDD, this))
	{
		return FALSE;
	}
	m_dlgFilter.SetParent(&m_xcTab);

	//if (!m_dlgPreview.Create(CProfilePreviewDlg::IDD, this))
	//{
	//	return FALSE;
	//}
	//m_dlgPreview.SetParent(&m_xcTab);

	return TRUE;
}

BOOL CProfileMainDlg::InitTab()
{
	if (-1 == m_xcTab.InsertItem(0, L"rfIo")) return FALSE;
	if (-1 == m_xcTab.InsertItem(1, L"I[fBIo")) return FALSE;
	if (-1 == m_xcTab.InsertItem(2, L"tB^ǉ")) return FALSE;
	//if (-1 == m_xcTab.InsertItem(3, L"_ݒ")) return FALSE;

	m_xcTab.SetCurSel(m_nLastTab);
	OnTcnSelchangeTab(NULL, NULL);
	m_xcTab.ModifyStyle(0, WS_CLIPCHILDREN|WS_CLIPSIBLINGS);

	return TRUE;
}

BOOL CProfileMainDlg::InitSize()
{
	if (::IsWindow(m_xcTab.GetSafeHwnd()))
	{
		CRect rcAdjust;

		m_xcTab.GetWindowRect(&rcAdjust);
		m_xcTab.AdjustRect(FALSE, &rcAdjust);
		m_xcTab.ScreenToClient(&rcAdjust);

		if (::IsWindow(m_dlgVideo.GetSafeHwnd()))
		{
			m_dlgVideo.MoveWindow(rcAdjust.left, rcAdjust.top, rcAdjust.Width(), rcAdjust.Height());
		}

		if (::IsWindow(m_dlgAudio.GetSafeHwnd()))
		{
			m_dlgAudio.MoveWindow(rcAdjust.left, rcAdjust.top, rcAdjust.Width(), rcAdjust.Height());
		}

		if (::IsWindow(m_dlgFilter.GetSafeHwnd()))
		{
			m_dlgFilter.MoveWindow(rcAdjust.left, rcAdjust.top, rcAdjust.Width(), rcAdjust.Height());
		}

		//if (::IsWindow(m_dlgPreview.GetSafeHwnd()))
		//{
		//	m_dlgPreview.MoveWindow(rcAdjust.left, rcAdjust.top, rcAdjust.Width(), rcAdjust.Height());
		//}
	}
	return TRUE;
}



BOOL CProfileMainDlg::InitControl()
{
	m_xcCheck.SetCheck(m_bPreview ? BST_CHECKED : BST_UNCHECKED);


	CCaptureFilterInfo dev;
	dev.Init();

	// rfILv`[tB^
	m_dlgVideo.m_vecID.clear();
	dev.GetDirectShowFilterID(FILTER_CATEGORY_VIDEO_CAPTURE, m_dlgVideo.m_vecID);

	// I[fBILv`tB^
	std::vector<CDirectShowFilterID> vecID;
	m_dlgAudio.m_vecID.clear();
	dev.GetDirectShowFilterID(FILTER_CATEGORY_AUDIO_CAPTURE, m_dlgAudio.m_vecID);
	dev.GetDirectShowFilterID(FILTER_CATEGORY_VIDEO_CAPTURE, vecID);
	m_dlgAudio.m_vecID.insert(m_dlgAudio.m_vecID.end(), vecID.begin(), vecID.end());

	// DirectShowtB^
	m_dlgFilter.m_vecID.clear();
	dev.GetDirectShowFilterID(FILTER_CATEGORY_DIRECTSHOW, m_dlgFilter.m_vecID);

	dev.UnInit();

	// DirectShowtB^̃\[g
	try {
		std::stable_sort(m_dlgFilter.m_vecID.begin(), m_dlgFilter.m_vecID.end(), Sort_CDirectShowFilterID(false));
	} catch (std::exception const&) {}


	m_dlgVideo.InitControl();
	m_dlgAudio.InitControl();
	m_dlgFilter.InitControl();

	return TRUE;
}


BOOL CProfileMainDlg::InitProfile()
{
	// vt@C
	m_xcCmbProfile.ResetContent();

	//int nProfileIndex = 0;
	for (auto it = m_vecProfile.begin(); it < m_vecProfile.end(); ++it)
	{
		m_xcCmbProfile.AddString(it->wsName.c_str());
		/*
		CString csTmp;
		csTmp.Format(L"%02d: %s", nProfileIndex, it->wsName.c_str());
		m_xcCmbProfile.AddString(csTmp);

		nProfileIndex++;
		*/
	}

	m_xcEditProfile.SetWindowText(m_vecProfile.at(m_nSelected).wsName.c_str());

	m_xcCmbProfile.SetCurSel(m_nSelected);

	m_dlgVideo.SetProfile(m_vecProfile.at(m_nSelected).Video);
	m_dlgAudio.SetProfile(m_vecProfile.at(m_nSelected).Audio);
	m_dlgFilter.SetProfile(m_vecProfile.at(m_nSelected).Filter);
	//m_dlgPreview.SetProfile(m_vecProfile.at(m_nSelected).Preview);

	return TRUE;
}


void CProfileMainDlg::OnTcnSelchangeTab(NMHDR *pNMHDR, LRESULT *pResult)
{
	int nSel = m_xcTab.GetCurSel();

	if (nSel < 0)
	{
		if (pResult)
		{
			*pResult = 0;
		}
	}

	m_nLastTab = nSel;

	m_dlgVideo.ShowWindow(nSel == 0 ? SW_SHOW : SW_HIDE);
	m_dlgAudio.ShowWindow(nSel == 1 ? SW_SHOW : SW_HIDE);
	m_dlgFilter.ShowWindow(nSel == 2 ? SW_SHOW : SW_HIDE);
	//m_dlgPreview.ShowWindow(nSel == 3 ? SW_SHOW : SW_HIDE);

	if (pResult)
	{
		*pResult = 0;
	}
}





void CProfileMainDlg::OnCbnSelchangeCmbProfile()
{
	int nSel = m_xcCmbProfile.GetCurSel();
	if (nSel == CB_ERR || nSel == m_nSelected)
	{
		// ̂Iꂽ㏑Ă܂̂ŏȂ
		return;
	}

	CString csEdit;
	m_xcEditProfile.GetWindowText(csEdit);
	//CString csTmp, csEdit;
	//m_xcEditProfile.GetWindowText(csEdit);
	//csTmp.Format(L"%02d: %s", m_nSelected, csEdit);
	
	//m_xcCmbProfile.DeleteString(m_nSelected);
	//m_xcCmbProfile.InsertString(m_nSelected, csTmp);
	//m_xcCmbProfile.SetCurSel(nSel);

	m_vecProfile.at(m_nSelected).wsName = csEdit;
	m_dlgVideo.GetProfile(m_vecProfile.at(m_nSelected).Video, m_vecProfile.at(m_nSelected).VideoProcAmp);
	m_dlgAudio.GetProfile(m_vecProfile.at(m_nSelected).Audio);
	m_dlgFilter.GetProfile(m_vecProfile.at(m_nSelected).Filter);

	m_xcEditProfile.SetWindowText(m_vecProfile.at(nSel).wsName.c_str());
	m_dlgVideo.SetProfile(m_vecProfile.at(nSel).Video);
	m_dlgAudio.SetProfile(m_vecProfile.at(nSel).Audio);
	m_dlgFilter.SetProfile(m_vecProfile.at(nSel).Filter);

	//m_dlgPreview.GetProfile(m_vecProfile.at(m_nSelected).Preview);
	//m_dlgPreview.SetProfile(m_vecProfile.at(nSel).Preview);

	m_nSelected = nSel;
}

void CProfileMainDlg::OnEnChangeEditProfile()
{
	int nSel = m_xcCmbProfile.GetCurSel();
	if (nSel == CB_ERR)
	{
		return;
	}

	//CString csTmp, csEdit;
	//m_xcEditProfile.GetWindowText(csEdit);
	//csTmp.Format(L"%02d: %s", nSel, csEdit);
	CString csTmp;
	m_xcEditProfile.GetWindowText(csTmp);
	m_xcCmbProfile.DeleteString(nSel);
	m_xcCmbProfile.InsertString(nSel, csTmp);
	m_xcCmbProfile.SetCurSel(nSel);
}

void CProfileMainDlg::OnOK()
{
	CString csEdit;
	m_xcEditProfile.GetWindowText(csEdit);
	m_vecProfile.at(m_nSelected).wsName = csEdit;

	m_dlgVideo.GetProfile(m_vecProfile.at(m_nSelected).Video, m_vecProfile.at(m_nSelected).VideoProcAmp);
	m_dlgAudio.GetProfile(m_vecProfile.at(m_nSelected).Audio);
	m_dlgFilter.GetProfile(m_vecProfile.at(m_nSelected).Filter);
	//m_dlgPreview.GetProfile(m_vecProfile.at(m_nSelected).Preview);

	CDialog::OnOK();
}

BOOL CProfileMainDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CProfileMainDlg::OnBnClickedBtnProfile()
{
	// ݑIĂݒ͕ۑĂȂ̂ŕۑKv
	CString csEdit;
	m_xcEditProfile.GetWindowText(csEdit);
	m_vecProfile.at(m_nSelected).wsName = csEdit;

	m_dlgVideo.GetProfile(m_vecProfile.at(m_nSelected).Video, m_vecProfile.at(m_nSelected).VideoProcAmp);
	m_dlgAudio.GetProfile(m_vecProfile.at(m_nSelected).Audio);
	m_dlgFilter.GetProfile(m_vecProfile.at(m_nSelected).Filter);

	CProfileEditDlg dlg;
	dlg.SetProfile(m_vecProfile);
	if (dlg.DoModal() == IDOK)
	{
		dlg.GetProfile(m_vecProfile);
		// ŏ̃vt@CIď
		m_nSelected = 0;
		InitProfile();
	}
}


void CProfileMainDlg::OnBnClickedCheck()
{
	m_bPreview = m_xcCheck.GetCheck() == BST_CHECKED ? TRUE : FALSE;
}
