// ProfileVideoDlg.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "ProfileVideoDlg.h"


// CProfileVideoDlg _CAO

IMPLEMENT_DYNAMIC(CProfileVideoDlg, CDialog)

CProfileVideoDlg::CProfileVideoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProfileVideoDlg::IDD, pParent)
{
	m_pEditBkBrush = new CBrush(RGB(255, 200, 200));
	m_bChangeFilter = false;
	m_nLastFilter = INT_MAX;
	m_nLastFormat = INT_MAX;
}

CProfileVideoDlg::~CProfileVideoDlg()
{
}

void CProfileVideoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_FILTER, m_xcCmbFilter);
	DDX_Control(pDX, IDC_CMB_FORMAT, m_xcCmbFormat);
	DDX_Control(pDX, IDC_SCROLL_OUTPUT_CX, m_xcScrollOutputCX);
	DDX_Control(pDX, IDC_SCROLL_OUTPUT_CY, m_xcScrollOutputCY);
	DDX_Control(pDX, IDC_SCROLL_FPS, m_xcScrollFPS);
	DDX_Control(pDX, IDC_CMB_STANDARD, m_xcCmbStandard);
	DDX_Control(pDX, IDC_LIST_FORMAT, m_xcListFormat);
	DDX_Control(pDX, IDC_LIST_PIN, m_xcListPin);
	DDX_Control(pDX, IDC_CMB_OUTPUT_CX, m_xcCmbOutputCX);
	DDX_Control(pDX, IDC_CMB_OUTPUT_CY, m_xcCmbOutputCY);
	DDX_Control(pDX, IDC_CMB_FPS, m_xcCmbFPS);
	DDX_Control(pDX, IDC_EDIT_XBAR1, m_xcEditXbar[0]);
	DDX_Control(pDX, IDC_EDIT_XBAR2, m_xcEditXbar[1]);
	DDX_Control(pDX, IDC_EDIT_XBAR3, m_xcEditXbar[2]);
	DDX_Control(pDX, IDC_EDIT_XBAR4, m_xcEditXbar[3]);
	DDX_Control(pDX, IDC_CMB_XBAR1, m_xcCmbXbar[0]);
	DDX_Control(pDX, IDC_CMB_XBAR2, m_xcCmbXbar[1]);
	DDX_Control(pDX, IDC_CMB_XBAR3, m_xcCmbXbar[2]);
	DDX_Control(pDX, IDC_CMB_XBAR4, m_xcCmbXbar[3]);
}


BEGIN_MESSAGE_MAP(CProfileVideoDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_CMB_FILTER, &CProfileVideoDlg::OnCbnSelchangeCmbFilter)
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_CMB_FORMAT, &CProfileVideoDlg::OnCbnSelchangeCmbFormat)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_FORMAT, &CProfileVideoDlg::OnLvnGetdispinfoListFormat)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST_FORMAT, &CProfileVideoDlg::OnNMCustomdrawListFormat)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_PIN, &CProfileVideoDlg::OnLvnGetdispinfoListPin)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST_PIN, &CProfileVideoDlg::OnNMCustomdrawListPin)
	ON_WM_CTLCOLOR()
	ON_WM_DESTROY()
	ON_CBN_EDITCHANGE(IDC_CMB_OUTPUT_CX, &CProfileVideoDlg::OnCbnEditchangeCmbOutputCx)
	ON_CBN_SELCHANGE(IDC_CMB_OUTPUT_CX, &CProfileVideoDlg::OnCbnSelchangeCmbOutputCx)
	ON_CBN_SELCHANGE(IDC_CMB_OUTPUT_CY, &CProfileVideoDlg::OnCbnSelchangeCmbOutputCy)
	ON_CBN_SELCHANGE(IDC_CMB_FPS, &CProfileVideoDlg::OnCbnSelchangeCmbFps)
	ON_CBN_EDITCHANGE(IDC_CMB_OUTPUT_CY, &CProfileVideoDlg::OnCbnEditchangeCmbOutputCy)
	ON_CBN_EDITCHANGE(IDC_CMB_FPS, &CProfileVideoDlg::OnCbnEditchangeCmbFps)
END_MESSAGE_MAP()


// CProfileVideoDlg bZ[W nh

BOOL CProfileVideoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcListPin.SetExtendedStyle(m_xcListPin.GetExtendedStyle()|
		LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

	m_xcListPin.InsertColumn(0, L"", LVCFMT_LEFT, 50);
	m_xcListPin.InsertColumn(1, L"s", LVCFMT_LEFT, 100);
	m_xcListPin.InsertColumn(2, L"sJeS", LVCFMT_LEFT, 100);
	m_xcListPin.InsertColumn(3, L"fBA^Cv", LVCFMT_LEFT, 95);

	m_xcListPin.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListPin.EnableWindow(FALSE);


	m_xcListFormat.SetExtendedStyle(m_xcListFormat.GetExtendedStyle()|
		LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

	m_xcListFormat.InsertColumn(0, L"tH[}bg", LVCFMT_LEFT, 120);
	m_xcListFormat.InsertColumn(1, L"l", LVCFMT_LEFT, 190);

	m_xcListFormat.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListFormat.EnableWindow(FALSE);


	// R{{bNX̃GfBbg{bNXEɂ
	CEdit *pEdit = NULL;
	pEdit = (CEdit*)m_xcCmbOutputCX.GetWindow(GW_CHILD);
	if (pEdit != NULL)
	{
		pEdit->ModifyStyle(ES_LEFT, ES_RIGHT, SWP_FRAMECHANGED);
	}

	pEdit = (CEdit*)m_xcCmbOutputCY.GetWindow(GW_CHILD);
	if (pEdit != NULL)
	{
		pEdit->ModifyStyle(ES_LEFT, ES_RIGHT, SWP_FRAMECHANGED);
	}

	pEdit = (CEdit*)m_xcCmbFPS.GetWindow(GW_CHILD);
	if (pEdit != NULL)
	{
		pEdit->ModifyStyle(ES_LEFT, ES_RIGHT, SWP_FRAMECHANGED);
	}

	m_xcCmbOutputCX.EnableWindow(FALSE);
	m_xcCmbOutputCY.EnableWindow(FALSE);
	m_xcCmbFPS.EnableWindow(FALSE);

	m_xcScrollFPS.SetScrollRange(0, 0);
	m_xcScrollFPS.EnableWindow(FALSE);

	m_xcScrollOutputCX.SetScrollRange(0, 0);
	m_xcScrollOutputCX.EnableWindow(FALSE);

	m_xcScrollOutputCY.SetScrollRange(0, 0);
	m_xcScrollOutputCY.EnableWindow(FALSE);

	m_xcCmbStandard.EnableWindow(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

BOOL CProfileVideoDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CProfileVideoDlg::InitControl(void)
{
	if (::IsWindow(m_xcCmbFilter.GetSafeHwnd()))
	{
		m_xcCmbFilter.AddString(L"rfIo͂Ȃ");
		std::vector<CDirectShowFilterID>::iterator it;
		for (it = m_vecID.begin(); it != m_vecID.end(); ++it)
		{
			m_xcCmbFilter.AddString(it->wsFriendlyName.c_str());
		}

		m_xcCmbFilter.SetCurSel(0);
	}
}

void CProfileVideoDlg::SetProfile(const CVideoCaptureFilter &profile)
{
	int nSel = 0; // R{{bNXԍ
	int nFilter = 0; // tB^ԍ
	std::vector<CDirectShowFilterID>::iterator it;
	for (it = m_vecID.begin(); it != m_vecID.end(); ++it)
	{
		if (profile.wsFriendlyName == it->wsFriendlyName &&
			profile.wsDevicePath == it->wsDevicePath)
		{
			nSel = nFilter + 1;
			break;
		}
		nFilter++;
	}

	m_xcCmbFilter.SetCurSel(nSel);
	OnCbnSelchangeCmbFilter();
	
	if (nSel > 0)
	{
		// tB^[IĂ̂ŃtH[}bgݒ肷

		// NXo[ݒ
		int nCrossbarCount = (int)m_Info.Xbar1.vecOutput.size();

		int nOutput = 0;
		for (auto it = profile.vecCrossbar.begin(); it != profile.vecCrossbar.end(); ++it)
		{
			if (nOutput >= 4)
			{
				break;
			}

			// NXo[ݒl[ȏ
			if (it->lInput >= 0)
			{
				try
				{
					int nInput = 0;
					std::vector<CCrossbarInputPinInfo>::iterator itInput;
					std::vector<CCrossbarInputPinInfo>::iterator itBegin = m_Info.Xbar1.vecOutput.at(nOutput).vecCanRoute.begin();
					std::vector<CCrossbarInputPinInfo>::iterator itEnd = m_Info.Xbar1.vecOutput.at(nOutput).vecCanRoute.end();
					for (itInput = itBegin; itInput != itEnd; ++itInput)
					{
						if (itInput->lIndex == it->lInput)
						{
							m_xcCmbXbar[nOutput].SetCurSel(nInput);
							break;
						}
						nInput++;
					}
				}
				catch (std::exception const&)
				{
				}
			}
			nOutput++;
		}

		// tH[}bgԍ͈͂ɂ邩
		int nFormatCount = (int)m_Info.vecFormat.size();
		if (profile.Format.nIndex < nFormatCount && profile.Format.nIndex >= 0)
		{
			m_xcCmbFormat.SetCurSel(profile.Format.nIndex);
			OnCbnSelchangeCmbFormat();

			CString csTmp;
			csTmp.Format(L"%d", profile.Format.biWidth);
			m_xcCmbOutputCX.SetWindowText(csTmp);
			OnCbnEditchangeCmbOutputCx();

			csTmp.Format(L"%d", profile.Format.biHeight);
			m_xcCmbOutputCY.SetWindowText(csTmp);
			OnCbnEditchangeCmbOutputCy();

			REFERENCE_TIME time = profile.Format.AvgTimePerFrame;
			double fps = 0.0;
			if (time != 0)
			{
				fps = 10000000.0 / (double)profile.Format.AvgTimePerFrame;
			}
			csTmp.Format(L"%.2f", fps);
			m_xcCmbFPS.SetWindowText(csTmp);
			OnCbnEditchangeCmbFps();


			int nStandard = 0;
			std::vector<CAnalogVideoStandardInfo>::iterator it;
			std::vector<CAnalogVideoStandardInfo>::iterator itBegin = m_Info.vecFormat.at(profile.Format.nIndex).vecStandard.begin();
			std::vector<CAnalogVideoStandardInfo>::iterator itEnd = m_Info.vecFormat.at(profile.Format.nIndex).vecStandard.end();
			
			for (it = itBegin; it != itEnd; ++it)
			{
				if (it->lElement == profile.Format.lStandard)
				{
					m_xcCmbStandard.SetCurSel(nStandard);
					break;
				}
				nStandard++;
			}
		}
	}

	// ̕ŃR{{bNXIĂ̂łŃtO
	m_bChangeFilter = false;
}

void CProfileVideoDlg::GetProfile(CVideoCaptureFilter &profile, CVideoProcAmpConfig *vpa)
{
	int nFilter = m_xcCmbFilter.GetCurSel(); // tB^ԍ
	int nFormat = m_xcCmbFormat.GetCurSel();	// tH[}bgԍ

	nFilter -= 1;

	if (m_bChangeFilter && vpa)
	{// tB^ύXꂽProcAmp
		for (int i = 0; i < 10; ++i)
		{
			vpa[i] = CVideoProcAmpConfig();
		}
	}

	if (nFilter < 0)
	{
		profile.wsFriendlyName = L"";
		profile.wsDevicePath = L"";
		profile.wsDescription = L"";
	}
	else
	{
		profile.vecCrossbar.clear();
		for (int nOutput = 0; nOutput < 4; nOutput++)
		{
			int nInput = m_xcCmbXbar[nOutput].GetCurSel();
			if (nInput != CB_ERR)
			{
				CCrossbar xbar;
				xbar.lInput = m_Info.Xbar1.vecOutput.at(nOutput).vecCanRoute.at(nInput).lIndex;
				xbar.lOutput = m_Info.Xbar1.vecOutput.at(nOutput).lIndex;
				profile.vecCrossbar.push_back(xbar);
			}
		}


		profile.wsFriendlyName = m_vecID.at(nFilter).wsFriendlyName;
		profile.wsDevicePath = m_vecID.at(nFilter).wsDevicePath;
		profile.wsDescription = m_vecID.at(nFilter).wsDescription;

		if (m_Info.vecFormat.size() <= 0)
		{
			profile.Format.nIndex = -1;
		}
		else
		{
			profile.Format.nIndex = nFormat;

			CString csTmp;
			m_xcCmbOutputCX.GetWindowText(csTmp);
			profile.Format.biWidth = _wtoi(csTmp);

			m_xcCmbOutputCY.GetWindowText(csTmp);
			profile.Format.biHeight = _wtoi(csTmp);

			m_xcCmbFPS.GetWindowText(csTmp);
			double fps = _wtof(csTmp);
			REFERENCE_TIME time = 10000;
			if (fps != 0.0)
			{
				time = (REFERENCE_TIME)(10000000.0 / fps);
			}
			profile.Format.AvgTimePerFrame = time;


			int nStandard = m_xcCmbStandard.GetCurSel();
			if (nStandard != CB_ERR)
			{
				profile.Format.lStandard = m_Info.vecFormat.at(profile.Format.nIndex).vecStandard.at(nStandard).lElement;
			}
			else
			{
				profile.Format.lStandard = 0;
			}
		}
	}
}

// Lv`[tB^IR{{bNX
void CProfileVideoDlg::OnCbnSelchangeCmbFilter()
{
	int nSel = m_xcCmbFilter.GetCurSel();

	// ڂIĂ牽Ȃ
	if (m_nLastFilter == nSel)
	{
		return;
	}

	m_bChangeFilter = true; // ύXꂽProcAmp
	m_nLastFilter = nSel;
	m_nLastFormat = INT_MAX;


	m_bValidOutputCX = TRUE;
	m_bValidOutputCY = TRUE;
	m_bValidFPS = TRUE;

	if (nSel == CB_ERR || (nSel - 1) < 0)
	{
		// tH[}bgR{{bNXNA
		m_xcCmbFormat.ResetContent();
		m_xcCmbFormat.EnableWindow(FALSE);

		// sXgNA
		m_xcListPin.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
		m_Info.vecPin.clear();
		m_xcListPin.EnableWindow(FALSE);
		m_xcListPin.RedrawWindow();

		// NXo[NA
		for (int i = 0; i < 4; i++)
		{
			m_xcEditXbar[i].SetWindowText(L"");
			m_xcEditXbar[i].EnableWindow(FALSE);
			m_xcCmbXbar[i].ResetContent();
			m_xcCmbXbar[i].EnableWindow(FALSE);
		}

		// ֘AڂNA
		OnCbnSelchangeCmbFormat();
		return;
	}

	nSel--;

	// tB^[̎擾
	CCaptureFilterInfo dev;
	dev.Init();

	m_Info.vecPin.clear();
	m_Info.vecFormat.clear();
	m_Info.Xbar1.vecInput.clear();
	m_Info.Xbar1.vecOutput.clear();
	m_Info.Xbar2.vecInput.clear();
	m_Info.Xbar2.vecOutput.clear();
	dev.GetVideoCaptureFilterInfo(m_vecID.at(nSel), m_Info);

	dev.UnInit();


	// sXg̍XV
	m_xcListPin.SetItemCountEx((int)m_Info.vecPin.size(), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListPin.EnableWindow(TRUE);
	m_xcListPin.RedrawWindow();


	// tH[}bgIR{{bNX
	if (::IsWindow(m_xcCmbFormat.GetSafeHwnd()))
	{
		m_xcCmbFormat.ResetContent();

		if (m_Info.vecFormat.size() <= 0)
		{
			m_xcCmbFormat.AddString(L"tB^tH[}bg擾ł܂ł");
			m_xcCmbFormat.SetCurSel(0);
			m_xcCmbFormat.EnableWindow(FALSE);
		}
		else
		{
			int nNumber = 0;
			std::vector<CVideoCaptureFormatInfo>::iterator it;
			for (it = m_Info.vecFormat.begin(); it != m_Info.vecFormat.end(); ++it)
			{
				CString csTmp;
				
				csTmp.Format(L"%02d: %s (%dbit) %dx%d %.2ffps",
					nNumber,
					it->wsFourCC.c_str(),
					it->vih.bmiHeader.biBitCount,
					it->ssc.InputSize.cx,
					it->ssc.InputSize.cy,
					ToFramePerSecond(it->vih.AvgTimePerFrame));
				m_xcCmbFormat.AddString(csTmp);

				nNumber++;
			}

			m_xcCmbFormat.SetCurSel(0);
			m_xcCmbFormat.EnableWindow(TRUE);
		}

		OnCbnSelchangeCmbFormat();
	}



	for (int i = 0; i < 4; i++)
	{
		m_xcEditXbar[i].SetWindowText(L"");
		m_xcEditXbar[i].EnableWindow(FALSE);
		m_xcCmbXbar[i].ResetContent();
		m_xcCmbXbar[i].EnableWindow(FALSE);
	}

	std::vector<CCrossbarOutputPinInfo>::iterator it1;
	std::vector<CCrossbarOutputPinInfo>::iterator it1Begin = m_Info.Xbar1.vecOutput.begin();
	std::vector<CCrossbarOutputPinInfo>::iterator it1End = m_Info.Xbar1.vecOutput.end();
	
	int nIndex = 0;
	for (it1 = it1Begin; it1 != it1End; ++it1)
	{
		if (nIndex >= 4)
		{
			break;
		}

		m_xcEditXbar[nIndex].SetWindowText(it1->wsType.c_str());
		m_xcEditXbar[nIndex].EnableWindow(TRUE);
		
		std::vector<CCrossbarInputPinInfo>::iterator it2;
		std::vector<CCrossbarInputPinInfo>::iterator it2Begin = it1->vecCanRoute.begin();
		std::vector<CCrossbarInputPinInfo>::iterator it2End = it1->vecCanRoute.end();

		int nSel = 0;
		int nIndex2 = 0;
		for (it2 = it2Begin; it2 != it2End; ++it2)
		{
			if (it1->lRouted == it2->lIndex)
			{
				nSel = nIndex2;
			}
			m_xcCmbXbar[nIndex].AddString(it2->wsType.c_str());

			nIndex2++;
		}
		
		m_xcCmbXbar[nIndex].SetCurSel(nSel);
		m_xcCmbXbar[nIndex].EnableWindow(TRUE);

		nIndex++;
	}

}

BOOL CProfileVideoDlg::OnScrollCtrl(
	UINT nSBCode, UINT nPos, CScrollBar* pScrollBar,
	CScrollBar *pMyScrollBar, CComboBox *pMyComboBox,
	int nMin, int nMax, int nGra)
{
	if (*pScrollBar == *pMyScrollBar)
	{
		int nNewPos = pScrollBar->GetScrollPos();

		if (nMin > nMax)
		{
			int nTmp = nMin;
			nMin = nMax;
			nMax = nMin;
		}

		switch (nSBCode)
		{
		// ܂݂hbO
		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:
			nNewPos = nPos;
			break;

		// {^NbN
		case SB_LINELEFT:
		case SB_PAGELEFT:
			nNewPos--;
			if (nMin + (nNewPos * nGra) < nMin)
			{
				nNewPos = 0;
			}
			break;
		case SB_LINERIGHT:
		case SB_PAGERIGHT:
			nNewPos++;
			if (nMin + (nNewPos * nGra) > nMax)
			{
				nNewPos = (nMax - nMin) / nGra;
			}
			break;

		default:
			break;
		}

		CString csTmp;
		csTmp.Format(L"%d", nMin + (nNewPos * nGra));
		pMyComboBox->SetWindowText(csTmp);
		pMyScrollBar->SetScrollPos(nNewPos);

		return TRUE;
	}
	return FALSE;
}


void CProfileVideoDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if (OnScrollCtrl(nSBCode, nPos, pScrollBar,
		&m_xcScrollOutputCX, &m_xcCmbOutputCX,
		m_Format.ssc.MinOutputSize.cx,
		m_Format.ssc.MaxOutputSize.cx,
		m_Format.ssc.OutputGranularityX))
	{
		m_bValidOutputCX = TRUE;
		m_xcCmbOutputCX.RedrawWindow();
		return;
	}

	if (OnScrollCtrl(nSBCode, nPos, pScrollBar,
		&m_xcScrollOutputCY, &m_xcCmbOutputCY,
		m_Format.ssc.MinOutputSize.cy,
		m_Format.ssc.MaxOutputSize.cy,
		m_Format.ssc.OutputGranularityY))
	{
		m_bValidOutputCY = TRUE;
		m_xcCmbOutputCY.RedrawWindow();
		return;
	}

	if (*pScrollBar == m_xcScrollFPS)
	{
		int nNewPos = pScrollBar->GetScrollPos();

		int nMin = (int)(ToFramePerSecond(m_Format.ssc.MaxFrameInterval) * 100.0);
		int nMax = (int)(ToFramePerSecond(m_Format.ssc.MinFrameInterval) * 100.0);

		if (nMin > nMax)
		{
			int nTmp = nMin;
			nMin = nMax;
			nMax = nMin;
		}

		switch (nSBCode)
		{
		// ܂݂hbO
		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:
			nNewPos = nPos;
			break;

		// {^NbN
		case SB_LINELEFT:
		case SB_PAGELEFT:
			{
				nNewPos--;
				if (nNewPos < nMin)
				{
					nNewPos = nMin;
				}
				break;
			}
		case SB_LINERIGHT:
		case SB_PAGERIGHT:
			{
				nNewPos++;
				if (nNewPos > nMax)
				{
					nNewPos = nMax;
				}
				break;
			}

		default:
			break;
		}

		CString csTmp;
		csTmp.Format(L"%.2f", (double)nNewPos / 100.0);
		m_xcCmbFPS.SetWindowText(csTmp);

		m_xcScrollFPS.SetScrollPos(nNewPos);

		m_bValidFPS = TRUE;
		m_xcCmbFPS.RedrawWindow();
	}
	else
	{
		CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
	}
}

BOOL CProfileVideoDlg::SetScrollValue(CScrollBar *pScrollBar, CComboBox *pComboBox, int nPos, int nMin, int nMax, int nGra)
{
	if (pScrollBar == NULL)
	{
		return FALSE;
	}

	BOOL bResult = TRUE;

	// őŏltɂȂĂꍇ̓Xbv
	if (nMin > nMax)
	{
		int nTmp = nMin;
		nMin = nMax;
		nMax = nMin;
	}

	CString csTmp;
	csTmp.Format(L"%d", nPos);
	pComboBox->SetWindowText(csTmp);

	if (nMin == nMax || nPos > nMax || nPos < nMin || nGra <= 0 || nGra > (nMax - nMin))
	{	
		// ݒlsiXN[o[KvȂjȂύXsɂ

		pScrollBar->EnableWindow(FALSE);
		pComboBox->EnableWindow(TRUE);
	}
	else
	{
		SCROLLINFO info;
		info.cbSize		= sizeof(SCROLLINFO); 
		info.fMask		= SIF_PAGE|SIF_POS|SIF_RANGE;
		info.nMin		= 0;
		info.nMax		= (nMax - nMin) / nGra;
		info.nPage		= 1;
		info.nPos		= (nPos - nMin) / nGra;
		bResult = pScrollBar->SetScrollInfo(&info);

		pScrollBar->EnableWindow(TRUE);
		pComboBox->EnableWindow(TRUE);
		pComboBox->RedrawWindow();
	}

	return bResult;
}

double CProfileVideoDlg::ToFramePerSecond(LONGLONG llFrameInterval)
{
	LONGLONG time;
	if (llFrameInterval < 41666)
	{
		// ő240fps
		time = 41666;
	}
	else if (llFrameInterval > 1000000000)
	{
		// ŏ0.01fps
		time = 1000000000;
	}
	else
	{
		time = llFrameInterval;
	}

	return 10000000.0 / static_cast<double>(time);
}

// tH[}bgIR{{bNX
void CProfileVideoDlg::OnCbnSelchangeCmbFormat()
{
	int nFilter = m_xcCmbFilter.GetCurSel(); // tB^ԍ
	int nFormat = m_xcCmbFormat.GetCurSel();	// tH[}bgԍ
	int nSel = nFilter;
	nFilter--; // 0Ԃ͑IfoCXȂȂ̂-1

	// tH[}bgIĂ牽Ȃ
	if (m_nLastFormat == nFormat)
	{
		return;
	}
	m_nLastFormat = nFormat;

	m_bValidOutputCX = TRUE;
	m_bValidOutputCY = TRUE;
	m_bValidFPS = TRUE;

	if (nSel == CB_ERR || nFormat == CB_ERR || nFilter < 0 || m_Info.vecFormat.size() <= 0)
	{
		// ItB^Ȃ̂Ŋ֘AڂύXsɂ
		m_xcListFormat.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
		m_xcListFormat.EnableWindow(FALSE);
		m_xcListFormat.RedrawWindow();

		m_xcScrollOutputCX.EnableWindow(FALSE);
		m_xcScrollOutputCY.EnableWindow(FALSE);
		m_xcScrollFPS.EnableWindow(FALSE);

		m_xcCmbOutputCX.ResetContent();
		m_xcCmbOutputCX.EnableWindow(FALSE);
		m_xcCmbOutputCX.RedrawWindow();
		m_xcCmbOutputCY.ResetContent();
		m_xcCmbOutputCY.EnableWindow(FALSE);
		m_xcCmbOutputCY.RedrawWindow();
		m_xcCmbFPS.ResetContent();
		m_xcCmbFPS.EnableWindow(FALSE);
		m_xcCmbFPS.RedrawWindow();
		m_xcCmbStandard.ResetContent();
		m_xcCmbStandard.EnableWindow(FALSE);
		m_xcCmbStandard.RedrawWindow();
		return;
	}

	// IꂽtH[}bgo[ϐɕۑ
	m_Format = m_Info.vecFormat.at(nFormat);

	m_xcListFormat.SetItemCountEx(9, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcListFormat.EnableWindow(TRUE);
	m_xcListFormat.RedrawWindow();

	

	std::vector<std::wstring> vecSet;
	std::vector<std::wstring>::iterator it;

	// o͕
	MakeOutputSizeSet(m_Format.ssc.InputSize.cx,
		m_Format.ssc.MinOutputSize.cx,
		m_Format.ssc.MaxOutputSize.cx,
		m_Format.ssc.OutputGranularityX,
		vecSet);

	m_xcCmbOutputCX.ResetContent();
	for (it = vecSet.begin(); it != vecSet.end(); ++it)
	{
		m_xcCmbOutputCX.AddString(it->c_str());
	}

	SetScrollValue(
		&m_xcScrollOutputCX,
		&m_xcCmbOutputCX,
		m_Format.ssc.InputSize.cx,
		m_Format.ssc.MinOutputSize.cx,
		m_Format.ssc.MaxOutputSize.cx,
		m_Format.ssc.OutputGranularityX);


	// o͍
	vecSet.clear();
	MakeOutputSizeSet(m_Format.ssc.InputSize.cy,
		m_Format.ssc.MinOutputSize.cy,
		m_Format.ssc.MaxOutputSize.cy,
		m_Format.ssc.OutputGranularityY,
		vecSet);

	m_xcCmbOutputCY.ResetContent();
	for (it = vecSet.begin(); it != vecSet.end(); ++it)
	{
		m_xcCmbOutputCY.AddString(it->c_str());
	}

	SetScrollValue(
		&m_xcScrollOutputCY,
		&m_xcCmbOutputCY,
		m_Format.ssc.InputSize.cy,
		m_Format.ssc.MinOutputSize.cy,
		m_Format.ssc.MaxOutputSize.cy,
		m_Format.ssc.OutputGranularityY);

	// FPSXN[o[
	vecSet.clear();
	MakeFpsSet(
		m_Format.vih.AvgTimePerFrame,
		m_Format.ssc.MinFrameInterval,
		m_Format.ssc.MaxFrameInterval,
		vecSet);

	m_xcCmbFPS.ResetContent();
	for (it = vecSet.begin(); it != vecSet.end(); ++it)
	{
		m_xcCmbFPS.AddString(it->c_str());
	}

	CString csTmp;
	csTmp.Format(L"%.2f", ToFramePerSecond(m_Format.vih.AvgTimePerFrame));
	m_xcCmbFPS.SetWindowText(csTmp);

	// FPS100{̐lɕϊ
	int nPos = (int)(ToFramePerSecond(m_Format.vih.AvgTimePerFrame) * 100.0);
	int nMin = (int)(ToFramePerSecond(m_Format.ssc.MaxFrameInterval) * 100.0);
	int nMax = (int)(ToFramePerSecond(m_Format.ssc.MinFrameInterval) * 100.0);

	if (nMin > nMax)
	{
		int nTmp = nMin;
		nMin = nMax;
		nMax = nMin;
	}

	if (nMin == nMax || nPos > nMax || nPos < nMin)
	{
		m_xcScrollFPS.EnableWindow(FALSE);
		m_xcCmbFPS.EnableWindow(TRUE);
		m_xcCmbFPS.RedrawWindow();
	}
	else
	{
		m_xcScrollFPS.SetScrollRange(nMin, nMax);
		m_xcScrollFPS.SetScrollPos(nPos);
		m_xcScrollFPS.EnableWindow(TRUE);
		m_xcCmbFPS.EnableWindow(TRUE);
		m_xcCmbFPS.RedrawWindow();
	}


	// AiOrfIWKiR{{bNX
	if (::IsWindow(m_xcCmbStandard.GetSafeHwnd()))
	{
		m_xcCmbStandard.ResetContent();

		if (m_Format.vecStandard.size() > 0)
		{
			int nCount = 0;
			int nIndex = 0;
			std::vector<CAnalogVideoStandardInfo>::iterator it;
			for (it = m_Format.vecStandard.begin(); it != m_Format.vecStandard.end(); ++it)
			{
				CString csTmp;
				csTmp.Format(L"%s", it->wsElement.c_str());
				m_xcCmbStandard.AddString(csTmp);

				// foCXݑIĂvf肷
				if (m_Format.lStandard == it->lElement)
				{
					nIndex = nCount;
				}
				nCount++;
			}

			m_xcCmbStandard.SetCurSel(nIndex);

			m_xcCmbStandard.EnableWindow(TRUE);
		}
		else
		{
			// vfȂꍇ
			m_xcCmbStandard.EnableWindow(FALSE);
		}
	}
}

void CProfileVideoDlg::OnLvnGetdispinfoListFormat(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (pDispInfo == NULL)
	{
		return;
	}

	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 0:
			{
				switch(i)
				{
				case 0:
					{
						csLine = L"Tu^Cv";
						break;
					}
				case 1:
					{
						csLine = L"̓TCY";
						break;
					}
				case 2:
					{
						csLine = L"ŏo̓TCY";
						break;
					}
				case 3:
					{
						csLine = L"őo̓TCY";
						break;
					}
				case 4:
					{
						csLine = L"o̓TCYוx";
						break;
					}
				case 5:
					{
						csLine = L"ŏFPS";
						break;
					}
				case 6:
					{
						csLine = L"őFPS";
						break;
					}
				case 7:
					{
						csLine = L"ŏf[^[g";
						break;
					}
				case 8:
					{
						csLine = L"őf[^[g";
						break;
					}

					/*
				case 5:
					{
						csLine = L"ŏNbvTCY";
						break;
					}
				case 6:
					{
						csLine = L"őNbvTCY";
						break;
					}
				case 7:
					{
						csLine = L"NbvTCYוx";
						break;
					}
				case 8:
					{
						csLine = L"NbvACg";
						break;
					}
					*/
				}
				break;
			}
		case 1:
			{
				switch(i)
				{
				case 0: // Tu^Cv
					{
						csLine.Format(L"%s (%dbit)", m_Format.wsFourCC.c_str(), m_Format.vih.bmiHeader.biBitCount);
						break;
					}
				case 1: // ̓TCY
					{
						csLine.Format(L"%dx%d", m_Format.ssc.InputSize.cx, m_Format.ssc.InputSize.cy);
						break;
					}
				case 2: // ŏo̓TCY
					{
						csLine.Format(L"%dx%d",
							m_Format.ssc.MinOutputSize.cx, m_Format.ssc.MinOutputSize.cy);
						break;
					}
				case 3: // őo̓TCY
					{
						csLine.Format(L"%dx%d",
							m_Format.ssc.MaxOutputSize.cx, m_Format.ssc.MaxOutputSize.cy);
						break;
					}
				case 4: // o̓TCYוx
					{
						csLine.Format(L"X = %d, Y = %d", m_Format.ssc.OutputGranularityX, m_Format.ssc.OutputGranularityY);
						break;
					}
				case 5: // ŏFPS
					{
						csLine.Format(L"%.2ffps",
							ToFramePerSecond(m_Format.ssc.MaxFrameInterval));
						break;
					}
				case 6: // őFPS
					{
						csLine.Format(L"%.2ffps",
							ToFramePerSecond(m_Format.ssc.MinFrameInterval));
						break;
					}
				case 7: // ŏf[^[g
					{

						std::wstring wsStr;
						DWORD dwBps = (DWORD)m_Format.ssc.MinBitsPerSecond;
						int nFigure = 0;

						do
						{
							wsStr += L"0123456789"[dwBps % 10];
							dwBps /= 10;
							nFigure++;

							if (0 != dwBps && 0 == (nFigure % 3))
							{
								wsStr += L",";
							}
						}
						while (0 != dwBps);

						std::reverse(wsStr.begin(), wsStr.end());


						csLine.Format(L"%sbps (%dMByte/s)",
							wsStr.c_str(), (int)((((double)m_Format.ssc.MinBitsPerSecond / 0.8) / 1024.0) / 1024.0));
						break;
					}
				case 8: // őf[^[g
					{
						std::wstring wsStr;
						DWORD dwBps = (DWORD)m_Format.ssc.MaxBitsPerSecond;
						int nFigure = 0;

						do
						{
							wsStr += L"0123456789"[dwBps % 10];
							dwBps /= 10;
							nFigure++;

							if (0 != dwBps && 0 == (nFigure % 3))
							{
								wsStr += L",";
							}
						}
						while (0 != dwBps);

						std::reverse(wsStr.begin(), wsStr.end());


						csLine.Format(L"%sbps (%dMByte/s)",
							wsStr.c_str(), (int)((((double)m_Format.ssc.MaxBitsPerSecond / 0.8) / 1024.0) / 1024.0));
						break;
					}
					/*
				case 5: // ŏNbvTCY
					{
						csLine.Format(L"%dx%d",
							m_Format.ssc.MinCroppingSize.cx, m_Format.ssc.MinCroppingSize.cy);
						break;
					}
				case 6: // őNbvTCY
					{
						csLine.Format(L"%dx%d",
							m_Format.ssc.MaxCroppingSize.cx, m_Format.ssc.MaxCroppingSize.cy);
						break;
					}
				case 7: // NbvTCYוx
					{
						csLine.Format(L"X = %d, Y = %d",
							m_Format.ssc.CropGranularityX, m_Format.ssc.CropGranularityY);
						break;
					}
				case 8: // NbvACg
					{
						csLine.Format(L"X = %d, Y = %d",
							m_Format.ssc.CropAlignX , m_Format.ssc.CropAlignY);
						break;
					}
					*/
				}
				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult)
	{
		*pResult = 0;
	}
}

void CProfileVideoDlg::OnNMCustomdrawListFormat(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	if (pNMCD == NULL)
	{
		return;
	}

	LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW)pNMCD;

	if (lplvcd == NULL)
	{
		return;
	}


	// `TCNJnbZ[WLb`
	if (lplvcd->nmcd.dwDrawStage == CDDS_PREPAINT)
	{
		// JX^h[sƂʒm
		if (pResult != NULL)
		{
			*pResult =  CDRF_NOTIFYITEMDRAW;
		}
		return;
	}

	// ACe`悷郁bZ[WLb`
	if (lplvcd->nmcd.dwDrawStage == CDDS_ITEMPREPAINT)
	{
		// s̕Fɂ
		lplvcd->clrText = RGB(0, 0, 0);

		// s̏ꍇ
		if(lplvcd->nmcd.dwItemSpec % 2 == 0)
		{
			// s̔wi𔒂ɂ
			lplvcd->clrTextBk = RGB(255, 255, 255);
		}
		else
		{
			// s̔wiDFɂ
			lplvcd->clrTextBk = RGB(240, 240, 240);
		}
	}

	if (pResult != NULL)
	{
		*pResult = 0;
	}
}

void CProfileVideoDlg::OnLvnGetdispinfoListPin(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (pDispInfo == NULL)
	{
		return;
	}

	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 0:
			{
				csLine = m_Info.vecPin.at(i).bInput ? L"IN" : L"OUT";
				break;
			}
		case 1:
			{
				csLine = m_Info.vecPin.at(i).wsName.c_str();
				break;
			}
		case 2:
			{
				csLine = m_Info.vecPin.at(i).wsCategory.c_str();
				break;
			}
		case 3:
			{
				csLine = m_Info.vecPin.at(i).wsMediaType.c_str();
				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult)
	{
		*pResult = 0;
	}
}

void CProfileVideoDlg::OnNMCustomdrawListPin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	if (pNMCD == NULL)
	{
		return;
	}

	LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW)pNMCD;

	if (lplvcd == NULL)
	{
		return;
	}


	// `TCNJnbZ[WLb`
	if (lplvcd->nmcd.dwDrawStage == CDDS_PREPAINT)
	{
		// JX^h[sƂʒm
		if (pResult != NULL)
		{
			*pResult =  CDRF_NOTIFYITEMDRAW;
		}
		return;
	}

	// ACe`悷郁bZ[WLb`
	if (lplvcd->nmcd.dwDrawStage == CDDS_ITEMPREPAINT)
	{
		// s̕Fɂ
		lplvcd->clrText = RGB(0, 0, 0);

		int i = (int)lplvcd->nmcd.dwItemSpec;
		if (m_Info.vecPin.at(i).wsCategory == L"CAPTURE" && m_Info.vecPin.at(i).wsMediaType == L"Video")
		{
			lplvcd->clrTextBk = RGB(200, 200, 255);
		}
		else if (m_Info.vecPin.at(i).wsCategory == L"PREVIEW" && m_Info.vecPin.at(i).wsMediaType == L"Video")
		{
			lplvcd->clrTextBk = RGB(255, 255, 200);
		}
		else if (m_Info.vecPin.at(i).wsCategory == L"CAPTURE" && m_Info.vecPin.at(i).wsMediaType == L"Audio")
		{
			lplvcd->clrTextBk = RGB(255, 200, 200);
		}
		else
		{
			lplvcd->clrTextBk = RGB(255, 255, 255);
		}
	}

	if (pResult != NULL)
	{
		*pResult = 0;
	}
}


HBRUSH CProfileVideoDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	HWND hWnd = pWnd->GetSafeHwnd();

    if (nCtlColor == CTLCOLOR_EDIT)
    {
		COMBOBOXINFO info;
		info.cbSize = sizeof COMBOBOXINFO;
		if (m_xcCmbOutputCX.GetComboBoxInfo(&info))
		{
			if (hWnd == info.hwndCombo ||
				hWnd == info.hwndItem)
			{
				if (!m_bValidOutputCX)
				{
					// F
					pDC->SetTextColor(RGB(0, 0, 0));
					// wiF
					pDC->SetBkColor(RGB(255, 200, 200));
					// Rg[wiF
					hbr = (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				}
			}
		}

		info.cbSize = sizeof COMBOBOXINFO;
		if (m_xcCmbOutputCY.GetComboBoxInfo(&info))
		{
			if (hWnd == info.hwndCombo ||
				hWnd == info.hwndItem)
			{
				if (!m_bValidOutputCY)
				{
					// F
					pDC->SetTextColor(RGB(0, 0, 0));
					// wiF
					pDC->SetBkColor(RGB(255, 200, 200));
					// Rg[wiF
					hbr = (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				}
			}
		}

		info.cbSize = sizeof COMBOBOXINFO;
		if (m_xcCmbFPS.GetComboBoxInfo(&info))
		{
			if (hWnd == info.hwndCombo ||
				hWnd == info.hwndItem)
			{
				if (!m_bValidFPS)
				{
					// F
					pDC->SetTextColor(RGB(0, 0, 0));
					// wiF
					pDC->SetBkColor(RGB(255, 200, 200));
					// Rg[wiF
					hbr = (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				}
			}
		}
    }

	return hbr;
}

void CProfileVideoDlg::OnDestroy()
{
	CDialog::OnDestroy();

	delete m_pEditBkBrush;
}

void CProfileVideoDlg::OnCbnEditchangeCmbOutputCx()
{
	m_bValidOutputCX = OnCmbEditChange(&m_xcCmbOutputCX, &m_xcScrollOutputCX,
		m_Format.ssc.MinOutputSize.cx,
		m_Format.ssc.MaxOutputSize.cx,
		m_Format.ssc.OutputGranularityX);

	m_xcCmbOutputCX.RedrawWindow();
}

BOOL CProfileVideoDlg::MakeOutputSizeSet(int nInput, int nMin, int nMax, int nGra, std::vector<std::wstring> &vecSet)
{
	std::vector<int> vec;
	std::vector<int>::iterator it;
	int var[3];

	if (nGra <= 0 || (nMin == nMax))
	{
		CString csTmp;
		csTmp.Format(L"%d", nInput);
		vecSet.push_back(std::wstring(csTmp));
	}
	else
	{
		vec.push_back(480);
		vec.push_back(720);
		vec.push_back(1080);
		vec.push_back(1280);
		vec.push_back(1920);

		var[0] = nInput;
		var[1] = nMin;
		var[2] = nMax;

		for (int i = 0; i < 3; i++)
		{
			it = std::find(vec.begin(), vec.end(), var[i]);
			if (it == vec.end())
			{
				vec.push_back(var[i]);
			}
		}

		std::sort(vec.begin(), vec.end());

		for (it = vec.begin(); it != vec.end(); ++it)
		{
			if (*it >= nMin && *it <= nMax && (*it % nGra) == 0)
			{
				CString csTmp;
				csTmp.Format(L"%d", *it);
				vecSet.push_back(std::wstring(csTmp));
			}
		}
	}

	return TRUE;
}


BOOL CProfileVideoDlg::MakeFpsSet(LONGLONG llInput, LONGLONG llMin, LONGLONG llMax, std::vector<std::wstring> &vecSet)
{	// double͐x̂ߒPɔrłȂ̂Őlɂ
	std::vector<int> vec;
	std::vector<int>::iterator it;
	int var[3];

	if (llMin == llMax)
	{
		CString csTmp;
		csTmp.Format(L"%.2f", ToFramePerSecond(llInput));
		vecSet.push_back(std::wstring(csTmp));
	}
	else
	{
		vec.push_back(2398);
		vec.push_back(2500);
		vec.push_back(2997);
		vec.push_back(3000);
		vec.push_back(5994);
		vec.push_back(6000);

		var[0] = (int)(ToFramePerSecond(llInput) * 100.0);
		var[1] = (int)(ToFramePerSecond(llMin) * 100.0);
		var[2] = (int)(ToFramePerSecond(llMax) * 100.0);

		for (int i = 0; i < 3; i++)
		{
			it = std::find(vec.begin(), vec.end(), var[i]);
			if (it == vec.end())
			{
				vec.push_back(var[i]);
			}
		}

		std::sort(vec.begin(), vec.end());

		int nMax = (int)(ToFramePerSecond(llMin) * 100.0);
		int nMin = (int)(ToFramePerSecond(llMax) * 100.0);
		for (it = vec.begin(); it != vec.end(); ++it)
		{
			if (*it >= nMin && *it <= nMax)
			{
				CString csTmp;
				csTmp.Format(L"%.2f", (double)*it / 100.0);
				vecSet.push_back(std::wstring(csTmp));
			}
		}
	}

	return TRUE;
}

void CProfileVideoDlg::OnCbnSelchangeCmbOutputCx()
{
	int nSel = m_xcCmbOutputCX.GetCurSel();

	if (nSel == CB_ERR)
	{
		return;
	}

	if (m_xcScrollOutputCX.IsWindowEnabled())
	{
		CString csTmp;
		m_xcCmbOutputCX.GetLBText(nSel, csTmp);

		int nValue= _wtoi(csTmp);

		// XN[o[ɒl𔽉f
		if (m_Format.ssc.OutputGranularityX > 0)
		{
			int nPos = (nValue - m_Format.ssc.MinOutputSize.cx) / m_Format.ssc.OutputGranularityX;
			m_xcScrollOutputCX.SetScrollPos(nPos);
		}
	}

	m_bValidOutputCX = TRUE;
	m_xcCmbOutputCX.RedrawWindow();
}

void CProfileVideoDlg::OnCbnSelchangeCmbOutputCy()
{
	int nSel = m_xcCmbOutputCY.GetCurSel();

	if (nSel == CB_ERR)
	{
		return;
	}

	if (m_xcScrollOutputCY.IsWindowEnabled())
	{
		CString csTmp;
		m_xcCmbOutputCY.GetLBText(nSel, csTmp);

		int nValue= _wtoi(csTmp);

		// XN[o[ɒl𔽉f
		if (m_Format.ssc.OutputGranularityY > 0)
		{
			int nPos = (nValue - m_Format.ssc.MinOutputSize.cy) / m_Format.ssc.OutputGranularityY;
			m_xcScrollOutputCY.SetScrollPos(nPos);
		}
	}

	m_bValidOutputCY = TRUE;
	m_xcCmbOutputCY.RedrawWindow();
}

void CProfileVideoDlg::OnCbnSelchangeCmbFps()
{
	int nSel = m_xcCmbFPS.GetCurSel();

	if (nSel == CB_ERR)
	{
		return;
	}

	if (m_xcScrollFPS.IsWindowEnabled())
	{
		CString csTmp;
		m_xcCmbFPS.GetLBText(nSel, csTmp);

		double nValue = _wtof(csTmp);

		// XN[o[ɒl𔽉f
		m_xcScrollFPS.SetScrollPos((int)(nValue * 100.0));

		m_bValidFPS = TRUE;
		m_xcCmbFPS.RedrawWindow();
	}

	m_bValidFPS = TRUE;
	m_xcCmbFPS.RedrawWindow();
}

BOOL CProfileVideoDlg::OnCmbEditChange(CComboBox *pComboBox, CScrollBar *pScrollBar, int nMin, int nMax, int nGra)
{
	CString csTmp;
	pComboBox->GetWindowText(csTmp);
	int nValue = _wtoi(csTmp);

	if (nMin > nMax)
	{
		int nTmp = nMin;
		nMin = nMax;
		nMax = nMin;
	}

	if (nGra > 0)
	{
		if ((nValue - nMin) % nGra != 0)
		{
			// וxŊ؂Ȃ
			return FALSE;
		}
	}

	if (nValue < nMin || nValue > nMax)
	{
		// l
		return FALSE;
	}


	// XN[o[ɒl𔽉f
	if (nGra > 0)
	{
		if (pScrollBar->IsWindowEnabled())
		{
			int nPos = (nValue - nMin) / nGra;
			pScrollBar->SetScrollPos(nPos);
		}
	}

	return TRUE;
}

void CProfileVideoDlg::OnCbnEditchangeCmbOutputCy()
{
	m_bValidOutputCY = OnCmbEditChange(&m_xcCmbOutputCY, &m_xcScrollOutputCY,
		m_Format.ssc.MinOutputSize.cy,
		m_Format.ssc.MaxOutputSize.cy,
		m_Format.ssc.OutputGranularityY);

	m_xcCmbOutputCY.RedrawWindow();
}

void CProfileVideoDlg::OnCbnEditchangeCmbFps()
{
	CString csTmp;
	m_xcCmbFPS.GetWindowText(csTmp);
	double dValue = _wtof(csTmp);
	int nValue = (int)(dValue * 100.0);

	int nMin = (int)(ToFramePerSecond(m_Format.ssc.MaxFrameInterval) * 100.0);
	int nMax = (int)(ToFramePerSecond(m_Format.ssc.MinFrameInterval) * 100.0);

	if (nMin > nMax)
	{
		int nTmp = nMin;
		nMin = nMax;
		nMax = nMin;
	}

	if (nValue < nMin || nValue > nMax)
	{
		// l
		m_bValidFPS = FALSE;
		m_xcCmbFPS.RedrawWindow();
		return;
	}

	// XN[o[ɒl𔽉f
	if (m_xcScrollFPS.IsWindowEnabled())
	{
		m_xcScrollFPS.SetScrollPos(nValue);
	}

	m_bValidFPS = TRUE;
	m_xcCmbFPS.RedrawWindow();
}

