#pragma once

#include "afxwin.h"
#include "afxcmn.h"

#include "CaptureGraphBuilder.h"
#include "CaptureFilterInfo.h"

// CProfileVideoDlg _CAO

class CProfileVideoDlg : public CDialog
{
	DECLARE_DYNAMIC(CProfileVideoDlg)

public:
	CProfileVideoDlg(CWnd* pParent = NULL);   // WRXgN^
	virtual ~CProfileVideoDlg();

// _CAO f[^
	enum { IDD = IDD_PROFILE_VIDEO };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);

	bool m_bChangeFilter; // tB^ύXtO ύXꂽProcAmp
	int m_nLastFilter;
	int m_nLastFormat;

	std::vector<CDirectShowFilterID> m_vecID;
	CVideoCaptureFilterInfo m_Info;
	CVideoCaptureFormatInfo m_Format;
	
	void InitControl(void);
	void SetProfile(const CVideoCaptureFilter &profile);
	void GetProfile(CVideoCaptureFilter &profile, CVideoProcAmpConfig *vpa);
	BOOL SetScrollValue(CScrollBar *pScrollBar, CComboBox *pComboBox, int nPos, int nMin, int nMax, int nGra);
	double ToFramePerSecond(LONGLONG llFrameInterval);
	BOOL MakeOutputSizeSet(int nInput, int nMin, int nMax, int nGra, std::vector<std::wstring> &vecSet);
	BOOL MakeFpsSet(LONGLONG llInput, LONGLONG llMin, LONGLONG llMax, std::vector<std::wstring> &vecSet);

	BOOL OnScrollCtrl(
		UINT nSBCode, UINT nPos, CScrollBar* pScrollBar,
		CScrollBar *pMyScrollBar, CComboBox *pMyComboBox,
		int nMin, int nMax, int nGra);

	BOOL OnCmbEditChange(CComboBox *pComboBox, CScrollBar *pScrollBar, int nMin, int nMax, int nGra);

	CBrush *m_pEditBkBrush;
	BOOL m_bValidOutputCX;
	BOOL m_bValidOutputCY;
	BOOL m_bValidFPS;

	CComboBox m_xcCmbFilter;
	CComboBox m_xcCmbFormat;
	CListCtrl m_xcListPin;
	CListCtrl m_xcListFormat;
	CScrollBar m_xcScrollOutputCX;
	CScrollBar m_xcScrollOutputCY;
	CScrollBar m_xcScrollFPS;
	CComboBox m_xcCmbStandard;

	afx_msg void OnCbnSelchangeCmbFilter();
	afx_msg void OnCbnSelchangeCmbFormat();

	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnLvnGetdispinfoListFormat(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawListFormat(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnGetdispinfoListPin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawListPin(NMHDR *pNMHDR, LRESULT *pResult);
	CComboBox m_xcCmbOutputCX;
	CComboBox m_xcCmbOutputCY;
	CComboBox m_xcCmbFPS;
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnDestroy();
	afx_msg void OnCbnEditchangeCmbOutputCx();
	afx_msg void OnCbnSelchangeCmbOutputCx();
	afx_msg void OnCbnSelchangeCmbOutputCy();
	afx_msg void OnCbnSelchangeCmbFps();
	afx_msg void OnCbnEditchangeCmbOutputCy();
	afx_msg void OnCbnEditchangeCmbFps();
	CEdit m_xcEditXbar[4];
	CComboBox m_xcCmbXbar[4];
};
