// RendererPage.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "RendererPage.h"
#include "afxdialogex.h"


// CRendererPage _CAO

IMPLEMENT_DYNAMIC(CRendererPage, CPropertyPage)

CRendererPage::CRendererPage(CMainDlg *dlg, CCaptureGraphProfile *profile)
	: CPropertyPage(CRendererPage::IDD)
	, dlg_(dlg)
	, profile_(profile)
{
	m_psp.dwFlags &= ~PSP_HASHELP;
}

CRendererPage::~CRendererPage()
{
}

void CRendererPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_VIDEO, m_xcCmbVideo);
	DDX_Control(pDX, IDC_CB_VIDEO, m_xcCbVideo);
	DDX_Control(pDX, IDC_CMB_AUDIO, m_xcCmbAudio);
	DDX_Control(pDX, IDC_CB_AUDIO, m_xcCbAudio);
	DDX_Control(pDX, IDC_CMB_RESIZER, m_xcCmbResizer);
}


BEGIN_MESSAGE_MAP(CRendererPage, CPropertyPage)
	ON_CBN_SELCHANGE(IDC_CMB_VIDEO, &CRendererPage::OnCbnSelchangeCmbVideo)
	ON_BN_CLICKED(IDC_CB_VIDEO, &CRendererPage::OnBnClickedCbVideo)
	ON_CBN_SELCHANGE(IDC_CMB_AUDIO, &CRendererPage::OnCbnSelchangeCmbAudio)
	ON_BN_CLICKED(IDC_CB_AUDIO, &CRendererPage::OnBnClickedCbAudio)
	ON_CBN_SELCHANGE(IDC_CMB_RESIZER, &CRendererPage::OnCbnSelchangeCmbResizer)
END_MESSAGE_MAP()


// CRendererPage bZ[W nh[


BOOL CRendererPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	if (!profile_)
	{
		m_xcCmbVideo.EnableWindow(FALSE);
		m_xcCbVideo.EnableWindow(FALSE);
		m_xcCmbAudio.EnableWindow(FALSE);
		m_xcCbAudio.EnableWindow(FALSE);
		m_xcCmbResizer.EnableWindow(FALSE);
		return TRUE;
	}

	// ݒÕvt@Cۑ
	store_ = *profile_;

	//---------------------------------------------------

	m_xcCmbVideo.AddString(L"Video Mixing Renderer 7");
	m_xcCmbVideo.AddString(L"Video Mixing Renderer 7 I[o[C");
	m_xcCmbVideo.AddString(L"Video Mixing Renderer 9");
	m_xcCmbVideo.AddString(L"Enhanced Video Renderer");
	m_xcCmbVideo.AddString(L"Enhanced Video Renderer Custom");

	switch (profile_->Preview.lVideoRenderer)
	{
	case VIDEO_RENDERER_VMR7:			m_xcCmbVideo.SetCurSel(0); break;
	case VIDEO_RENDERER_VMR7_OFFSCREEN:	m_xcCmbVideo.SetCurSel(1); break;
	case VIDEO_RENDERER_VMR9:			m_xcCmbVideo.SetCurSel(2); break;
	case VIDEO_RENDERER_EVR:			m_xcCmbVideo.SetCurSel(3); break;
	case VIDEO_RENDERER_EVR_CUSTOM:		m_xcCmbVideo.SetCurSel(4); break;
	default: m_xcCmbVideo.SetCurSel(0); break;
	}

	m_xcCbVideo.SetCheck(profile_->Preview.bVideoPreviewPin ? BST_UNCHECKED : BST_CHECKED);

	//---------------------------------------------------

	m_xcCmbAudio.AddString(L"DirectSound Renderer");
	m_xcCmbAudio.AddString(L"WaveOut Renderer");

	switch (profile_->Preview.lAudioRenderer)
	{
	case AUDIO_RENDERER_DIRECTSOUND:	m_xcCmbAudio.SetCurSel(0); break;
	case AUDIO_RENDERER_WAVEOUT:		m_xcCmbAudio.SetCurSel(1); break;
	default: m_xcCmbAudio.SetCurSel(0); break;
	}

	m_xcCbAudio.SetCheck(profile_->Preview.bAudioPreviewPin ? BST_UNCHECKED : BST_CHECKED);

	//---------------------------------------------------

	m_xcCmbResizer.AddString(L"ftHg");
	m_xcCmbResizer.AddString(L"Nearest neighbor");
	m_xcCmbResizer.AddString(L"Bilinear");
	m_xcCmbResizer.AddString(L"SmootherStep");
	m_xcCmbResizer.AddString(L"Bicubic");
	m_xcCmbResizer.AddString(L"Bicubic (V[vlX)");
	m_xcCmbResizer.AddString(L"Bicubic (V[vlX)");
	m_xcCmbResizer.AddString(L"B-spline");
	m_xcCmbResizer.AddString(L"Mitchell-Netravali spline");
	m_xcCmbResizer.AddString(L"Catmull-Rom spline");
	m_xcCmbResizer.AddString(L"Lanczos2");
	m_xcCmbResizer.AddString(L"Lanczos3");

	switch (profile_->Preview.lResizer)
	{
	case d3dutl::RESIZER_DEFAULT:				m_xcCmbResizer.SetCurSel(0); break;
	case d3dutl::RESIZER_SHADER_NEAREST:		m_xcCmbResizer.SetCurSel(1); break;
	case d3dutl::RESIZER_SHADER_BILINEAR:		m_xcCmbResizer.SetCurSel(2); break;
	case d3dutl::RESIZER_SHADER_SMOOTHERSTEP:	m_xcCmbResizer.SetCurSel(3); break;
	case d3dutl::RESIZER_SHADER_BICUBIC06:		m_xcCmbResizer.SetCurSel(4); break;
	case d3dutl::RESIZER_SHADER_BICUBIC08:		m_xcCmbResizer.SetCurSel(5); break;
	case d3dutl::RESIZER_SHADER_BICUBIC10:		m_xcCmbResizer.SetCurSel(6); break;
	case d3dutl::RESIZER_SHADER_BSPLINE4:		m_xcCmbResizer.SetCurSel(7); break;
	case d3dutl::RESIZER_SHADER_MITCHELL4:		m_xcCmbResizer.SetCurSel(8); break;
	case d3dutl::RESIZER_SHADER_CATMULL4:		m_xcCmbResizer.SetCurSel(9); break;
	case d3dutl::RESIZER_SHADER_2PASS_LANCZOS2:	m_xcCmbResizer.SetCurSel(10); break;
	case d3dutl::RESIZER_SHADER_2PASS_LANCZOS3:	m_xcCmbResizer.SetCurSel(11); break;
	default: m_xcCmbResizer.SetCurSel(0); break;
	}

	if (profile_->Preview.lVideoRenderer != VIDEO_RENDERER_EVR_CUSTOM)
	{
		m_xcCmbResizer.EnableWindow(FALSE);
	}

	if (d3dutl::GetD3X9Dll() == NULL)
	{
		m_xcCmbResizer.EnableWindow(FALSE);
	}

	//---------------------------------------------------

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void CRendererPage::OnCbnSelchangeCmbVideo()
{
	if (!profile_) { return; }

	long renderer;
	switch (m_xcCmbVideo.GetCurSel())
	{
	case 0: renderer = VIDEO_RENDERER_VMR7;				break;
	case 1: renderer = VIDEO_RENDERER_VMR7_OFFSCREEN;	break;
	case 2: renderer = VIDEO_RENDERER_VMR9;				break;
	case 3: renderer = VIDEO_RENDERER_EVR;				break;
	case 4: renderer = VIDEO_RENDERER_EVR_CUSTOM;		break;
	default: return;
	}

	if (renderer == VIDEO_RENDERER_EVR_CUSTOM && d3dutl::GetD3X9Dll() != NULL)
	{
		m_xcCmbResizer.EnableWindow(TRUE);
	}
	else
	{
		m_xcCmbResizer.EnableWindow( FALSE);
	}

	profile_->Preview.lVideoRenderer = renderer;
	if (dlg_) { dlg_->OnPreviewIsRunBuild(); }

	pageEvr_->InitCtrl();
	pageVmr9_->InitCtrl();
}

void CRendererPage::OnBnClickedCbVideo()
{
	if (!profile_) { return; }

	profile_->Preview.bVideoPreviewPin = m_xcCbVideo.GetCheck() == BST_CHECKED ? FALSE : TRUE;
	if (dlg_) { dlg_->OnPreviewIsRunBuild(); }
}

void CRendererPage::OnCbnSelchangeCmbAudio()
{
	if (!profile_) { return; }

	long renderer;
	switch (m_xcCmbAudio.GetCurSel())
	{
	case 0: renderer = AUDIO_RENDERER_DIRECTSOUND;	break;
	case 1: renderer = AUDIO_RENDERER_WAVEOUT;		break;
	default: return;
	}

	profile_->Preview.lAudioRenderer = renderer;
	if (dlg_) { dlg_->OnPreviewIsRunBuild(); }
}

void CRendererPage::OnBnClickedCbAudio()
{
	if (!profile_) { return; }

	profile_->Preview.bAudioPreviewPin = m_xcCbAudio.GetCheck() == BST_CHECKED ? FALSE : TRUE;
	if (dlg_) { dlg_->OnPreviewIsRunBuild(); }
}

void CRendererPage::OnCbnSelchangeCmbResizer()
{
	if (!profile_) { return; }

	int resizer;
	switch (m_xcCmbResizer.GetCurSel())
	{
	case 0:		resizer = d3dutl::RESIZER_DEFAULT; break;
	case 1:		resizer = d3dutl::RESIZER_SHADER_NEAREST; break;
	case 2:		resizer = d3dutl::RESIZER_SHADER_BILINEAR; break;
	case 3:		resizer = d3dutl::RESIZER_SHADER_SMOOTHERSTEP; break;
	case 4:		resizer = d3dutl::RESIZER_SHADER_BICUBIC06; break;
	case 5:		resizer = d3dutl::RESIZER_SHADER_BICUBIC08; break;
	case 6:		resizer = d3dutl::RESIZER_SHADER_BICUBIC10; break;
	case 7:		resizer = d3dutl::RESIZER_SHADER_BSPLINE4; break;
	case 8:		resizer = d3dutl::RESIZER_SHADER_MITCHELL4; break;
	case 9:		resizer = d3dutl::RESIZER_SHADER_CATMULL4; break;
	case 10:	resizer = d3dutl::RESIZER_SHADER_2PASS_LANCZOS2; break;
	case 11:	resizer = d3dutl::RESIZER_SHADER_2PASS_LANCZOS3; break;
	default: return;
	}

	profile_->Preview.lResizer = resizer;
	if (dlg_) { dlg_->m_Preview.SetResizer(resizer); }
}


void CRendererPage::OnOK()
{
	CPropertyPage::OnOK();
}


