// RotationPage.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "RotationPage.h"
#include "afxdialogex.h"


// CRotationPage _CAO

IMPLEMENT_DYNAMIC(CRotationPage, CPropertyPage)

CRotationPage::CRotationPage(CMainDlg *dlg, CCaptureGraphProfile *profile)
	: CPropertyPage(CRotationPage::IDD)
	, dlg_(dlg)
	, profile_(profile)
	, enableCtrl_(FALSE)
{
	m_psp.dwFlags &= ~PSP_HASHELP;
}

CRotationPage::~CRotationPage()
{
}

void CRotationPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_ROTATION, m_xcCmbRotation);
	DDX_Control(pDX, IDC_CB_DOUBLE_HEIGHT, m_xcCbDoubleHeight);
	DDX_Control(pDX, IDC_CB_FLIP_HORIZONTAL, m_xcCbFlipHorizontal);
	DDX_Control(pDX, IDC_CB_FLIP_VERTICAL, m_xcCbFlipVertical);
}


BEGIN_MESSAGE_MAP(CRotationPage, CPropertyPage)
	ON_CBN_SELCHANGE(IDC_CMB_ROTATION, &CRotationPage::OnCbnSelchangeCmbRotation)
	ON_BN_CLICKED(IDC_CB_DOUBLE_HEIGHT, &CRotationPage::OnBnClickedCbDoubleHeight)
	ON_BN_CLICKED(IDC_CB_FLIP_HORIZONTAL, &CRotationPage::OnBnClickedCbFlipHorizontal)
	ON_BN_CLICKED(IDC_CB_FLIP_VERTICAL, &CRotationPage::OnBnClickedCbFlipVertical)
END_MESSAGE_MAP()


// CRotationPage bZ[W nh[


BOOL CRotationPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// TODO:  ɏǉĂ

	m_xcCmbRotation.AddString(L"]Ȃ");
	m_xcCmbRotation.AddString(L"E90x]");
	m_xcCmbRotation.AddString(L"90x]");
	m_xcCmbRotation.AddString(L"180x]");

	switch(profile_->Preview.lTransformRotation)
	{
	case TRANSFORM_ROTATION_NONE:	m_xcCmbRotation.SetCurSel(0); break;
	case TRANSFORM_ROTATION_R90:	m_xcCmbRotation.SetCurSel(1); break;
	case TRANSFORM_ROTATION_L90:	m_xcCmbRotation.SetCurSel(2); break;
	case TRANSFORM_ROTATION_180:	m_xcCmbRotation.SetCurSel(3); break;
	default:
		m_xcCmbRotation.SetCurSel(0); break;
	}

	m_xcCbDoubleHeight.SetCheck(profile_->Preview.bTransformDoubleHeight == TRUE ? BST_CHECKED : BST_UNCHECKED);
	m_xcCbFlipHorizontal.SetCheck(profile_->Preview.bTransformFlipHorizontal == TRUE ? BST_CHECKED : BST_UNCHECKED);
	m_xcCbFlipVertical.SetCheck(profile_->Preview.bTransformFlipVertical == TRUE ? BST_CHECKED : BST_UNCHECKED);

	EnableCtrl(enableCtrl_);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void CRotationPage::OnOK()
{

	CPropertyPage::OnOK();
}




void CRotationPage::OnCbnSelchangeCmbRotation()
{
	long rotation = TRANSFORM_ROTATION_NONE;
	switch(m_xcCmbRotation.GetCurSel())
	{
	case 0: rotation = TRANSFORM_ROTATION_NONE;	break;
	case 1: rotation = TRANSFORM_ROTATION_R90;	break;
	case 2: rotation = TRANSFORM_ROTATION_L90;	break;
	case 3: rotation = TRANSFORM_ROTATION_180;	break;
	default: return;
	}

	profile_->Preview.lTransformRotation = rotation;
	if (dlg_) { dlg_->OnPreviewIsRunBuild(); }
}


void CRotationPage::OnBnClickedCbDoubleHeight()
{
	profile_->Preview.bTransformDoubleHeight = m_xcCbDoubleHeight.GetCheck() == BST_CHECKED ? TRUE : FALSE;
	if (dlg_) { dlg_->OnPreviewIsRunBuild(); }
}

void CRotationPage::OnBnClickedCbFlipHorizontal()
{
	profile_->Preview.bTransformFlipHorizontal = m_xcCbFlipHorizontal.GetCheck() == BST_CHECKED ? TRUE : FALSE;
	if (dlg_) { dlg_->OnPreviewIsRunBuild(); }
}


void CRotationPage::OnBnClickedCbFlipVertical()
{
	profile_->Preview.bTransformFlipVertical = m_xcCbFlipVertical.GetCheck() == BST_CHECKED ? TRUE : FALSE;
	dlg_->m_Preview.SetTransformFlipVertical(profile_->Preview.bTransformFlipVertical);
}


void CRotationPage::EnableCtrl(BOOL enable)
{
	if (IsWindow(m_hWnd))
	{
		m_xcCmbRotation.EnableWindow(enable);
		m_xcCbDoubleHeight.EnableWindow(enable);
		m_xcCbFlipHorizontal.EnableWindow(enable);
		m_xcCbFlipVertical.EnableWindow(enable);
	}
	enableCtrl_ = enable;
}