// YCExpandPage.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "YCExpandPage.h"
#include "afxdialogex.h"


// CYCExpandPage _CAO

IMPLEMENT_DYNAMIC(CYCExpandPage, CPropertyPage)

CYCExpandPage::CYCExpandPage(CMainDlg *dlg, CCaptureGraphProfile *profile)
	: CPropertyPage(CYCExpandPage::IDD)
	, dlg_(dlg)
	, profile_(profile)
	, enableCtrl_(FALSE)
{
	m_psp.dwFlags &= ~PSP_HASHELP;
}

CYCExpandPage::~CYCExpandPage()
{
}

void CYCExpandPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_YCEXPAND, m_xcCmbYCExpand);
}


BEGIN_MESSAGE_MAP(CYCExpandPage, CPropertyPage)
	ON_CBN_SELCHANGE(IDC_CMB_YCEXPAND, &CYCExpandPage::OnCbnSelchangeCmbYcexpand)
END_MESSAGE_MAP()


// CYCExpandPage bZ[W nh[


BOOL CYCExpandPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_xcCmbYCExpand.AddString(L"Ȃ");
	m_xcCmbYCExpand.AddString(L"UYVYoCgz");
	m_xcCmbYCExpand.AddString(L"YUY2oCgz");

	switch(profile_->Preview.lTransformYCExpand)
	{
	case TRANSFORM_YCEXPAND_NONE:	m_xcCmbYCExpand.SetCurSel(0); break;
	case TRANSFORM_YCEXPAND_UYVY:	m_xcCmbYCExpand.SetCurSel(1); break;
	case TRANSFORM_YCEXPAND_YUY2:	m_xcCmbYCExpand.SetCurSel(2); break;
	default:
		m_xcCmbYCExpand.SetCurSel(0); break;
	}

	EnableCtrl(enableCtrl_);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}



void CYCExpandPage::OnOK()
{


	CPropertyPage::OnOK();
}



void CYCExpandPage::OnCbnSelchangeCmbYcexpand()
{
	long ycexpand = TRANSFORM_YCEXPAND_NONE;
	switch(m_xcCmbYCExpand.GetCurSel())
	{
	case 0: ycexpand = TRANSFORM_YCEXPAND_NONE;	break;
	case 1: ycexpand = TRANSFORM_YCEXPAND_UYVY;	break;
	case 2: ycexpand = TRANSFORM_YCEXPAND_YUY2;	break;
	default: return;
	}

	profile_->Preview.lTransformYCExpand = ycexpand;
	if (dlg_) { dlg_->OnPreviewIsRunBuild(); }
}

void CYCExpandPage::EnableCtrl(BOOL enable)
{
	if (IsWindow(m_hWnd))
	{
		m_xcCmbYCExpand.EnableWindow(enable);
	}
	enableCtrl_ = enable;
}